/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/base/async",["require","exports","vs/base/errors","vs/base/lib/winjs.base"],function(e,t,r,n){function i(e,t){return new n.TPromise(function(n,i,o){e.done(function(e){try{t(e)}catch(i){r.onUnexpectedError(i)}n(e)},function(e){try{t(e)}catch(n){r.onUnexpectedError(n)}i(e)},function(e){o(e)})},function(){e.cancel()})}function o(e){function t(){return e.length?e.pop()():null}function r(e){e&&i.push(e);var o=t();return o?o.then(r):n.TPromise.as(i)}var i=[];return e=e.reverse(),n.Promise.as(null).then(r)}function s(e){var t,r=this,n=!1;return function(){return n?t:(n=!0,t=e.apply(r,arguments))}}var a=function(){function e(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}return e.prototype.queue=function(e){var t=this;if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){var r=function(){t.queuedPromise=null;var e=t.queue(t.queuedPromiseFactory);return t.queuedPromiseFactory=null,e};this.queuedPromise=new n.Promise(function(e,n,i){t.activePromise.then(r,r,i).done(e)},function(){t.activePromise.cancel()})}return new n.Promise(function(e,r,n){t.queuedPromise.then(e,r,n)},function(){})}return this.activePromise=e(),new n.Promise(function(e,r,n){t.activePromise.done(function(r){t.activePromise=null,e(r)},function(e){t.activePromise=null,r(e)},n)},function(){t.activePromise.cancel()})},e}();t.Throttler=a;var u=function(){function e(e){this.defaultDelay=e,this.timeoutPromise=null,this.completionPromise=null,this.onSuccess=null,this.task=null}return e.prototype.trigger=function(e,t){var r=this;return void 0===t&&(t=this.defaultDelay),this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new n.Promise(function(e){r.onSuccess=e},function(){}).then(function(){r.completionPromise=null,r.onSuccess=null;var e=r.task();return r.task=null,e})),this.timeoutPromise=n.Promise.timeout(t),this.timeoutPromise.then(function(){r.timeoutPromise=null,r.onSuccess(null)}),this.completionPromise},e.prototype.isTriggered=function(){return!!this.timeoutPromise},e.prototype.cancel=function(){this.cancelTimeout(),this.completionPromise&&(this.completionPromise.cancel(),this.completionPromise=null)},e.prototype.cancelTimeout=function(){this.timeoutPromise&&(this.timeoutPromise.cancel(),this.timeoutPromise=null)},e}();t.Delayer=u;var c=function(e){function t(t){e.call(this,t),this.throttler=new a}return __extends(t,e),t.prototype.trigger=function(t,r){var n=this;return e.prototype.trigger.call(this,function(){return n.throttler.queue(t)},r)},t}(u);t.ThrottledDelayer=c;var l=function(e){function t(t,r){void 0===r&&(r=0),e.call(this,t),this.minimumPeriod=r,this.periodThrottler=new a}return __extends(t,e),t.prototype.trigger=function(t,r){var i=this;return e.prototype.trigger.call(this,function(){return i.periodThrottler.queue(function(){return n.Promise.join([n.Promise.timeout(i.minimumPeriod),t()]).then(function(e){return e[1]})})},r)},t}(c);t.PeriodThrottledDelayer=l;var p=function(){function e(){var e=this;this._value=new n.TPromise(function(t,r){e._completeCallback=t,e._errorCallback=r})}return Object.defineProperty(e.prototype,"value",{get:function(){return this._value},enumerable:!0,configurable:!0}),e.prototype.complete=function(e){this._completeCallback(e)},e.prototype.error=function(e){this._errorCallback(e)},e}();t.PromiseSource=p;var d=function(e){function t(t){var n,i,o;e.call(this,function(e,t,r){n=e,i=t,o=r},function(){i(r.canceled())}),t.then(n,i,o)}return __extends(t,e),t}(n.TPromise);t.ShallowCancelThenPromise=d,t.always=i,t.sequence=o,t.once=s;var h=function(){function e(e){this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0}return e.prototype.queue=function(e){var t=this;return new n.TPromise(function(r,n,i){t.outstandingPromises.push({factory:e,c:r,e:n,p:i}),t.consume()})},e.prototype.consume=function(){for(var e=this;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){var t=this.outstandingPromises.shift();this.runningPromises++;var r=t.factory();r.done(t.c,t.e,t.p),r.done(function(){return e.consumed()},function(){return e.consumed()})}},e.prototype.consumed=function(){this.runningPromises--,this.consume()},e}();t.Limiter=h}),define("vs/base/assert",["require","exports"],function(e,t){function r(e,t){if(!e||null===e)throw new Error(t?"Assertion failed ("+t+")":"Assertion Failed")}function n(e,t,r){if(e!==t||!e||!t)throw new Error(r?"Assertion failed ("+r+")":"Assertion Failed")}t.ok=r,t.equals=n}),define("vs/base/hash",["require","exports"],function(e,t){function r(e){for(var t=1540483477,r=24,n=0,i=e.length,o=i,s=0^o,a=n;o>=2;){var u=e.charCodeAt(a),c=e.charCodeAt(a+1),l=u|c<<16;l*=t,l^=l>>r,l*=t,s*=t,s^=l,a+=2,o-=2}return 1===o&&(s^=e.charCodeAt(a),s*=t),s^=s>>13,s*=t,s^=s>>15}function n(e,t){return(t<<5)+t+e&2147483647}t.computeMurmur2StringHashCode=r,t.combine=n}),define("vs/base/paths",["require","exports","./env"],function(e,t,r){function n(e,r){e=i(e),r=i(r);for(var n=e.split(t.sep),o=r.split(t.sep);n.length>0&&o.length>0&&n[0]===o[0];)n.shift(),o.shift();for(var s=0,a=n.length;a>s;s++)o.unshift("..");return o.join(t.sep)}function i(e,r){if(!e)return e;for(var n=e.split(/[\\\/]/),i=0,o=n.length;o>i;i++)"."===n[i]&&n[i+1]&&(n.splice(i,1),i--);return n.join(r?t.nativeSep:t.sep)}function o(e){function t(){return"."===r||"/"===r||"\\"===r?(r=void 0,n=!0):r=s(r),{value:r,done:n}}var r=e,n=!1;return{next:t}}function s(e){var t=~e.lastIndexOf("/")||~e.lastIndexOf("\\");return 0===t?".":0===~t?e[0]:e.substring(0,~t)}function a(e){var t=~e.lastIndexOf("/")||~e.lastIndexOf("\\");return 0===t?e:~t===e.length-1?a(e.substring(0,e.length-1)):e.substr(~t+1)}function u(e){e=a(e);var t=~e.lastIndexOf(".");return t?e.substring(~t):""}function c(e){if(!e)return 0;if(e=e.replace(/\/|\\/g,"/"),"/"===e[0])return"/"!==e[1]?1:2;if(":"===e[1])return"/"===e[2]?3:2;if(0===e.indexOf("file:///"))return 8;var t=e.indexOf("://");return-1!==t?t+3:0}function l(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];var r,n=c(e[0]);r=e[0].substr(0,n),e[0]=e[0].substr(n);for(var i=[],o=/[\\\/]$/.test(e[e.length-1]),s=0;s<e.length;s++)i.push.apply(i,e[s].split(/\/|\\/));for(var s=0;s<i.length;s++){var a=i[s];"."===a||0===a.length?(i.splice(s,1),s-=1):".."===a&&i[s-1]&&".."!==i[s-1]&&(i.splice(s-1,2),s-=2)}o&&i.push("");var u=i.join("/");return r&&(u=r.replace(/\/|\\/g,"/")+u),u}function p(e){return r.isWindows&&e?(e=this.normalize(e,!0),e[0]===t.nativeSep&&e[1]===t.nativeSep):!1}function d(e){return e&&"/"===e[0]}function h(e,r){return d(r?e:i(e))?e:t.sep+e}function f(e){return e&&e.length>1&&"."===e[0]}function g(e,t){var r=_(i(e)),n=_(i(t)),o=n.length;n[o-1]||(o-=1);for(var s=0;o>s;s++)if(r[s]!==n[s])return!1;return!0}t.sep="/",t.nativeSep=r.isWindows?"\\":"/",t.relative=n,t.normalize=i,t.dirnames=o,t.dirname=s,t.basename=a,t.extname=u,t.join=l,t.isUNC=p,t.isAbsolute=d,t.makeAbsolute=h,t.isRelative=f,t.isEqualOrParent=g;var m=function(e){return e.split(t.sep)},v=function(e){return e.split(t.sep).map(function(e){return e.toLowerCase()})},_=r.isCaseSensitiveFs?m:v}),define("vs/base/uri",["require","exports","vs/base/worker/marshalling","vs/base/env"],function(e,t,r,n){function i(e){return encodeURIComponent(e).replace(/[!'()*]/g,function(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()})}var o,o=function(){function e(){this._scheme=e._empty,this._authority=e._empty,this._path=e._empty,this._query=e._empty,this._fragment=e._empty}return Object.defineProperty(e.prototype,"scheme",{get:function(){return this._scheme},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"authority",{get:function(){return this._authority},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"path",{get:function(){return this._path},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"query",{get:function(){return this._query},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fragment",{get:function(){return this._fragment},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fsPath",{get:function(){if(!this._fsPath){var t;t=this._authority&&"file"===this.scheme?"//"+this._authority+this._path:e._driveLetterPath.test(this._path)?this._path[1].toLowerCase()+this._path.substr(2):this._path,n.isWindows&&(t=t.replace(/\//g,"\\")),this._fsPath=t}return this._fsPath},enumerable:!0,configurable:!0}),e.prototype.with=function(t,r,n,i,o){var s=new e;return s._scheme=t||this.scheme,s._authority=r||this.authority,s._path=n||this.path,s._query=i||this.query,s._fragment=o||this.fragment,e._validate(s),s},e.prototype.withScheme=function(e){return this.with(e,void 0,void 0,void 0,void 0)},e.prototype.withAuthority=function(e){return this.with(void 0,e,void 0,void 0,void 0)},e.prototype.withPath=function(e){return this.with(void 0,void 0,e,void 0,void 0)},e.prototype.withQuery=function(e){return this.with(void 0,void 0,void 0,e,void 0)},e.prototype.withFragment=function(e){return this.with(void 0,void 0,void 0,void 0,e)},e.parse=function(t){var r=e._parse(t);return r=r.with(void 0,decodeURIComponent(r.authority),decodeURIComponent(r.path),decodeURIComponent(r.query),decodeURIComponent(r.fragment))},e.file=function(t){t=t.replace(/\\/g,"/"),t=t.replace(/%/g,"%25"),t=t.replace(/#/g,"%23"),t=t.replace(/\?/g,"%3F"),t=e._driveLetter.test(t)?"/"+t:t;var r=e._parse(t);if(r.scheme||r.fragment||r.query)throw new Error;return r=r.with("file",void 0,decodeURIComponent(r.path),void 0,void 0)},e._parse=function(t){var r=new e,n=e._regexp.exec(t);return n&&(r._scheme=n[2]||r._scheme,r._authority=n[4]||r._authority,r._path=n[5]||r._path,r._query=n[7]||r._query,r._fragment=n[9]||r._fragment),e._validate(r),r},e.create=function(t,r,n,i,o){return(new e).with(t,r,n,i,o)},e._validate=function(e){if(e.authority&&e.path&&"/"!==e.path[0])throw new Error;var t=e.path.indexOf("//");if(-1!==t&&(0!==t||!e.authority))throw new Error},e.prototype.toString=function(){if(!this._formatted){var t=[];if(this._scheme&&(t.push(this._scheme),t.push(":")),(this._authority||"file"===this._scheme)&&t.push("//"),this._authority){var r,n=this._authority;n=n.toLowerCase(),r=n.indexOf(":"),-1===r?t.push(i(n)):(t.push(i(n.substr(0,r))),t.push(n.substr(r)))}if(this._path){var o,s=this._path;e._driveLetterPath.test(s)?s="/"+s[1].toLowerCase()+s.substr(2):e._driveLetter.test(s)&&(s=s[0].toLowerCase()+s.substr(1)),o=s.split("/");for(var a=0,u=o.length;u>a;a++)o[a]=i(o[a]);t.push(o.join("/"))}this._fragment&&(t.push("#"),t.push(i(this._fragment))),this._query&&(t.push("?"),t.push(i(this._query))),this._formatted=t.join("")}return this._formatted},e.prototype.toJSON=function(){return this.toString()},e.prototype._toSerialized=function(){return{$isURI:!0,$value:this.toString().replace(/URL_MARSHAL_REMOVE=.*$/,"")}},e._empty="",e._regexp=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,e._driveLetterPath=/^\/[a-zA-z]:/,e._driveLetter=/^[a-zA-z]:/,e}();!function(e){function t(e){return n.isWindows?e.replace(/\//g,"\\"):e}function r(e){if(e=decodeURI(e),n.isWindows){if(/^file:\/\/\//.test(e))return t(e.substr(8));if(/^file:\/\//.test(e))return t(e.substr(5))}else if(/^file:\/\//.test(e))return e.substr(7);throw new Error("Invalid file URI: "+e)}e.correctFileUriToFilePath=r}(o||(o={}));var o;return function(e){function t(t){return t instanceof e?!0:t?"string"!=typeof t.scheme?!1:"string"!=typeof t.authority?!1:"string"!=typeof t.fsPath?!1:"string"!=typeof t.query?!1:"string"!=typeof t.fragment?!1:"function"!=typeof t.with?!1:"function"!=typeof t.withScheme?!1:"function"!=typeof t.withAuthority?!1:"function"!=typeof t.withPath?!1:"function"!=typeof t.withQuery?!1:"function"!=typeof t.withFragment?!1:"function"!=typeof t.toString?!1:"function"!=typeof t.toJSON?!1:!0:!1}e.isURI=t}(o||(o={})),r.registerMarshallingContribution({canSerialize:function(e){return o.isURI(e)},serialize:function(e){return e._toSerialized()},canDeserialize:function(e){return e.$isURI},deserialize:function(e){return o.parse(e.$value)}}),o});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/base/network",["require","exports","./assert","./hash","./strings","vs/base/worker/marshalling","vs/base/paths","vs/base/uri"],function(e,t,r,n,i,o,s,a){o.registerMarshallingContribution({canSerialize:function(e){return e instanceof h},serialize:function(e){return e._toSerialized()},canDeserialize:function(e){return e.$isURL},deserialize:function(e){return new h(e.$value)}});var u=":".charCodeAt(0),c="/".charCodeAt(0),l="?".charCodeAt(0),p="#".charCodeAt(0),d=function(){function e(e){this.spec=e||i.empty,this.specLength=this.spec.length,this.parse()}return e.prototype.forwardSubstring=function(e,t){return t>e?this.spec.substring(e,t):i.empty},e.prototype.getScheme=function(){return this.forwardSubstring(this.schemeStart,this.domainStart-1)},e.prototype.getProtocol=function(){return this.forwardSubstring(this.schemeStart,this.domainStart)},e.prototype.getDomain=function(){return this.forwardSubstring(this.domainStart+2,this.portStart)},e.prototype.getPort=function(){return this.forwardSubstring(this.portStart+1,this.pathStart)},e.prototype.getHost=function(){return this.forwardSubstring(this.domainStart+2,this.pathStart)},e.prototype.getPath=function(){return this.forwardSubstring(this.pathStart,this.queryStringStart)},e.prototype.getQueryString=function(){return this.forwardSubstring(this.queryStringStart+1,this.fragmentIdStart)},e.prototype.getFragmentId=function(){return this.forwardSubstring(this.fragmentIdStart+1,this.specLength)},e.prototype.getAllBeforePath=function(){return this.forwardSubstring(0,this.pathStart)},e.prototype.getAllBeforeFragmentId=function(){return this.forwardSubstring(0,this.fragmentIdStart)},e.prototype.combine=function(e){var t=e.indexOf("?"),r=e.indexOf("#"),n=e.length;-1!==t&&n>t&&(n=t),-1!==r&&n>r&&(n=r);var o=e.substring(0,n),a=e.substring(n);o=o.replace("\\","/");var u;for(u=i.startsWith(o,"/")?s.join(o):s.join(s.dirname(this.getPath()),o);"/"===u.charAt(0);)u=u.substr(1);for(;0===u.indexOf("../");)u=u.substr(3);return this.getAllBeforePath()+"/"+u+a},e.prototype.parse=function(){var e,t,r=0,n=1,i=2,o=3,s=4,a=r,d=this.spec,h=this.specLength,f=-1,g=-1;for(this.schemeStart=0,this.domainStart=this.specLength,this.portStart=this.specLength,this.pathStart=this.specLength,this.queryStringStart=this.specLength,this.fragmentIdStart=this.specLength,e=0;h>e;e++){switch(t=d.charCodeAt(e),a){case r:f===c&&t===c&&(a=n,this.domainStart=e-1);break;case n:t===u?(a=i,this.portStart=e):t===c?(a=o,this.portStart=e,this.pathStart=e):t===p&&(this.portStart=e,this.pathStart=e,this.queryStringStart=e,this.fragmentIdStart=e,e=h);break;case i:t===c?(a=o,this.pathStart=e):t===p&&(this.pathStart=e,this.queryStringStart=e,this.fragmentIdStart=e,e=h);break;case o:t===l?(a=s,this.queryStringStart=e):t===p&&(this.queryStringStart=e,this.fragmentIdStart=e,e=h);break;case s:t===p&&(this.fragmentIdStart=e,e=h)}g=f,f=t}a===r&&(this.schemeStart=this.specLength)},e}();t.ParsedUrl=d;var h=function(e){function t(t){e.call(this),r.ok(!!t,"spec must not be null"),this._uri="string"==typeof t?a.parse(t):t,this._spec=this._uri.toString(),this._parsed=null}return __extends(t,e),t.fromEncoded=function(e){return new t(decodeURIComponent(e))},t.fromValue=function(e){return new t(e)},t.fromUri=function(e){return new t(e)},t.prototype.equals=function(e){return this.toString()!==String(e)?!1:e instanceof t||a.isURI(e)},t.prototype.hashCode=function(){return n.computeMurmur2StringHashCode(this._spec)},t.prototype.isInMemory=function(){return this.scheme===f.inMemory},t.prototype.getScheme=function(){return this._ensureParsedUrl(),this._parsed.getScheme()},t.prototype.getPath=function(){return this._ensureParsedUrl(),this._parsed.getPath()},t.prototype.toUnique=function(){return this._ensureParsedUrl(),this._parsed.getAllBeforeFragmentId()},t.prototype.startsWith=function(e){return i.startsWith(this._spec,e._spec)},t.prototype.combine=function(e){return this._ensureParsedUrl(),new t(this._parsed.combine(e))},t.prototype._ensureParsedUrl=function(){null===this._parsed&&(this._parsed=new d(this._spec))},Object.defineProperty(t.prototype,"scheme",{get:function(){return this._uri.scheme},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"authority",{get:function(){return this._uri.authority},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"path",{get:function(){return this._uri.path},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"fsPath",{get:function(){return this._uri.fsPath},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"query",{get:function(){return this._uri.query},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"fragment",{get:function(){return this._uri.fragment},enumerable:!0,configurable:!0}),t.prototype.withScheme=function(e){return a.create(e,this.authority,this.fsPath,this.query,this.fragment)},t.prototype.withAuthority=function(e){return a.create(this.scheme,e,this.fsPath,this.query,this.fragment)},t.prototype.withPath=function(e){return a.create(this.scheme,this.authority,e,this.query,this.fragment)},t.prototype.withQuery=function(e){return a.create(this.scheme,this.authority,this.fsPath,e,this.fragment)},t.prototype.withFragment=function(e){return a.create(this.scheme,this.authority,this.fsPath,this.query,e)},t.prototype.with=function(e,t,r,n,i){return a.create(e,t,r,n,i)},t.prototype.toString=function(){return this._spec},t.prototype.toJSON=function(){return this.toString()},t.prototype._toSerialized=function(){return{$isURL:!0,$value:this.toString().replace(/URL_MARSHAL_REMOVE=.*$/,"")}},t}(a);t.URL=h;var f;!function(e){e.inMemory="inmemory",e.http="http",e.https="https",e.file="file"}(f=t.schemas||(t.schemas={}))}),define("vs/base/time/precision",["require","exports"],function(e,t){function r(){return new i(n?self.performance.now():(new Date).getTime())}var n=self.performance&&"function"==typeof self.performance.now,i=function(){function e(e){this._startTime=e,this._stopTime=-1}return e.prototype.stop=function(){this._stopTime=n?self.performance.now():(new Date).getTime()},e.prototype.elapsed=function(){if(-1!==this._stopTime)return this._stopTime-this._startTime;var e=n?self.performance.now():(new Date).getTime();return e-this._startTime},e}();t.StopWatch=i,t.createStopWatch=r}),define("vs/base/performance/timer",["require","exports","vs/base/env","vs/base/errors","vs/base/time/precision"],function(e,t,r,n,i){function o(e,t,r,n){return d.start(e,t,r,n)}function s(){return d}var a=!!self.msWriteProfilerMark;!function(e){e[e.EDITOR=0]="EDITOR",e[e.LANGUAGES=1]="LANGUAGES",e[e.WORKER=2]="WORKER",e[e.WORKBENCH=3]="WORKBENCH",e[e.STARTUP=4]="STARTUP"}(t.Topic||(t.Topic={}));var u=t.Topic,c=function(){function e(){}return e.prototype.stop=function(){},e.prototype.timeTaken=function(){return-1},e}(),l=function(){function e(e,t,r,n,o){if(this.timeKeeper=e,this.name=t,this.description=o,this.topic=r,this.stopTime=null,n)return this.startTime=n,void 0;if(this.startTime=new Date,this.sw=i.createStopWatch(),a){var s=["Monaco",this.topic,this.name,"start"];self.msWriteProfilerMark(s.join("|"))}}return e.prototype.stop=function(e){if(null===this.stopTime){if(e)return this.stopTime=e,this.sw=null,this.timeKeeper._onEventStopped(this),void 0;if(this.stopTime=new Date,this.sw&&this.sw.stop(),this.timeKeeper._onEventStopped(this),a){var t=["Monaco",this.topic,this.name,"stop"];self.msWriteProfilerMark(t.join("|"))}}},e.prototype.timeTaken=function(){return this.sw?this.sw.elapsed():this.stopTime?this.stopTime.getTime()-this.startTime.getTime():-1},e}(),p=function(){function e(){this.cleaningIntervalId=-1,this.collectedEvents=[],this.listeners=[]}return e.prototype.isEnabled=function(){return r.enablePerformanceEvents},e.prototype.start=function(e,r,n,i){if(!this.isEnabled())return t.nullEvent;var o;"string"==typeof e?o=e:e===u.EDITOR?o="Editor":e===u.LANGUAGES?o="Languages":e===u.WORKER?o="Worker":e===u.WORKBENCH?o="Workbench":e===u.STARTUP&&(o="Startup"),this.initAutoCleaning();var s=new l(this,r,o,n,i);return this.addEvent(s),s},e.prototype.dispose=function(){-1!==this.cleaningIntervalId&&(clearInterval(this.cleaningIntervalId),this.cleaningIntervalId=-1)},e.prototype.addListener=function(e){this.listeners.push(e)},e.prototype.removeListener=function(e){for(var t=0;t<this.listeners.length;t++)if(this.listeners[t]===e)return this.listeners.splice(t,1),void 0},e.prototype.addEvent=function(t){t.id=e.EVENT_ID,e.EVENT_ID++,this.collectedEvents.push(t),this.collectedEvents.length>e._EVENT_CACHE_LIMIT&&this.collectedEvents.shift()},e.prototype.initAutoCleaning=function(){var t=this;-1===this.cleaningIntervalId&&(this.cleaningIntervalId=setInterval(function(){var r=Date.now();t.collectedEvents.forEach(function(t){!t.stopTime&&r-t.startTime.getTime()>=e._MAX_TIMER_LENGTH&&t.stop()})},e._CLEAN_UP_INTERVAL))},e.prototype.getCollectedEvents=function(){return this.collectedEvents.slice(0)},e.prototype.clearCollectedEvents=function(){this.collectedEvents=[]},e.prototype._onEventStopped=function(e){for(var t=[e],r=this.listeners.slice(0),i=0;i<r.length;i++)try{r[i](t)}catch(o){n.onUnexpectedError(o)}},e.prototype.setInitialCollectedEvents=function(t,r){var n=this;this.isEnabled()&&(r&&(e.PARSE_TIME=r),t.forEach(function(e){var t=new l(n,e.name,e.topic,e.startTime,e.description);t.stop(e.stopTime),n.addEvent(t)}))},e._MAX_TIMER_LENGTH=6e4,e._CLEAN_UP_INTERVAL=12e4,e._EVENT_CACHE_LIMIT=1e3,e.EVENT_ID=1,e.PARSE_TIME=new Date,e}();t.TimeKeeper=p;var d=new p;t.nullEvent=new c,t.start=o,t.getTimeKeeper=s}),define("vs/base/http",["require","exports"],function(e,t){function r(e){return e>=300&&303>=e||307===e}function n(e,t,r,n){var i,o;return{header:function(r){if("undefined"==typeof o)for(o=Object.create(null),c.lastIndex=t;;){var n=c.exec(e);if(!n)break;if(o[n[1].toLowerCase()]=n[2],n[3])break}return o[r.toLowerCase()]},value:function(){return"undefined"==typeof i&&(i=e.substr(r+2,n)),i}}}function i(e,t,r){void 0===r&&(r=0);var i=e.responseText;for(u.lastIndex=r;;){var o=u.exec(i);if(!o)return r;var s=parseInt(o[1],10);if(i.length<u.lastIndex+s)return r;t.push(n(i,r,u.lastIndex-2,s)),r=u.lastIndex+s}}t.GET="GET",t.POST="POST",t.PUT="PUT",t.DELETE="DELETE";var o;!function(e){e.CONTENT_TYPE="Content-Type",e.CONTENT_LENGTH="Content-Length",e.LAST_MODIFIED="Last-Modified",e.LOCATION="Location",e.ETAG="ETag",e.X_CONTENT_CHARSET="X-Content-Charset",e.X_CONTENT_TYPES="X-Content-Types",e.X_CONTENT_HASH="X-Content-Hash",e.X_FILEPATH="X-Filepath",e.X_RESOURCE="X-Resource"}(o=t.Header||(t.Header={}));var s;!function(e){e.RAW="application/octet-stream",e.JSON="application/json",e.TEXT="text/plain",e.HTML="text/html"}(s=t.Mime||(t.Mime={}));var a;!function(e){e.UTF8="utf-8",e.UTF8_BOM="UTF8_BOM"}(a=t.Charset||(t.Charset={})),t.isRedirect=r;var u=/X-Chunk-Length:(\d+)\r\n\r\n/gi,c=/(.+?):(.+?)\r\n(\r\n)?/gm;t.parseChunkedData=i});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/base/ui/events",["require","exports"],function(e,t){var r=function(){function e(e){this.time=(new Date).getTime(),this.originalEvent=e,this.source=null}return e}();t.Event=r;var n=function(e){function t(t,r,n){e.call(this,n),this.stack=r,this.message=t}return __extends(t,e),t}(r);t.MessageEvent=n;var i=function(e){function t(t,r,n,i){e.call(this,i),this.key=t,this.oldValue=r,this.newValue=n}return __extends(t,e),t}(r);t.PropertyChangeEvent=i;var o=function(e){function t(t,r){e.call(this,r),this.element=t}return __extends(t,e),t}(r);t.ViewerEvent=o,t.EventType={PROPERTY_CHANGED:"propertyChanged",SELECTION:"selection",FOCUS:"focus",BLUR:"blur",HIGHLIGHT:"highlight",EXPAND:"expand",COLLAPSE:"collapse",TOGGLE:"toggle",CONTENTS_CHANGED:"contentsChanged",BEFORE_RUN:"beforeRun",RUN:"run",EDIT:"edit",SAVE:"save",CANCEL:"cancel",INFO:"info",WARNING:"warning",ERROR:"error",CHANGE:"change",DISPOSE:"dispose"}}),define("vs/base/bits/bits",["require","exports"],function(e,t){function r(e,t,r){return void 0===r&&(r="0"),new Array(t-e.length+1).join(r)+e}function n(e,t){return void 0===t&&(t=32),r((e>>>0).toString(16),t/4)}function i(e,t,r){void 0===r&&(r=32);var n=r-t,i=~((1<<n)-1);return(e<<t|(i&e)>>>n)>>>0}function o(e,t){var r=65535&e,n=e>>>16,i=65535&t,o=t>>>16,s=0,a=0,u=0,c=0,l=i*r;return s+=65535&l,a+=l>>>16,l=i*n,a+=65535&l,u+=l>>>16,l=o*r,a+=65535&l,u+=l>>>16,u+=a>>>16,a=65535&a,l=o*n,u+=65535&l,c+=l>>>16,c+=u>>>16,u=65535&u,[(c<<16|u)>>>0,(a<<16|s)>>>0]}t.leftPad=r,t.toHexString=n,t.leftRotate=i,t.multiply64=o}),define("vs/base/bits/encoding",["require","exports","./bits"],function(e,t,r){function n(e){if(e>>>=0,128>e)return 1;if(2048>e)return 2;if(65536>e)return 3;if(2097152>e)return 4;if(67108864>e)return 5;if(2147483648>e)return 6;throw new Error("Code point 0x"+r.toHexString(e)+" not encodable in UTF8.")}function i(e,t,r){var i=n(e);if(1===i)return t[r]=e,1;t[r]=255&(252<<6-i|e>>>6*(i-1));for(var o=1;i>o;o++)t[r+o]=255&(128|63&e>>>6*(i-o-1));return i}function o(e,t){var r,o,s=0,a=0,u=0,c=0;for(r=0,o=e.length;o>r;r++){if(a=e.charCodeAt(r),a>=55296&&56320>a){if(u=e.charCodeAt(++r),!(u>=56320&&57344>u))throw new Error("Invalid char code");c=((a-55296&1023)<<10|u-56320&1023)+65536}else c=a;s+=n(c)}t&&(s+=3);var l=new ArrayBuffer(s),p=new Uint8Array(l),d=0;for(t&&(p[0]=239,p[1]=187,p[2]=191,d+=3),r=0,o=e.length;o>r;r++)a=e.charCodeAt(r),a>=55296&&56320>a?(u=e.charCodeAt(++r),c=((a-55296&1023)<<10|u-56320&1023)+65536):c=a,d+=i(c,p,d);return l}function s(e,t,r,n){var i=2*e.length;if(i>n)throw Error("Unable to encode string to UTF16. Need "+i+" bytes, but only have "+n+" bytes.");for(var o=0;o<e.length;o++)t.setUint16(r+2*o,e.charCodeAt(o),!1);return i}t.UTF8="utf8",t.encodeToUTF8=o,t.encodeToUTF16=s,t.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:2},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:3},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:4},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:5},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:6},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:7},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:8},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:9},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:10},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:11},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:12},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:13},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:14},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:15},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:16},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:17},windows866:{labelLong:"Cyrillic (Windows 866)",labelShort:"Windows 866",order:18},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:19},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:20},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:21},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:22},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:23},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:24},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:25},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:26},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:27},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:28},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:29},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:30},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:31},gbk:{labelLong:"Chinese (GBK)",labelShort:"GBK",order:32},gb18030:{labelLong:"Chinese (GB18030)",labelShort:"GB18030",order:33},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:34},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:35},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:36},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:37},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:38},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:39},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:40},"koi8-ru":{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:41},"koi8-t":{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:42},GB2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:43}}}),define("vs/base/arrays",["require","exports"],function(e,t){function r(e,t){return void 0===t&&(t=0),e[e.length-(1+t)]}function n(e,t){for(var r=0,n=e.length;n>r;r++)t(e[r],function(){e.splice(r,1),r--,n--})}function i(e,t,r){if(e.length!==t.length)return!1;for(var n=0,i=e.length;i>n;n++)if(!r(e[n],t[n]))return!1;return!0}function o(e,t){void 0===t&&(t=null);for(var r=new Array(e);e-->0;)r.push(t);return r}function s(e,t,r){for(var n=0,i=e.length-1;i>=n;){var o=Math.floor((n+i)/2),s=r(e[o],t);if(0>s)n=o+1;else{if(!(s>0))return o;i=o-1}}return-1}function a(e,t){var r=0,n=e.length;if(0===n)return 0;for(;n>r;){var i=Math.floor((r+n)/2);t(e[i])?n=i:r=i+1}return r}function u(e,t){var r=new Array;if(t)for(var n={},i=0;i<e.length;i++)for(var o=0;o<e[i].length;o++){var s=e[i][o],a=t(s);n.hasOwnProperty(a)||(n[a]=!0,r.push(s))}else for(var i=0,u=e.length;u>i;i++)r.push.apply(r,e[i]);return r}function c(e,t){for(var r,n=0,i=e.length-1;i>n;)r=n+Math.ceil((i-n)/2),e[r].startIndex>t?i=r-1:n=r;return n}function l(e){return e?e.filter(function(e){return!!e}):e}function p(e,t){return e.indexOf(t)>=0}function d(e,t,r){var n=e[t],i=e[r];e[t]=i,e[r]=n}function h(e,t,r){e.splice(r,0,e.splice(t,1)[0])}function f(e){return!Array.isArray(e)||0===e.length}function g(e,t){return e===t}function m(e,t,r){return void 0===r&&(r=g),e.every(function(e){return t.some(function(t){return r(e,t)})})}function v(e,t,r){return void 0===r&&(r=g),e.every(function(e){return!t.some(function(t){return r(e,t)})})}function _(e,t){if(!t)return e.filter(function(t,r){return e.indexOf(t)===r});var r={};return e.filter(function(e){var n=t(e);return r[n]?!1:(r[n]=!0,!0)})}function y(e,t,r){void 0===r&&(r=null);for(var n=0;n<e.length;n++){var i=e[n];if(t(i))return i}return r}function b(e,t){for(var r=[],n=0;t>n;n++)r.push(e);return r}function S(e,t,r){void 0===r&&(r=function(e,t){return e===t});for(var n=0,i=0,o=Math.min(e.length,t.length);o>i&&r(e[i],t[i]);i++)n++;return n}t.tail=r,t.forEach=n,t.equals=i,t.fill=o,t.binarySearch=s,t.findFirst=a,t.merge=u,t.findIndexInSegmentsArray=c,t.coalesce=l,t.contains=p,t.swap=d,t.move=h,t.isFalsyOrEmpty=f,t.withlist=m,t.blocklist=v,t.distinct=_,t.first=y,t.repeat=b,t.commonPrefixLength=S}),define("vs/base/mime",["require","exports","vs/base/paths","vs/base/types","vs/base/strings"],function(e,t,r,n,i){function o(e){void 0===e&&(e=!0);var t=function(t){return e?/^\./.test(t):!0},r=function(e){return e.replace(/^\./,"")},n=[];n=n.concat(Object.keys(d)),n=n.concat(Object.keys(h)),n=n.concat(Object.keys(g)),n=n.filter(t).map(r),n.sort();
for(var i=[],o=null,s=null,a=[],u=function(){a.length>0&&i.push("'"+a.join("', '")+"'")},c=0,l=n.length;l>c;c++){var p=n[c];if(0!==p.length&&p!==s){var f=p.charAt(0);o!==f&&(u(),o=f,a=[]),a.push(p),s=p}}return u(),i.join(",\n")}function s(e,t){e&&t&&(g[e]=t)}function a(e,t){e&&t&&m.push({regexp:e,mime:t})}function u(e){if(!e)return!1;var r;return r=n.isArray(e)?e:e.split(",").map(function(e){return e.trim()}),r.indexOf(t.MIME_BINARY)>=0}function c(e,n){if(!e)return[t.MIME_UNKNOWN];e=e.toLowerCase();var o=r.basename(e),s=r.extname(e);for(var a in g){var u=a.toLowerCase();if(o===u||"."===a[0]&&i.endsWith(o,u)){var c=[g[a]];return c.push(t.MIME_TEXT),c}}if(n&&i.startsWithUTF8BOM(n)&&(n=n.substr(1)),n&&n.length>0)for(var l=0;l<m.length;++l){var p=n.match(m[l].regexp);if(p&&p.length>0&&p[0].length===n.length)return[m[l].mime,t.MIME_TEXT]}if(d[o]){var c=[d[o]];return c.push(t.MIME_TEXT),c}if(h[s]){var c=[h[s]];return h[s]!==t.MIME_TEXT&&c.push(t.MIME_TEXT),c}if(f[s]){var c=[f[s]];return f[s]!==t.MIME_BINARY&&c.push(t.MIME_BINARY),c}return[t.MIME_UNKNOWN]}function l(e){return e?"string"==typeof e?e===t.MIME_BINARY||e===t.MIME_TEXT||e===t.MIME_UNKNOWN:1===e.length&&l(e[0]):!0}function p(e,t){for(var r in g){var n=g[r];if(n===e)return t+r}for(var r in h)if(h.hasOwnProperty(r)){var n=h[r];if(n===e)return t+r}for(var r in f)if(f.hasOwnProperty(r)){var n=f[r];if(n===e)return t+r}return null}t.MIME_TEXT="text/plain",t.MIME_BINARY="application/octet-stream",t.MIME_UNKNOWN="application/unknown",t.generateKnownFilenames=o;var d={jakefile:"text/javascript",makefile:"text/x-makefile"},h={".html":"text/html",".htm":"text/html",".shtml":"text/html",".mdoc":"text/html",".jsp":"text/html",".asp":"text/html",".aspx":"text/html",".jshtm":"text/x-jshtm",".js":"text/javascript",".json":"application/json",".bowerrc":"application/json",".jshintrc":"application/json",".jscsrc":"application/json",".css":"text/css",".less":"text/x-less",".txt":"text/plain",".gitignore":"text/plain",".dtd":"application/xml-dtd",".php":"application/x-php",".phtml":"application/x-php",".ctp":"application/x-php",".md":"text/x-web-markdown",".markdown":"text/x-web-markdown",".mdown":"text/x-web-markdown",".mkdn":"text/x-web-markdown",".mkd":"text/x-web-markdown",".mdwn":"text/x-web-markdown",".mdtxt":"text/x-web-markdown",".mdtext":"text/x-web-markdown",".dot":"text/x-dot",".cshtml":"text/x-cshtml",".handlebars":"text/x-handlebars-template",".hbs":"text/x-handlebars-template",".scss":"text/x-scss"},f={".bmp":"image/bmp",".gif":"image/gif",".jpg":"image/jpg",".jpeg":"image/jpg",".jpe":"image/jpg",".png":"image/png",".tiff":"image/tiff",".tif":"image/tiff",".ico":"image/x-icon",".tga":"image/x-tga",".psd":"image/vnd.adobe.photoshop",".mid":"audio/midi",".midi":"audio/midi",".mp4a":"audio/mp4",".mpga":"audio/mpeg",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".m2a":"audio/mpeg",".m3a":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".spx":"audio/ogg",".aac":"audio/x-aac",".wav":"audio/x-wav",".wma":"audio/x-ms-wma",".mp4":"video/mp4",".mp4v":"video/mp4",".mpg4":"video/mp4",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpe":"video/mpeg",".m1v":"video/mpeg",".m2v":"video/mpeg",".ogv":"video/ogg",".qt":"video/quicktime",".mov":"video/quicktime",".webm":"video/webm",".mkv":"video/x-matroska",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".wmv":"video/x-ms-wmv",".flv":"video/x-flv",".avi":"video/x-msvideo",".movie":"video/x-sgi-movie",".exe":"application/x-msdownload-exe",".dll":"application/x-msdownload",".com":"application/x-msdownload",".msi":"application/x-msdownload",".pdf":"application/pdf",".doc":"application/msword",".dot":"application/msword",".ppt":"application/vnd.ms-powerpoint",".pps":"application/vnd.ms-powerpoint",".xls":"application/vnd.ms-excel",".xlm":"application/vnd.ms-excel",".xla":"application/vnd.ms-excel",".xlc":"application/vnd.ms-excel",".xlt":"application/vnd.ms-excel",".xlw":"application/vnd.ms-excel",".zip":"application/zip",".rar":"application/x-rar-compressed",".iso":"application/x-iso9660-image",".dmg":"application/x-apple-diskimage",".tar":"application/x-tar",".gz":"application/x-gzip",".7z":"application/x-7z-compressed",".cab":"application/vnd.ms-cab-compressed",".ttf":"application/x-font-ttf",".jar":"application/java-archive",".ai":"application/postscript",".swf":"application/x-shockwave-flash",".aif":"audio/x-aiff",".odt":"application/vnd.oasis.opendocument.text",".class":"application/java-vm",".jnilib":"application/octet-stream",".woff":"application/x-font-woff",".suo":"application/octet-stream",".deb":"application/x-debian-package",".sit":"application/x-stuffit",".sitx":"application/x-stuffitx",".docx":"application/vnd.openxmlformats-officedocument.wordprocessingml.document",".dotx":"application/vnd.openxmlformats-officedocument.wordprocessingml.template",".rtf":"application/rtf",".war":"application/octet-stream",".nupkg":"application/octet-stream",".cspkg":"application/octet-stream",".pyc":"application/octet-stream",".pyo":"application/octet-stream"},g=Object.create(null);t.registerTextMimeByFilename=s;var m=[];t.registerTextMimeByFirstLine=a,t.isBinaryMime=u,t.guessMimeTypes=c,t.isUnspecific=l,t.suggestFilename=p}),define("vs/platform/platform",["require","exports","vs/base/env","vs/base/types","vs/base/assert"],function(e,t,r,n,i){var o=function(){function e(){this.data={}}return e.prototype.add=function(e,t){i.ok(n.isString(e)),i.ok(n.isObject(t)),i.ok(!this.data.hasOwnProperty(e),"There is already an extension with this id"),this.data[e]=t},e.prototype.knows=function(e){return this.data.hasOwnProperty(e)},e.prototype.as=function(e){return this.data[e]||null},e}();t.Registry=new o;var s=function(){function e(){this.toBeInstantiated=[],this.instances=[]}return e.prototype.setInstantiationService=function(e){var t=this;if(this.instantiationService=e,r.isTesting())this.toBeInstantiated.forEach(function(e){t.instantiate(e)});else for(;this.toBeInstantiated.length>0;){var n=this.toBeInstantiated.shift();this.instantiate(n)}},e.prototype.instantiate=function(e){var t=this.instantiationService.createInstance(e);this.instances.push(t)},e.prototype._register=function(e){this.instantiationService?this.instantiate(e):this.toBeInstantiated.push(e)},e.prototype._getInstances=function(){return this.instances.slice(0)},e.prototype._setInstances=function(e){this.instances=e},e}();t.BaseRegistry=s}),define("vs/platform/plugins",["require","exports","vs/base/lib/winjs.base","vs/base/errors","vs/base/env"],function(e,t,r,n,i){function o(e){S.INSTANCE.registerPlugins(e)}function s(e){S.INSTANCE.registerPlugin(e)}function a(){return S.INSTANCE.getAllPluginDescriptions()}function u(e,t){S.INSTANCE.registerPointListener(e,t)}function c(e){return S.INSTANCE.activateByEvent(e)}function l(e){return S.INSTANCE.activateAndGet(e)}function p(e){void 0===e&&(e=[]),S.INSTANCE.registrationDone(e)}function d(e){return S.INSTANCE.get(e)}function h(){return S.INSTANCE.onReady()}function f(e){S.INSTANCE=e.accept(S.INSTANCE)}function g(e){S.INSTANCE.setInstantiationService(e)}function m(e){if(!Array.isArray(e))return!1;for(var t=0,r=e.length;r>t;t++)if("string"!=typeof e[t])return!1;return!0}var v=Object.hasOwnProperty,_=this.MonacoPlugins||{},y=this;t.registerPlugins=o,t.registerPlugin=s,t.getAllPluginDescriptions=a,t.registerPointListener=u,t.activateByEvent=c,t.activateAndGet=l,t.registrationDone=p,t.get=d,t.onReady=h,t.replacePluginManager=f,t.setInstantiationService=g;var b=function(){function e(e,t){t(e)}return e}(),S=function(){function t(e){var t=this;e?(this._onReady=r.TPromise.as(!0),this._onReadyC=function(){}):this._onReady=new r.TPromise(function(e){t._onReadyC=e},function(){console.warn("Should really not cancel this ready promise!")}),this._MonacoPlugins=_,this.activatingPlugins={},this.activatedPlugins={},this._pointListeners={},this._instantiationService=null;for(var n in this._MonacoPlugins)if(v.call(this._MonacoPlugins,n)){var i=this._isInvalidPluginDescription(this._MonacoPlugins[n]);if(i)throw new Error("Detected invalid plugin description: "+i)}}return t.prototype.setInstantiationService=function(e){this._instantiationService||(this._instantiationService=e)},t.prototype.registrationDone=function(e){e.forEach(function(e){return n.onUnexpectedError(e)}),this._onReadyC(!0)},t.prototype.onReady=function(){return this._onReady},t.prototype.get=function(e){if(!v.call(this.activatedPlugins,e))throw new Error("Plugin `"+e+"` is not known or not activated");return this.activatedPlugins[e]},t.prototype.accept=function(e){if(this._MonacoPlugins=e._MonacoPlugins,Object.keys(e.activatingPlugins).length>0)throw new Error("Unexpected plugin activation occured");if(Object.keys(e.activatedPlugins).length>0)throw new Error("Unexpected plugin activation occured");return this._pointListeners=e._pointListeners,this._instantiationService=e._instantiationService,this},t.prototype.registerPointListener=function(e,t){this._pointListeners[e]=this._pointListeners[e]||[],this._pointListeners[e].push(t),this._triggerPointListeners(e,this._getAllPluginDescriptionsByPoint(e))},t.prototype._triggerPointListeners=function(e,t){if(t&&0!==t.length&&v.call(this._pointListeners,e))for(var r=this._pointListeners[e].slice(0),n=0;n<r.length;n++)r[n](t)},t.prototype.registerPlugins=function(e){for(var t=0,r=e.length;r>t;t++)this.registerPlugin(e[t])},t.prototype.registerPlugin=function(e){if(i.enableTypeScriptServiceMode||"vs.language.typescript"!==e.pluginId&&!/^typescript\.textMate.*$/.test(e.pluginId)){if(!i.enableTypeScriptServiceModeForJS&&"vs.language.typescript"===e.pluginId){var t=e.contributes.language;if(Array.isArray(t)&&1===t.length){var r=t[0].extensions;if(Array.isArray(r)){var n=r.indexOf(".js");~n&&r.splice(n,1)}var o=t[0].mimetypes;if(Array.isArray(o)){var n=o.indexOf("text/javascript");~n&&o.splice(n,1)}}}var s=this._isInvalidPluginDescription(e);if(s)throw new Error("Invalid plugin description: "+s);if(v.call(this._MonacoPlugins,e.pluginId)&&console.warn("Plugin `"+e.pluginId+"` is already registered"),e.contributes)for(var a in e.contributes)v.call(e.contributes,a)&&this._triggerPointListeners(a,[e]);this._MonacoPlugins[e.pluginId]=e}},t.prototype._getAllPluginDescriptionsByPoint=function(e){var t=[];for(var r in this._MonacoPlugins)if(v.call(this._MonacoPlugins,r)){var n=this._MonacoPlugins[r];n.contributes&&v.call(n.contributes,e)&&t.push(n)}return t},t.prototype.getAllPluginDescriptions=function(){var e=[];for(var t in this._MonacoPlugins)v.call(this._MonacoPlugins,t)&&e.push(this._MonacoPlugins[t]);return e},t.prototype.activateByEvent=function(e){var t=this;return this._onReady.then(function(){var r=t.getAllPluginDescriptions(),n=r.filter(function(r){return v.call(t.activatedPlugins,r.pluginId)?!1:r.activationEvents?r.activationEvents.indexOf(e)>=0:!1});return t._activatePlugins(n)})},t.prototype.activateAndGet=function(e){var t=this;return this._onReady.then(function(){if(!v.call(t._MonacoPlugins,e))throw new Error("Plugin `"+e+"` is not known");return t._activatePlugins([t._MonacoPlugins[e]]).then(function(){return t.get(e)})})},t.prototype._activatePlugins=function(e){for(var t=this,n=Object.create(null),i=Object.create(null),o=0,s=e.length;s>o;o++){var a=e[o],u=!0;if("undefined"!=typeof a.dependencies)for(var c=0,l=a.dependencies.length;l>c;c++){var p=a.dependencies[c];if(!v.call(this._MonacoPlugins,p)){console.error("Unknown dependency `"+p+"` for plugin `"+a.pluginId+"`. Skipping plugin activation."),u=!1;break}n[p]=this._MonacoPlugins[p],i[a.pluginId]=a}u&&(i[a.pluginId]=a)}var d=Object.keys(n).map(function(e){return n[e]}),h=Object.keys(i).map(function(e){return i[e]}),f=function(){return r.TPromise.join(h.map(function(e){return t._activatePlugin(e)}))};return d.length?this._activatePlugins(d).then(f):f()},t.prototype._activatePlugin=function(e){var t=this;return v.call(this.activatedPlugins,e.pluginId)?r.TPromise.as(this.activatedPlugins):v.call(this.activatingPlugins,e.pluginId)?this.activatingPlugins[e.pluginId]:(this.activatingPlugins[e.pluginId]=this._actualActivatePlugin(e).then(function(r){return t.activatedPlugins[e.pluginId]=r,delete t.activatingPlugins[e.pluginId],r},function(t){return console.error("Activating plugin `"+e.pluginId+"` failed: ",t),console.log("Here is the error stack: ",t.stack),{}}).then(function(r){return t.activatedPlugins[e.pluginId]=r,delete t.activatingPlugins[e.pluginId],r}),this.activatingPlugins[e.pluginId])},t._callActivate=function(e,n,i){if(void 0===i&&(i=[]),"function"==typeof e.activate){if(!n)return console.warn("Instantiating a plugin without having the instantiation service"),t.callActivateWithCtx(e,{},i);var o;return n.createInstance(b,function(r){o=t.callActivateWithCtx(e,r,i)}),o}return r.TPromise.as(e)},t.callActivateWithCtx=function(e,t,n){void 0===n&&(n=[]);var i=[t].concat(n);try{return r.TPromise.as(e.activate.apply(y,i))}catch(o){return r.TPromise.wrapError(o)}},t._loadAMDModule=function(t){return new r.TPromise(function(r,n){e([t],function(e){r(e)},n)})},t.prototype._actualActivatePlugin=function(e){var r=this;return t._loadAMDModule(e.mainModule).then(function(n){return n=n||{},t._callActivate(n,r._instantiationService,e.mainModuleExtra)})},t.prototype._isInvalidPluginDescription=function(e){return"string"!=typeof e.pluginId?"Could not find property `pluginId`":"undefined"==typeof e.dependencies||m(e.dependencies)?"undefined"==typeof e.activationEvents||m(e.activationEvents)?"undefined"!=typeof e.mainModule&&"string"!=typeof e.mainModule?"Property `mainModule` is not a string":"undefined"==typeof e.mainModuleExtra||Array.isArray(e.mainModuleExtra)?void 0:"Property `mainModuleExtra` is not an array":"Property `activationEvents` is not a string array":"Property `dependencies` is not a string array"},t.INSTANCE=new t(!0),t}();t.PluginManager=S}),define("vs/platform/configuration/configurationRegistry",["require","exports","vs/nls!vs/editor/worker/editorWorkerServer","vs/platform/platform","vs/base/objects","vs/base/strings","vs/platform/plugins"],function(e,t,r,n,i,o,s){t.Extensions={Configuration:"base.contributions.configuration"};var a=function(){function e(){this.configurationContributors=[]}return e.prototype.registerConfiguration=function(e){this.configurationContributors.push(e)},e.prototype.getConfigurations=function(){return this.configurationContributors.slice(0)},e.prototype.getConfigurationSchemas=function(){var e={id:"local://configuration/user/settings",description:r.localize("vs_platform_configuration_configurationRegistry",0),type:"object",allOf:[]},t={id:"local://configuration/workspace/settings",description:r.localize("vs_platform_configuration_configurationRegistry",1),type:"object",allOf:[]},n={id:"local://configuration/default/settings",description:r.localize("vs_platform_configuration_configurationRegistry",2),$ref:"local://configuration/user/settings"},s=[];return s.push(e),s.push(t),s.push(n),this.configurationContributors.forEach(function(r){var n=i.clone(r);n.id=o.format("local://configuration/{0}/{1}",r.container?r.workspace?"workspace":"user":"internal",r.id),r.container||(r.workspace||e.allOf.push({$ref:n.id}),t.allOf.push({$ref:n.id})),s.push(n)}),s},e}(),u=new a;n.Registry.add(t.Extensions.Configuration,u),s.registerPointListener("configuration",function(e){for(var t=0;t<e.length;t++){var r=e[t].contributes.configuration,n=i.clone(r);n.id=e[t].pluginId,u.registerConfiguration(n)}})});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/platform/files/files",["require","exports","vs/base/assert","vs/base/paths","vs/base/uri","vs/nls!vs/editor/worker/editorWorkerServer","vs/base/bits/encoding","vs/base/types","vs/base/strings","vs/base/arrays","vs/base/env","vs/base/ui/events","vs/base/mime","vs/platform/configuration/configurationRegistry","vs/platform/platform"],function(e,t,r,n,i,o,s,a,u,c,l,p,d,h,f){function g(e){return"undefined"!=typeof e.charset&&"string"!=typeof e.charset?!1:"string"!=typeof e.etag?!1:"string"!=typeof e.mime?!1:"number"!=typeof e.mtime?!1:"string"!=typeof e.name?!1:"string"!=typeof e.path?!1:"string"!=typeof e.value?!1:!0}!function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"}(t.FileChangeType||(t.FileChangeType={}));var m=t.FileChangeType;t.EventType={FILE_CHANGES:"files:fileChanges"};var v=function(e){function t(t){e.call(this),this._changes=t}return __extends(t,e),t.fromRaw=function(e){return e=c.distinct(e,function(e){return e.type+e.resource}),new t(e.map(function(e){return{type:e.type,resource:i.parse(e.resource),workspacePath:e.path?n.makeAbsolute(n.normalize(e.path),!0):void 0}}))},Object.defineProperty(t.prototype,"changes",{get:function(){return this._changes},enumerable:!0,configurable:!0}),t.prototype.filterWorkspacePath=function(e){return new t(this._changes.filter(function(t){if(!t.workspacePath)return!1;var r=t.workspacePath.split(/\//);return r.shift(),e(t,r)}))},t.prototype.contains=function(e,t){return e?this.containsAny([e],t):!1},t.prototype.containsAny=function(e,t){return e&&e.length?this._changes.some(function(r){return r.type!==t?!1:t===m.DELETED?e.some(function(e){return e?n.isEqualOrParent(e.fsPath,r.resource.fsPath):!1}):e.some(function(e){return e?e.fsPath===r.resource.fsPath:!1})}):!1},t.prototype.getAdded=function(){return this.getOfType(m.ADDED)},t.prototype.gotAdded=function(){return this.hasType(m.ADDED)},t.prototype.getDeleted=function(){return this.getOfType(m.DELETED)},t.prototype.gotDeleted=function(){return this.hasType(m.DELETED)},t.prototype.getUpdated=function(){return this.getOfType(m.UPDATED)},t.prototype.gotUpdated=function(){return this.hasType(m.UPDATED)},t.prototype.getOfType=function(e){return this._changes.filter(function(t){return t.type===e})},t.prototype.hasType=function(e){return this._changes.some(function(t){return t.type===e})},t}(p.Event);t.FileChangesEvent=v,t.isIContent=g;var _=function(){function e(e,t,r,i,o,s,a,u){this.resource=e,this.path=t&&n.makeAbsolute(n.normalize(t)),this.value=r,this.name=i,this.etag=u,this.mime=s,this.charset=a,this.mtime="number"==typeof o?o:"string"==typeof o?new Date(o).getTime():-1,this.mime&&this.mime.indexOf("; charset")>=0&&(this.mime=this.mime.substring(0,this.mime.indexOf(";")))}return e}();t.Content=_,function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ANY=2]="ANY"}(t.StatType||(t.StatType={}));var y=t.StatType,b=function(){function e(e,t,o,s,u,c,l){r.ok(!s||o,"Only a directory can have children"),this.resource="string"==typeof e?i.parse(e):e,this.path=n.makeAbsolute(n.normalize(t)),a.isString(u)?this.name=u:this.path&&(this.name=n.basename(this.path)),this.isDirectory=!!o,this.hasChildren=o&&s,this.mime=o?void 0:d.guessMimeTypes(this.path).join(", "),this.isDirectoryResolved=!1,this.etag=l,this.mtime=c,this.isDirectory&&(this.children=[])}return e.fromRAW=function(t,r,i){var o=new e(t.resource,t.path,t.isDirectory,t.hasChildren,t.name,t.mtime,t.etag);if(r&&r instanceof e?r.addChild(o):a.isString(r)&&(o.path=n.makeAbsolute(n.normalize(r))),o.isDirectory&&(o.children=[],o.isDirectoryResolved=!!t.children||!!i&&i.some(function(e){return n.isEqualOrParent(e,o.path)}),t.children))for(var s=0,u=t.children.length;u>s;s++)e.fromRAW(t.children[s],o,i);return o},e.prototype.clone=function(){var t=new e(i.parse(this.resource.toString()),this.path,this.isDirectory,this.hasChildren,this.name,this.mtime,this.etag);return t.isDirectoryResolved=this.isDirectoryResolved,this.parent&&(t.parent=this.parent),this.isDirectory&&this.children.forEach(function(e){t.addChild(e.clone())}),t},e.prototype.addChild=function(e){r.ok(this.isDirectory,"Can only add a child to a folder"),this.removeChild(e),e.parent=this,e.updatePath(!1),this.children.push(e),this.hasChildren=this.children.length>0},e.prototype.hasChild=function(e,t,n){void 0===n&&(n=y.ANY),r.ok(this.isDirectory,"Can only call hasChild on a directory"),r.ok(a.isString(e),"Expected parameter of type String");for(var i=0;i<this.children.length;i++){var o=this.children[i];if(!(n===y.FILE&&o.isDirectory||n===y.FOLDER&&!o.isDirectory)){if(o.name===e)return!0;if(t&&o.name.toLowerCase()===e.toLowerCase())return!0}}return!1},e.prototype.removeChild=function(e){r.ok(this.isDirectory,"Can only remove a child from a directory"),r.ok(!!this.children,"Expected children for directory but found none: "+this.path);for(var t=0;t<this.children.length;t++)if(this.children[t].path===e.path){this.children.splice(t,1);break}this.hasChildren=this.children.length>0},e.prototype.move=function(e,t,n){var i=this;r.ok(e.isDirectory,"Can only move an element into a directory"),r.ok(!this.isRoot(),"Can not move the root"),t||(t=function(e){e()}),this.parent.removeChild(this),t(function(){e.addChild(i),i.updatePath(!0),n&&n()})},e.prototype.updatePath=function(e){this.resource=i.file(n.join(this.parent.resource.fsPath,this.name)),this.path=n.join(this.parent.path,this.name),e&&this.isDirectory&&this.hasChildren&&this.children&&this.children.forEach(function(e){e.updatePath(!0)})},e.prototype.rename=function(e){r.ok(!this.isRoot(),"Can not rename root"),this.name=e.name,this.mime=e.mime,this.mtime=e.mtime,this.updatePath(!0)},e.prototype.find=function(e){return r.ok(a.isString(e),"Expected String as parameter"),r.ok(this.isDirectory,"Can only find() in directories"),r.ok(this.isRoot(),"Can only find() from root"),this.doFind(e)},e.prototype.doFind=function(e){if(e===n.sep&&this.isRoot())return this;if(!this.hasChildren)return null;e=u.trim(e,n.sep);var t=e.split(n.sep);if(t.length>0)for(var r=0;r<this.children.length;r++)if(this.children[r].name===t[0])return 1===t.length?this.children[r]:this.children[r].doFind(e.substr(e.indexOf(n.sep)));return null},e.prototype.isRoot=function(){return this.path===n.sep},e.prototype.isAncestorOf=function(e){return this.isDirectory&&n.isEqualOrParent(e.path,this.path)},e.prototype.isParentOf=function(e){if(!this.isAncestorOf(e))return!1;var t=this.isRoot()?u.empty:this.path;return 2===e.path.substring(t.length).split(n.sep).length},e.prototype.equals=function(t){return t&&t instanceof e&&t.path===this.path},e}();t.FileStatImpl=b,function(e){e[e.FILE_IS_BINARY=0]="FILE_IS_BINARY",e[e.FILE_IS_DIRECTORY=1]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=2]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=3]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=4]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=5]="FILE_MOVE_CONFLICT",e[e.FILE_READ_ONLY=6]="FILE_READ_ONLY",e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE"}(t.FileOperationResult||(t.FileOperationResult={}));t.FileOperationResult;if(l.isNative){var S=f.Registry.as(h.Extensions.Configuration),k={id:"files",order:6,title:o.localize("vs_platform_files_files",0),type:"object",properties:{"files.exclude":{id:"glob-pattern",type:"object",description:o.localize("vs_platform_files_files",1),default:{"**/.git":!0,"**/.DS_Store":!0},additionalProperties:{anyOf:[{type:"boolean",description:o.localize("vs_platform_files_files",2)},{type:"object",properties:{when:{type:"string",pattern:"\\w*\\$\\(basename\\)\\w*",default:"$(basename).ext",description:o.localize("vs_platform_files_files",3)}}}]}},"files.encoding":{type:"string",enum:Object.keys(s.SUPPORTED_ENCODINGS),default:"utf8",description:o.localize("vs_platform_files_files",4)},"files.trimTrailingWhitespace":{type:"boolean",default:!1,description:o.localize("vs_platform_files_files",5)}}};S.registerConfiguration(k)}});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/platform/services",["require","exports","vs/base/lib/winjs.base","vs/base/async","vs/base/env","vs/base/strings","vs/base/network","vs/base/uri","vs/base/paths","vs/base/performance/timer","vs/base/objects","vs/base/hash","vs/base/errors","vs/base/worker/marshalling","vs/base/http","vs/base/ui/events","vs/platform/files/files"],function(e,t,r,n,i,o,s,a,u,c,l,p,d,h,f,g,m){var v=function(){function e(e){this._staticArguments=e}return e.prototype.appendStaticArguments=function(e){this._staticArguments.push.apply(this._staticArguments,e)},e.prototype.staticArguments=function(e){return isNaN(e)?this._staticArguments.slice(0):this._staticArguments[e]},e.prototype._validate=function(e){if(!e)throw d.illegalArgument("can not be falsy")},e}();t.AbstractDescriptor=v;var _=function(e){function t(t){for(var r=[],n=1;n<arguments.length;n++)r[n-1]=arguments[n];e.call(this,r),this._ctor=t}return __extends(t,e),Object.defineProperty(t.prototype,"ctor",{get:function(){return this._ctor},enumerable:!0,configurable:!0}),t.prototype.equals=function(e){return e===this?!0:e instanceof t?e.ctor===this.ctor:!1},t.prototype.hashCode=function(){return 61*(1+this.ctor.length)},t}(v);t.SyncDescriptor=_,h.registerMarshallingContribution({canSerialize:function(e){return e instanceof y},serialize:function(e,t){return{$isAsyncDescriptor:!0,$moduleName:e.moduleName,$ctorName:e.ctorName,$staticArguments:t(e.staticArguments())}},canDeserialize:function(e){return e.$isAsyncDescriptor},deserialize:function(e,t){var r=new y(e.$moduleName,e.$ctorName);return r.appendStaticArguments(t(e.$staticArguments)),r}});var y=function(t){function r(e,r){for(var n=[],i=2;i<arguments.length;i++)n[i-2]=arguments[i];t.call(this,n),this._moduleName=e,this._ctorName=r}return __extends(r,t),r.create=function(e,t){return new r(e,t)},Object.defineProperty(r.prototype,"moduleName",{get:function(){return this._moduleName},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"ctorName",{get:function(){return this._ctorName},enumerable:!0,configurable:!0}),r.prototype.equals=function(e){return e===this?!0:e instanceof r?e.moduleName===this.moduleName&&e.ctorName===this.ctorName:!1},r.prototype.hashCode=function(){return p.computeMurmur2StringHashCode(this.moduleName)*p.computeMurmur2StringHashCode(this.ctorName)},r.prototype.toSyncDescriptor=function(){var t;try{t=e(this.moduleName)}catch(r){return null}var n=t[this.ctorName],i=new _(n);return i.appendStaticArguments(this.staticArguments()),i},r}(v);t.AsyncDescriptor=y,function(e){e[e.None=0]="None",e[e.Group1=1]="Group1",e[e.Group2=2]="Group2",e[e.Group3=3]="Group3",e[e.Group4=4]="Group4",e[e.Group5=5]="Group5",e[e.Group6=6]="Group6",e[e.Group7=7]="Group7",e[e.Group8=8]="Group8",e[e.Group9=9]="Group9",e[e.All=10]="All"}(t.ThreadAffinity||(t.ThreadAffinity={}));var b=(t.ThreadAffinity,function(){function e(e,t,r){void 0===r&&(r={}),this.workspace=e,this.configuration=t,this.options=r}return e.prototype.getWorkspace=function(){return this.workspace},e.prototype.getConfiguration=function(){return this.configuration},e.prototype.getOptions=function(){return this.options},e.prototype.toWorkspaceRelativePath=function(e){if(e&&this.workspace){var t=this.workspace.resource.fsPath;if(u.isEqualOrParent(e.fsPath,t))return u.makeAbsolute(u.normalize(e.fsPath.substr(t.length)))}return null},e.prototype.toResource=function(e){return"string"==typeof e&&this.workspace?a.file(u.join(this.workspace.resource.fsPath,e)):null},e}());t.BaseWorkspaceContextService=b;var S=function(){function e(e,t,r){var n=null;if(e&&e.contextService){var s=e.contextService,a=s.getWorkspace();this._serviceMap=a||Object.create(null),this._telemetryService=e.telemetryService;var u=s.getConfiguration();u&&(this._additionalHeaders=u.additionalHeaders),a&&(n=o.rtrim(a.resource.toString(),"/")+"/",!i.isNative&&a.publicUrl&&(n=a.publicUrl))}else this._serviceMap=e,this._additionalHeaders=t,this._telemetryService=r;this.computeOrigin(n)}return e.prototype.computeOrigin=function(e){if(e){this._origin=e;var t=new s.URL(this._origin).getPath();t&&t.length>0&&(this._origin=this._origin.substring(0,this._origin.length-t.length+1)),o.endsWith(this._origin,"/")||(this._origin+="/")}else this._origin="/"},e.prototype.getRequestUrl=function(e,t,r){if(this._serviceMap[e]){var n=this._serviceMap[e]+o.normalizePath(t),i=new s.URL(n);return i.getScheme()?n:r?this._origin+o.ltrim(n,"/"):n}return null},e.prototype.getPath=function(e,t){var r=this.getRequestUrl(e,"/",!0);if(!r)return null;var n=t.toString().indexOf(r);return 0===n?t.toString().substr(r.length-1):null},e.prototype.getAdditionalHeaders=function(){return this._additionalHeaders||{}},e.prototype.supportsPrivateChannel=function(){return!1},e.prototype.establishPrivateChannel=function(){return r.Promise.wrapError("Not Implemented")},e.prototype.supportsRemoteEvents=function(){return!1},e.prototype.addRemoteListener=function(){throw new Error("Not Implemented")},e.prototype.makeCrossOriginRequest=function(e){var t=this.getRequestUrl("http");if(t){var r=o.format("{0}?url={1}",t,encodeURIComponent(e.url));return e.url=r,this.makeRequest(e)}return null},e.prototype.makeRequest=function(e){var t=c.nullEvent,i=!1,s=e.url;if(!s)throw new Error("IRequestService.makeRequest: Url is required");if((o.startsWith(s,"http://")||o.startsWith(s,"https://"))&&this._origin&&!o.startsWith(s,this._origin)){var a=this.makeCrossOriginRequest(e);if(a)return a;i=!0}var u=e;if(!i){var p=this.getAdditionalHeaders();this._telemetryService&&(p["X-TelemetrySession"]=this._telemetryService.sessionID),p["X-Requested-With"]="XMLHttpRequest",u.headers=l.mixin(u.headers,p)}return e.timeout&&(u.customRequestInitializer=function(t){t.timeout=e.timeout}),this._telemetryService&&(t=this._telemetryService.start(i?"CorsXHR":"WorkbenchXHR",{url:s},!1)),n.always(r.xhr(u),function(e){t.data&&(t.data.status=e.status),t.stop()})},e.prototype.makeChunkedRequest=function(e){var t,n,i,o=this,s=0,a=!1;return new r.TPromise(function(r,a,u){t=r,n=a,i=u,o.makeRequest(e).done(function(e){var r={request:e,chunks:[]};s=f.parseChunkedData(e,r.chunks,s),t(r)},function(e){n(e)},function(){})},function(){a=!0})},e.prototype.reconnect=function(){},e}();t.BaseRequestService=S;var k=function(){function e(){}return e.CONNECTION_STATE_CHANGE="connectionStateChanged",e.CONNECTION_RECONNECTED="connectionReconnected",e}();t.RequstServiceEventTypes=k,function(e){e[e.CONNECTED=0]="CONNECTED",e[e.DISCONNECTED=1]="DISCONNECTED",e[e.SESSION_OVER=2]="SESSION_OVER",e[e.OUTDATED_CLIENT=3]="OUTDATED_CLIENT"}(t.ConnectionState||(t.ConnectionState={}));t.ConnectionState;!function(e){e[e.GLOBAL=0]="GLOBAL",e[e.WORKSPACE=1]="WORKSPACE"}(t.StorageScope||(t.StorageScope={}));t.StorageScope;t.StorageEventType={STORAGE:"storage"};var C=function(e){function t(t,r,n,i){e.call(this,t,r,n,i)}return __extends(t,e),t.prototype.isLocal=function(){return!this.originalEvent},t}(g.PropertyChangeEvent);t.StorageEvent=C,function(e){e[e.LEFT=0]="LEFT",e[e.CENTER=1]="CENTER",e[e.RIGHT=2]="RIGHT"}(t.Position||(t.Position={}));var T=t.Position;t.POSITIONS=[T.LEFT,T.CENTER,T.RIGHT];var E=function(){function e(e){this._selection=e||[]}return Object.defineProperty(e.prototype,"selection",{get:function(){return this._selection},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return 0===this._selection.length},e.EMPTY=new e([]),e}();t.Selection=E;var w=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.toArray=function(){return this.selection},t}(E);t.StructuredSelection=w,function(e){e[e["transient"]=1]="transient",e[e.permanent=2]="permanent"}(t.MarkerType||(t.MarkerType={}));var x=(t.MarkerType,function(){function e(){}return e.UPDATED="update",e}());t.ConfigurationServiceEventTypes=x,t.ResourceEvents={ADDED:"resource.added",REMOVED:"resource.removed",CHANGED:"resource.changed"};var M;!function(e){!function(e){e[e.File=1]="File",e[e.Text=2]="Text"}(e.QueryType||(e.QueryType={}));var t=(e.QueryType,function(){function e(){}return e.prototype.search=function(){return r.TPromise.as({results:[]})},e.Instance=new e,e}());e.NullSearchService=t}(M=t.Search||(t.Search={})),t.Files=m});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);
r.prototype=t.prototype,e.prototype=new r};define("vs/base/uuid",["require","exports"],function(e,t){function r(e,t){return"function"==typeof e[t]&&0===e[t].length}function n(e){return e instanceof a||e instanceof u||r(e,"asHex",0)&&r(e,"equals",1)}function i(){return new u}function o(e){if(!c.test(e))throw new Error("invalid uuid");return new a(e)}function s(){return i().asHex()}t.isUUID=n;var a=function(){function e(e){this._value=e}return e.prototype.asHex=function(){return this._value},e.prototype.equals=function(e){return this.asHex()===e.asHex()},e}(),u=function(e){function t(){e.call(this,[t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),"-",t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),"-","4",t._randomHex(),t._randomHex(),t._randomHex(),"-",t._oneOf(t._timeHighBits),t._randomHex(),t._randomHex(),t._randomHex(),"-",t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex()].join(""))}return __extends(t,e),t._oneOf=function(e){var t=Math.floor(e.length*Math.random());return e[t]},t._randomHex=function(){return t._oneOf(t._chars)},t._chars=["0","1","2","3","4","5","6","6","7","8","9","a","b","c","d","e","f"],t._timeHighBits=["8","9","a","b"],t}(a);t.empty=new a("00000000-0000-0000-0000-000000000000"),t.v4=i;var c=/^[0-9A-Fa-f]{8}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{4}-[0-9A-Fa-f]{12}$/;t.parse=o,t.generateUuid=s}),define("vs/platform/telemetry/abstractTelemetryService",["require","exports","vs/base/uuid","vs/base/performance/timer","vs/base/errors","vs/base/types","vs/base/objects","vs/platform/platform","vs/base/env","vs/base/hash"],function(e,t,r,n,i,o,s,a,u,c){var l={enableTelemetry:!0,publicOnly:!0,enableHardIdel:!0,enableSoftIdle:!0},p=function(){function e(e,t){var o=this;if(void 0===e&&(e=null),this.contextService=e,this.config=s.withDefaults(t,l),this.sessionID=this.config.sessionID||r.generateUuid()+Date.now(),this.timeKeeper=new n.TimeKeeper,this.toUnbind=[],this.appenders=[],this.timeKeeperListener=function(e){return o.onTelemetryTimerEventStop(e)},this.timeKeeper.addListener(this.timeKeeperListener),this.toUnbind.push(i.errorHandler.addListener(this.onErrorEvent.bind(this))),this.startTime=new Date,this.eventCount=0,this.enableGlobalErrorHandler(),this.contextService&&this.contextService.getConfiguration()&&this.contextService.getConfiguration().profile){var a=this.contextService.getConfiguration().profile.userEmail;a&&(this.userIdHash=c.computeMurmur2StringHashCode(a).toString())}}return e.prototype.loadTelemetryAppendersFromRegistery=function(){for(var e=a.Registry.as(t.Extenstions.TelemetryAppenders).getTelemetryAppenderDescriptors(),r=0;r<e.length;r++){var n=e[r],i=this.instantiationService.createInstance(n);this.appenders.push(i)}},e.prototype._safeStringify=function(e){return s.safeStringify(e)},e.prototype.onTelemetryTimerEventStop=function(e){for(var t=0;t<e.length;t++){var r=e[t],n=r.data||{};n.duration=r.timeTaken(),"public"===r.topic?this.publicLog(r.name,n):this.log(r.name,n)}},e.prototype.onErrorEvent=function(e){Array.isArray(e.stack)&&(e.stack=e.stack.join("\n")),e.detail&&e.detail.stack&&(e=e.detail),e.stack&&(e.message||(e.message=this._safeStringify(e)),e.message=this.cleanupInfo(e.message),e.stack=this.cleanupInfo(e.stack),this.publicLog("UnhandledError",e))},e.prototype.cleanupInfo=function(e){var t=/file:\/\/\/.*?\/resources\/app\//gi;return e=e.replace(t,""),t=/file:\/\/\/.*/gi,e=e.replace(t,""),t=/ENOENT: no such file or directory.*?\'([^\']+)\'/gi,e=e.replace(t,"ENOENT: no such file or directory")},e.prototype.enableGlobalErrorHandler=function(){o.isFunction(self.onerror)&&(this.oldOnError=self.onerror);var e=this,t=function(t,r,n,i,o){e.onUncaughtError(t,r,n,i,o),e.oldOnError&&e.oldOnError.apply(this,arguments)};self.onerror=t},e.prototype.onUncaughtError=function(t,r,n,i,s){if(!o.isString(t)||!e.FILTERS.some(function(e){return t.indexOf(e)>=0})){r=this.cleanupInfo(r),t=this.cleanupInfo(t);var a={message:t,filename:r,line:n,column:i};s&&(a.error={name:s.name,message:s.message},s.stack&&(Array.isArray(s.stack)&&(s.stack=s.stack.join("\n")),a.stack=this.cleanupInfo(s.stack))),this.publicLog("UncaughtError",a)}},e.prototype.handleEvent=function(e,t,r){if(this.config.enableTelemetry){this.eventCount++,r=this.addCommonProperties(r);for(var n=0;n<this.appenders.length;n++)this.appenders[n].log(e,t,r)}},e.prototype.addCommonProperties=function(e){e=e||{};var t=new Date;return e.sessionID=this.sessionID,e.timestamp=t,e.version=u.version,e.userId=this.userIdHash,e.commitHash=u.commitHash,e["common.platform"]=u.Platform[u.platform],e["common.timesincesessionstart"]=t.getTime()-this.startTime.getTime(),e["common.sequence"]=this.eventCount,e},e.prototype.dispose=function(){for(;this.toUnbind.length;)this.toUnbind.pop()();this.timeKeeper.removeListener(this.timeKeeperListener),this.timeKeeper.dispose(),this.oldOnError&&(self.onerror=this.oldOnError);for(var e=0;e<this.appenders.length;e++)this.appenders[e].dispose()},e.prototype.setInstantiationService=function(e){this.instantiationService=e,this.instantiationService&&this.loadTelemetryAppendersFromRegistery()},e.prototype.start=function(e,t,r){var n=r?"public":"private",i=this.timeKeeper.start(n,e);return t&&(i.data=t),i},e.prototype.log=function(e,t){this.config.publicOnly||this.handleEvent(e,!1,t)},e.prototype.publicLog=function(e,t){this.handleEvent(e,!0,t)},e.prototype.getAppendersCount=function(){return this.appenders.length},e.prototype.getAppenders=function(){return this.appenders},e.prototype.addTelemetryAppender=function(e){this.appenders.push(e)},e.prototype.removeTelemetryAppender=function(e){var t=this.appenders.indexOf(e);t>-1&&this.appenders.splice(t,1)},e.FILTERS=["NPObject"],e}();t.AbstractTelemetryService=p,t.Extenstions={TelemetryAppenders:"telemetry.appenders"};var d=function(){function e(){this.telemetryAppenderDescriptors=[]}return e.prototype.registerTelemetryAppenderDescriptor=function(e){this.telemetryAppenderDescriptors.push(e)},e.prototype.getTelemetryAppenderDescriptors=function(){return this.telemetryAppenderDescriptors},e}();a.Registry.add(t.Extenstions.TelemetryAppenders,new d)});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/platform/telemetry/workerTelemetryService",["require","exports","vs/platform/telemetry/abstractTelemetryService"],function(e,t,r){var n=function(e){function t(t,r){void 0===t&&(t=null),r=r||{},r.enableHardIdle=!1,r.enableSoftIdle=!1,e.call(this,t,r)}return __extends(t,e),t}(r.AbstractTelemetryService);t.WorkerTelemetryService=n;var i=function(){function e(e){this.workerPublisher=e}return e.prototype.log=function(e,t,r){var r=r||{};r.workerTelemetry=!0,this.workerPublisher&&this.workerPublisher.sendMessage("telemetryService",{eventName:e,isPublic:t,data:r})},e.prototype.dispose=function(){this.workerPublisher=null},e}();t.WorkerTelemetryAppender=i}),define("vs/base/eventEmitter",["require","exports","vs/base/errors"],function(e,t,r){var n=function(){function e(e,t,r){void 0===r&&(r=null),this._type=e,this._data=t,this._emitterType=r}return e.prototype.getType=function(){return this._type},e.prototype.getData=function(){return this._data},e.prototype.getEmitterType=function(){return this._emitterType},e}();t.EmitterEvent=n;var i=function(){function e(e){if(void 0===e&&(e=null),this._listeners={},this._bulkListeners=[],this._collectedEvents=[],this._deferredCnt=0,e){this._allowedEventTypes={};for(var t=0;t<e.length;t++)this._allowedEventTypes[e[t]]=!0}else this._allowedEventTypes=null}return e.prototype.dispose=function(){this._listeners={},this._bulkListeners=[],this._collectedEvents=[],this._deferredCnt=0,this._allowedEventTypes=null},e.prototype.addListener=function(e,t){if("*"===e)throw new Error("Use addBulkListener(listener) to register your listener!");if(this._allowedEventTypes&&!this._allowedEventTypes.hasOwnProperty(e))throw new Error("This object will never emit this event type!");this._listeners.hasOwnProperty(e)?this._listeners[e].push(t):this._listeners[e]=[t];var r=this;return function(){r&&(r._removeListener(e,t),r=null,t=null)}},e.prototype.addListener2=function(e,t){var r=this.addListener(e,t);return{dispose:r}},e.prototype.on=function(e,t){return this.addListener(e,t)},e.prototype.addOneTimeListener=function(e,t){var r=this.addListener(e,function(e){r(),t(e)});return r},e.prototype.addOneTimeDisposableListener=function(e,t){var r=this.addOneTimeListener(e,t);return{dispose:r}},e.prototype.addBulkListener=function(e){var t=this;return this._bulkListeners.push(e),function(){t._removeBulkListener(e)}},e.prototype.addBulkListener2=function(e){var t=this.addBulkListener(e);return{dispose:t}},e.prototype.addEmitter=function(e,t){var r=this;return void 0===t&&(t=null),e.addBulkListener(function(e){var i=e;if(t){i=[];for(var o=0,s=e.length;s>o;o++)i.push(new n(e[o].getType(),e[o].getData(),t))}0===r._deferredCnt?r._emitEvents(i):r._collectedEvents.push.apply(r._collectedEvents,i)})},e.prototype.addEmitter2=function(e,t){var r=this.addEmitter(e,t);return{dispose:r}},e.prototype.addEmitterTypeListener=function(e,t,r){if(t){if("*"===e)throw new Error("Bulk listeners cannot specify an emitter type");return this.addListener(e+"/"+t,r)}return this.addListener(e,r)},e.prototype._removeListener=function(e,t){if(this._listeners.hasOwnProperty(e))for(var r=this._listeners[e],n=0,i=r.length;i>n;n++)if(r[n]===t){r.splice(n,1);break}},e.prototype._removeBulkListener=function(e){for(var t=0,r=this._bulkListeners.length;r>t;t++)if(this._bulkListeners[t]===e){this._bulkListeners.splice(t,1);break}},e.prototype._emitToSpecificTypeListeners=function(e,t){if(this._listeners.hasOwnProperty(e))for(var n=this._listeners[e].slice(0),i=0,o=n.length;o>i;i++)try{n[i](t)}catch(s){r.onUnexpectedError(s)}},e.prototype._emitToBulkListeners=function(e){for(var t=this._bulkListeners.slice(0),n=0,i=t.length;i>n;n++)try{t[n](e)}catch(o){r.onUnexpectedError(o)}},e.prototype._emitEvents=function(e){this._bulkListeners.length>0&&this._emitToBulkListeners(e);for(var t=0,r=e.length;r>t;t++){var n=e[t];this._emitToSpecificTypeListeners(n.getType(),n.getData()),n.getEmitterType()&&this._emitToSpecificTypeListeners(n.getType()+"/"+n.getEmitterType(),n.getData())}},e.prototype.emit=function(e,t){if(void 0===t&&(t={}),this._allowedEventTypes&&!this._allowedEventTypes.hasOwnProperty(e))throw new Error("Cannot emit this event type because it wasn't white-listed!");if(this._listeners.hasOwnProperty(e)||0!==this._bulkListeners.length){var r=new n(e,t);0===this._deferredCnt?this._emitEvents([r]):this._collectedEvents.push(r)}},e.prototype.deferredEmit=function(e){this._deferredCnt=this._deferredCnt+1;var t=null;try{t=e()}catch(n){r.onUnexpectedError(n)}return this._deferredCnt=this._deferredCnt-1,0===this._deferredCnt&&this._emitCollected(),t},e.prototype._emitCollected=function(){var e=this._collectedEvents;this._collectedEvents=[],e.length>0&&this._emitEvents(e)},e}();t.EventEmitter=i});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/worker/resourceService",["require","exports","vs/base/eventEmitter","vs/base/types","vs/platform/services"],function(e,t,r,n,i){var o=function(e){function t(){e.call(this),this.data={},this.linked={},this.unbinds={}}return __extends(t,e),t.prototype.insert=function(e,t){var r=this,n=this.remove(e,t),o=e.toString();return this.data[o]=t,this.unbinds[o]=[],this.unbinds[o].push(t.addBulkListener(function(t){r.emit(i.ResourceEvents.CHANGED,{url:e,originalEvents:t})})),this.emit(i.ResourceEvents.ADDED,{url:e,addedElement:t,removedElement:n}),n},t.prototype.get=function(e){return this.data[e.toString()]?this.data[e.toString()]:null},t.prototype.all=function(){var e=this;return Object.keys(this.data).map(function(t){return e.data[t]})},t.prototype.contains=function(e){return!!this.data[e.toString()]},t.prototype.remove=function(e,t){if(!this.contains(e))return!1;for(var r=e.toString(),o=this.data[r];this.unbinds[r].length>0;)this.unbinds[r].pop()();for(var s in this.linked[r])if(this.linked.hasOwnProperty(s)){var a=this.linked[r][s];n.isFunction(a.onRemove)&&a.onRemove()}return delete this.unbinds[r],delete this.linked[r],delete this.data[r],this.emit(i.ResourceEvents.REMOVED,{url:e,removedElement:o,addedElement:t}),!0},t}(r.EventEmitter);t.ResourceService=o}),define("vs/editor/worker/dispatcherService",["require","exports","vs/base/lib/winjs.base","vs/base/types"],function(e,t,r,n){var i=function(){function e(){this.table={}}return e.prototype.register=function(e){if(n.isString(e))this.table[e]=arguments[1];else for(var t in e){var r=e[t];n.isFunction(r)&&(this.table[t]=r.bind(e))}},e.prototype.dispatch=function(e){if(!this.table[e.type])return r.Promise.wrapError(new Error("no handler/route for: "+e.type));try{var t=e.payload,n=this.table[e.type].apply(this.table[e.type],t);return r.Promise.is(n)?n:r.Promise.as(n)}catch(i){return r.Promise.wrapError(i)}},e}();t.DispatcherService=i}),define("vs/base/collections",["require","exports"],function(e,t){function r(){return Object.create(null)}function n(){return Object.create(null)}function i(e,t,r){void 0===r&&(r=null);var n=String(t);return a(e,n)?e[n]:r}function o(e,t,r){var n=String(t);return a(e,n)?e[n]:("function"==typeof r&&(r=r()),e[n]=r,r)}function s(e,t,r){e[r(t)]=t}function a(e,t){return m.call(e,t)}function u(e){return{every:function(t){for(var r in e)if(m.call(e,r)&&!t(r))return!1;return!0}}}function c(e){var t=[];for(var r in e)m.call(e,r)&&t.push(e[r]);return t}function l(e,t){for(var r in e)if(m.call(e,r)){var n=t({key:r,value:e[r]},function(){delete e[r]});if(n===!1)return}}function p(e,t){return m.call(e,t)?(delete e[t],!0):!1}function d(e,t){var n=r();return e.forEach(function(e){return o(n,t(e),[]).push(e)}),n}function h(e){var r=e.length;return 0===r?t.EmptyIterable:1===r?e[0]:{every:function(t){for(var n=0;r>n;n++)if(!e[n].every(t))return!1;return!0}}}function f(e){return{every:function(t){return t(e)}}}function g(e){if(Array.isArray(e))return e;var t=[];return e.every(function(e){return t.push(e),!0}),t}t.createStringDictionary=r,t.createNumberDictionary=n,t.lookup=i,t.lookupOrInsert=o,t.insert=s;var m=Object.prototype.hasOwnProperty;t.contains=a,t.keys=u,t.values=c,t.forEach=l,t.remove=p,t.groupBy=d,t.EmptyIterable={every:function(){return!0}},t.combine=h,t.singleton=f,t.toArray=g;var v=function(){function e(e){this.size=e,this.cache=Object.create(null),this.order=[]}return e.prototype.get=function(e){var t=this.cache[e];return t&&t.element},e.prototype.put=function(e,t,r){var n=this.cache[e],i={element:t,onRemove:r};this.cache[e]=i,n||this.order.push(e),this.swipe()},e.prototype.swipe=function(){for(;this.order.length>this.size;){var e=this.order.shift(),t=this.cache[e];t.onRemove(),delete this.cache[e]}},e}();t.LimitedSizeCache=v}),define("vs/platform/thread/attribute",["require","exports","vs/base/lib/winjs.base","vs/platform/services"],function(e,t,r,n){function i(e,t){for(var r in e)if(e[r]===t)return r;throw new Error("Member not found in prototype")}function o(e){var r=e[t.THREAD_SERVICE_PROPERTY_NAME];if(!r)throw new Error("Objects that use thread attributes must be instantiated with the thread service");return r}function s(e,t){var r=i(e.prototype,t);e.prototype[r]=function(){for(var e=[],n=0;n<arguments.length;n++)e[n-0]=arguments[n];return o(this).MainThread(this,r,t,e)}}function a(e,t,s,a){void 0===a&&(a=n.ThreadAffinity.None);var u,c=i(e.prototype,t);"function"==typeof s?u=s:"undefined"!=typeof s&&(a=s),e.prototype[c]=function(){for(var e=[],n=0;n<arguments.length;n++)e[n-0]=arguments[n];if(u){var i=this,s=u.call(i);return r.Promise.is(s)||(s=r.Promise.as(s)),s.then(function(){return o(i).OneWorker(i,c,t,e,a)})}return o(this).OneWorker(this,c,t,e,a)}}function u(e,t){var r=i(e.prototype,t);e.prototype[r]=function(){for(var e=[],n=0;n<arguments.length;n++)e[n-0]=arguments[n];return o(this).AllWorkers(this,r,t,e)}}function c(e,t){var r=i(e.prototype,t);e.prototype[r]=function(){for(var e=[],n=0;n<arguments.length;n++)e[n-0]=arguments[n];return o(this).Everywhere(this,r,t,e)}}t.THREAD_SERVICE_PROPERTY_NAME="__$$__threadService",t.MainThread=s,t.OneWorker=a,t.AllWorkers=u,t.Everywhere=c}),define("vs/base/callbackList",["require","exports"],function(){var e=function(){function e(){}return e.prototype.add=function(e,t,r){var n=this;void 0===t&&(t=null),this._callbacks||(this._callbacks=[],this._contexts=[]),this._callbacks.push(e),this._contexts.push(t),Array.isArray(r)&&r.push({dispose:function(){return n.remove(e,t)}})},e.prototype.remove=function(e,t){if(void 0===t&&(t=null),this._callbacks){for(var r=!1,n=0,i=this._callbacks.length;i>n;n++)if(this._callbacks[n]===e){if(this._contexts[n]===t)return this._callbacks.splice(n,1),this._contexts.splice(n,1),void 0;r=!0}if(r)throw new Error("When adding a listener with a context, you should remove it with the same context")}},e.prototype.invoke=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];if(this._callbacks){for(var r=[],n=this._callbacks.slice(0),i=this._contexts.slice(0),o=0,s=n.length;s>o;o++)r.push(n[o].apply(i[o],e));return r}},e}();return e}),define("vs/base/eventSource",["require","exports","vs/base/callbackList"],function(e,t,r){var n=function(){function e(){}return e.prototype.fire=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return this._value?this._value.invoke.apply(this._value,e):void 0},Object.defineProperty(e.prototype,"value",{get:function(){var e=this;return this._value||(this._value=new r),{add:function(t,r,n){e._value.add(t,r,n)},remove:this._value.remove.bind(this._value)}},enumerable:!0,configurable:!0}),e}();return n}),define("vs/base/severity",["require","exports","vs/nls!vs/editor/worker/editorWorkerServer","vs/base/strings"],function(e,t,r,n){var i;!function(e){e[e.Ignore=0]="Ignore",e[e.Info=1]="Info",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(i||(i={}));var i;return function(e){function t(t){return t?n.equalsIgnoreCase(s,t)?e.Error:n.equalsIgnoreCase(a,t)||n.equalsIgnoreCase(u,t)?e.Warning:n.equalsIgnoreCase(c,t)?e.Info:e.Ignore:e.Ignore}function i(e){return l[e]||n.empty}function o(e,t){return t-e}var s="error",a="warning",u="warn",c="info",l=Object.create(null);l[e.Error]=r.localize("vs_base_severity",0),l[e.Warning]=r.localize("vs_base_severity",1),l[e.Info]=r.localize("vs_base_severity",2),e.fromValue=t,e.toString=i,e.compare=o}(i||(i={})),i}),define("vs/platform/markers/markerService2",["require","exports","vs/base/network","vs/base/arrays","vs/base/strings","vs/base/collections","vs/platform/thread/attribute","vs/base/eventSource","vs/base/severity"],function(e,t,r,n,i,o,s,a,u){var c;!function(e){function t(e){var t=/^(.*)→(.*)$/.exec(e);return{owner:t[1],resource:r.URL.fromValue(t[2])}}function n(e){return e.owner+"→"+e.resource}function o(e,t){return new RegExp(i.format("^({0})→({1})$",e?i.escapeRegExpCharacters(e):".*",t?i.escapeRegExpCharacters(t.toString()):".*"))}function s(e,t){return e+"→"+t}e.fromValue=t,e.valueOf=n,e.selector=o,e.raw=s}(c||(c={}));var l=function(){function e(e){this._data=Object.create(null),this._stats=this.emptyStats(),this._onMarkerChanged=new a,e.registerInstance(this)}return e.prototype.getId=function(){return"__markerService"},e.prototype.getSerializableState=function(){return this._data},e.prototype.setData=function(e){this._data=e},e.prototype.getStatistics=function(){return this._stats},Object.defineProperty(e.prototype,"onMarkerChanged",{get:function(){return this._onMarkerChanged?this._onMarkerChanged.value:null},enumerable:!0,configurable:!0}),e.prototype.changeOne=function(e,t,r){var i=c.raw(e,t),o=this._data[i],s=!n.isFalsyOrEmpty(o),a=!n.isFalsyOrEmpty(r),u=this.computeStats(o),l=this.computeStats(r);a?this._data[i]=r:s&&delete this._data[i],this.isStatRelevant(t)&&(this.updateStatsMinus(u),this.updateStatsPlus(l)),this._onMarkerChanged.fire([t])},e.prototype.changeAll=function(e,t){var r=this,i=this.emptyStats(),s=this.emptyStats(),a=Object.create(null);this._forEach(e,null,-1,function(e,t){var n=c.fromValue(e.key).resource;r.isStatRelevant(n)&&r.updateStatsPlus(i,r.computeStats(e.value)),a[n.toString()]=n,t()}),n.isFalsyOrEmpty(t)||t.forEach(function(t){a[t.resource.toString()]=t.resource,o.lookupOrInsert(r._data,c.raw(e,t.resource),[]).push(t.marker),r.isStatRelevant(t.resource)&&r.updateStatsMarker(s,t.marker)}),this.updateStatsMinus(i),this.updateStatsPlus(s),this._onMarkerChanged.fire(o.values(a))},e.prototype.remove=function(e,t){var r=this,n=this.emptyStats(),i=Object.create(null),s=Object.create(null);t.forEach(function(e){return s[e.toString()]=!0}),o.forEach(this._data,function(t,o){var a,u=c.fromValue(t.key);u.owner===e&&s[a=u.resource.toString()]&&(r.isStatRelevant(u.resource)&&r.updateStatsPlus(n,r.computeStats(t.value)),i[a]=u.resource,o())}),this.updateStatsMinus(n),this._onMarkerChanged.fire(o.values(i))},e.prototype.removeAll=function(e){var t=this,r=this.emptyStats(),n=Object.create(null);this._forEach(e,null,-1,function(e,i){var o=c.fromValue(e.key).resource;t.isStatRelevant(o)&&t.updateStatsPlus(r,t.computeStats(e.value)),n[o.toString()]=o,i()}),this.updateStatsMinus(r),this._onMarkerChanged.fire(o.values(n))},e.prototype.read=function(e){var t=this;void 0===e&&(e={});var r=[];return this._forEach(e.owner,e.resource,e.take,function(e){return t._fromEntry(e,r)}),r},e.prototype.readResources=function(e){var t=[],r=0;return o.forEach(this._data,function(n){var i=c.fromValue(n.key);return(!e.owner||e.owner===i.owner)&&(t.push(i.resource),e.take&&r++>=e.take)?!1:void 0}),t},e.prototype.isStatRelevant=function(e){return e.scheme!==r.schemas.inMemory},e.prototype._forEach=function(e,t,r,n){var i=c.selector(e,t),s=0;o.forEach(this._data,function(e,t){return i.test(e.key)&&(n(e,t),r>0&&s++>=r)?!1:void 0})},e.prototype._fromEntry=function(t,r){var n=c.fromValue(t.key);t.value.forEach(function(t){e._sanitize(t),r.push({owner:n.owner,resource:n.resource,code:t.code,message:t.message,severity:t.severity,startLineNumber:t.startLineNumber,startColumn:t.startColumn,endLineNumber:t.endLineNumber,endColumn:t.endColumn})})},e.prototype.computeStats=function(e){var t=0,r=0,n=0,i=0;if(e)for(var o=0;o<e.length;o++){var s=e[o];if(s.severity)switch(s.severity){case u.Error:t++;break;case u.Warning:r++;break;case u.Info:n++;break;default:i++}else i++}return{errors:t,warnings:r,infos:n,unknwons:i}},e.prototype.emptyStats=function(){return{errors:0,warnings:0,infos:0,unknwons:0}},e.prototype.updateStatsPlus=function(e,t){t||(t=e,e=this._stats),e.errors+=t.errors,e.warnings+=t.warnings,e.infos+=t.infos,e.unknwons+=t.unknwons},e.prototype.updateStatsMinus=function(e,t){t||(t=e,e=this._stats),e.errors-=t.errors,e.warnings-=t.warnings,e.infos-=t.infos,e.unknwons-=t.unknwons},e.prototype.updateStatsMarker=function(e,t){switch(t.severity){case u.Error:e.errors++;break;case u.Warning:e.warnings++;break;case u.Info:e.infos++;break;default:e.unknwons++}},e._sanitize=function(e){e.code=e.code||null,e.startLineNumber=e.startLineNumber>0?e.startLineNumber:1,e.startColumn=e.startColumn>0?e.startColumn:1,e.endLineNumber=e.endLineNumber>=e.startLineNumber?e.endLineNumber:e.startLineNumber,e.endColumn=e.endColumn>0?e.endColumn:e.startColumn},e.$changeOne=s.MainThread(e,e.prototype.changeOne),e.$changeAll=s.MainThread(e,e.prototype.changeAll),e}();t.MarkerService=l}),define("vs/platform/thread/abstractThreadService",["require","exports","vs/base/lib/winjs.base","vs/base/env","vs/platform/thread/attribute","vs/base/remote/remote","vs/base/types"],function(e,t,r,n,i,o,s){var a=function(){function e(){this.isInMainThread=!n.isInWebWorker()&&!n.isInEmulatedWebWorker()&&!n.isInProcessWorker(),this._boundObjects={},this._pendingObjects=[],this._localObjMap=Object.create(null),this._proxyObjMap=Object.create(null)}return e.prototype.setInstantiationService=function(e){this._instantiationService=e},e.prototype.createInstance=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return this._doCreateInstance(e)},e.prototype._doCreateInstance=function(e){var t=this,n=this._instantiationService.createInstance.apply(this._instantiationService,e);if(r.Promise.is(n)){var i=n.then(function(e){if(e.asyncCtor){var t=e.asyncCtor();if(r.Promise.is(t))return t.then(function(){return e})}return e});return this._pendingObjects.push(i),i.then(function(e){for(var r=t._finishInstance(e),n=0;n<t._pendingObjects.length;n++)if(t._pendingObjects[n]===i){t._pendingObjects.splice(n,1);break}return r})}return this._finishInstance(n)},e.prototype._finishInstance=function(e){return e[i.THREAD_SERVICE_PROPERTY_NAME]=this,this._boundObjects[e.getId()]=e,e.creationDone&&e.creationDone(),e},e.prototype.registerInstance=function(e){this._finishInstance(e)},e.prototype.handle=function(e,t,r){if(!this._localObjMap[e])throw new Error("Unknown actor "+e);var n=this._localObjMap[e];return n[t].apply(n,r)},e.prototype._getLocalInstance=function(e){if(!this._localObjMap[e])throw new Error("Missing participant "+e);return this._localObjMap[e]},e.prototype._getProxyInstance=function(e){if(!this._proxyObjMap[e])throw new Error("Missing participant "+e);return this._proxyObjMap[e]},e.prototype._createAndRegisterProxyInstance=function(e,t,r){var n=o.createProxyFromCtor(e,t,r.ctor);return this._proxyObjMap[t]=n,n},e.prototype._createAndRegisterLocalInstance2=function(e,t){var r=this._instantiationService.createInstance(t,this);return this._localObjMap[e]=r,r},e.prototype.proxifyMethods=function(e,t){if(!s.isObject(t))return null;this._localObjMap[e]=t;var r={$__CREATE__PROXY__REQUEST:e};for(var n in t)"function"==typeof t[n]&&(r[n]=t[n].bind(t));return r},e.prototype.proxifyMembers=function(e,t,r){if(!s.isObject(t))return null;this._localObjMap[e]=t;var n={$__CREATE__PROXY__REQUEST:e};for(var i in t)-1!==r.indexOf(i)&&(n[i]="function"==typeof t[i]?t[i].bind(t):t[i]);return n},e.prototype.isProxyObject=function(e){return e&&!!e.$__IS_REMOTE_OBJ},e}();t.AbstractThreadService=a});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/platform/thread/workerThreadService",["require","exports","vs/base/lib/winjs.base","vs/platform/thread/abstractThreadService"],function(e,t,r,n){var i=function(e){function t(t,n,i,o){var s=this;e.call(this),this._mainThreadData=t,this._remoteCom=n,this._remoteCom.registerBigHandler(this),this._dispatcherService=i,this._dispatcherService.register("threadService",function(e,t,n){if(!s._boundObjects.hasOwnProperty(e))return r.Promise.join(s._pendingObjects.slice(0)).then(function(){if(!s._boundObjects.hasOwnProperty(e))return r.Promise.wrapError(new Error("Bound object `"+e+"` was not found."));var i=s._boundObjects[e];return r.Promise.as(i[t].apply(i,n))});var i=s._boundObjects[e];return r.Promise.as(i[t].apply(i,n))}),this._publisher=o}return __extends(t,e),t.prototype._finishInstance=function(t){var r=t.getId();if(this._mainThreadData.hasOwnProperty(r)){var n=this._mainThreadData[r];delete this._mainThreadData[r],t.setData||console.log("BROKEN INSTANCE!!! "+r),t.setData(n)}return e.prototype._finishInstance.call(this,t)},t.prototype.MainThread=function(e,t,r,n){return this._publisher.sendMessage("threadService",{identifier:e.getId(),memberName:t,args:n})},t.prototype.OneWorker=function(e,t,r,n){return r.apply(e,n)},t.prototype.AllWorkers=function(e,t,r,n){return r.apply(e,n)},t.prototype.Everywhere=function(e,t,r,n){return r.apply(e,n)},t.prototype.ensureWorkers=function(){},t.prototype.addStatusListener=function(){},t.prototype.removeStatusListener=function(){},t.prototype.registerAndInstantiateMainProcessActor=function(e,t){return this._createAndRegisterProxyInstance(this._remoteCom,e,t)},t.prototype.registerAndInstantiatePluginHostActor=function(){throw new Error("Not supported in this runtime context: Cannot communicate from Worker directly to Plugin Host!")},t.prototype.registerAndInstantiateWorkerActor=function(e,t){return this._createAndRegisterLocalInstance2(e,t)},t}(n.AbstractThreadService);t.WorkerThreadService=i}),define("vs/base/filters",["require","exports","vs/base/strings"],function(e,t,r){function n(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,r){for(var n=0,i=e.length;i>n;n++){var o=e[n](t,r);if(o)return o}return null}}function i(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,r){for(var n=[],i=0,o=e.length;o>i;i++){var s=e[i](t,r);if(!s)return null;n=n.concat(s)}return n}}function o(e,t,r){if(0===r.length||r.length<t.length)return null;e&&(t=t.toLowerCase(),r=r.toLowerCase());for(var n=0;n<t.length;n++)if(t[n]!==r[n])return null;return t.length>0?[{start:0,end:t.length}]:[]}function s(e,t){var r=t.toLowerCase().indexOf(e.toLowerCase());return-1===r?null:[{start:r,end:r+e.length}]}function a(e,t){return u(e.toLowerCase(),t.toLowerCase(),0,0)}function u(e,t,r,n){if(r===e.length)return[];if(n===t.length)return null;if(e[r]===t[n]){var i=null;if(i=u(e,t,r+1,n+1))return f({start:n,end:n+1},i)}return u(e,t,r,n+1)}function c(e,t){if(0===t.length)return null;for(var r=null,n=0;n<t.length&&null===(r=m(e.toLowerCase(),t,0,n));)n=g(t,n+1);return r}function l(e){var t=e.charCodeAt(0);return t>=97&&122>=t}function p(e){var t=e.charCodeAt(0);return t>=65&&90>=t}function d(e){var t=e.charCodeAt(0);return t>=48&&57>=t}function h(e){return l(e)||p(e)||d(e)}function f(e,t){return 0===t.length?t=[e]:e.end===t[0].start?t[0].start=e.start:t.unshift(e),t}function g(e,t){for(var r=t;r<e.length;r++){var n=e[r];if(p(n)||d(n)||r>0&&!h(e[r-1]))return r}return e.length}function m(e,t,r,n){if(r===e.length)return[];if(n===t.length)return null;if(e[r]!==t[n].toLowerCase())return null;var i=null,o=n+1;for(i=m(e,t,r+1,n+1);!i&&(o=g(t,o))<t.length;)i=m(e,t,r+1,o),o++;return null===i?null:f({start:n,end:n+1},i)}t.or=n,t.and=i,t.matchesStrictPrefix=function(e,t){return o(!1,e,t)},t.matchesPrefix=function(e,t){return o(!0,e,t)},t.matchesContiguousSubString=s,t.matchesSubString=a,t.matchesCamelCase=c;var v=function(){function e(){}return e.matches=function(t,n){var i=e.RegExpCache[t];i||(i=new RegExp(r.convertSimple2RegExpPattern(t),"i"),e.RegExpCache[t]=i);var o=i.exec(n);return o?[{start:o.index,end:o.index+o[0].length}]:e.DefaultFilter(t,n)},e.DefaultFilter=n(t.matchesPrefix,c,s),e.RegExpCache={},e}();t.CombinedMatcher=v}),define("vs/editor/modes/modesFilters",["require","exports","vs/base/filters"],function(e,t,r){function n(e){return function(t,r){var n=e(t,r.label);return r.highlights=n||[],!!n}}function i(e,t){return function(r,n){return e(r,n)||t(r,n)}}function o(e,t){return function(r,n){return e(r,n)&&t(r,n)}}t.StrictPrefix=n(r.matchesStrictPrefix),t.Prefix=n(r.matchesPrefix),t.CamelCase=n(r.matchesCamelCase),t.ContiguousSubString=n(r.matchesContiguousSubString),t.or=i,t.and=o,t.DefaultFilter=i(i(t.Prefix,t.CamelCase),t.ContiguousSubString)}),define("vs/editor/modes/modes",["require","exports","vs/base/types"],function(e,t,r){function n(e){return null===e||"object"!=typeof e?!1:"string"!=typeof e.label||"string"!=typeof e.codeSnippet||"string"!=typeof e.type?!1:r.isUndefinedOrNull(e.highlights)||r.isArray(e.highlights)?r.isUndefinedOrNull(e.typeLabel)||"string"==typeof e.typeLabel?r.isUndefinedOrNull(e.documentationLabel)||"string"==typeof e.documentationLabel?!0:!1:!1:!1}!function(e){e[e.None=0]="None",e[e.Open=1]="Open",e[e.Close=-1]="Close"}(t.Bracket||(t.Bracket={}));t.Bracket;t.isISuggestion=n,function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent"}(t.IndentAction||(t.IndentAction={}));
t.IndentAction}),define("vs/editor/modes/nullMode",["require","exports","vs/editor/modes/modes"],function(e,t,r){function n(e){void 0===e&&(e="");for(var t="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",r="(-?\\d*\\.\\d\\w*)|([^",n=0;n<t.length;n++)e.indexOf(t[n])>=0||(r+="\\"+t[n]);return r+="\\s]+)",new RegExp(r,"g")}function i(e,t,n,i){void 0===i&&(i=0);var o=[{startIndex:i,type:"",bracket:r.Bracket.None}],s=[{startIndex:i,mode:e}];return{tokens:o,actualStopOffset:i+t.length,endState:n,modeTransitions:s}}var o=function(){function e(e,t){this.mode=e,this.stateData=t}return e.prototype.clone=function(){var t=this.stateData?this.stateData.clone():null;return new e(this.mode,t)},e.prototype.equals=function(e){if(this.mode!==e.getMode())return!1;var t=e.getStateData();return this.stateData||t?this.stateData&&t?this.stateData.equals(t):!1:!0},e.prototype.getMode=function(){return this.mode},e.prototype.tokenize=function(e){return e.advanceToEOS(),{type:""}},e.prototype.getStateData=function(){return this.stateData},e.prototype.setStateData=function(e){this.stateData=e},e}();t.NullState=o,t.createWordRegExp=n;var s=function(){function e(){this.tokenTypeClassificationSupport=this}return e.prototype.getId=function(){return e.ID},e.prototype.bindModel=function(){},e.prototype.unbindModel=function(){},e.prototype.getNonWordTokenTypes=function(){return[]},e.prototype.getWordDefinition=function(){return e.DEFAULT_WORD_REGEXP},e.DEFAULT_WORD_REGEXP=n(),e.ID="vs.editor.modes.nullMode",e}();t.NullMode=s,t.nullTokenize=i}),define("vs/platform/instantiation/instantiationService",["require","exports","vs/base/lib/winjs.base","vs/base/errors","vs/base/strings","vs/base/types","vs/platform/services","vs/base/collections"],function(e,t,r,n,i,o,s,a){function u(e){return new p(e,new c)}t.create=u;var c=function(){function e(){this._value=0}return Object.defineProperty(e.prototype,"locked",{get:function(){return 0===this._value},enumerable:!0,configurable:!0}),e.prototype.runUnlocked=function(e){this._value++;try{return e()}finally{this._value--}},e}(),l=function(){function e(e,t){var r=this;this._services=e,this._lock=t,a.forEach(this._services,function(e){r.registerService(e.key,e.value)})}return e.prototype.registerService=function(e,t){var r=this;Object.defineProperty(this,e,{get:function(){if(r._lock.locked)throw n.illegalState("the services map can only be used during construction");if(!t)throw n.illegalArgument(i.format("service with '{0}' not found",e));return t},set:function(){throw n.illegalState("services cannot be changed")},configurable:!1,enumerable:!1}),this._services[e]=t},Object.defineProperty(e.prototype,"lock",{get:function(){return this._lock},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"services",{get:function(){return this._services},enumerable:!0,configurable:!0}),e.prototype.createInstance=function(e,t){var r=[e.ctor,this];return r.push.apply(r,e.staticArguments()),r.push.apply(r,t),this._lock.runUnlocked(function(){var t=o.create.apply(null,r);return e._validate(t),t})},e}(),p=function(){function t(e,t){e.instantiationService=this,this._servicesMap=new l(e,t)}return t.prototype.createChild=function(e){var r={};return a.forEach(this._servicesMap.services,function(e){r[e.key]=e.value}),a.forEach(e,function(e){r[e.key]=e.value}),new t(r,this._servicesMap.lock)},t.prototype.registerService=function(e,t){this._servicesMap.registerService(e,t)},t.prototype.createInstance=function(e){for(var t=new Array(arguments.length-1),r=1,n=arguments.length;n>r;r++)t[r-1]=arguments[r];return e instanceof s.SyncDescriptor?this._servicesMap.createInstance(e,t):e instanceof s.AsyncDescriptor?this._createInstanceAsync(e,t):this._servicesMap.createInstance(new s.SyncDescriptor(e),t)},t.prototype._createInstanceAsync=function(t,i){var o,a=this;return new r.TPromise(function(r,u){e([t.moduleName],function(e){if(o&&u(o),!e)return u(n.illegalArgument("module not found: "+t.moduleName));var c;if(c=t.ctorName?e[t.ctorName]:e,"function"!=typeof c)return u(n.illegalArgument("not a function: "+t.ctorName||t.moduleName));try{i.unshift.apply(i,t.staticArguments()),r(a._servicesMap.createInstance(new s.SyncDescriptor(c),i))}catch(l){return u(l)}},u)},function(){o=n.canceled()})},t}()});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/platform/thread/nullThreadService",["require","exports","vs/base/lib/winjs.base","vs/platform/thread/abstractThreadService","vs/platform/instantiation/instantiationService"],function(e,t,r,n,i){var o=function(e){function t(t){e.call(this),this._warn=t,this.setInstantiationService(i.create({threadService:this}))}return __extends(t,e),t.prototype._doCreateInstance=function(t){return this._warn&&console.warn("Instantiating using the null thread service"),e.prototype._doCreateInstance.call(this,t)},t.prototype.MainThread=function(e,t,r,n){return r.apply(e,n)},t.prototype.OneWorker=function(){return r.Promise.as(null)},t.prototype.AllWorkers=function(){return r.Promise.as(null)},t.prototype.Everywhere=function(e,t,r,n){return r.apply(e,n)},t.prototype.ensureWorkers=function(){},t.prototype.addStatusListener=function(){},t.prototype.removeStatusListener=function(){},t.prototype.registerAndInstantiateMainProcessActor=function(e,t){return this._createAndRegisterLocalInstance2(e,t)},t.prototype.registerAndInstantiatePluginHostActor=function(e,t){return this._createAndRegisterLocalInstance2(e,t)},t.prototype.registerAndInstantiateWorkerActor=function(e,t){return this._createAndRegisterLocalInstance2(e,t)},t}(n.AbstractThreadService);t.NULL_THREAD_SERVICE=new o(!0)}),define("vs/editor/modes/stream",["require","exports"],function(e,t){var r=function(){function e(e){this._source=e,this.sourceLength=e.length,this._pos=0,this.whitespace="	  ",this.whitespaceArr=this.stringToArray(this.whitespace),this.separators="",this.separatorsArr=this.stringToArray(this.separators),this.tokenStart=-1,this.tokenEnd=-1}return e.prototype.stringToArray=function(t){return e.STRING_TO_ARRAY_CACHE.hasOwnProperty(t)||(e.STRING_TO_ARRAY_CACHE[t]=this.actualStringToArray(t)),e.STRING_TO_ARRAY_CACHE[t]},e.prototype.actualStringToArray=function(e){for(var t=0,r=0;r<e.length;r++)t=e.charCodeAt(r);var n=[];for(r=0;t>r;r++)n[r]=!1;for(r=0;r<e.length;r++)n[e.charCodeAt(r)]=!0;return n},e.prototype.pos=function(){return this._pos},e.prototype.eos=function(){return this._pos>=this.sourceLength},e.prototype.peek=function(){if(this._pos>=this.sourceLength)throw new Error("Stream is at the end");return this._source[this._pos]},e.prototype.next=function(){if(this._pos>=this.sourceLength)throw new Error("Stream is at the end");return this.tokenStart=-1,this.tokenEnd=-1,this._source[this._pos++]},e.prototype.next2=function(){if(this._pos>=this.sourceLength)throw new Error("Stream is at the end");this.tokenStart=-1,this.tokenEnd=-1,this._pos++},e.prototype.advance=function(e){if(0===e)return"";var t=this._pos;return this._pos+=e,this.tokenStart=-1,this.tokenEnd=-1,this._source.substring(t,this._pos)},e.prototype._advance2=function(e){return 0===e?e:(this._pos+=e,this.tokenStart=-1,this.tokenEnd=-1,e)},e.prototype.advanceToEOS=function(){var e=this._pos;return this._pos=this.sourceLength,this.resetPeekedToken(),this._source.substring(e,this._pos)},e.prototype.goBack=function(e){this._pos-=e,this.resetPeekedToken()},e.prototype.createPeeker=function(e){var t=this;if(e instanceof RegExp)return function(){var r=e.exec(t._source.substr(t._pos));if(null===r)return 0;if(0!==r.index)throw new Error('Regular expression must begin with the character "^"');return r[0].length};if((e instanceof String||"string"==typeof e)&&e)return function(){for(var r=e.length,n=t._pos+r<=t.sourceLength,i=0;n&&r>i;i++)n=t._source.charCodeAt(t._pos+i)===e.charCodeAt(i);return n?r:0};throw new Error("Condition must be either a regular expression, function or a non-empty string")},e.prototype._advanceIfStringCaseInsensitive=function(e){var t,r=this._pos,n=this._source,i=e.length;if(1>i||r+i>this.sourceLength)return 0;for(t=0;i>t;t++)if(n.charAt(r+t).toLowerCase()!==e.charAt(t).toLowerCase())return 0;return i},e.prototype.advanceIfStringCaseInsensitive=function(e){return this.advance(this._advanceIfStringCaseInsensitive(e))},e.prototype.advanceIfStringCaseInsensitive2=function(e){return this._advance2(this._advanceIfStringCaseInsensitive(e))},e.prototype._advanceIfString=function(e){var t,r=this._pos,n=this._source,i=e.length;if(1>i||r+i>this.sourceLength)return 0;for(t=0;i>t;t++)if(n.charCodeAt(r+t)!==e.charCodeAt(t))return 0;return i},e.prototype.advanceIfString=function(e){return this.advance(this._advanceIfString(e))},e.prototype.advanceIfString2=function(e){return this._advance2(this._advanceIfString(e))},e.prototype._advanceIfCharCode=function(e){return this._pos<this.sourceLength&&this._source.charCodeAt(this._pos)===e?1:0},e.prototype.advanceIfCharCode=function(e){return this.advance(this._advanceIfCharCode(e))},e.prototype.advanceIfCharCode2=function(e){return this._advance2(this._advanceIfCharCode(e))},e.prototype._advanceIfRegExp=function(e){return this._pos>=this.sourceLength?0:e.test(this._source.substr(this._pos))?RegExp.lastMatch.length:0},e.prototype.advanceIfRegExp=function(e){return this.advance(this._advanceIfRegExp(e))},e.prototype.advanceIfRegExp2=function(e){return this._advance2(this._advanceIfRegExp(e))},e.prototype.advanceLoop=function(e,t,r){if(this.eos())return"";var n=this.createPeeker(e),i=this._pos,o=0,s=null;for(s=t?function(e){return e>0}:function(e){return 0===e};!this.eos()&&s(o=n());)o>0?this.advance(o):this.next();return r&&!this.eos()&&this.advance(o),this._source.substring(i,this._pos)},e.prototype.advanceWhile=function(e){return this.advanceLoop(e,!0,!1)},e.prototype.advanceUntil=function(e,t){return this.advanceLoop(e,!1,t)},e.prototype._advanceUntilString=function(e,t){if(this.eos()||0===e.length)return 0;var r=this._pos,n=this._source.indexOf(e,r);return-1===n?this.sourceLength-r:t?n+e.length-r:n-r},e.prototype.advanceUntilString=function(e,t){return this.advance(this._advanceUntilString(e,t))},e.prototype.advanceUntilString2=function(e,t){return this._advance2(this._advanceUntilString(e,t))},e.prototype.resetPeekedToken=function(){this.tokenStart=-1,this.tokenEnd=-1},e.prototype.setTokenRules=function(e,t){(this.separators!==e||this.whitespace!==t)&&(this.separators=e,this.separatorsArr=this.stringToArray(this.separators),this.whitespace=t,this.whitespaceArr=this.stringToArray(this.whitespace),this.resetPeekedToken())},e.prototype.peekToken=function(){if(-1!==this.tokenStart)return this._source.substring(this.tokenStart,this.tokenEnd);var e=this._source,t=this.sourceLength,r=this.whitespaceArr,n=this.separatorsArr,i=this._pos;if(i>=t)throw new Error("Stream is at the end");for(;r[e.charCodeAt(i)]&&t>i;)i++;var o=i;if(n[e.charCodeAt(o)]&&t>o)o++;else for(;!n[e.charCodeAt(o)]&&!r[e.charCodeAt(o)]&&t>o;)o++;return this.tokenStart=i,this.tokenEnd=o,e.substring(i,o)},e.prototype.nextToken=function(){if(this._pos>=this.sourceLength)throw new Error("Stream is at the end");var e;return e=-1===this.tokenStart?this.peekToken():this._source.substring(this.tokenStart,this.tokenEnd),this._pos=this.tokenEnd,this.tokenStart=-1,this.tokenEnd=-1,e},e.prototype.peekWhitespace=function(){for(var e=this._source,t=this.sourceLength,r=this.whitespaceArr,n=this._pos;r[e.charCodeAt(n)]&&t>n;)n++;return e.substring(this._pos,n)},e.prototype._skipWhitespace=function(){for(var e=this._source,t=this.sourceLength,r=this.whitespaceArr,n=this._pos,i=this._pos;r[e.charCodeAt(i)]&&t>i;)i++;return i-n},e.prototype.skipWhitespace=function(){return this.advance(this._skipWhitespace())},e.prototype.skipWhitespace2=function(){return this._advance2(this._skipWhitespace())},e.STRING_TO_ARRAY_CACHE={},e}();t.LineStream=r}),define("vs/editor/modes/autoIndentation/autoIndentation",["require","exports","vs/editor/modes/modes","vs/base/strings"],function(e,t,r,n){var i;!function(e){e[e.Unknown=0]="Unknown",e[e.Lowercase=1]="Lowercase",e[e.Uppercase=2]="Uppercase",e[e.Camelcase=3]="Camelcase"}(i||(i={}));var o=function(){function e(e,t,r,n){void 0===t&&(t=[]),void 0===r&&(r=null),void 0===n&&(n=!1),this.brackets=e,this.regexBrackets=t?t:[],this.docComment=r?r:null,this.caseInsensitive=n?n:!1}return e.prototype.getElectricCharacters=function(){for(var e,t=[],r=this.brackets.length,n=0;r>n;n++)if(e=this.brackets[n],e.isElectric){var i=e.close.charAt(e.close.length-1);t.push(this.caseInsensitive?i.toLowerCase():i)}var o;r=this.regexBrackets.length;for(var n=0;r>n;n++)o=this.regexBrackets[n],o.openTrigger&&t.push(this.caseInsensitive?o.openTrigger.toLowerCase():o.openTrigger),o.closeTrigger&&t.push(this.caseInsensitive?o.closeTrigger.toLowerCase():o.closeTrigger);if(this.docComment&&t.push(this.docComment.open.charAt(this.docComment.open.length-1)),this.caseInsensitive)for(var s=t.length,n=0;s>n;++n)t.push(t[n].toUpperCase());return t=t.filter(function(e,t,r){return r.indexOf(e)==t})},e.prototype.onEnter=function(e,t){return 0===e.getTokenCount()?null:this._onEnterDocComment(e,t)||this._onEnterRegexBrackets(e,t)||this._onEnterStandardBrackets(e,t)},e.prototype.onElectricCharacter=function(e,t){return 0===e.getTokenCount()?null:this._onElectricCharacterDocComment(e,t)||this._onElectricCharacterRegexBrackets(e,t)||this._onElectricCharacterStandardBrackets(e,t)},e.prototype.tokenTypeFromString=function(e){var t=e;this.caseInsensitive&&(t=e.toLowerCase());for(var r,n=0;n<this.brackets.length;n++)if(r=this.brackets[n],t===r.open||t===r.close)return r.tokenType;return null},e.prototype.bracketTypeFromString=function(e){var t=e;this.caseInsensitive&&(t=e.toLowerCase());for(var n,i=0;i<this.brackets.length;i++){if(n=this.brackets[i],t===n.open)return r.Bracket.Open;if(t===n.close)return r.Bracket.Close}return null},e.prototype.tokenTypeIsBracket=function(e){for(var t=0;t<this.brackets.length;t++)if(e===this.brackets[t].tokenType)return!0;return!1},e.prototype.stringIsBracket=function(e){var t=e;this.caseInsensitive&&(t=e.toLowerCase());for(var r,n=0;n<this.brackets.length;n++)if(r=this.brackets[n],t===r.open||t===r.close)return!0;return!1},e.prototype.containsTokenTypes=function(e,t){for(var r=t.split("."),n=0;n<r.length;++n)if(e.indexOf(r[n])<0)return!1;return!0},e.prototype._onEnterStandardBrackets=function(e,t){for(var n=0,i=e.findIndexOfOffset(t-1),o=0;i>=o&&!(o===i&&e.getTokenEndIndex(o)>t);o++){var s=e.getTokenBracket(o);s===r.Bracket.Open&&n++,s===r.Bracket.Close&&n--}for(var a=i;a>0&&""===e.getTokenType(a);)a--;if(a>=0&&e.getTokenEndIndex(a)>t)return n>0?{indentAction:r.IndentAction.Indent}:null;if(e.getTokenBracket(a)!==r.Bracket.Open)return n>0?{indentAction:r.IndentAction.Indent}:null;for(var u=i+1;u<e.getTokenCount()&&""===e.getTokenType(u);)u++;return u<e.getTokenCount()&&e.getTokenType(u)===e.getTokenType(a)&&e.getTokenBracket(u)===r.Bracket.Close?{indentAction:r.IndentAction.IndentOutdent}:{indentAction:r.IndentAction.Indent}},e.prototype._onEnterRegexBrackets=function(e,t){for(var n=0;n<this.regexBrackets.length;++n){var i=this.regexBrackets[n],o=e.getLineContent();this.caseInsensitive&&(o=o.toLowerCase());var s=o.substr(0,t),a=s.match(i.open);if(a){if(i.closeComplete){s=o.substring(t);var u=a[0].replace(i.open,i.closeComplete);if(0===s.indexOf(u))return{indentAction:r.IndentAction.IndentOutdent}}return{indentAction:r.IndentAction.Indent}}}return null},e.prototype._onEnterDocComment=function(e,t){if(!this.docComment)return null;var n=e.findIndexOfOffset(t);if(!this.containsTokenTypes(e.getTokenType(n),this.docComment.scope))return null;var i=e.getLineContent(),o=i.indexOf(this.docComment.open),s=-1;return this.docComment.close&&(s=i.indexOf(this.docComment.close)),-1===o&&-1===s?{indentAction:r.IndentAction.None,appendText:this.docComment.lineStart.replace(/^\s*/,"")}:-1!==o&&t>=o+3?-1!==s&&s>=t?{indentAction:r.IndentAction.IndentOutdent,appendText:this.docComment.lineStart}:{indentAction:r.IndentAction.None,appendText:this.docComment.lineStart}:null},e.prototype._onElectricCharacterStandardBrackets=function(e,t){var r=e.findIndexOfOffset(t),i=e.getTokenText(r),o=e.getTokenType(r);if(!this.stringIsBracket(i))return null;if(r>=0&&e.getTokenEndIndex(r)-1>t)return null;var s=n.firstNonWhitespaceIndex(e.getLineContent());return-1!==s&&s<=t-i.length?null:{matchBracketType:o}},e.prototype._onElectricCharacterRegexBrackets=function(e,t){for(var r=e.getLineContent(),n=0;n<this.regexBrackets.length;++n){var i=this.regexBrackets[n];if(i.openTrigger&&i.closeComplete&&(r.charAt(t)===i.openTrigger||this.caseInsensitive&&r.charAt(t).toLowerCase()===i.openTrigger.toLowerCase())){var o=r.substr(0,t+1),s=o.match(i.open);if(s){var a=s[0].replace(i.open,i.closeComplete);return i.matchCase&&(a=this._changeLettercase(a,this._detectLetercase(s[0]))),{appendText:a}}}if(i.closeTrigger&&(r.charAt(t)===i.closeTrigger||this.caseInsensitive&&r.charAt(t).toLowerCase()===i.closeTrigger.toLowerCase())){var s=o.match(i.close);if(s){var u=s[0];return this.caseInsensitive&&(u=u.toLowerCase()),{matchBracketType:u.replace(i.close,i.tokenType)}}}}return null},e.prototype._onElectricCharacterDocComment=function(e,t){if(!this.docComment||!this.docComment.close)return null;var r=e.getLineContent(),n=r[t];if(n!==this.docComment.open.charAt(this.docComment.open.length-1))return null;if(r.indexOf(this.docComment.close,t)>=0)return null;var i=e.findIndexOfOffset(t);return this.containsTokenTypes(e.getTokenType(i),this.docComment.scope)?r.substring(e.getTokenStartIndex(i),t+1)!==this.docComment.open?null:{appendText:this.docComment.close}:null},e.prototype._detectLetercase=function(e){return e.toLowerCase()===e?i.Lowercase:e.toUpperCase()===e?i.Uppercase:e.length>1&&e.charAt(0).toUpperCase()===e.charAt(0)&&e.charAt(1).toLowerCase()===e.charAt(1)?i.Camelcase:i.Unknown},e.prototype._changeLettercase=function(e,t){switch(t){case i.Lowercase:return e.toLowerCase();case i.Uppercase:return e.toUpperCase();case i.Camelcase:for(var r=e.toLowerCase().split(" "),n=0;n<r.length;++n)r[n]=r[n].charAt(0).toUpperCase()+r[n].substr(1);return r.join(" ");default:return e}},e}();t.Brackets=o});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/modes/supports",["require","exports","vs/base/types","vs/base/strings","vs/base/arrays","vs/base/lib/winjs.base","vs/editor/modes/stream","vs/editor/modes/modes","vs/editor/modes/nullMode","vs/editor/modes/autoIndentation/autoIndentation","vs/editor/modes/modesFilters"],function(e,t,r,n,i,o,s,a,u,c,l){function p(e,t,r){var n=e.modeTransitions;if(1===n.length)return r(n[0].mode,e,t);var o=i.findIndexInSegmentsArray(n,t),s=n[o].mode,a=n[o].startIndex,u=e.findIndexOfOffset(a),c=-1,l=-1;o+1<n.length?(l=e.findIndexOfOffset(n[o+1].startIndex),c=e.getTokenStartIndex(l)):(l=e.getTokenCount(),c=e.getLineContent().length);var p=e.getTokenStartIndex(u),d=new f(e,s,u,l,p,c);return r(s,d,t-p)}function d(e,t,r,i){if(void 0===i&&(i=!1),!Array.isArray(r)||0===r.length)return!1;if(e.getLineContent().length<=t)return!1;for(var o=e.findIndexOfOffset(t),s=e.getTokenType(o),a=0,u=r.length;u>a;a++)if(i){if(s.indexOf(r[a])>=0)return!0}else if(n.endsWith(s,r[a]))return!0;return!1}var h=function(){function e(e,t,r){this.startIndex=e,this.type=t,this.bracket=r}return e}();t.Token=h,t.handleEvent=p,t.isLineToken=d;var f=function(){function e(e,t,r,n,i,o){this.modeTransitions=[{startIndex:0,mode:t}],this._actual=e,this._firstTokenInModeIndex=r,this._nextTokenAfterMode=n,this._firstTokenCharacterOffset=i,this._nextCharacterAfterModeIndex=o}return e.prototype.getLineContent=function(){var e=this._actual.getLineContent();return e.substring(this._firstTokenCharacterOffset,this._nextCharacterAfterModeIndex)},e.prototype.getTokenCount=function(){return this._nextTokenAfterMode-this._firstTokenInModeIndex},e.prototype.findIndexOfOffset=function(e){return this._actual.findIndexOfOffset(e+this._firstTokenCharacterOffset)-this._firstTokenInModeIndex},e.prototype.getTokenStartIndex=function(e){return this._actual.getTokenStartIndex(e+this._firstTokenInModeIndex)-this._firstTokenCharacterOffset},e.prototype.getTokenEndIndex=function(e){return this._actual.getTokenEndIndex(e+this._firstTokenInModeIndex)-this._firstTokenCharacterOffset},e.prototype.getTokenType=function(e){return this._actual.getTokenType(e+this._firstTokenInModeIndex)},e.prototype.getTokenBracket=function(e){return this._actual.getTokenBracket(e+this._firstTokenInModeIndex)},e.prototype.getTokenText=function(e){return this._actual.getTokenText(e+this._firstTokenInModeIndex)},e}();t.FilteredLineContext=f;var g=function(){function e(e){this._mode=e}return Object.defineProperty(e.prototype,"mode",{get:function(){return this._mode},enumerable:!0,configurable:!0}),e}();t.AbstractSupport=g;var m=function(e){function t(t,n,i){e.call(this,t);var o=t,s=!1;void 0!==n&&(void 0!==i?(o=n,s=i):"boolean"==typeof n&&(s=n)),this.customization=o,this.supportsNestedModes=s,this.shouldGenerateEmbeddedModels=s,this.defaults={enterNestedMode:!r.isFunction(o.enterNestedMode),getNestedMode:!r.isFunction(o.getNestedMode),getNestedModeInitialState:!r.isFunction(o.getNestedModeInitialState),getLeavingNestedModeData:!r.isFunction(o.getLeavingNestedModeData),onReturningFromNestedMode:!r.isFunction(o.onReturningFromNestedMode)}}return __extends(t,e),t.prototype.getInitialState=function(){return this.customization.getInitialState()},t.prototype.tokenize=function(e,t,r,n){return void 0===r&&(r=0),void 0===n&&(n=r+e.length),t.getMode()!==this.mode?this._nestedTokenize(e,t,r,n,[],[]):this._myTokenize(e,t,r,n,[],[])},t.prototype._nestedTokenize=function(e,t,r,n,i,o){for(var s=t.getStateData(),a=this.getLeavingNestedModeData(e,s),c=t;c.getStateData()&&c.getStateData().getMode()!==this.mode;)c=c.getStateData();var l=c.getMode();if(!a){var p;return p=l.tokenizationSupport?l.tokenizationSupport.tokenize(e,t,r,n):u.nullTokenize(l,e,t,r),p.tokens=i.concat(p.tokens),p.modeTransitions=o.concat(p.modeTransitions),p}var d=a.nestedModeBuffer;if(d.length>0){var h;h=l.tokenizationSupport?l.tokenizationSupport.tokenize(d,t,r,n):u.nullTokenize(l,d,t,r),t=h.endState,i=i.concat(h.tokens),o=o.concat(h.modeTransitions)}var f=a.bufferAfterNestedMode,g=a.stateAfterNestedMode;return g.setStateData(s.getStateData()),this.onReturningFromNestedMode(g,t),this._myTokenize(f,g,r+d.length,n,i,o)},t.prototype._myTokenize=function(e,r,n,i,o,u){var c,l,p=new s.LineStream(e),d=null,f=null;r=r.clone(),(u.length<=0||u[u.length-1].mode!==this.mode)&&u.push({startIndex:n,mode:this.mode});for(var g=Math.min(i-n,e.length),m=a.Bracket.None;p.pos()<g;){l=p.pos();do{if(c=r.tokenize(p),null===c||void 0===c||(void 0===c.type||null===c.type)&&(void 0===c.nextState||null===c.nextState))throw new Error("Tokenizer must return a valid state");if(c.nextState&&(c.nextState.setStateData(r.getStateData()),r=c.nextState),p.pos()<=l)throw new Error("Stream did not advance while tokenizing. Mode id is "+this.mode.getId()+' (stuck at token type: "'+c.type+'", prepend tokens: "'+o.map(function(e){return e.type}).join(",")+'").')}while(!c.type&&""!==c.type);if((d!==c.type||c.bracket||null===d)&&o.push(new h(l+n,c.type,c.bracket||m)),d=c.type,this.supportsNestedModes&&this.enterNestedMode(r)){var v=this._getEmbeddedLevel(r);if(v<t.MAX_EMBEDDED_LEVELS){var _=this.getNestedModeInitialState(r);if(!p.eos()){var y=e.substr(p.pos()),b=this._nestedTokenize(y,_.state,n+p.pos(),i,o,u);return b.retokenize=b.retokenize||_.missingModePromise,b}r=_.state,f=_.missingModePromise}}}return{tokens:o,actualStopOffset:p.pos()+n,modeTransitions:u,endState:r,retokenize:f}},t.prototype._getEmbeddedLevel=function(e){for(var t=-1;e;)t++,e=e.getStateData();return t},t.prototype.enterNestedMode=function(e){return this.defaults.enterNestedMode?!1:this.customization.enterNestedMode(e)},t.prototype.getNestedMode=function(e){return this.defaults.getNestedMode?null:this.customization.getNestedMode(e)},t._validatedNestedMode=function(e){var t=new u.NullMode,r=null;return e&&e.mode&&(t=e.mode),e&&e.missingModePromise&&(r=e.missingModePromise),{mode:t,missingModePromise:r}},t.prototype.getNestedModeInitialState=function(e){if(this.defaults.getNestedModeInitialState){var r,n=t._validatedNestedMode(this.getNestedMode(e)),i=n.missingModePromise;return r=n.mode.tokenizationSupport?n.mode.tokenizationSupport.getInitialState():new u.NullState(n.mode,null),r.setStateData(e),{state:r,missingModePromise:i}}return this.customization.getNestedModeInitialState(e)},t.prototype.getLeavingNestedModeData=function(e,t){return this.defaults.getLeavingNestedModeData?null:this.customization.getLeavingNestedModeData(e,t)},t.prototype.onReturningFromNestedMode=function(e,t){return this.defaults.onReturningFromNestedMode?null:this.customization.onReturningFromNestedMode(e,t)},t.MAX_EMBEDDED_LEVELS=5,t}(g);t.TokenizationSupport=m;var v=function(e){function t(t,n){void 0===n&&(n=t),e.call(this,t),this.defaults={getElectricCharacters:!r.isFunction(n.getElectricCharacters),onElectricCharacter:!r.isFunction(n.onElectricCharacter),onEnter:!r.isFunction(n.onEnter)},this.customization=n}return __extends(t,e),t.prototype.getElectricCharacters=function(){return this.defaults.getElectricCharacters?[]:this.customization.getElectricCharacters()},t.prototype.onElectricCharacter=function(e,t){var r=this;return p(e,t,function(e,t,n){return r.mode===e?r.defaults.onElectricCharacter?null:r.customization.onElectricCharacter(t,n):e.electricCharacterSupport?e.electricCharacterSupport.onElectricCharacter(t,n):null})},t.prototype.onEnter=function(e,t){var r=this;return p(e,t,function(e,t,n){return r.mode===e?r.defaults.onEnter?null:r.customization.onEnter(t,n):e.electricCharacterSupport?e.electricCharacterSupport.onEnter(t,n):null})},t}(g);t.ElectricCharacterSupport=v;var _=function(e){function t(t,r){e.call(this,t),this.contribution=r,this.brackets=new c.Brackets(r.brackets,r.regexBrackets,r.docComment,r.caseInsensitive)}return __extends(t,e),t.prototype.getElectricCharacters=function(){return Array.isArray(this.contribution.embeddedElectricCharacters)?this.contribution.embeddedElectricCharacters.concat(this.brackets.getElectricCharacters()):this.brackets.getElectricCharacters()},t.prototype.onElectricCharacter=function(e,t){var r=this;return p(e,t,function(e,t,n){return r.mode===e?r.brackets.onElectricCharacter(t,n):e.electricCharacterSupport?e.electricCharacterSupport.onElectricCharacter(t,n):null})},t.prototype.onEnter=function(e,t){var r=this;return p(e,t,function(e,t,n){return r.mode===e?r.brackets.onEnter(t,n):e.electricCharacterSupport?e.electricCharacterSupport.onEnter(t,n):null})},t}(g);t.BracketElectricCharacterSupport=_;var y=function(e){function t(t,r){e.call(this,t),this.contribution=r}return __extends(t,e),t.prototype.canFindDeclaration=function(e,t){var r=this;return p(e,t,function(e,t,n){return r.mode===e?!Array.isArray(r.contribution.tokens)||r.contribution.tokens.length<1||d(t,n,r.contribution.tokens):e.declarationSupport?e.declarationSupport.canFindDeclaration(t,n):!1})},t.prototype.findDeclaration=function(e,t){return this.contribution.findDeclaration(e,t)},t}(g);t.DeclarationSupport=y;var b=function(e){function t(t,r){e.call(this,t),this.contribution=r}return __extends(t,e),t.prototype.canFindTypeDeclaration=function(e,t){var r=this;return p(e,t,function(e,t,n){return r.mode===e?!Array.isArray(r.contribution.tokens)||r.contribution.tokens.length<1||d(t,n,r.contribution.tokens):e.typeDeclarationSupport?e.typeDeclarationSupport.canFindTypeDeclaration(t,n):!1})},t.prototype.findTypeDeclaration=function(e,t){return this.contribution.findTypeDeclaration(e,t)},t}(g);t.TypeDeclarationSupport=b;var S=function(e){function t(t,r){e.call(this,t),this.contribution=r}return __extends(t,e),t.prototype.canFindReferences=function(e,t){var r=this;return p(e,t,function(e,t,n){return r.mode===e?!Array.isArray(r.contribution.tokens)||r.contribution.tokens.length<1||d(t,n,r.contribution.tokens):e.referenceSupport?e.referenceSupport.canFindReferences(t,n):!1})},t.prototype.findReferences=function(e,t,r){return this.contribution.findReferences(e,t,r)},t}(g);t.ReferenceSupport=S;var k=function(e){function t(t,r){e.call(this,t),this.contribution=r}return __extends(t,e),t.prototype.getParameterHintsTriggerCharacters=function(){return this.contribution.triggerCharacters},t.prototype.shouldTriggerParameterHints=function(e,t){var r=this;return p(e,t,function(e,t,n){return r.mode===e?Array.isArray(r.contribution.excludeTokens)?1===r.contribution.excludeTokens.length&&"*"===r.contribution.excludeTokens[0]?!1:!d(t,n-1,r.contribution.excludeTokens):!0:e.parameterHintsSupport?e.parameterHintsSupport.shouldTriggerParameterHints(t,n):!1})},t.prototype.getParameterHints=function(e,t){return this.contribution.getParameterHints(e,t)},t}(g);t.ParameterHintsSupport=k;var C=function(e){function t(t,r){if(e.call(this,t),this.contribution=r,this.suggest=function(e,t){return r.suggest(e,t)},"function"==typeof r.getSuggestionDetails&&(this.getSuggestionDetails=function(e,t,n){return r.getSuggestionDetails(e,t,n)}),this.sortByType=[],this.separatorForType=[],Array.isArray(r.sortBy)&&r.sortBy.length>0)for(var n=0;n<r.sortBy.length;++n)this.sortByType.push(r.sortBy[n].type),this.separatorForType.push(r.sortBy[n].partSeparator)}return __extends(t,e),t.prototype.shouldAutotriggerSuggest=function(e,t,r){var n=this;return p(e,t,function(e,t,i){return n.mode===e?Array.isArray(n.contribution.excludeTokens)?1===n.contribution.excludeTokens.length&&"*"===n.contribution.excludeTokens[0]?!1:!d(t,i-1,n.contribution.excludeTokens,!0):!0:e.suggestSupport?e.suggestSupport.shouldAutotriggerSuggest(t,i,r):!1})},t.prototype.getFilter=function(){return l.DefaultFilter},t.prototype.getSorter=function(){var e=this;return function(t,r){if(e.sortByType.length>0){var i=e.sortByType.indexOf(t.type),o=e.sortByType.indexOf(r.type);if(0>i&&(i=e.sortByType.length),0>o&&(o=e.sortByType.length),o>i)return-1;if(i>o)return 1;if(i<e.sortByType.length){var s=e.separatorForType[i],a="string"==typeof s&&s.length>0?t.label.split(s):[t.label],u="string"==typeof s&&s.length>0?r.label.split(s):[r.label];if(a.length<u.length)return-1;if(a.length>u.length)return 1;for(var c=0;c<a.length;c++){var l=n.localeCompare(a[c],u[c]);if(0!==l)return l}return 0}}return n.localeCompare(t.label.toLowerCase(),r.label.toLowerCase())}},t.prototype.getTriggerCharacters=function(){return this.contribution.triggerCharacters},t.prototype.shouldShowEmptySuggestionList=function(){return!0},t}(g);t.SuggestSupport=C;var T=function(e){function t(t,r){e.call(this,t,r),this.suggest=function(e,t){return r.suggest(e,t).then(function(n){return r.composeSuggest(e,t,n)})}}return __extends(t,e),t}(C);t.ComposableSuggestSupport=T;var E=function(e){function t(t,r){e.call(this,t),this._autoClosingPairs=r.autoClosingPairs,this._surroundingPairs=Array.isArray(r.surroundingPairs)?r.surroundingPairs:r.autoClosingPairs}return __extends(t,e),t.prototype.getAutoClosingPairs=function(){return this._autoClosingPairs},t.prototype.shouldAutoClosePair=function(e,t,r){var n=this;return p(t,r,function(t,r,i){if(n.mode===t){if(0===r.getTokenCount())return!0;for(var o=r.findIndexOfOffset(i-1),s=r.getTokenType(o),a=0;a<n._autoClosingPairs.length;++a)if(n._autoClosingPairs[a].open===e){if(n._autoClosingPairs[a].notIn)for(var u=0;u<n._autoClosingPairs[a].notIn.length;++u)if(s.indexOf(n._autoClosingPairs[a].notIn[u])>-1)return!1;break}return!0}return t.characterPairSupport?t.characterPairSupport.shouldAutoClosePair(e,r,i):null})},t.prototype.getSurroundingPairs=function(){return this._surroundingPairs},t}(g);t.CharacterPairSupport=E;var w=function(){function e(){}return e.prototype.valueSetsReplace=function(e,t,r){for(var n=null;e.length>0&&null===n;)n=this.valueSetReplace(e.pop(),t,r);
return n},e.prototype.valueSetReplace=function(e,t,r){var n=e.indexOf(t);return n>=0?(n+=r?1:-1,0>n?n=e.length-1:n%=e.length,e[n]):null},e}();t.ReplaceSupport=new w;var x=function(){function e(e,t){void 0===t&&(t=null),this.resourceService=e,this.defaults={textReplace:!t||!r.isFunction(t.textReplace),navigateValueSetFallback:!t||!r.isFunction(t.navigateValueSetFallback)},this.customization=t}return e.prototype.navigateValueSet=function(e,t,r){var n=this.doNavigateValueSet(e,t,r,!0);return n&&n.value&&n.range?o.TPromise.as(n):this.defaults.navigateValueSetFallback?o.TPromise.as(null):this.customization.navigateValueSetFallback(e,t,r)},e.prototype.doNavigateValueSet=function(e,t,r,n){var i,o=this.resourceService.get(e),s={range:null,value:null};if(n)t.startColumn===t.endColumn&&(t.endColumn+=1),i=o.getValueInRange(t),s.range=t;else{var a={lineNumber:t.startLineNumber,column:t.startColumn},u=o.getWordAtPosition(a,!0,!0);if(!u||-1===u.startColumn)return null;i=u.word,s.range={startLineNumber:t.startLineNumber,endLineNumber:t.endLineNumber,startColumn:u.startColumn,endColumn:u.endColumn}}var c=this.numberReplace(i,r);if(null!==c)s.value=c;else{var l=this.textReplace(i,r);if(null!==l)s.value=l;else if(n)return this.doNavigateValueSet(e,t,r,!1)}return s},e.prototype.numberReplace=function(e,t){var r=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),n=Number(e),i=parseFloat(e);return isNaN(n)||isNaN(i)||n!==i?null:0!==n||t?(n=Math.floor(n*r),n+=t?r:-r,String(n/r)):null},e.prototype.textReplace=function(e,t){return this.defaults.textReplace?null:this.customization.textReplace(e,t)},e}();t.InplaceReplaceSupport=x;var M=function(){function e(e){this._contribution=e}return e.prototype.getCommentsConfiguration=function(){return this._contribution.commentsConfiguration},e}();t.CommentsSupport=M;var L=function(){function e(e){this._contribution=e}return e.prototype.getNonWordTokenTypes=function(){return"undefined"==typeof this._contribution.nonWordTokenTypes?[]:this._contribution.nonWordTokenTypes},e.prototype.getWordDefinition=function(){return"undefined"==typeof this._contribution.wordDefinition?u.NullMode.DEFAULT_WORD_REGEXP:this._contribution.wordDefinition},e}();t.TokenTypeClassificationSupport=L});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/modes/modesExtensions",["require","exports","vs/base/lib/winjs.base","vs/base/strings","vs/platform/platform","./modesFilters","vs/editor/modes/nullMode","vs/platform/services","vs/platform/thread/nullThreadService","vs/platform/thread/attribute","./supports","vs/platform/plugins","vs/base/errors","vs/base/objects","vs/base/env","vs/base/mime","vs/base/eventEmitter"],function(e,t,r,n,i,o,s,a,u,c,l,p,d,h,f,g,m){function v(e){return Q[e]||ct.INSTANCE.getModeIdForLanguageNameLowercase(e)}function _(e,t){return null===e&&null===t?!0:null===e||null===t?!1:e.equals(t)}function y(e){return e?e.clone():null}function b(e){rt.push(e)}function S(e,r,n,o){var s=i.Registry.as(t.Extensions.EditorModes);s.registerMode(e,r,n,o)}function k(e,t,r,n,i){S(e,t,r,new a.AsyncDescriptor(n,i))}function C(e,r){var n=i.Registry.as(t.Extensions.EditorModes);n.configureModeById(e,r)}function T(e){var r=i.Registry.as(t.Extensions.EditorModes);return r.getOrCreateMode(e)}function E(e){var r=i.Registry.as(t.Extensions.EditorModes);return r.getMode(e)}function w(e,r,n){var o=i.Registry.as(t.Extensions.EditorModes);o.registerWorkerParticipant(e,new a.AsyncDescriptor(r,n))}function x(e,t,r){var n=ot.getThreadService()||u.NULL_THREAD_SERVICE;return n.isInMainThread&&st.instantiateModeInWorkers(r),n.createInstance(t,{id:r}).then(function(e){return e.configSupport&&e.configSupport.configure(at.getConfigurationForMode(r)),e})}function M(e,t){ot.registerModeSupport(e,"characterPairSupport",function(e){return new l.CharacterPairSupport(e,t)})}function L(e,t){ot.registerModeSupport(e,"codeLensSupport",function(){return t})}function I(e,t){ot.registerModeSupport(e,"commentsSupport",function(){return new l.CommentsSupport(t)})}function A(e,t){ot.registerModeSupport(e,"declarationSupport",function(e){return new l.DeclarationSupport(e,t)})}function N(e,t){ot.registerModeSupport(e,"electricCharacterSupport",function(e){return new l.BracketElectricCharacterSupport(e,t)})}function P(e,t){ot.registerModeSupport(e,"extraInfoSupport",function(){return t})}function O(e,t){ot.registerModeSupport(e,"formattingSupport",function(){return t})}function R(e,t){ot.registerModeSupport(e,"inplaceReplaceSupport",function(){return t})}function D(e,t){ot.registerModeSupport(e,"navigateTypesSupport",function(){return t})}function W(e,t){ot.registerModeSupport(e,"occurrencesSupport",function(){return t})}function B(e,t){ot.registerModeSupport(e,"outlineSupport",function(){return t})}function F(e,t){ot.registerModeSupport(e,"parameterHintsSupport",function(e){return new l.ParameterHintsSupport(e,t)})}function U(e,t){ot.registerModeSupport(e,"quickFixSupport",function(){return t})}function z(e,t){ot.registerModeSupport(e,"referenceSupport",function(e){return new l.ReferenceSupport(e,t)})}function j(e,t){ot.registerModeSupport(e,"renameSupport",function(){return t})}function H(e,t){ot.registerModeSupport(e,"suggestSupport",function(e){return new l.SuggestSupport(e,t)})}function q(e,t){ot.registerModeSupport(e,"tokenizationSupport",t)}function V(e,t){ot.registerModeSupport(e,"tokenTypeClassificationSupport",function(){return new l.TokenTypeClassificationSupport(t)})}function G(e,t){lt[e]=(lt[e]||[]).concat(t)}function K(e,t,r){var n=pt[e];n||(pt[e]=n={}),n[t]=r}function X(e,t){var r=e.getWordAtPosition(t,!1),i={currentWord:r?r.word.substring(0,t.column-r.startColumn):"",suggestions:[]};if(n.isFalsyOrWhitespace(e.getLineContent(t.lineNumber).substr(0,r?r.startColumn-1:t.column-1))){var o=e.getMode().getId(),s=[],a=pt[o];if(a)for(var u in a)s=s.concat(a[u]);var c=lt[o];c&&(s=s.concat(c)),i.suggestions=s}return i}t.createWordRegExp=s.createWordRegExp;var $=Object.prototype.hasOwnProperty;t.isDigit=function(){var e="0".charCodeAt(0),t="1".charCodeAt(0),r="2".charCodeAt(0),n="3".charCodeAt(0),i="4".charCodeAt(0),o="5".charCodeAt(0),s="6".charCodeAt(0),a="7".charCodeAt(0),u="8".charCodeAt(0),c="9".charCodeAt(0),l="a".charCodeAt(0),p="b".charCodeAt(0),d="c".charCodeAt(0),h="d".charCodeAt(0),f="e".charCodeAt(0),g="f".charCodeAt(0),m="A".charCodeAt(0),v="B".charCodeAt(0),_="C".charCodeAt(0),y="D".charCodeAt(0),b="E".charCodeAt(0),S="F".charCodeAt(0);return function(k,C){var T=k.charCodeAt(0);switch(C){case 1:return T===e;case 2:return T>=e&&t>=T;case 3:return T>=e&&r>=T;case 4:return T>=e&&n>=T;case 5:return T>=e&&i>=T;case 6:return T>=e&&o>=T;case 7:return T>=e&&s>=T;case 8:return T>=e&&a>=T;case 9:return T>=e&&u>=T;case 10:return T>=e&&c>=T;case 11:return T>=e&&c>=T||T===l||T===m;case 12:return T>=e&&c>=T||T>=l&&p>=T||T>=m&&v>=T;case 13:return T>=e&&c>=T||T>=l&&d>=T||T>=m&&_>=T;case 14:return T>=e&&c>=T||T>=l&&h>=T||T>=m&&y>=T;case 15:return T>=e&&c>=T||T>=l&&f>=T||T>=m&&b>=T;default:return T>=e&&c>=T||T>=l&&g>=T||T>=m&&S>=T}}}();var Y=function(){function t(e,t,r){void 0===r&&(r=null),this._resourceService=e.resourceService,this._instantiationService=e.instantiationService,this._threadService=e.threadService,this._modelService=e.modelService,this._descriptor=t,this._workerDescriptor=r||a.AsyncDescriptor.create("vs/languages/nullWorker","NullWorker"),this._options=null,this.autoValidateDelay=500,this.modelSyncSupport=this,this.occurrencesSupport=this,this.suggestSupport=this,this.inplaceReplaceSupport=this,this.diffSupport=this,this.dirtyDiffSupport=this,this.linkSupport=this,this.configSupport=this,this.commentsSupport=this,this.tokenTypeClassificationSupport=this,this._workerPiecePromise=null}return t.prototype.getId=function(){return this._descriptor.id},t.prototype.creationDone=function(){this._threadService.isInMainThread&&this._pickAWorkerToValidate()},t.prototype._getOrCreateWorker=function(){var e=this;return this._workerPiecePromise||(this._workerPiecePromise=t._loadModule(this._workerDescriptor.moduleName).then(function(){var t=ot.getWorkerParticipants(e._descriptor.id);return r.TPromise.join(t.map(function(t){return e._instantiationService.createInstance(t)}))}).then(function(t){return e._instantiationService.createInstance(e._workerDescriptor,e,t)})),this._workerPiecePromise},t._loadModule=function(t){return new r.TPromise(function(r,n){e([t],r,n)},function(){})},t.prototype._worker=function(e){return this._getOrCreateWorker().then(e)},t.prototype.bindModel=function(e){this._modelService&&this._modelService.addModel(e)},t.prototype.unbindModel=function(e){this._modelService&&this._modelService.removeModel(e)},t.prototype._pickAWorkerToValidate=function(){return this._worker(function(e){return e.enableValidator()})},t.prototype.getFilter=function(){return o.DefaultFilter},t.prototype.suggest=function(e,t){return this._worker(function(r){return r.suggest(e,t)})},t.prototype.getTriggerCharacters=function(){return[]},t.prototype.shouldAutotriggerSuggest=function(e,r,n){return l.handleEvent(e,r,function(e,r,i){return e.suggestSupport?e instanceof t?e.shouldAutotriggerSuggestImpl(r,i,n):e.suggestSupport.shouldAutotriggerSuggest(r,i,n):!1})},t.prototype.shouldAutotriggerSuggestImpl=function(){return!1},t.prototype.shouldShowEmptySuggestionList=function(){return!0},t.prototype.findOccurrences=function(e,t,r){return void 0===r&&(r=!1),this._worker(function(n){return n.findOccurrences(e,t,r)})},t.prototype.navigateValueSet=function(e,t,r){return this._worker(function(n){return n.inplaceReplaceSupport.navigateValueSet(e,t,r)})},t.prototype.computeDiff=function(e,t,r){return this._worker(function(n){return n.computeDiff(e,t,r)})},t.prototype.computeDirtyDiff=function(e,t){return this._worker(function(r){return r.computeDirtyDiff(e,t)})},t.prototype.computeLinks=function(e){return this._worker(function(t){return t.computeLinks(e)})},t.prototype.configure=function(e){return this._options=e,this._threadService.isInMainThread?this._configureWorkers(e):this._worker(function(t){return t.configure(e)})},t.prototype._configureWorkers=function(e){return this._worker(function(t){return t.configure(e)})},t.prototype.getNonWordTokenTypes=function(){return[]},t.prototype.getWordDefinition=function(){return s.NullMode.DEFAULT_WORD_REGEXP},t.prototype.getCommentsConfiguration=function(){return null},t.prototype._getMirrorModelAtPosition=function(e,t){var r=this._resourceService.get(e);return r.getEmbeddedAtPosition(t)},t.prototype._delegateToModeAtPosition=function(e,t,r){var n=this._resourceService.get(e);if(!n)return null;var i=n.getEmbeddedAtPosition(t);if(!i)return r(!1,n);var o=i.getMode();return r(o.getId()!==this.getId(),i)},t.prototype._delegateToAllModes=function(e,t){var r=this._resourceService.get(e);return r?t(r.getAllEmbedded()):null},t.$_pickAWorkerToValidate=c.OneWorker(t,t.prototype._pickAWorkerToValidate,a.ThreadAffinity.Group1),t.$suggest=c.OneWorker(t,t.prototype.suggest),t.$findOccurrences=c.OneWorker(t,t.prototype.findOccurrences),t.$navigateValueSet=c.OneWorker(t,t.prototype.navigateValueSet),t.$computeDiff=c.OneWorker(t,t.prototype.computeDiff),t.$computeDirtyDiff=c.OneWorker(t,t.prototype.computeDirtyDiff),t.$computeLinks=c.OneWorker(t,t.prototype.computeLinks),t.$_configureWorkers=c.AllWorkers(t,t.prototype._configureWorkers),t}();t.AbstractMode=Y;var J;!function(e){function t(e,t){return o(e,i(t))}function r(e,t,r){return a(e,i(t),r)}function i(e){return e&&e.tokenizationSupport?e.tokenizationSupport:{shouldGenerateEmbeddedModels:!1,getInitialState:function(){return new s.NullState(null,null)},tokenize:function(e,t,r,n){return void 0===r&&(r=0),s.nullTokenize(null,e,t,r,n)}}}function o(e,t){var r={tagName:"div",style:"white-space: pre",children:[]},n=function(e,t){r.children.push({tagName:"span",className:e,text:t})},i=function(){r.children.push({tagName:"br"})};return u(e,t,n,i),r}function a(e,t,r){void 0===r&&(r=""),r&&r.length>0&&(r=" "+r);var i="",o=function(e,t){i+='<span class="'+e+r+'">'+n.escape(t)+"</span>"},s=function(){i+="<br/>"};return i='<div style="white-space: pre;">',u(e,t,o,s),i+="</div>"}function u(e,t,r,n){for(var i=e.split(/\r\n|\r|\n/),o=t.getInitialState(),s=0;s<i.length;s++)o=c(i[s],t,r,o),s<i.length-1&&n()}function c(e,t,r,n){for(var i,o=t.tokenize(e,n),s=o.endState,a=o.tokens,u=0,c=0;c<a.length;c++){var l=a[c];c<a.length-1?(i=e.substring(u,a[c+1].startIndex),u=a[c+1].startIndex):i=e.substr(u);var p="token",d=l.type.replace(/[^a-z0-9\-]/gi," ");d.length>0&&(p+=" "+d),r(p,i)}return s}e.tokenizeToHtmlContent=t,e.tokenizeToString=r}(J=t.TextToHtmlTokenizer||(t.TextToHtmlTokenizer={}));var Q={css:"text/css",handlebars:"text/x-handlebars-template",htm:"text/html",html:"text/html",xhtml:"text/html",javascript:"text/javascript",js:"text/javascript",json:"application/json",less:"text/x-less",markdown:"text/x-web-markdown",php:"application/x-php",text:"text/plain",razor:"text/x-cshtml",sass:"text/x-scss",scss:"text/x-scss"};t.languageAliasToMime=v;var Z=function(){function e(){}return e.apply=function(e){if(e){var r=i.Registry.as(t.Extensions.EditorModes),n=r.getRegisteredModes();n.forEach(function(t){var n=e[t];r.configureModeById(t,n)})}},e}();t.ModesConfiguration=Z;var et=function(){function e(e,t){void 0===t&&(t=null),this.mode=e,this.stateData=t}return e.prototype.getMode=function(){return this.mode},e.prototype.clone=function(){var e=this.makeClone();return e.initializeFrom(this),e},e.prototype.makeClone=function(){throw new Error("Abstract Method")},e.prototype.initializeFrom=function(e){this.stateData=null!==e.stateData?e.stateData.clone():null},e.prototype.getStateData=function(){return this.stateData},e.prototype.setStateData=function(e){this.stateData=e},e.prototype.equals=function(t){return null===t||this.mode!==t.getMode()?!1:t instanceof e?_(this.stateData,t.stateData):!1},e.prototype.tokenize=function(){throw new Error("Abstract Method")},e}();t.AbstractState=et,t.safeStateEquals=_,t.safeStateClone=y,t.Extensions={EditorModes:"editor.modes"};var tt=function(e){function t(t,r){e.call(this,t,{id:r}),this._eventEmitter=new m.EventEmitter}return __extends(t,e),t.prototype.registerSupport=function(e,t){var r=t(this);this[e]=r;var n={codeLensSupport:!1,modelSyncSupport:!1,tokenizationSupport:!1,occurrencesSupport:!1,declarationSupport:!1,typeDeclarationSupport:!1,navigateTypesSupport:!1,referenceSupport:!1,suggestSupport:!1,parameterHintsSupport:!1,extraInfoSupport:!1,outlineSupport:!1,logicalSelectionSupport:!1,formattingSupport:!1,inplaceReplaceSupport:!1,diffSupport:!1,dirtyDiffSupport:!1,emitOutputSupport:!1,linkSupport:!1,configSupport:!1,electricCharacterSupport:!1,commentsSupport:!1,characterPairSupport:!1,tokenTypeClassificationSupport:!1,quickFixSupport:!1};n[e]=!0,this._eventEmitter.emit("modeSupportChanged",n)},t.prototype.addSupportChangedListener=function(e){return this._eventEmitter.addListener2("modeSupportChanged",e)},t}(Y),rt=[];t.registerThreadServiceListener=b;var nt=function(){function e(e){this.instantiationService=e.instantiationService}return e.prototype.getId=function(){return"vs/editor/modes/modesExtensions.InstantiationServiceExtractor"},e}(),it=function(){function e(){this._threadService=null,this._activationPromises={},this._instantiatedModes={},this._frankensteinModes={}}return e.prototype.getThreadService=function(){return this._threadService},e.prototype.setThreadService=function(e){if(null===this._threadService){this._threadService=e,rt.forEach(function(t){return t(e)}),st.register(e),at.register(e);var t=e.createInstance(nt);p.setInstantiationService(t.instantiationService)}},e.prototype.registerWorkerParticipant=function(e,t){var r={pluginId:e+":"+t.moduleName+"."+t.ctorName+".impl",activationEvents:["mode:"+e],something:t,isFake:!0};p.registerPlugin(r)},e.prototype.getWorkerParticipants=function(e){return p.getAllPluginDescriptions().filter(function(t){return"undefined"!=typeof t.activationEvents?t.activationEvents.indexOf("mode:"+e)>=0:!1}).map(function(e){return e.something})},e.prototype.isRegisteredMode=function(e){return ct.INSTANCE.isRegisteredMode(e)},e.prototype.getRegisteredModes=function(){return ct.INSTANCE.getRegisteredModes()},e.prototype.getRegisteredMimetypes=function(){return ct.INSTANCE.getRegisteredMimetypes()},e.prototype.getRegisteredLanguageNames=function(){return ct.INSTANCE.getRegisteredLanguageNames()},e.prototype.getMimeForMode=function(e){return ct.INSTANCE.getMimeForMode(e)},e.prototype.getLanguageName=function(e){return ct.INSTANCE.getLanguageName(e)},e.prototype.registerMode=function(e,t,r,n){var i={};r.forEach(function(t){return i[t]=e});var o={};o[t]=e;var s={};s[e]=!0;var a={pluginId:e+".impl",isFake:!0,activationEvents:["textModel:"+e],mainModule:"vs/editor/modes/modesExtensions",mainModuleExtra:[n,e,!1],contributes:{language:[{id:e,aliases:[t],__isCompat:!0,mimetypes:r}]},forceLoadingInUI:!0};p.registerPlugin(a)},e.prototype.configureMode=function(e,t){var r=this.getModeId(e);r&&this.configureModeById(r,t)},e.prototype.configureModeById=function(e,t){at.configureModeById(e,t)},e.prototype.lookup=function(e){for(var t=[],r=ct.INSTANCE.extractModeIds(e),n=0;n<r.length;n++){var i=r[n];t.push({modeId:i,isInstantiated:this._instantiatedModes.hasOwnProperty(i)})}return t},e.prototype.getMode=function(e){for(var t=ct.INSTANCE.extractModeIds(e),r=!1,n=0;n<t.length;n++){if(this._instantiatedModes.hasOwnProperty(t[n]))return this._instantiatedModes[t[n]];r=r||"plainText"===t[n]}if(f.isTesting()||r){var i=null;return this.getOrCreateMode(e).then(function(e){i=e}).done(null,d.onUnexpectedError),i}},e.prototype.getModeId=function(e){var t=ct.INSTANCE.extractModeIds(e);return t.length>0?t[0]:null},e.prototype.getModeIdByLanguageName=function(e){var t=ct.INSTANCE.getModeIdsFromLanguageName(e);return t.length>0?t[0]:null},e.prototype.getModeIdByFilenameOrFirstLine=function(e,t){var r=ct.INSTANCE.getModeIdsFromFilenameOrFirstLine(e,t);return r.length>0?r[0]:null},e.prototype.getOrCreateMode=function(e){var t=this;return p.onReady().then(function(){var r=t.getModeId(e);return t._getOrCreateMode(r||"plainText")})},e.prototype.getOrCreateModeByLanguageName=function(e){var t=this;return p.onReady().then(function(){var r=t.getModeIdByLanguageName(e);return t._getOrCreateMode(r||"plainText")})},e.prototype.getOrCreateModeByFilenameOrFirstLine=function(e,t){var r=this;return p.onReady().then(function(){var n=r.getModeIdByFilenameOrFirstLine(e,t);return r._getOrCreateMode(n||"plainText")})},e.prototype._getOrCreateMode=function(e){var t=this;return this._instantiatedModes.hasOwnProperty(e)?r.TPromise.as(this._instantiatedModes[e]):this._activationPromises.hasOwnProperty(e)?this._activationPromises[e]:(this._activationPromises[e]=this._createMode(e).then(function(r){return t._instantiatedModes[e]=r,delete t._activationPromises[e],t._instantiatedModes[e]}),this._activationPromises[e])},e.prototype._createMode=function(e){var t=this,r="textModel:"+e;if(ct.INSTANCE.isCompat(e))return p.activateByEvent(r).then(function(t){if(t=t.filter(function(e){return!!e}),0===t.length)return console.warn("mode not found: "+e),null;if(1===t.length)return t[0];throw new Error("Cannot have more than one mode for activation event "+r+"!")});var n=this._threadService||u.NULL_THREAD_SERVICE;return n.isInMainThread&&st.instantiateModeInWorkers(e),this._frankensteinModes.hasOwnProperty(e)||(this._frankensteinModes[e]=n.createInstance(tt,e)),p.activateByEvent(r).then(function(){return t._frankensteinModes[e]})},e.prototype.registerModeSupport=function(e,t,r){if(!this._frankensteinModes.hasOwnProperty(e)){if(ct.INSTANCE.isCompat(e))return console.warn("Cannot register support "+t+" on mode "+e+" because it is not a Frankenstein mode"),void 0;var n=this._threadService||u.NULL_THREAD_SERVICE;n.isInMainThread&&st.instantiateModeInWorkers(e),this._frankensteinModes[e]=n.createInstance(tt,e)}var i=this._frankensteinModes[e];i.registerSupport(t,r)},e}(),ot=new it;i.Registry.add(t.Extensions.EditorModes,ot),t.registerModeAsyncDescriptor=S,t.registerMode=k,t.configureMode=C,t.getOrCreateMode=T,t.getMode=E,t.registerWorkerParticipant=w;var st=function(){function e(){}return e.register=function(t){e.INSTANCE_REGISTERED||(e.INSTANCE_REGISTERED=!0,t.registerInstance(e.INSTANCE))},e.instantiateModeInWorkers=function(t){e.register(u.NULL_THREAD_SERVICE),e.INSTANCE._instantiateInWorkers(t)},e.prototype.getId=function(){return"vs.editor.modes.modeInstantiator"},e.prototype._instantiateInWorkers=function(e){ot._getOrCreateMode(e).done(null,d.onUnexpectedError)},e.INSTANCE=new e,e.INSTANCE_REGISTERED=!1,e.$_instantiateInWorkers=c.AllWorkers(e,e.prototype._instantiateInWorkers),e}(),at=function(){function e(e){void 0===e&&(e={}),this._config=e}return e.configureModeById=function(t,r){e.INSTANCE._configureModeById(t,r)},e.getConfigurationForMode=function(t){return e.INSTANCE._getConfigurationForMode(t)},e.register=function(t){if(!(e.INSTANCE instanceof ut)){var r=new ut(e.INSTANCE);t.registerInstance(r),e.INSTANCE=r}},e.prototype._configureModeById=function(e,t){var r=this._config[e]||{},n=h.mixin(h.clone(r),t);return h.equals(r,n)?!1:(this._config[e]=n,!0)},e.prototype._getConfigurationForMode=function(e){return this._config[e]||{}},e.INSTANCE=new e,e}(),ut=function(e){function t(t){e.call(this,t._config)}return __extends(t,e),t.prototype.getId=function(){return"vs.editor.modes.modeConfigurator"},t.prototype.getSerializableState=function(){return this._config},t.prototype.setData=function(e){this._config=e},t.prototype._configureModeById=function(t,r){if(e.prototype._configureModeById.call(this,t,r)){var n=ot.getMode(t);n&&n.configSupport&&n.configSupport.configure(this._getConfigurationForMode(t))}},t.$_configureModeById=c.Everywhere(t,t.prototype._configureModeById),t}(at);t.activate=x,t.registerDeclarativeCharacterPairSupport=M,t.registerCodeLensSupport=L,t.registerDeclarativeCommentsSupport=I,t.registerDeclarativeDeclarationSupport=A,t.registerDeclarativeElectricCharacterSupport=N,t.registerExtraInfoSupport=P,t.registerFormattingSupport=O,t.registerInplaceReplaceSupport=R,t.registerNavigateTypesSupport=D,t.registerOccurrencesSupport=W,t.registerOutlineSupport=B,t.registerDeclarativeParameterHintsSupport=F,t.registerQuickFixSupport=U,t.registerDeclarativeReferenceSupport=z,t.registerRenameSupport=j,t.registerDeclarativeSuggestSupport=H,t.registerTokenizationSupport=q,t.registerDeclarativeTokenTypeClassificationSupport=V,b(function(e){e.registerInstance(ct.INSTANCE),ct.INSTANCE.registeredWithThreadService()});var ct=function(){function e(){var e=this;this._isRegisteredWithThreadService=!1,this.knownModeIds={},this.mime2LanguageId={},this.name2LanguageId={},this.id2Name={},this.isCompatModeId={},this.lowerName2Id={},this._isRegisteredWithThreadService=!1,p.registerPointListener("language",function(t){return e._onLanguages(t)})}return e.prototype.registeredWithThreadService=function(){this._isRegisteredWithThreadService=!0},e.prototype.getId=function(){return"modesExtensions.LanguagePoint"},e.prototype.getSerializableState=function(){return{knownModeIds:this.knownModeIds,mime2LanguageId:this.mime2LanguageId,name2LanguageId:this.name2LanguageId,id2Name:this.id2Name,isCompatModeId:this.isCompatModeId,lowerName2Id:this.lowerName2Id}},e.prototype.setData=function(e){this.knownModeIds=e.knownModeIds,this.mime2LanguageId=e.mime2LanguageId,this.name2LanguageId=e.name2LanguageId,this.id2Name=e.id2Name,this.isCompatModeId=e.isCompatModeId,this.lowerName2Id=e.lowerName2Id},e.prototype._onLanguages=function(e){this._isRegisteredWithThreadService?this._onLanguagesEverywhere(e):this._onLanguagesImpl(e)},e.prototype._onLanguagesEverywhere=function(e){this._onLanguagesImpl(e)},e.prototype._onLanguagesImpl=function(e){for(var t=0;t<e.length;t++){var r=e[t].contributes.language;if(Array.isArray(r))for(var n=0;n<r.length;n++)this._onLanguage(e[t],r[n]);else console.warn("Ignoring `language` point for "+e[t].pluginId)}},e.prototype._onLanguage=function(e,t){if("string"!=typeof t.id)return console.warn("Ignoring `language` point for "+e.pluginId),void 0;this.knownModeIds[t.id]=!0;var r=null;if("undefined"!=typeof t.mimetypes&&Array.isArray(t.mimetypes))for(var i=0;i<t.mimetypes.length;i++)r||(r=t.mimetypes[i]),this.mime2LanguageId[t.mimetypes[i]]=t.id;if(r||(r="text/x-"+t.id,this.mime2LanguageId[r]=t.id),"undefined"!=typeof t.extensions&&Array.isArray(t.extensions))for(var i=0;i<t.extensions.length;i++)g.registerTextMimeByFilename(t.extensions[i],r);if("undefined"!=typeof t.filenames&&Array.isArray(t.filenames))for(var i=0;i<t.filenames.length;i++)g.registerTextMimeByFilename(t.filenames[i],r);if("string"==typeof t.firstLine&&t.firstLine.length>0){var o=t.firstLine;"^"!==o.charAt(0)&&(o="^"+o);try{var s=new RegExp(o);n.regExpLeadsToEndlessLoop(s)||g.registerTextMimeByFirstLine(s,r)}catch(a){d.onUnexpectedError(a)}}var u=null;if("undefined"!=typeof t.aliases&&Array.isArray(t.aliases))for(var i=0;i<t.aliases.length;i++)t.aliases[i]&&0!==t.aliases[i].length&&(u||(u=t.aliases[i],this.name2LanguageId[t.aliases[i]]=t.id),this.lowerName2Id[t.aliases[i].toLowerCase()]=t.id);this.id2Name[t.id]=u||"","undefined"!=typeof t.__isCompat&&(this.isCompatModeId[t.id]=!0)},e.prototype.isRegisteredMode=function(e){return $.call(this.mime2LanguageId,e)?!0:$.call(this.knownModeIds,e)},e.prototype.getRegisteredModes=function(){return Object.keys(this.knownModeIds)},e.prototype.getRegisteredMimetypes=function(){return Object.keys(this.mime2LanguageId)},e.prototype.getRegisteredLanguageNames=function(){return Object.keys(this.name2LanguageId)},e.prototype.getLanguageName=function(e){return this.id2Name[e]||null},e.prototype.getModeIdForLanguageNameLowercase=function(e){return this.lowerName2Id[e]||null},e.prototype.getMimeForMode=function(e){for(var t in this.mime2LanguageId)if(this.mime2LanguageId.hasOwnProperty(t)){var r=this.mime2LanguageId[t];if(r===e)return t}return null},e.prototype.extractModeIds=function(e){var t=this;return e?e.split(",").map(function(e){return e.trim()}).map(function(e){return t.mime2LanguageId[e]||e}).filter(function(e){return t.knownModeIds[e]}):[]},e.prototype.getModeIdsFromLanguageName=function(e){return e?$.call(this.name2LanguageId,e)?[this.name2LanguageId[e]]:[]:[]},e.prototype.getModeIdsFromFilenameOrFirstLine=function(e,t){if(!e&&!t)return[];var r=g.guessMimeTypes(e,t);return this.extractModeIds(r.join(","))},e.prototype.isCompat=function(e){return this.isCompatModeId[e]||!1},e.INSTANCE=new e,e.$_onLanguagesEverywhere=c.Everywhere(e,e.prototype._onLanguagesEverywhere),e}(),lt=Object.create(null),pt=Object.create(null);t.registerDefaultSnippets=G,t.registerSnippets=K,t.getSnippets=X}),define("vs/editor/core/internalConstants",["require","exports"],function(e,t){t.Handler={ExecuteCommand:"executeCommand",ExecuteCommands:"executeCommands",CursorLeft:"cursorLeft",CursorLeftSelect:"cursorLeftSelect",CursorWordLeft:"cursorWordLeft",CursorWordLeftSelect:"cursorWordLeftSelect",CursorRight:"cursorRight",CursorRightSelect:"cursorRightSelect",CursorWordRight:"cursorWordRight",CursorWordRightSelect:"cursorWordRightSelect",CursorUp:"cursorUp",CursorUpSelect:"cursorUpSelect",CursorDown:"cursorDown",CursorDownSelect:"cursorDownSelect",CursorPageUp:"cursorPageUp",CursorPageUpSelect:"cursorPageUpSelect",CursorPageDown:"cursorPageDown",CursorPageDownSelect:"cursorPageDownSelect",CursorHome:"cursorHome",CursorHomeSelect:"cursorHomeSelect",CursorEnd:"cursorEnd",CursorEndSelect:"cursorEndSelect",CursorTop:"cursorTop",CursorTopSelect:"cursorTopSelect",CursorBottom:"cursorBottom",CursorBottomSelect:"cursorBottomSelect",AddCursorDown:"addCursorDown",AddCursorUp:"addCursorUp",CursorUndo:"cursorUndo",MoveTo:"moveTo",MoveToSelect:"moveToSelect",CreateCursor:"createCursor",LastCursorMoveToSelect:"lastCursorMoveToSelect",JumpToBracket:"jumpToBracket",Type:"type",ReplacePreviousChar:"replacePreviousChar",Paste:"paste",Tab:"tab",Indent:"indent",Outdent:"outdent",DeleteLeft:"deleteLeft",DeleteRight:"deleteRight",DeleteWordLeft:"deleteWordLeft",DeleteWordRight:"deleteWordRight",DeleteAllLeft:"deleteAllLeft",DeleteAllRight:"deleteAllRight",Enter:"enter",RemoveSecondaryCursors:"removeSecondaryCursors",CancelSelection:"cancelSelection",Cut:"cut",Undo:"undo",Redo:"redo",WordSelect:"wordSelect",WordSelectDrag:"wordSelectDrag",LastCursorWordSelect:"lastCursorWordSelect",LineSelect:"lineSelect",LineSelectDrag:"lineSelectDrag",LastCursorLineSelect:"lastCursorLineSelect",LastCursorLineSelectDrag:"lastCursorLineSelectDrag",LineInsertBefore:"lineInsertBefore",LineInsertAfter:"lineInsertAfter",LineBreakInsert:"lineBreakInsert",SelectAll:"selectAll"}}),define("vs/editor/core/constants",["require","exports","./internalConstants"],function(e,t,r){t.EditorType={ICodeEditor:"vs.editor.ICodeEditor",IDiffEditor:"vs.editor.IDiffEditor",ITerminal:"vs.editor.ITerminal"},t.ClassName={EditorWarningDecoration:"greensquiggly",EditorErrorDecoration:"redsquiggly"},t.InternalHandlers={Indent:r.Handler.Indent,Outdent:r.Handler.Outdent,LineInsertBefore:r.Handler.LineInsertBefore,LineInsertAfter:r.Handler.LineInsertAfter,AddCursorUp:r.Handler.AddCursorUp,AddCursorDown:r.Handler.AddCursorDown},t.EventType={Disposed:"disposed",ConfigurationChanged:"configurationChanged",ModelDispose:"modelDispose",ModelChanged:"modelChanged",ModelTokensChanged:"modelTokensChanged",ModelModeChanged:"modelsModeChanged",ModelModeSupportChanged:"modelsModeSupportChanged",ModelContentChanged:"contentChanged",ModelContentChanged2:"contentChanged2",ModelContentChangedFlush:"flush",ModelContentChangedLinesDeleted:"linesDeleted",ModelContentChangedLinesInserted:"linesInserted",ModelContentChangedLineChanged:"lineChanged",EditorTextBlur:"blur",EditorTextFocus:"focus",EditorFocus:"widgetFocus",EditorBlur:"widgetBlur",ModelPropertiesChanged:"propertiesChanged",ModelDecorationsChanged:"decorationsChanged",CursorPositionChanged:"positionChanged",CursorSelectionChanged:"selectionChanged",CursorRevealRange:"revealRange",ViewFocusGained:"focusGained",ViewFocusLost:"focusLost",ViewFocusChanged:"focusChanged",ViewScrollWidthChanged:"scrollWidthChanged",ViewScrollHeightChanged:"scrollHeightChanged",ViewScrollChanged:"scrollChanged",ViewZonesChanged:"zonesChanged",ViewLayoutChanged:"viewLayoutChanged",ContextMenu:"contextMenu",MouseDown:"mousedown",MouseUp:"mouseup",MouseMove:"mousemove",MouseLeave:"mouseleave",KeyDown:"keydown",KeyUp:"keyup",EditorLayout:"editorLayout",DiffUpdated:"diffUpdated"}}),define("vs/editor/core/view/model/prefixSumComputer",["require","exports"],function(e,t){var r=function(){function e(e){this.values=e,this.prefixSum=[];for(var t=0,r=this.values.length;r>t;t++)this.prefixSum[t]=0;this.prefixSumValidIndex=-1}return e.prototype.getCount=function(){return this.values.length},e.prototype.insertValue=function(e,t){this.values.splice(e,0,t),this.prefixSum.splice(e,0,0),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.insertValues=function(t,r){0!==r.length&&(this.values=this.values.slice(0,t).concat(r).concat(this.values.slice(t)),this.prefixSum=this.prefixSum.slice(0,t).concat(e._zeroArray(r.length)).concat(this.prefixSum.slice(t)),t-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=t-1))},e._zeroArray=function(e){for(var t=new Array(e),r=0;e>r;r++)t[r]=0;return t},e.prototype.changeValue=function(e,t){this.values[e]!==t&&(this.values[e]=t,e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1))},e.prototype.removeValues=function(e,t){this.values.splice(e,t),this.prefixSum.splice(e,t),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.getTotalValue=function(){return 0===this.values.length?0:this.getAccumulatedValue(this.values.length-1)},e.prototype.getAccumulatedValue=function(e){if(0>e)return 0;if(e<=this.prefixSumValidIndex)return this.prefixSum[e];var t=this.prefixSumValidIndex+1;0===t&&(this.prefixSum[0]=this.values[0],t++),e>=this.values.length&&(e=this.values.length-1);
for(var r=t;e>=r;r++)this.prefixSum[r]=this.prefixSum[r-1]+this.values[r];return this.prefixSumValidIndex=Math.max(this.prefixSumValidIndex,e),this.prefixSum[e]},e.prototype.getIndexOf=function(e,t){for(var r,n,i,o=0,s=this.values.length-1;s>=o;)if(r=o+(s-o)/2|0,i=this.getAccumulatedValue(r),n=i-this.values[r],n>e)s=r-1;else{if(!(e>=i))break;o=r+1}t.index=r,t.remainder=e-n},e}();t.PrefixSumComputer=r}),define("vs/base/lifecycle",["require","exports"],function(e,t){function r(e){for(var t=0,r=e.length;r>t;t++)e[t]&&e[t].dispose();return[]}function n(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return{dispose:function(){return r(e)}}}function i(e){return{dispose:function(){return r(e)}}}function o(e){return{dispose:function(){return e()}}}function s(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return i(e.map(o))}function a(e){if(e){if("function"==typeof e)return e(),null;if(Array.isArray(e)){for(;e.length>0;)e.pop()();return e}return null}return null}t.disposeAll=r,t.combinedDispose=n,t.combinedDispose2=i,t.fnToDisposable=o,t.toDisposable=s,t.cAll=a;var u=function(){function e(e){this._prefix=e,this._lastId=0}return e.prototype.generate=function(){return this._prefix+ ++this._lastId},e}();t.IdGenerator=u}),define("vs/editor/core/model/tokensBinaryEncoding",["require","exports","vs/base/strings","vs/base/errors"],function(e,t,r,n){function i(e,r){if(0===r.length)return m;if(1===r.length&&0===r[0].startIndex&&!r[0].type&&!r[0].bracket)return _;var i,o,s,a,u,c,l=e._inflate,p=e._deflate,d=-1,h=new Array(r.length);for(i=0,o=r.length;o>i;i++)c=r[i],c.startIndex<=d&&(c.startIndex=d+1,n.onUnexpectedError({message:"Invalid tokens detected",tokens:r})),p.hasOwnProperty(c.type)?s=p[c.type]:(s=l.length,p[c.type]=s,l.push(c.type)),a=c.bracket,0>a&&(a=2),u=a*t.BRACKET_OFFSET+s*t.TYPE_OFFSET+c.startIndex*t.START_INDEX_OFFSET,h[i]=u,d=c.startIndex;return h}function o(e,r){if(0===r)return f;var n=r/t.START_INDEX_OFFSET&t.START_INDEX_MASK,i=r/t.TYPE_OFFSET&t.TYPE_MASK,o=r/t.BRACKET_OFFSET&t.BRACKET_MASK;return 2===o&&(o=-1),new h(n,e._inflate[i],o)}function s(e){return e/t.START_INDEX_OFFSET&t.START_INDEX_MASK}function a(e,n){var i=n/t.TYPE_OFFSET&t.TYPE_MASK;return 0===i?r.empty:e._inflate[i]}function u(e){var r=e/t.BRACKET_OFFSET&t.BRACKET_MASK;return 2===r&&(r=-1),r}function c(e,r){if(0===r.length)return g;if(1===r.length&&0===r[0])return v;var n,i,o,s,a,u,c=new Array(r.length),l=e._inflate;for(n=0,i=r.length;i>n;n++)o=r[n],s=o/t.START_INDEX_OFFSET&t.START_INDEX_MASK,u=o/t.TYPE_OFFSET&t.TYPE_MASK,a=o/t.BRACKET_OFFSET&t.BRACKET_MASK,2===a&&(a=-1),c[n]=new h(s,l[u],a);return c}function l(e,t){return d(e,t)}function p(e,r,n,i,o){if(0===r.length)return g;if(1===r.length&&0===r[0])return v;var s,a,u,c,l,p,f,m=d(r,n),_=[],y=e._inflate;for(u=r[m],p=u/t.TYPE_OFFSET&t.TYPE_MASK,f=u/t.BRACKET_OFFSET&t.BRACKET_MASK,l=0,_.push(new h(l,y[p],f)),s=m+1,a=r.length;a>s&&(u=r[s],c=u/t.START_INDEX_OFFSET&t.START_INDEX_MASK,!(c>=i));s++)p=u/t.TYPE_OFFSET&t.TYPE_MASK,f=u/t.BRACKET_OFFSET&t.BRACKET_MASK,l=c-n+o,_.push(new h(l,y[p],f));return _}function d(e,t){for(var r,n,i=0,o=e.length-1;o>i;)r=i+Math.ceil((o-i)/2),n=4294967295&e[r],n>t?o=r-1:i=r;return i}var h=function(){function e(e,t,r){this.startIndex=e,this.type=t,this.bracket=r}return e}();t.START_INDEX_MASK=4294967295,t.TYPE_MASK=65535,t.BRACKET_MASK=255,t.START_INDEX_OFFSET=1,t.TYPE_OFFSET=Math.pow(2,32),t.BRACKET_OFFSET=Math.pow(2,48);var f={startIndex:0,type:"",bracket:0},g=[],m=[],v=[f],_=[0];t.deflateArr=i,t.inflate=o,t.getStartIndex=s,t.getType=a,t.getBracket=u,t.inflateArr=c,t.findIndexOfOffset=l,t.sliceAndInflate=p,t.findIndexInSegmentsArray=d}),define("vs/editor/editor",["require","exports","vs/editor/core/model/tokensBinaryEncoding"],function(e,t,r){function n(e){return"indent"===e?i.Indent:"same"===e?i.Same:i.None}!function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(t.SelectionDirection||(t.SelectionDirection={}));t.SelectionDirection;!function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent"}(t.WrappingIndent||(t.WrappingIndent={}));var i=t.WrappingIndent;t.wrappingIndentFromString=n,function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"}(t.OverviewRulerLane||(t.OverviewRulerLane={}));t.OverviewRulerLane;!function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.EndOfLinePreference||(t.EndOfLinePreference={}));t.EndOfLinePreference;!function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"}(t.EndOfLineSequence||(t.EndOfLineSequence={}));t.EndOfLineSequence;t.LineTokensBinaryEncoding=r,function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));t.TrackedRangeStickiness;!function(e){e[e.Simple=0]="Simple",e[e.Center=1]="Center",e[e.CenterIfOutsideViewport=2]="CenterIfOutsideViewport"}(t.VerticalRevealType||(t.VerticalRevealType={}));t.VerticalRevealType;!function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"}(t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));t.ContentWidgetPositionPreference;!function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"}(t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));t.OverlayWidgetPositionPreference;!function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET"}(t.MouseTargetType||(t.MouseTargetType={}));t.MouseTargetType;t.KEYBINDING_CONTEXT_EDITOR_TEXT_FOCUS="editorTextFocus",t.KEYBINDING_CONTEXT_EDITOR_FOCUS="editorFocus",t.KEYBINDING_CONTEXT_EDITOR_TAB_MOVES_FOCUS="editorTabMovesFocus",t.KEYBINDING_CONTEXT_EDITOR_HAS_MULTIPLE_SELECTIONS="editorHasMultipleSelections",t.KEYBINDING_CONTEXT_EDITOR_HAS_NON_EMPTY_SELECTION="editorHasSelection",t.KEYBINDING_CONTEXT_EDITOR_LANGUAGE_ID="editorLangId"}),define("vs/editor/core/model/modelLine",["require","exports","vs/editor/editor","vs/base/strings"],function(e,t,r,n){function i(e,t,r){return 0===r?h.INSTANCE:!t||0===t.length||1===t.length&&0===t[0].startIndex&&""===t[0].type&&!t[0].bracket?f.INSTANCE:new d(e,t)}function o(e,t,r){return 0===r?h.INSTANCE:!t||0===t.length||1===t.length&&0===t[0]?f.INSTANCE:new d(e,t)}function s(e,t){return t&&0!==t.length?1===t.length&&0===t[0].startIndex?t[0].mode===e?g.INSTANCE:new m(t[0].mode):new v(t):g.INSTANCE}var a=function(){function e(e,t){this.lineNumber=e,this.text=t,this.isInvalid=!1,this._recreateLineTokens(null,null),this._recreateModeTransitions(null,null)}return e.prototype.setState=function(e){this._state=e},e.prototype.getState=function(){return this._state||null},e.prototype._setLineTokens=function(e){("undefined"!=typeof this._lineTokens||e!==h.INSTANCE&&e!==f.INSTANCE)&&(this._lineTokens=e)},e.prototype.getTokens=function(){return this._lineTokens?this._lineTokens:0===this.text.length?h.INSTANCE:f.INSTANCE},e.prototype.getModeTransitions=function(){return this._modeTransitions?this._modeTransitions:g.INSTANCE},e.prototype._recreateLineTokens=function(e,t){this._setLineTokens(i(e,t,this.text.length))},e.prototype._recreateLineTokens2=function(e,t){this._setLineTokens(o(e,t,this.text.length))},e.prototype._setModeTransitions=function(e){("undefined"!=typeof this._modeTransitions||e!==g.INSTANCE)&&(this._modeTransitions=e)},e.prototype._recreateModeTransitions=function(e,t){this._setModeTransitions(s(e,t))},e.prototype.insertText=function(e,t,n,i){var o=this.text,s=o.length+1,a=this.getTokens(),u=a.getBinaryEncodedTokens(),c=a instanceof d,l=n.text.length;t=Math.max(1,t),t=Math.min(t,s);var p,h;if(l>0){var f=o.substring(0,t-1)+n.text+o.substring(t-1,o.length);if(c){var g,m,v,_,y,b,S=r.LineTokensBinaryEncoding;for(p=0,h=u.length;h>p;p++)g=u[p],m=g/S.START_INDEX_OFFSET&S.START_INDEX_MASK,m>=t-1&&m>0&&(y=g/S.TYPE_OFFSET&S.TYPE_MASK,b=g/S.BRACKET_OFFSET&S.BRACKET_MASK,_=m+l,v=b*S.BRACKET_OFFSET+y*S.TYPE_OFFSET+_*S.START_INDEX_OFFSET,u[p]=v)}if(this._markers){var k;for(p=0,h=this._markers.length;h>p;p++)k=this._markers[p],(k.column>t||k.column===t&&(i||!k.stickToPreviousCharacter))&&(e[k.id]=!0,k.oldLineNumber=k.oldLineNumber||this.lineNumber,k.oldColumn=k.oldColumn||k.column,k.column+=l)}this.text=f,this._recreateLineTokens2(a.getBinaryEncodedTokensMap(),u)}if(n.markers&&(h=n.markers.length,h>0))for(this._markers||(this._markers=[]),p=0;h>p;p++)k=n.markers[p],e[k.id]=!0,k.oldLineNumber=k.oldLineNumber||this.lineNumber,k.oldColumn=k.oldColumn||k.column,k.line=this,k.column+=t-1,this._markers.push(k)},e.prototype.removeText=function(e,t,n,i,o){var s=n,a="",u=[],c=this.text,l=c.length+1,p=this.getTokens(),h=p.getBinaryEncodedTokens(),f=p instanceof d;t=Math.max(1,t),n=Math.max(1,n),t=Math.min(t,l),n=Math.min(n,l);var g;if(n>t&&n>1&&l>t){a=c.substring(t-1,n-1);var m=c.substring(0,t-1)+c.substring(n-1,c.length);if(f){var v,_,y,b,S,k,C,T=r.LineTokensBinaryEncoding;for(g=0;g<h.length;g++)v=h[g],_=v/T.START_INDEX_OFFSET&T.START_INDEX_MASK,b=_,_>=n-1?b=_-a.length:_>=t-1&&(b=t-1),b>=m.length?(h.splice(g,1),g--):(S=v/T.TYPE_OFFSET&T.TYPE_MASK,k=v/T.BRACKET_OFFSET&T.BRACKET_MASK,y=k*T.BRACKET_OFFSET+S*T.TYPE_OFFSET+b*T.START_INDEX_OFFSET,h[g]=y,g>0&&(C=h[g-1]/T.START_INDEX_OFFSET&T.START_INDEX_MASK,C>=b&&(h.splice(g-1,1),g--)))}this.text=m,this._recreateLineTokens2(p.getBinaryEncodedTokensMap(),h)}if(this._markers){var E;for(g=0;g<this._markers.length;g++)E=this._markers[g],E.column>s||E.column===s&&(o||!E.stickToPreviousCharacter)?(e[E.id]=!0,E.oldLineNumber=E.oldLineNumber||this.lineNumber,E.oldColumn=E.oldColumn||E.column,E.column-=a.length):(E.column>t||E.column===t&&(o||!E.stickToPreviousCharacter))&&(e[E.id]=!0,E.oldLineNumber=E.oldLineNumber||this.lineNumber,E.oldColumn=E.oldColumn||E.column,i?(E.line=null,E.column-=t-1,this._markers.splice(g,1),g--,u.push(E)):E.column=t)}return{text:a,markers:u}},e.prototype.addMarker=function(e){e.line=this,this._markers?this._markers.push(e):this._markers=[e]},e.prototype.addMarkers=function(e){var t,r;for(t=0,r=e.length;r>t;t++)e[t].line=this;this._markers=this._markers?this._markers.concat(e):e.slice(0)},e.prototype.removeMarker=function(e){var t=this._indexOfMarkerId(e.id);t>=0&&this._markers.splice(t,1),e.line=null},e.prototype.getMarkers=function(){return this._markers?this._markers.slice(0):[]},e.prototype.updateLineNumber=function(e,t){if(this._markers){var r,n,i,o=this._markers;for(r=0,n=o.length;n>r;r++)i=o[r],e[i.id]=!0,i.oldLineNumber=i.oldLineNumber||this.lineNumber}this.lineNumber=t},e.prototype.deleteLine=function(e,t,r){if(this._markers){var n,i,o,s=this._markers;for(n=0,i=s.length;i>n;n++)o=s[n],e[o.id]=!0,o.oldColumn=o.oldColumn||o.column,o.oldLineNumber=o.oldLineNumber||r,o.column=t;return s}return[]},e.prototype._indexOfMarkerId=function(e){if(this._markers){var t,r,n=this._markers;for(t=0,r=n.length;r>t;t++)if(n[t].id===e)return t}return-1},e.prototype.setTokens=function(e,t,r,n){this._recreateLineTokens(e,t),this._recreateModeTransitions(r,n)},e}();t.ModelLine=a;var u=r.LineTokensBinaryEncoding.getStartIndex,c=r.LineTokensBinaryEncoding.getType,l=r.LineTokensBinaryEncoding.getBracket,p=r.LineTokensBinaryEncoding.findIndexOfOffset,d=function(){function e(e,t){this.map=e,this._tokens="number"==typeof t[0]?t:r.LineTokensBinaryEncoding.deflateArr(e,t)}return e.prototype.getBinaryEncodedTokensMap=function(){return this.map},e.prototype.getBinaryEncodedTokens=function(){return this._tokens},e.prototype.getTokenCount=function(){return this._tokens.length},e.prototype.getTokenStartIndex=function(e){return u(this._tokens[e])},e.prototype.getTokenType=function(e){return c(this.map,this._tokens[e])},e.prototype.getTokenBracket=function(e){return l(this._tokens[e])},e.prototype.getTokenEndIndex=function(e,t){return e+1<this._tokens.length?u(this._tokens[e+1]):t},e.prototype.equals=function(e){return this===e},e.prototype.findIndexOfOffset=function(e){return p(this._tokens,e)},e}();t.LineTokens=d;var h=function(){function e(){}return e.prototype.getBinaryEncodedTokens=function(){return e.TOKENS},e.prototype.getBinaryEncodedTokensMap=function(){return null},e.prototype.getTokenCount=function(){return 0},e.prototype.getTokenStartIndex=function(){return 0},e.prototype.getTokenType=function(){return n.empty},e.prototype.getTokenBracket=function(){return 0},e.prototype.getTokenEndIndex=function(){return 0},e.prototype.equals=function(e){return e===this},e.prototype.findIndexOfOffset=function(){return 0},e.INSTANCE=new e,e.TOKENS=[],e}(),f=function(){function e(){}return e.prototype.getBinaryEncodedTokensMap=function(){return null},e.prototype.getBinaryEncodedTokens=function(){return e.TOKENS},e.prototype.getTokenCount=function(){return 1},e.prototype.getTokenStartIndex=function(){return 0},e.prototype.getTokenType=function(){return n.empty},e.prototype.getTokenBracket=function(){return 0},e.prototype.getTokenEndIndex=function(e,t){return t},e.prototype.equals=function(e){return this===e},e.prototype.findIndexOfOffset=function(){return 0},e.INSTANCE=new e,e.TOKENS=[0],e}();t.DefaultLineTokens=f;var g=function(){function e(){}return e.prototype.toArray=function(e){return[{startIndex:0,mode:e}]},e.INSTANCE=new e,e}(),m=function(){function e(e){this._mode=e}return e.prototype.toArray=function(){return[{startIndex:0,mode:this._mode}]},e}(),v=function(){function e(e){this._modeTransitions=e}return e.prototype.toArray=function(){return this._modeTransitions.slice(0)},e}()}),define("vs/editor/core/position",["require","exports"],function(e,t){function r(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column}function n(e){return e?[0|e.lineNumber,0|e.column]:[-1,-1]}function i(e){return-1===e[0]&&-1===e[1]?null:new u(e[0],e[1])}function o(e){for(var t=[],r=0,n=e.length;n>r;r++){var i=e[r];i?(t[2*r+0]=0|i.lineNumber,t[2*r+1]=0|i.column):(t[2*r+0]=-1,t[2*r+1]=-1)}return t}function s(e){for(var t=[],r=0,n=Math.floor(e.length/2);n>r;r++)t[r]=-1===e[2*r+0]&&-1===e[2*r+1]?null:new u(e[2*r+0],e[2*r+1]);return t}t.isIPosition=r,t.serialize=n,t.deserialize=i,t.serializeMany=o,t.deserializeMany=s;var a;!function(e){function t(e){return{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:e.lineNumber,endColumn:e.column}}function r(e){return{lineNumber:e.startLineNumber,column:e.startColumn}}function n(e){return{lineNumber:e.endLineNumber,column:e.endColumn}}e.asEmptyRange=t,e.startPosition=r,e.endPosition=n}(a=t.PositionUtils||(t.PositionUtils={}));var u=function(){function e(e,t){this.lineNumber=e,this.column=t}return e.prototype.equals=function(e){return!!e&&this.lineNumber===e.lineNumber&&this.column===e.column},e.prototype.isBefore=function(e){return this.lineNumber<e.lineNumber?!0:e.lineNumber<this.lineNumber?!1:this.column<e.column},e.prototype.isBeforeOrEqual=function(e){return this.lineNumber<e.lineNumber?!0:e.lineNumber<this.lineNumber?!1:this.column<=e.column},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e}();t.Position=u}),define("vs/editor/core/range",["require","exports","vs/editor/core/position"],function(e,t,r){function n(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn}function i(e){return e?[0|e.startLineNumber,0|e.startColumn,0|e.endLineNumber,0|e.endColumn]:[-1,-1,-1,-1]}function o(e){return-1===e[0]&&-1===e[1]&&-1===e[2]&&-1===e[3]?null:new S(e[0],e[1],e[2],e[3])}function s(e){for(var t=[],r=0,n=e.length;n>r;r++){var i=e[r];i?(t[4*r+0]=0|i.startLineNumber,t[4*r+1]=0|i.startColumn,t[4*r+2]=0|i.endLineNumber,t[4*r+3]=0|i.endColumn):(t[4*r+0]=-1,t[4*r+1]=-1,t[4*r+2]=-1,t[4*r+3]=-1)}return t}function a(e){for(var t=[],r=0,n=Math.floor(e.length/4);n>r;r++)t[r]=-1===e[4*r+0]&&-1===e[4*r+1]&&-1===e[4*r+2]&&-1===e[4*r+3]?null:new S(e[4*r+0],e[4*r+1],e[4*r+2],e[4*r+3]);return t}function u(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn}function c(e,t){return t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber?!1:t.lineNumber===e.startLineNumber&&t.column<e.startColumn?!1:t.lineNumber===e.endLineNumber&&t.column>e.endColumn?!1:!0}function l(e,t){return t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber?!1:t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber?!1:t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn?!1:t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn?!1:!0}function p(e,t){return e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn?!1:t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn?!1:!0}function d(e,t){var r=e.startLineNumber,n=e.startColumn,i=e.endLineNumber,o=e.endColumn,s=t.startLineNumber,a=t.startColumn,u=t.endLineNumber,c=t.endColumn;return s>r?(r=s,n=a):r===s&&(n=Math.max(n,a)),i>u?(i=u,o=c):i===u&&(o=Math.min(o,c)),r>i?null:r===i&&n>o?null:new S(r,n,i,o)}function h(e,t){var r,n,i,o;return t.startLineNumber<e.startLineNumber?(r=t.startLineNumber,n=t.startColumn):t.startLineNumber===e.startLineNumber?(r=t.startLineNumber,n=Math.min(t.startColumn,e.startColumn)):(r=e.startLineNumber,n=e.startColumn),t.endLineNumber>e.endLineNumber?(i=t.endLineNumber,o=t.endColumn):t.endLineNumber===e.endLineNumber?(i=t.endLineNumber,o=Math.max(t.endColumn,e.endColumn)):(i=e.endLineNumber,o=e.endColumn),new S(r,n,i,o)}function f(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn}function g(e,t){return e.startLineNumber===t.startLineNumber?e.startColumn===t.startColumn?e.endLineNumber===t.endLineNumber?e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber:e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber}function m(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber}function v(e){return e.endLineNumber>e.startLineNumber}function _(e){return 17*e.startLineNumber+23*e.startColumn+29*e.endLineNumber+37*e.endColumn}function y(e){return{startLineNumber:e.startLineNumber,startColumn:e.startColumn,endLineNumber:e.startLineNumber,endColumn:e.startColumn}}function b(e){return e?new S(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):null}t.isIRange=n,t.serialize=i,t.deserialize=o,t.serializeMany=s,t.deserializeMany=a,t.isEmpty=u,t.containsPosition=c,t.containsRange=l,t.areIntersectingOrTouching=p,t.intersectRanges=d,t.plusRange=h,t.equalsRange=f,t.compareRangesUsingStarts=g,t.compareRangesUsingEnds=m,t.spansMultipleLines=v,t.hashCode=_,t.collapseToStart=y;var S=function(){function e(e,t,r,n){e>r||e===r&&t>n?(this.startLineNumber=r,this.startColumn=n,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=r,this.endColumn=n)}return e.prototype.isEmpty=function(){return u(this)},e.prototype.containsPosition=function(e){return c(this,e)},e.prototype.containsRange=function(e){return l(this,e)},e.prototype.plusRange=function(e){return h(this,e)},e.prototype.intersectRanges=function(e){return d(this,e)},e.prototype.equalsRange=function(e){return f(this,e)},e.prototype.getEndPosition=function(){return new r.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new r.Position(this.startLineNumber,this.startColumn)},e.prototype.cloneRange=function(){return new e(this.startLineNumber,this.startColumn,this.endLineNumber,this.endColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(t,r){return new e(this.startLineNumber,this.startColumn,t,r)},e.prototype.setStartPosition=function(t,r){return new e(t,r,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return new e(this.startLineNumber,this.startColumn,this.startLineNumber,this.startColumn)},e}();t.Range=S,t.create=b});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/core/model/textModel",["require","exports","vs/base/eventEmitter","vs/editor/editor","vs/editor/core/model/modelLine","vs/base/strings","vs/editor/core/position","vs/editor/core/range","vs/editor/core/constants","vs/base/eventSource","vs/base/env"],function(e,t,r,n,i,o,s,a,u,c,l){var p=" ".charCodeAt(0),d="	".charCodeAt(0),h=999,f=l.isLinux||l.isMacintosh?"\n":"\r\n",g=function(e){function t(t,r){t.push(u.EventType.ModelContentChanged),e.call(this,t),this._constructLines(r),this._setVersionId(1),this._isDisposed=!1,this._onContentChanged=new c,this.onContentChanged=this._onContentChanged.value}return __extends(t,e),t.prototype.getVersionId=function(){if(this._isDisposed)throw new Error("TextModel.getVersionId: Model is disposed");return this._versionId},t.prototype.getAlternativeVersionId=function(){if(this._isDisposed)throw new Error("TextModel.getAlternativeVersionId: Model is disposed");return this._alternativeVersionId},t.prototype._increaseVersionId=function(){this._setVersionId(this._versionId+1)},t.prototype._setVersionId=function(e){this._versionId=e,this._alternativeVersionId=this._versionId},t.prototype._overwriteAlternativeVersionId=function(e){this._alternativeVersionId=e},t.prototype.isDisposed=function(){return this._isDisposed},t.prototype.dispose=function(){if(this._isDisposed)throw new Error("TextModel.dispose: Model is disposed");this._isDisposed=!0,this._lines=null,this._EOL=null,this._BOM=null,e.prototype.dispose.call(this)},t.prototype._createContentChangedFlushEvent=function(){return{changeType:u.EventType.ModelContentChangedFlush,detail:null,versionId:-1,isUndoing:!1,isRedoing:!1}},t.prototype._emitContentChanged2=function(e,t,r,n,i,o,s,c){var l={range:new a.Range(e,t,r,n),rangeLength:i,text:o,versionId:this.getVersionId(),isUndoing:s,isRedoing:c};this.emit(u.EventType.ModelContentChanged2,l),this._onContentChanged.fire([l])},t.prototype._resetValue=function(e,r){this._constructLines(t.toRawText(r)),this._increaseVersionId(),e.detail=this.toRawText(),e.versionId=this._versionId},t.prototype.toRawText=function(){return{BOM:this._BOM,EOL:this._EOL,lines:this.getLinesContent(),length:this.getValueLength()}},t.prototype.setValue=function(e){if(this._isDisposed)throw new Error("TextModel.setValue: Model is disposed");if(null!==e){var t=this.getFullModelRange(),r=this.getValueLengthInRange(t),n=this.getLineCount(),i=this.getLineMaxColumn(n),o=this._createContentChangedFlushEvent();this._resetValue(o,e),this._emitModelContentChangedFlushEvent(o),this._emitContentChanged2(1,1,n,i,r,this.getValue(),!1,!1)}},t.prototype.getValue=function(e,t){if(void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModel.getValue: Model is disposed");var r=this.getFullModelRange(),n=this.getValueInRange(r,e);return t?this._BOM+n:n},t.prototype.getValueLength=function(e,t){if(void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModel.getValueLength: Model is disposed");var r=this.getFullModelRange(),n=this.getValueLengthInRange(r,e);return t?this._BOM.length+n:n},t.prototype.getEmptiedValueInRange=function(e,t,r){if(void 0===t&&(t=""),void 0===r&&(r=n.EndOfLinePreference.TextDefined),this._isDisposed)throw new Error("TextModel.getEmptiedValueInRange: Model is disposed");var i=this.validateRange(e);if(i.isEmpty())return"";if(i.startLineNumber===i.endLineNumber)return this._repeatCharacter(t,i.endColumn-i.startColumn);var o=this._getEndOfLine(r),s=i.startLineNumber-1,a=i.endLineNumber-1,u=[];u.push(this._repeatCharacter(t,this._lines[s].text.length-i.startColumn+1));for(var c=s+1;a>c;c++)u.push(this._repeatCharacter(t,this._lines[c].text.length));return u.push(this._repeatCharacter(t,i.endColumn-1)),u.join(o)},t.prototype._repeatCharacter=function(e,t){for(var r="",n=0;t>n;n++)r+=e;return r},t.prototype.getValueInRange=function(e,t){if(void 0===t&&(t=n.EndOfLinePreference.TextDefined),this._isDisposed)throw new Error("TextModel.getValueInRange: Model is disposed");var r=this.validateRange(e);if(r.isEmpty())return"";if(r.startLineNumber===r.endLineNumber)return this._lines[r.startLineNumber-1].text.substring(r.startColumn-1,r.endColumn-1);var i=this._getEndOfLine(t),o=r.startLineNumber-1,s=r.endLineNumber-1,a=[];a.push(this._lines[o].text.substring(r.startColumn-1));for(var u=o+1;s>u;u++)a.push(this._lines[u].text);return a.push(this._lines[s].text.substring(0,r.endColumn-1)),a.join(i)},t.prototype.getValueLengthInRange=function(e,t){if(void 0===t&&(t=n.EndOfLinePreference.TextDefined),this._isDisposed)throw new Error("TextModel.getValueInRange: Model is disposed");var r=this.validateRange(e);if(r.isEmpty())return 0;if(r.startLineNumber===r.endLineNumber)return r.endColumn-r.startColumn;var i=this._getEndOfLine(t).length,o=r.startLineNumber-1,s=r.endLineNumber-1,a=0;a+=this._lines[o].text.length-r.startColumn+1;for(var u=o+1;s>u;u++)a+=i+this._lines[u].text.length;return a+=i+(r.endColumn-1)},t.prototype.isDominatedByLongLines=function(e){if(this._isDisposed)throw new Error("TextModel.isDominatedByLongLines: Model is disposed");var t,r,n,i=0,o=0,s=this._lines;for(t=0,r=this._lines.length;r>t;t++)n=s[t].text.length,n>=e?o+=n:i+=n;return o>i},t.prototype._extractIndentationFactors=function(){var e,t,r,n,i,o,s,a,u,c,l,h=this._lines,f=0,g="",m=0,v=[],_=0,y=[];for(e=0,t=h.length;t>e;e++){for(s=h[e].text,a=!1,u=0,l=0,c=0,r=0,n=s.length;n>r;r++)if(i=s.charCodeAt(r),i===d)c++;else{if(i!==p){a=!0,u=r;break}l++}if(1===l&&(l=0),a&&(c>0||l>0)&&(f++,c>0&&_++,l>0&&(y[l]=(y[l]||0)+1)),a){l=0;var b=!0;for(r=0;m>r&&u>r;r++)o=g.charCodeAt(r),i=s.charCodeAt(r),b&&o!==i&&(b=!1),b||(o===p&&l++,i===p&&l++);for(;m>r;r++)o=g.charCodeAt(r),o===p&&l++;for(;u>r;r++)i=s.charCodeAt(r),i===p&&l++;1===l&&(l=0),l>0&&(v[l]=(v[l]||0)+1),m=u,g=s}}return{linesWithIndentationCount:f,linesIndentedWithTabs:_,relativeSpaceCounts:v,absoluteSpaceCounts:y}},t.prototype.guessIndentation=function(e){if(this._isDisposed)throw new Error("TextModel.guessIndentation: Model is disposed");var t,r,n=this._extractIndentationFactors(),i=n.linesWithIndentationCount,o=n.linesIndentedWithTabs,s=n.absoluteSpaceCounts,a=n.relativeSpaceCounts,u=0;for(t=1,r=s.length;r>t;t++)u+=s[t]||0;if(o>=u)return{insertSpaces:!1,tabSize:e};if(6>i&&o>0)return{insertSpaces:!1,tabSize:e};var c,l,p,d,h=[];for(c=2,r=s.length;r>c;c++)if(s[c]){for(l=0,p=0,d=c;r>d;d+=c)s[d]?l+=s[d]:p+=c/d;h[c]=l/(1+p)}var f=e,g=0,m=[2,4,6,8];for(t=0;t<m.length;t++)c=m[t],l=(h[c]||0)+(a[c]||0),l>g&&(f=c,g=l);return{insertSpaces:!0,tabSize:f}},t.prototype.getLineCount=function(){if(this._isDisposed)throw new Error("TextModel.getLineCount: Model is disposed");return this._lines.length},t.prototype.getLineContent=function(e){if(this._isDisposed)throw new Error("TextModel.getLineContent: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._lines[e-1].text},t.prototype.getLinesContent=function(){if(this._isDisposed)throw new Error("TextModel.getLineContent: Model is disposed");for(var e=[],t=0,r=this._lines.length;r>t;t++)e[t]=this._lines[t].text;return e},t.prototype.getEOL=function(){if(this._isDisposed)throw new Error("TextModel.getEOL: Model is disposed");return this._EOL},t.prototype.setEOL=function(e){var t=e===n.EndOfLineSequence.CRLF?"\r\n":"\n";if(this._EOL!==t){var r=this.getFullModelRange(),i=this.getValueLengthInRange(r),o=this.getLineCount(),s=this.getLineMaxColumn(o);this._EOL=t,this._increaseVersionId();var a=this._createContentChangedFlushEvent();a.detail=this.toRawText(),a.versionId=this._versionId,this._emitModelContentChangedFlushEvent(a),this._emitContentChanged2(1,1,o,s,i,this.getValue(),!1,!1)}},t.prototype.getLineMinColumn=function(){return 1},t.prototype.getLineMaxColumn=function(e){if(this._isDisposed)throw new Error("TextModel.getLineMaxColumn: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._lines[e-1].text.length+1},t.prototype.getLineFirstNonWhitespaceColumn=function(e){if(this._isDisposed)throw new Error("TextModel.getLineFirstNonWhitespaceColumn: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");var t=o.firstNonWhitespaceIndex(this._lines[e-1].text);return-1===t?0:t+1},t.prototype.getLineLastNonWhitespaceColumn=function(e){if(this._isDisposed)throw new Error("TextModel.getLineLastNonWhitespaceColumn: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");var t=o.lastNonWhitespaceIndex(this._lines[e-1].text);return-1===t?0:t+2},t.prototype.validateLineNumber=function(e){if(this._isDisposed)throw new Error("TextModel.validateLineNumber: Model is disposed");return 1>e&&(e=1),e>this._lines.length&&(e=this._lines.length),e},t.prototype.validatePosition=function(e){if(this._isDisposed)throw new Error("TextModel.validatePosition: Model is disposed");var t=e.lineNumber?e.lineNumber:1,r=e.column?e.column:1;1>t&&(t=1),t>this._lines.length&&(t=this._lines.length),1>r&&(r=1);var n=this.getLineMaxColumn(t);return r>n&&(r=n),new s.Position(t,r)},t.prototype.validateRange=function(e){if(this._isDisposed)throw new Error("TextModel.validateRange: Model is disposed");var t=this.validatePosition(new s.Position(e.startLineNumber,e.startColumn)),r=this.validatePosition(new s.Position(e.endLineNumber,e.endColumn));return new a.Range(t.lineNumber,t.column,r.lineNumber,r.column)},t.prototype.modifyPosition=function(e,t){if(this._isDisposed)throw new Error("TextModel.modifyPosition: Model is disposed");for(var r=this.validatePosition(e);t>0;){var n=this.getLineMaxColumn(r.lineNumber);if(r.column<n){var i=Math.min(t,n-r.column);t-=i,r.column+=i}if(0===t)break;if(t-=this._EOL.length,0>t)throw new Error("TextModel.modifyPosition: Breaking line terminators");if(++r.lineNumber,r.lineNumber>this._lines.length)throw new Error("TextModel.modifyPosition: Offset goes beyond the end of the model");r.column=1}for(;0>t;){if(r.column>1){var o=Math.min(-t,r.column-1);t+=o,r.column-=o}if(0===t)break;if(t+=this._EOL.length,t>0)throw new Error("TextModel.modifyPosition: Breaking line terminators");if(--r.lineNumber,r.lineNumber<1)throw new Error("TextModel.modifyPosition: Offset goes beyond the beginning of the model");r.column=this.getLineMaxColumn(r.lineNumber)}return r},t.prototype.getFullModelRange=function(){if(this._isDisposed)throw new Error("TextModel.getFullModelRange: Model is disposed");var e=this.getLineCount();return new a.Range(1,1,e,this.getLineMaxColumn(e))},t.prototype._emitModelContentChangedFlushEvent=function(e){this.emit(u.EventType.ModelContentChanged,e)},t.toRawText=function(e){for(var t=0,r=-1;-1!==(r=e.indexOf("\r",r+1));)t++;var n=e.split(/\r\n|\r|\n/),i="";o.startsWithUTF8BOM(n[0])&&(i=o.UTF8_BOM_CHARACTER,n[0]=n[0].substr(1));var s=n.length-1,a="";return a=0===s?f:t>s/2?"\r\n":"\n",{BOM:i,EOL:a,lines:n,length:e.length}},t.prototype._constructLines=function(e){var t,r,n=e.lines,o=[];for(t=0,r=n.length;r>t;t++)o.push(new i.ModelLine(t+1,n[t]));this._BOM=e.BOM,this._EOL=e.EOL,this._lines=o
},t.prototype._getEndOfLine=function(e){switch(e){case n.EndOfLinePreference.LF:return"\n";case n.EndOfLinePreference.CRLF:return"\r\n";case n.EndOfLinePreference.TextDefined:return this.getEOL()}throw new Error("Unknown EOL preference")},t.prototype._toRegExp=function(e,t,r,n){if(""===e)return null;var i=null;try{i=o.createRegExp(e,t,r,n)}catch(s){return null}return o.regExpLeadsToEndlessLoop(i)?null:i},t.prototype.findMatches=function(e,t,r,n,i){if(this._isDisposed)throw new Error("Model.findMatches: Model is disposed");var o=this._toRegExp(e,r,n,i);if(!o)return[];var s;return s=a.isIRange(t)?t:this.getFullModelRange(),this._doFindMatches(s,o)},t.prototype.findNextMatch=function(e,t,r,n,i){if(this._isDisposed)throw new Error("Model.findNextMatch: Model is disposed");var o=this._toRegExp(e,r,n,i);if(!o)return null;var s,a,u=this.validatePosition(t),c=this.getLineCount(),l=u.lineNumber;if(s=this._lines[l-1].text.substring(u.column-1),a=this._findMatchInLine(o,s,l,u.column-1))return a;for(var p=1;c>p;p++){var d=(l+p-1)%c;if(s=this._lines[d].text,a=this._findMatchInLine(o,s,d+1,0))return a}return null},t.prototype._doFindMatches=function(e,t){var r,n=[],i=0;if(e.startLineNumber===e.endLineNumber)return r=this._lines[e.startLineNumber-1].text.substring(e.startColumn-1,e.endColumn-1),i=this._findMatchesInLine(t,r,e.startLineNumber,e.startColumn-1,i,n),n;r=this._lines[e.startLineNumber-1].text.substring(e.startColumn-1),i=this._findMatchesInLine(t,r,e.startLineNumber,e.startColumn-1,i,n);for(var o=e.startLineNumber+1;o<e.endLineNumber&&h>i;o++)i=this._findMatchesInLine(t,this._lines[o-1].text,o,0,i,n);return h>i&&(r=this._lines[e.endLineNumber-1].text.substring(0,e.endColumn-1),i=this._findMatchesInLine(t,r,e.endLineNumber,0,i,n)),n},t.prototype._findMatchInLine=function(e,t,r,n){var i=e.exec(t);return i?new a.Range(r,i.index+1+n,r,i.index+1+i[0].length+n):null},t.prototype._findMatchesInLine=function(e,t,r,n,i,o){var s;do if(s=e.exec(t),s&&(o.push(new a.Range(r,s.index+1+n,r,s.index+1+s[0].length+n)),i++,i>=h))return i;while(s);return i},t}(r.EventEmitter);t.TextModel=g}),define("vs/platform/configuration/keybindings",["require","exports","vs/nls!vs/editor/worker/editorWorkerServer","vs/base/env"],function(e,t,r,n){function i(e){return c(e,!0,"+")}function o(e){var t=[e.ctrlCmd?"CmdOrCtrl+":"",e.winCtrl&&n.isMacintosh?"Ctrl+":"",e.shift?"Shift+":"",e.alt?"Alt+":"",s(e)].join("");return e.chord?t+" "+o(e.chord):t}function s(e){switch(e.key.toLowerCase()){case"uparrow":return"Up";case"downarrow":return"Down";case"leftarrow":return"Left";case"rightarrow":return"Right";case"del":return"Delete"}return e.key}function a(e,t){return void 0===t&&(t="-"),c(e,!1,t)}function u(e){if(_)switch(e.key){case"LeftArrow":return T;case"UpArrow":return E;case"RightArrow":return w;case"DownArrow":return x}return"Del"===e.key?"Delete":e.key}function c(e,t,r){var i=[];(e.ctrlCmd&&!n.isMacintosh||e.winCtrl&&n.isMacintosh)&&i.push(t?y:"Ctrl"),e.shift&&i.push(t?b:"Shift"),e.alt&&i.push(t?S:"Alt"),e.ctrlCmd&&n.isMacintosh&&i.push(t?k:"Meta"),e.winCtrl&&!n.isMacintosh&&i.push(t?C:"Meta"),t?i.push(u(e)):i.push(e.key);var o=t&&_?i.join(""):i.join(r);return e.chord?o+" "+c(e.chord,t,r):o}function l(e){if(n.isWindows){if(e&&e.win)return e.win}else if(n.isMacintosh){if(e&&e.mac)return e.mac}else if(e&&e.linux)return e.linux;return e}function p(e){var t=l(e);t&&t.primary&&h(t.primary,e.id,e.weight,0,e.context),t&&Array.isArray(t.secondary)&&t.secondary.forEach(function(t,r){return h(t,e.id,e.weight,-r-1,e.context)})}function d(e){p(e),L[e.id]=e.handler}function h(e,t,r,n,i){M.push({keybinding:e,command:t,context:i,weight1:r,weight2:n})}function f(){return L}function g(){return M}function m(e,t){var r=Object.create(null);return e.lookupKeybinding(t).map(function(e){return e.keybinding}).filter(function(e){var t=a(e);return r[t]?!1:(r[t]=!0,!0)})}function v(e,t){return m(e,t).map(function(e){return i(e)})}t.toLabel=i,t.toAtomAccelerator=o,t.asString=a;var _=n.isMacintosh,y=_?"⌃":r.localize("vs_platform_configuration_keybindings",0),b=_?"⇧":r.localize("vs_platform_configuration_keybindings",1),S=_?"⌥":r.localize("vs_platform_configuration_keybindings",2),k=_?"⌘":r.localize("vs_platform_configuration_keybindings",3),C=r.localize("vs_platform_configuration_keybindings",4),T=String.fromCharCode(8592),E=String.fromCharCode(8593),w=String.fromCharCode(8594),x=String.fromCharCode(8595),M=[],L=Object.create(null);t.reducePlatform=l,t.registerCommandRule=p,t.registerCommandDesc=d,t.getCommands=f,t.getDefaultKeybindings=g,t.KEYBINDING_CONTEXT_OPERATOR_EQUAL="equal",t.KEYBINDING_CONTEXT_OPERATOR_NOT_EQUAL="not_equal",t.WEIGHT={editorCore:function(e){return void 0===e&&(e=0),0+e},editorContrib:function(e){return void 0===e&&(e=0),100+e},workbenchContrib:function(e){return void 0===e&&(e=0),200+e}},t.lookupKeyBindings=m,t.lookupKeyBindingsAsLabels=v}),define("vs/editor/core/config/config",["require","exports","vs/editor/core/internalConstants","vs/editor/editor","vs/platform/configuration/keybindings"],function(e,t,r,n,i){function o(e,t,r,n){var i=r.context.editorId;if(!i)return n&&console.warn("Cannot execute "+e+" because no editor is focused."),null;var o=t.codeEditorService.getCodeEditor(i);return o?o:(n&&console.warn("Cannot execute "+e+" because editor `"+i+"` could not be found."),null)}function s(e,t,r,n){var i=o(e,t,r,!0);i&&n(i)}function a(e){var t=e.editorService.getActiveEditor&&e.editorService.getActiveEditor();if(t){var r=t.getControl();if(r&&"function"==typeof r.getEditorType){var n=r;return n}}return null}function u(e,t,r){s(e,t,r,function(t){t.trigger("keyboard",e,r)})}function c(e,t,r,o){void 0===r&&(r=i.WEIGHT.editorCore());var s={id:e,handler:u.bind(null,e),weight:r,context:o?o:[{key:n.KEYBINDING_CONTEXT_EDITOR_TEXT_FOCUS}],primary:t.primary,secondary:t.secondary,win:t.win,mac:t.mac,linux:t.linux};i.registerCommandDesc(s)}function l(e,t){return{shift:e,alt:!0,key:t}}function p(e,t){return{ctrlCmd:!0,shift:e,key:t}}function d(e,t,r){c(e,{primary:p(t,r),mac:{primary:l(t,r)}})}function h(e,t){var i=r.Handler.SelectAll;if(t.context[n.KEYBINDING_CONTEXT_EDITOR_TEXT_FOCUS]){var s=o(i,e,t,!1);if(s)return s.trigger("keyboard",i,t),void 0}var u=document.activeElement;if(u&&["input","textarea"].indexOf(u.tagName.toLowerCase())>=0)return u.select(),void 0;var c=a(e);return c?(c.trigger("keyboard",i,t),void 0):void 0}var f=function(){function e(){this.editor={fontFamily:"",fontSize:0,lineHeight:0,lineNumbers:!0,selectOnLineNumbers:!0,lineNumbersMinChars:5,glyphMargin:!1,lineDecorationsWidth:10,revealHorizontalRightPadding:30,tabSize:"auto",insertSpaces:"auto",roundedSelection:!0,theme:"vs",pageSize:1,readOnly:!1,scrollbar:{verticalScrollbarSize:14,horizontal:"auto",useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1},overviewRulerLanes:2,hideCursorInOverviewRuler:!1,scrollBeyondLastLine:!0,automaticLayout:!1,wrappingColumn:300,wrappingIndent:"same",wordWrapBreakBeforeCharacters:"{([+",wordWrapBreakAfterCharacters:" 	})]?|&,;",wordWrapBreakObtrusiveCharacters:".",tabFocusMode:!1,mouseWheelScrollSensitivity:1,forcedTokenizationBoundary:1e3,longLineBoundary:300,isDominatedByLongLines:!1,hover:!0,contextmenu:!0,quickSuggestions:!0,quickSuggestionsDelay:10,iconsInSuggestions:!0,autoClosingBrackets:!0,formatOnType:!1,suggestOnTriggerCharacters:!0,selectionHighlight:!0,outlineMarkers:!1,referenceInfos:!0}}return e}();t.ConfigClass=f,t.findFocusedEditor=o,t.withCodeEditorFromCommandHandler=s,t.getActiveEditor=a,t.Config=new f;var g=r.Handler;c(g.CursorLeft,{primary:{key:"LeftArrow"},mac:{primary:{key:"LeftArrow"},secondary:[{winCtrl:!0,key:"B"}]}}),c(g.CursorLeftSelect,{primary:{shift:!0,key:"LeftArrow"}}),c(g.CursorRight,{primary:{key:"RightArrow"},mac:{primary:{key:"RightArrow"},secondary:[{winCtrl:!0,key:"F"}]}}),c(g.CursorRightSelect,{primary:{shift:!0,key:"RightArrow"}}),c(g.CursorUp,{primary:{key:"UpArrow"},mac:{primary:{key:"UpArrow"},secondary:[{winCtrl:!0,key:"P"}]}}),c(g.CursorUpSelect,{primary:{shift:!0,key:"UpArrow"},secondary:[p(!0,"UpArrow")],mac:{primary:{shift:!0,key:"UpArrow"}}}),c(g.CursorDown,{primary:{key:"DownArrow"},mac:{primary:{key:"DownArrow"},secondary:[{winCtrl:!0,key:"N"}]}}),c(g.CursorDownSelect,{primary:{shift:!0,key:"DownArrow"},secondary:[p(!0,"DownArrow")],mac:{primary:{shift:!0,key:"DownArrow"}}}),c(g.CursorPageUp,{primary:{key:"PageUp"}}),c(g.CursorPageUpSelect,{primary:{shift:!0,key:"PageUp"}}),c(g.CursorPageDown,{primary:{key:"PageDown"}}),c(g.CursorPageDownSelect,{primary:{shift:!0,key:"PageDown"}}),c(g.CursorHome,{primary:{key:"Home"},mac:{primary:{key:"Home"},secondary:[{ctrlCmd:!0,key:"LeftArrow"},{winCtrl:!0,key:"A"}]}}),c(g.CursorHomeSelect,{primary:{shift:!0,key:"Home"},mac:{primary:{shift:!0,key:"Home"},secondary:[{ctrlCmd:!0,shift:!0,key:"LeftArrow"}]}}),c(g.CursorEnd,{primary:{key:"End"},mac:{primary:{key:"End"},secondary:[{ctrlCmd:!0,key:"RightArrow"},{winCtrl:!0,key:"E"}]}}),c(g.CursorEndSelect,{primary:{shift:!0,key:"End"},mac:{primary:{shift:!0,key:"End"},secondary:[{ctrlCmd:!0,shift:!0,key:"RightArrow"}]}}),c(g.Tab,{primary:{key:"Tab"}},i.WEIGHT.editorCore(),[{key:n.KEYBINDING_CONTEXT_EDITOR_TEXT_FOCUS},{key:n.KEYBINDING_CONTEXT_EDITOR_TAB_MOVES_FOCUS,operator:i.KEYBINDING_CONTEXT_OPERATOR_NOT_EQUAL,operand:!0}]),c(g.Outdent,{primary:{shift:!0,key:"Tab"}},i.WEIGHT.editorCore(),[{key:n.KEYBINDING_CONTEXT_EDITOR_TEXT_FOCUS},{key:n.KEYBINDING_CONTEXT_EDITOR_TAB_MOVES_FOCUS,operator:i.KEYBINDING_CONTEXT_OPERATOR_NOT_EQUAL,operand:!0}]),c(g.DeleteLeft,{primary:{key:"Backspace"},secondary:[{shift:!0,key:"Backspace"}],mac:{primary:{key:"Backspace"},secondary:[{shift:!0,key:"Backspace"},{winCtrl:!0,key:"H"},{winCtrl:!0,key:"Backspace"}]}}),c(g.DeleteRight,{primary:{key:"Delete"},mac:{primary:{key:"Delete"},secondary:[{winCtrl:!0,key:"D"}]}}),c(g.DeleteAllLeft,{primary:null,mac:{primary:{ctrlCmd:!0,key:"Backspace"}}}),c(g.DeleteAllRight,{primary:null,mac:{primary:{winCtrl:!0,key:"K"},secondary:[{ctrlCmd:!0,key:"Delete"}]}}),d(g.CursorWordLeft,!1,"LeftArrow"),d(g.CursorWordLeftSelect,!0,"LeftArrow"),d(g.CursorWordRight,!1,"RightArrow"),d(g.CursorWordRightSelect,!0,"RightArrow"),d(g.DeleteWordLeft,!1,"Backspace"),d(g.DeleteWordRight,!1,"Delete"),c(g.CancelSelection,{primary:{key:"Escape"}},i.WEIGHT.editorCore(),[{key:n.KEYBINDING_CONTEXT_EDITOR_TEXT_FOCUS},{key:n.KEYBINDING_CONTEXT_EDITOR_HAS_NON_EMPTY_SELECTION}]),c(g.RemoveSecondaryCursors,{primary:{key:"Escape"}},i.WEIGHT.editorCore(1),[{key:n.KEYBINDING_CONTEXT_EDITOR_TEXT_FOCUS},{key:n.KEYBINDING_CONTEXT_EDITOR_HAS_MULTIPLE_SELECTIONS}]),c(g.CursorTop,{primary:{ctrlCmd:!0,key:"Home"},mac:{primary:{ctrlCmd:!0,key:"UpArrow"}}}),c(g.CursorTopSelect,{primary:{ctrlCmd:!0,shift:!0,key:"Home"},mac:{primary:{ctrlCmd:!0,shift:!0,key:"UpArrow"}}}),c(g.CursorBottom,{primary:{ctrlCmd:!0,key:"End"},mac:{primary:{ctrlCmd:!0,key:"DownArrow"}}}),c(g.CursorBottomSelect,{primary:{ctrlCmd:!0,shift:!0,key:"End"},mac:{primary:{ctrlCmd:!0,shift:!0,key:"DownArrow"}}}),c(g.LineBreakInsert,{primary:null,mac:{primary:{winCtrl:!0,key:"O"}}}),c(g.Undo,{primary:{ctrlCmd:!0,key:"Z"}}),c(g.CursorUndo,{primary:{ctrlCmd:!0,key:"U"}}),c(g.Redo,{primary:{ctrlCmd:!0,key:"Y"},secondary:[{ctrlCmd:!0,shift:!0,key:"Z"}],mac:{primary:{ctrlCmd:!0,shift:!0,key:"Z"}}}),i.registerCommandDesc({id:"editor.action.selectAll",handler:h,weight:i.WEIGHT.editorCore(),context:null,primary:{ctrlCmd:!0,key:"A"}})}),define("vs/editor/core/model/tokenIterator",["require","exports","vs/editor/editor"],function(e,t,r){var n=r.LineTokensBinaryEncoding.getStartIndex,i=r.LineTokensBinaryEncoding.inflate,o=function(){function e(e,t){this._model=e,this._currentLineNumber=t.lineNumber,this._currentTokenIndex=0,this._readLineTokens(this._currentLineNumber),this._next=null,this._prev=null;for(var r=t.column-1,i=Number.MAX_VALUE,o=this._currentTokens.length-1;o>=0;o--){if(n(this._currentTokens[o])<=r&&i>=r){this._currentTokenIndex=o,this._next=this._current(),this._prev=this._current();break}i=n(this._currentTokens[o])}}return e.prototype._readLineTokens=function(e){this._currentLineTokens=this._model.getLineTokens(e,!1),this._currentTokens=this._currentLineTokens.getBinaryEncodedTokens(),this._map=this._currentLineTokens.getBinaryEncodedTokensMap()},e.prototype._advanceNext=function(){if(this._prev=this._next,this._next=null,this._currentTokenIndex+1<this._currentTokens.length)this._currentTokenIndex++,this._next=this._current();else{for(;this._currentLineNumber+1<=this._model.getLineCount();)if(this._currentLineNumber++,this._readLineTokens(this._currentLineNumber),this._currentTokens.length>0){this._currentTokenIndex=0,this._next=this._current();break}null===this._next&&(this._readLineTokens(this._currentLineNumber),this._currentTokenIndex=this._currentTokens.length,this._advancePrev(),this._next=null)}},e.prototype._advancePrev=function(){if(this._next=this._prev,this._prev=null,this._currentTokenIndex>0)this._currentTokenIndex--,this._prev=this._current();else for(;this._currentLineNumber>1;)if(this._currentLineNumber--,this._readLineTokens(this._currentLineNumber),this._currentTokens.length>0){this._currentTokenIndex=this._currentTokens.length-1,this._prev=this._current();break}},e.prototype._current=function(){return{token:i(this._map,this._currentTokens[this._currentTokenIndex]),lineNumber:this._currentLineNumber,startColumn:n(this._currentTokens[this._currentTokenIndex])+1,endColumn:this._currentTokenIndex+1<this._currentTokens.length?n(this._currentTokens[this._currentTokenIndex+1])+1:this._model.getLineContent(this._currentLineNumber).length+1}},e.prototype.hasNext=function(){return null!==this._next},e.prototype.next=function(){var e=this._next;return this._advanceNext(),e},e.prototype.hasPrev=function(){return null!==this._prev},e.prototype.prev=function(){var e=this._prev;return this._advancePrev(),e},e.prototype._invalidate=function(){var e=function(){throw new Error("iteration isn't valid anymore")};this.hasNext=e,this.next=e,this.hasPrev=e,this.prev=e},e}();t.TokenIterator=o}),define("vs/editor/core/model/textModelWithTokensHelpers",["require","exports","vs/editor/editor","vs/editor/modes/nullMode","vs/base/errors","vs/editor/core/range"],function(e,t,r,n,i,o){var s=r.LineTokensBinaryEncoding.getType,a=r.LineTokensBinaryEncoding.getBracket,u=r.LineTokensBinaryEncoding.getStartIndex,c=function(){function e(){}return e._safeGetWordDefinition=function(e){var t=null;if(e.tokenTypeClassificationSupport)try{t=e.tokenTypeClassificationSupport.getWordDefinition()}catch(r){i.onUnexpectedError(r)}return t},e.ensureValidWordDefinition=function(e){var t=n.NullMode.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)t=e;else{var r="g";e.ignoreCase&&(r+="i"),e.multiline&&(r+="m"),t=new RegExp(e.source,r)}return t.lastIndex=0,t},e.massageWordDefinitionOf=function(t){return e.ensureValidWordDefinition(e._safeGetWordDefinition(t))},e.getWords=function(t,r,n,i){if(void 0===i&&(i=!1),i&&!t._lineIsTokenized(r))return e._getWordsInText(t.getLineContent(r),e.massageWordDefinitionOf(t.getMode()));var o,a,c,l,p,d=[],h=t.getLineContent(r),f=t.getLineTokens(r,!1),g=f.getBinaryEncodedTokens(),m=f.getBinaryEncodedTokensMap(),v=t._getLineModeTransitions(r),_={};if(n&&(_=e._getNonWordTokenMap(t)),0!==h.length){var y=0,b=y+1<v.length?v[y+1].startIndex:Number.MAX_VALUE,S=e.massageWordDefinitionOf(v[y].mode);for(o=0,a=0,c=g.length;c>o;o++){if(p=o===c-1?h.length:u(g[o+1]),a>=b&&(y++,b=y+1<v.length?v[y+1].startIndex:Number.MAX_VALUE,S=e.massageWordDefinitionOf(v[y].mode)),!n||!_.hasOwnProperty(s(m,g[o]))){var k,C=h.substring(a,p),T=C.match(S)||[],E=0;for(l=0;l<T.length;l++){var w=T[l].trim();w.length>0&&(k=C.indexOf(w,E),E=k+w.length,d.push({start:a+k,end:a+E}))}}a=p}}return d},e._getWordsInText=function(e,t){var r,n,i,o,s,a,u=e.match(t)||[],c=[];for(r=0;r<u.length;r++)a=u[r].trim(),a.length>0&&(n=e.indexOf(a,i),i=n+a.length,o=n,s=i,c.push({start:o,end:s}));return c},e.getWordAtPosition=function(t,r,n,i){if(void 0===i&&(i=!1),i&&!t._lineIsTokenized(r.lineNumber))return e._getWordAtText(r.column,e.massageWordDefinitionOf(t.getMode()),t.getLineContent(r.lineNumber),0);var o=t.getLineTokens(r.lineNumber,!1),a=o.getBinaryEncodedTokens(),c=o.getBinaryEncodedTokensMap(),l=-1,p=-1;if(a.length>0&&(l=o.findIndexOfOffset(r.column-1),l>0&&u(a[l])===r.column-1&&(p=l-1)),n&&(-1!==l||-1!==p)){var d=e._getNonWordTokenMap(t);-1!==l&&d.hasOwnProperty(s(c,a[l]))&&(l=-1),-1!==p&&d.hasOwnProperty(s(c,a[p]))&&(p=-1)}var h,f=e.massageWordDefinitionOf(t.getModeAtPosition(r.lineNumber,r.column)),g=t.getLineContent(r.lineNumber),m=null;return m||-1===l||(h=g.substring(u(a[l]),l+1<a.length?u(a[l+1]):Number.MAX_VALUE),m=e._getWordAtText(r.column,f,h,u(a[l]))),m||-1===p||(h=g.substring(u(a[p]),p+1<a.length?u(a[p+1]):Number.MAX_VALUE),m=e._getWordAtText(r.column,f,h,u(a[p]))),m},e._getWordAtText=function(e,t,r,n){var i,o,s,a,u,c,l=r.match(t);if(l)for(i=0;i<l.length;i++)if(c=l[i].trim(),c.length>0&&(o=r.indexOf(c,s),s=o+c.length,a=n+o+1,u=n+s+1,e>=a&&u>=e))return{word:c,startColumn:a,endColumn:u};return null},e._getNonWordTokenMap=function(e){var t,r,n=e._getNonWordTokenTypes(),i={};for(t=0,r=n.length;r>t;t++)i[n[t]]=!0;return i},e}();t.WordHelper=c;var l=function(){function e(){}return e._sign=function(e){return 0>e?-1:e>0?1:0},e._findMatchingBracketUp=function(t,r,n,i,c){var l,p,d,h=c;for(l=n;l>=1;l--){var f=t.getLineTokens(l,!1),g=f.getBinaryEncodedTokens(),m=f.getBinaryEncodedTokensMap(),v=t.getLineContent(l);for(d=(l===n?i:g.length)-1;d>=0;d--)if(s(m,g[d])===r&&(h+=e._sign(a(g[d])),0===h))return p=d===g.length-1?v.length:u(g[d+1]),new o.Range(l,u(g[d])+1,l,p+1)}return null},e._findMatchingBracketDown=function(t,r,n,i,c){var l,p,d,h,f,g=1;for(l=n,p=t.getLineCount();p>=l;l++){if(c&&!t._lineIsTokenized(l))return{range:null,isAccurate:!1};var m=t.getLineTokens(l,!1),v=m.getBinaryEncodedTokens(),_=m.getBinaryEncodedTokensMap(),y=t.getLineContent(l);for(h=l===n?i+1:0,f=v.length;f>h;h++)if(s(_,v[h])===r&&(g+=e._sign(a(v[h])),0===g))return d=h===v.length-1?y.length:u(v[h+1]),{range:new o.Range(l,u(v[h])+1,l,d+1),isAccurate:!0}}return{range:null,isAccurate:!0}},e.findMatchingBracketUp=function(t,r,n){var i,o,s,a=n.column-1,c=-1,l=t.getLineTokens(n.lineNumber,!1),p=l.getBinaryEncodedTokens(),d=t.getLineContent(n.lineNumber);for(i=0,o=p.length;-1===c&&o>i;i++)s=i===o-1?d.length:u(p[i+1]),u(p[i])<=a&&s>=a&&(c=i);return e._findMatchingBracketUp(t,r,n.lineNumber,c+1,0)},e.matchBracket=function(t,r,n){if(n&&!t._lineIsTokenized(r.lineNumber))return{brackets:null,isAccurate:!1};var i,c,l=t.getLineContent(r.lineNumber),p={brackets:null,isAccurate:!0};if(l.length>0){var d,h,f,g,m,v=r.column-1,_=t.getLineTokens(r.lineNumber,!1),y=_.getBinaryEncodedTokens(),b=_.getBinaryEncodedTokensMap();for(i=0,c=y.length;null===p.brackets&&c>i;i++)if(d=y[i],f=u(d),m=s(b,d),g=a(d),h=i===c-1?l.length:u(y[i+1]),v>=f&&h>=v){if(0>g){var S=e._findMatchingBracketUp(t,m,r.lineNumber,i,-1);S&&(p.brackets=[new o.Range(r.lineNumber,f+1,r.lineNumber,h+1),S])}if(null===p.brackets&&g>0){var k=e._findMatchingBracketDown(t,m,r.lineNumber,i,n);p.isAccurate=k.isAccurate,k.range&&(p.brackets=[new o.Range(r.lineNumber,f+1,r.lineNumber,h+1),k.range])}}}return p},e}();t.BracketsHelper=l}),define("vs/base/time/schedulers",["require","exports"],function(e,t){var r=function(){function e(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}return e.prototype.dispose=function(){this.cancel(),this.runner=null},e.prototype.cancel=function(){-1!==this.timeoutToken&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)},e.prototype.setRunner=function(e){this.runner=e},e.prototype.setTimeout=function(e){this.timeout=e},e.prototype.schedule=function(){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,this.timeout)},e.prototype.onTimeout=function(){this.timeoutToken=-1,this.runner&&this.runner()},e}();t.RunOnceScheduler=r});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/core/model/textModelWithTokens",["require","exports","vs/nls!vs/editor/worker/editorWorkerServer","vs/base/lib/winjs.base","vs/base/lifecycle","vs/editor/core/model/textModel","vs/editor/modes/nullMode","vs/base/errors","vs/editor/core/constants","vs/base/arrays","vs/editor/core/config/config","vs/editor/core/model/tokenIterator","vs/editor/core/model/textModelWithTokensHelpers","vs/base/time/schedulers","vs/base/performance/timer","vs/base/time/precision"],function(e,t,r,n,i,o,s,a,u,c,l,p,d,h,f,g){var m=function(){function e(){this._inflate=[""],this._deflate={"":0}}return e}();t.TokensInflatorMap=m;var v=function(){function e(e,t){var r=this;this._modePromise=e,this._externalModePromise=new n.TPromise(function(e,t){r._externalModePromise_c=e,r._externalModePromise_e=t}),this._model=t,this._isDisposed=!1,n.TPromise.timeout(0).then(function(){return r._modePromise}).then(function(e){if(r._isDisposed)return r._externalModePromise_c(!1),void 0;var t=r._model;r.dispose(),t.setMode(e),t._warmUpTokens(),r._externalModePromise_c(!0)}).done(null,function(e){r._externalModePromise_e(e),a.onUnexpectedError(e)})}return e.prototype.getModePromise=function(){return this._externalModePromise},e.prototype.dispose=function(){this._modePromise=null,this._model=null,this._isDisposed=!0},e}(),_=function(){function e(e,t){var r=this;this._retokenizePromise=e,this._model=t,this._isDisposed=!1,this.isFulfilled=!1,n.TPromise.timeout(0).then(function(){return r._retokenizePromise}).then(function(){r._isDisposed||(r.isFulfilled=!0,r._model.onRetokenizerFulfilled())}).done(null,a.onUnexpectedError)}return e.prototype.getRange=function(){return null},e.prototype.dispose=function(){this._retokenizePromise=null,this._model=null,this._isDisposed=!0},e}();t.FullModelRetokenizer=_;var y=function(){function e(e,t){this.modeTransitions=t.getModeTransitions().toArray(e),this._text=t.text,this._lineTokens=t.getTokens()}return e.prototype.getLineContent=function(){return this._text},e.prototype.getTokenCount=function(){return this._lineTokens.getTokenCount()},e.prototype.getTokenStartIndex=function(e){return this._lineTokens.getTokenStartIndex(e)},e.prototype.getTokenEndIndex=function(e){return this._lineTokens.getTokenEndIndex(e,this._text.length)},e.prototype.getTokenType=function(e){return this._lineTokens.getTokenType(e)},e.prototype.getTokenBracket=function(e){return this._lineTokens.getTokenBracket(e)},e.prototype.getTokenText=function(e){var t=this._lineTokens.getTokenStartIndex(e),r=this._lineTokens.getTokenEndIndex(e,this._text.length);return this._text.substring(t,r)},e.prototype.findIndexOfOffset=function(e){return this._lineTokens.findIndexOfOffset(e)},e}(),b=function(e){function t(r,i,o,a){var c=this;if(r.push(u.EventType.ModelTokensChanged),r.push(u.EventType.ModelModeChanged),r.push(u.EventType.ModelModeSupportChanged),e.call(this,r,i),this._shouldAutoTokenize=o,this._shouldSimplifyMode=i.length>t.MODEL_SYNC_LIMIT,this._shouldDenyMode=i.length>t.MODEL_TOKENIZATION_LIMIT,this._stopLineTokenizationAfter=l.Config.editor.stopLineTokenizationAfter,a)if(n.Promise.is(a)){var p=a;this._modeToModelBinder=new v(p,this),this._mode=new s.NullMode}else this._mode=this._massageMode(a),this._resetModeListener(this._mode);else this._mode=new s.NullMode;this._revalidateTokensTimeout=-1,this._scheduleRetokenizeNow=new h.RunOnceScheduler(function(){return c._retokenizeNow()},200),this._retokenizers=[],this._resetTokenizationState()}return __extends(t,e),t.prototype.dispose=function(){this._modeToModelBinder&&(this._modeToModelBinder.dispose(),this._modeToModelBinder=null),this._resetModeListener(null),this._clearTimers(),this._mode=null,this._lastState=null,this._tokensInflatorMap=null,this._retokenizers=i.disposeAll(this._retokenizers),this._scheduleRetokenizeNow.dispose(),e.prototype.dispose.call(this)},t.prototype._massageMode=function(e){return this._shouldDenyMode?new s.NullMode:this._shouldSimplifyMode?new S(e):e},t.prototype.whenModeIsReady=function(){return this._modeToModelBinder?this._modeToModelBinder.getModePromise():n.Promise.as(this._mode)},t.prototype.onRetokenizerFulfilled=function(){this._scheduleRetokenizeNow.schedule()},t.prototype._retokenizeNow=function(){var e=this._retokenizers.filter(function(e){return e.isFulfilled});this._retokenizers=this._retokenizers.filter(function(e){return!e.isFulfilled});for(var t=!1,r=0;r<e.length;r++)e[r].getRange()||(t=!0);if(t){for(var r=0,n=this._lines.length;n>r;r++)this._lines[r].isInvalid=!0;this._invalidLineStartIndex=0}else{for(var i=Number.MAX_VALUE,r=0;r<e.length;r++){var o=e[r].getRange();i=Math.min(i,o.startLineNumber);for(var s=o.startLineNumber;s<=o.endLineNumber;s++)this._lines[s-1].isInvalid=!0}i-1<this._invalidLineStartIndex&&(this._invalidLineStartIndex<this._lines.length&&(this._lines[this._invalidLineStartIndex].isInvalid=!0),this._invalidLineStartIndex=i-1)}this._beginBackgroundTokenization();for(var r=0;r<e.length;r++)e[r].dispose()},t.prototype._createRetokenizer=function(e){return new _(e,this)},t.prototype._resetValue=function(t,r){e.prototype._resetValue.call(this,t,r),this._resetTokenizationState()},t.prototype._resetMode=function(e,t){this._mode=t,this._resetModeListener(t),this._resetTokenizationState(),this.emitModelTokensChangedEvent(1,this.getLineCount())},t.prototype._resetModeListener=function(e){var t=this;this._modeListener&&(this._modeListener.dispose(),this._modeListener=null),e&&"function"==typeof e.addSupportChangedListener&&(this._modeListener=e.addSupportChangedListener(function(e){return t._onModeSupportChanged(e)}))},t.prototype._onModeSupportChanged=function(e){this._emitModelModeSupportChangedEvent(e),e.tokenizationSupport&&(this._resetTokenizationState(),this.emitModelTokensChangedEvent(1,this.getLineCount()))},t.prototype._resetTokenizationState=function(){this._retokenizers=i.disposeAll(this._retokenizers),this._scheduleRetokenizeNow.cancel(),this._clearTimers(),this._initializeTokenizationState(),this._tokenizationElapsedTime=0,this._tokenizationTotalCharacters=1},t.prototype._clearTimers=function(){-1!==this._revalidateTokensTimeout&&(clearTimeout(this._revalidateTokensTimeout),this._revalidateTokensTimeout=-1)},t.prototype._initializeTokenizationState=function(){var e=null;if(this._mode.tokenizationSupport)try{e=this._mode.tokenizationSupport.getInitialState()}catch(r){r.friendlyMessage=t.MODE_TOKENIZATION_FAILED_MSG,a.onUnexpectedError(r),this._mode=new s.NullMode}e||(e=new s.NullState(this._mode,null)),this._lines[0].setState(e),this._lastState=null,this._tokensInflatorMap=new m,this._invalidLineStartIndex=0,this._beginBackgroundTokenization()},t.prototype.setStopLineTokenizationAfter=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.setStopLineTokenizationAfter: Model is disposed");this._stopLineTokenizationAfter=e},t.prototype.getLineTokens=function(e,t){if(void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModelWithTokens.getLineTokens: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return t||this._updateTokensUntilLine(e,!0),this._lines[e-1].getTokens()},t.prototype.getLineContext=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.getLineContext: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._updateTokensUntilLine(e,!0),new y(this._mode,this._lines[e-1])},t.prototype._getInternalTokens=function(e){return this._updateTokensUntilLine(e,!0),this._lines[e-1].getTokens()},t.prototype.setValue=function(t,r){if(void 0===r&&(r=null),this._isDisposed)throw new Error("TextModelWithTokens.setValue: Model is disposed");if(null!==t&&e.prototype.setValue.call(this,t),r)if(this._modeToModelBinder&&(this._modeToModelBinder.dispose(),this._modeToModelBinder=null),n.Promise.is(r))this._modeToModelBinder=new v(r,this);else{var i=this._massageMode(r);if(this._mode!==i){var o={oldMode:this._mode,newMode:i};this._resetMode(o,i),this._emitModelModeChangedEvent(o)}}},t.prototype.getMode=function(){if(this._isDisposed)throw new Error("TextModelWithTokens.getMode: Model is disposed");return this._mode},t.prototype.setMode=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens.setMode: Model is disposed");e&&this.setValue(null,e)},t.prototype.getModeAtPosition=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTokens.getModeAtPosition: Model is disposed");var r=this.validatePosition({lineNumber:e,column:t}),n=r.lineNumber,i=r.column;if(1===i)return this.getStateBeforeLine(n).getMode();if(i===this.getLineMaxColumn(n))return this.getStateAfterLine(n).getMode();var o=this._getLineModeTransitions(n),s=c.findIndexInSegmentsArray(o,i-1);return o[s].mode},t.prototype._invalidateLine=function(e){this._lines[e].isInvalid=!0,e<this._invalidLineStartIndex&&(this._invalidLineStartIndex<this._lines.length&&(this._lines[this._invalidLineStartIndex].isInvalid=!0),this._invalidLineStartIndex=e,this._beginBackgroundTokenization())},t.prototype._updateLineTokens=function(e,t,r,n){this._lines[e].setTokens(t,n.tokens,r,n.modeTransitions)},t.prototype._beginBackgroundTokenization=function(){var e=this;this._shouldAutoTokenize&&-1===this._revalidateTokensTimeout&&(this._revalidateTokensTimeout=setTimeout(function(){e._revalidateTokensTimeout=-1,e._revalidateTokensNow()},0))},t.prototype._warmUpTokens=function(){if(this._isDisposed)throw new Error("TextModelWithTokens._warmUpTokens: Model is disposed");for(var e=Math.min(100,this.getLineCount()),t=e,r=1;e>=r;r++){var n=this._lines[r-1].text;if(n.length>=200){t=r-1;break}}this._revalidateTokensNow(t)},t.prototype._revalidateTokensNow=function(e){void 0===e&&(e=this._invalidLineStartIndex+1e6);var t=f.start(f.Topic.EDITOR,"backgroundTokenization");e=Math.min(this._lines.length,e);for(var r,n=20,i=this._invalidLineStartIndex+1,o=0,s=0,a=0,u=this._stopLineTokenizationAfter,c=g.createStopWatch(),l=i;e>=l;l++){if(r=c.elapsed(),r>n){e=l-1;break}if(s=this._lines[l-1].text.length,-1!==u&&s>u&&(s=u),o>0&&(a=r/o*s,r+a>n)){e=l-1;break}this._updateTokensUntilLine(l,!1),o+=s}r=c.elapsed();var p=f.start(f.Topic.EDITOR,"**speed: "+this._tokenizationTotalCharacters/this._tokenizationElapsedTime);p.stop(),e>=i&&this.emitModelTokensChangedEvent(i,e),this._invalidLineStartIndex<this._lines.length&&this._beginBackgroundTokenization(),t.stop()},t.prototype.getStateBeforeLine=function(e){return this._updateTokensUntilLine(e-1,!0),this._lines[e-1].getState()},t.prototype.getStateAfterLine=function(e){return this._updateTokensUntilLine(e,!0),e<this._lines.length?this._lines[e].getState():this._lastState},t.prototype._getLineModeTransitions=function(e){if(this._isDisposed)throw new Error("TextModelWithTokens._getLineModeTransitions: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return this._updateTokensUntilLine(e,!0),this._lines[e-1].getModeTransitions().toArray(this._mode)},t.prototype._updateTokensUntilLine=function(e,r){var n=this._lines.length,i=e-1,o=this._stopLineTokenizationAfter;-1===o&&(o=1e9);for(var u=g.createStopWatch(),c=0,l=this._invalidLineStartIndex+1,p=e,d=this._invalidLineStartIndex;i>=d;d++){var h=d+1,f=null,m=this._lines[d].text;if(this._mode.tokenizationSupport){try{f=this._mode.tokenizationSupport.tokenize(this._lines[d].text,this._lines[d].getState(),0,o),c=f?f.actualStopOffset:this._lines[d].text.length}catch(v){v.friendlyMessage=t.MODE_TOKENIZATION_FAILED_MSG,a.onUnexpectedError(v)}f&&f.retokenize&&this._retokenizers.push(this._createRetokenizer(f.retokenize,d+1)),f&&f.tokens&&f.tokens.length>0&&(f.actualStopOffset=Math.max(f.actualStopOffset,f.tokens[f.tokens.length-1].startIndex+1)),f&&f.actualStopOffset<m.length&&(f.tokens.push({startIndex:f.actualStopOffset,type:"",bracket:0}),f.endState=this._lines[d].getState())
}if(f||(f=s.nullTokenize(this._mode,m,this._lines[d].getState())),f.modeTransitions||(f.modeTransitions=[]),0===f.modeTransitions.length&&f.modeTransitions.push({startIndex:0,mode:this._mode}),this._updateLineTokens(d,this._tokensInflatorMap,this._mode,f),this._lines[d].isInvalid&&(this._lines[d].isInvalid=!1),n>h)if(null!==this._lines[h].getState()&&f.endState.equals(this._lines[h].getState())){for(var _=d+1;n>_&&!this._lines[_].isInvalid;){if(n>_+1){if(null===this._lines[_+1].getState())break}else if(null===this._lastState)break;_++}this._invalidLineStartIndex=Math.max(this._invalidLineStartIndex,_),d=_-1}else this._lines[h].setState(f.endState);else this._lastState=f.endState}this._invalidLineStartIndex=Math.max(this._invalidLineStartIndex,i+1),this._tokenizationElapsedTime+=u.elapsed(),this._tokenizationTotalCharacters+=c,r&&p>=l&&this.emitModelTokensChangedEvent(l,p)},t.prototype.emitModelTokensChangedEvent=function(e,t){var r={fromLineNumber:e,toLineNumber:t};this.emit(u.EventType.ModelTokensChanged,r)},t.prototype._emitModelModeChangedEvent=function(e){this.emit(u.EventType.ModelModeChanged,e)},t.prototype._emitModelModeSupportChangedEvent=function(e){this.emit(u.EventType.ModelModeSupportChanged,e)},t.prototype._lineIsTokenized=function(e){return this._invalidLineStartIndex>e-1},t.prototype._getNonWordTokenTypes=function(){var e=[];try{this._mode.tokenTypeClassificationSupport&&(e=this._mode.tokenTypeClassificationSupport.getNonWordTokenTypes())}catch(t){a.onUnexpectedError(t)}return e},t.prototype._getWordDefinition=function(){return d.WordHelper.massageWordDefinitionOf(this._mode)},t.prototype.getWordAtPosition=function(e,t,r){if(void 0===t&&(t=!0),void 0===r&&(r=!1),this._isDisposed)throw new Error("TextModelWithTokens.getWordAtPosition: Model is disposed");return d.WordHelper.getWordAtPosition(this,this.validatePosition(e),t,r)},t.prototype.getWordUntilPosition=function(e,t,r){if(void 0===r&&(r=!1),this._isDisposed)throw new Error("TextModelWithTokens.getWordUntilPosition: Model is disposed");var n=this.getWordAtPosition(e,t,r);return n?{word:n.word.substr(0,e.column-n.startColumn),startColumn:n.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype.getWords=function(e,t,r){if(void 0===r&&(r=!1),this._isDisposed)throw new Error("TextModelWithTokens.getWords: Model is disposed");if(1>e||e>this.getLineCount())throw new Error("Illegal value "+e+" for `lineNumber`");return d.WordHelper.getWords(this,this.validateLineNumber(e),t,r)},t.prototype.tokenIterator=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTokens.tokenIterator: Model is disposed");var r=new p.TokenIterator(this,this.validatePosition(e)),n=t(r);return r._invalidate(),n},t.prototype.findMatchingBracketUp=function(e,t){if(this._isDisposed)throw new Error("TextModelWithTokens.findMatchingBracketUp: Model is disposed");return d.BracketsHelper.findMatchingBracketUp(this,e,this.validatePosition(t))},t.prototype.matchBracket=function(e,t){if(void 0===t&&(t=!1),this._isDisposed)throw new Error("TextModelWithTokens.matchBracket: Model is disposed");return d.BracketsHelper.matchBracket(this,this.validatePosition(e),t)},t.MODE_TOKENIZATION_FAILED_MSG=r.localize("vs_editor_core_model_textModelWithTokens",0),t.MODEL_SYNC_LIMIT=5242880,t.MODEL_TOKENIZATION_LIMIT=52428800,t}(o.TextModel);t.TextModelWithTokens=b;var S=function(){function e(e){this._id="vs.editor.modes.simplifiedMode:"+e.getId(),this.tokenizationSupport=e.tokenizationSupport,this.electricCharacterSupport=e.electricCharacterSupport,this.commentsSupport=e.commentsSupport,this.characterPairSupport=e.characterPairSupport,this.tokenTypeClassificationSupport=e.tokenTypeClassificationSupport}return e.prototype.getId=function(){return this._id},e}()});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/core/model/mirrorModel",["require","exports","vs/base/network","vs/editor/core/constants","vs/editor/core/view/model/prefixSumComputer","vs/editor/core/model/textModelWithTokens","vs/editor/core/model/modelLine","vs/base/lifecycle","vs/editor/core/model/textModel"],function(e,t,r,n,i,o,s,a,u){function c(e,t,r,n,i,o){return new h(e,t,u.TextModel.toRawText(r),n,i,o)}var l=function(e){function t(t,r,i,o,s,a){e.call(this,t.concat([n.EventType.ModelDispose]),i,!1,o),a||(a={}),this._setVersionId(r),this._associatedResource=s,this._extraProperties=a}return __extends(t,e),t.prototype.getModeId=function(){if(this._isDisposed)throw new Error("AbstractMirrorModel.getModeId: Model is disposed");return this.getMode().getId()},t.prototype.getEmbeddedAtPosition=function(){return null},t.prototype.getAllEmbedded=function(){return[]},t.prototype._constructLines=function(t){e.prototype._constructLines.call(this,t),this._EOL="\n"},t.prototype.destroy=function(){this.dispose()},t.prototype.dispose=function(){this.emit(n.EventType.ModelDispose),e.prototype.dispose.call(this)},t.prototype.getAssociatedResource=function(){if(this._isDisposed)throw new Error("AbstractMirrorModel.getAssociatedResource: Model is disposed");return this._associatedResource},t.prototype.getProperty=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getProperty: Model is disposed");return this._extraProperties.hasOwnProperty(e)?this._extraProperties[e]:null},t.prototype._ensurePrefixSum=function(){if(!this._lineStarts){for(var e=[],t=this.getEOL().length,r=0,n=this._lines.length;n>r;r++)e.push(this._lines[r].text.length+t);this._lineStarts=new i.PrefixSumComputer(e)}},t.prototype.getRangeFromOffsetAndLength=function(e,t){if(this._isDisposed)throw new Error("AbstractMirrorModel.getRangeFromOffsetAndLength: Model is disposed");var r=this.getPositionFromOffset(e),n=this.getPositionFromOffset(e+t);return{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:n.lineNumber,endColumn:n.column}},t.prototype.getOffsetAndLengthFromRange=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getOffsetAndLengthFromRange: Model is disposed");var t=this.getOffsetFromPosition({lineNumber:e.startLineNumber,column:e.startColumn}),r=this.getOffsetFromPosition({lineNumber:e.endLineNumber,column:e.endColumn});return{offset:t,length:r-t}},t.prototype.getPositionFromOffset=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getPositionFromOffset: Model is disposed");this._ensurePrefixSum();var t={index:0,remainder:0};return this._lineStarts.getIndexOf(e,t),{lineNumber:t.index+1,column:this.getEOL().length+t.remainder}},t.prototype.getOffsetFromPosition=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getOffsetFromPosition: Model is disposed");return this.getLineStart(e.lineNumber)+e.column-1},t.prototype.getLineStart=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getLineStart: Model is disposed");this._ensurePrefixSum();var t=Math.min(e,this._lines.length)-1;return this._lineStarts.getAccumulatedValue(t-1)},t.prototype.getAllWordsWithRange=function(){if(this._isDisposed)throw new Error("AbstractMirrorModel.getAllWordsWithRange: Model is disposed");if(this._lines.length>1e4)return[];var e,t=[],r=function(r){var i=n.text.substring(r.start,r.end),o={startLineNumber:e+1,startColumn:r.start+1,endLineNumber:e+1,endColumn:r.end+1};t.push({text:i,range:o})};for(e=0;e<this._lines.length;e++){var n=this._lines[e];this.wordenize(n.text).forEach(r)}return t},t.prototype.getAllWords=function(){var e=this;if(this._isDisposed)throw new Error("AbstractMirrorModel.getAllWords: Model is disposed");var t=[];return this._lines.forEach(function(r){e.wordenize(r.text).forEach(function(e){t.push(r.text.substring(e.start,e.end))})}),t},t.prototype.getAllUniqueWords=function(e){if(this._isDisposed)throw new Error("AbstractMirrorModel.getAllUniqueWords: Model is disposed");var t=!1,r={};return this.getAllWords().filter(function(n){return e&&!t&&e===n?(t=!0,!1):r[n]?!1:(r[n]=!0,!0)})},t.prototype.wordenize=function(e){for(var t,r=[],n=this._getWordDefinition();t=n.exec(e);)r.push({start:t.index,end:t.index+t[0].length});return r},t.prototype.getWord=function(e,t,r){for(var n=this.wordenize(e),i=0;i<n.length&&t>=n[i].start;i++){var o=n[i];if(t<=o.end)return r(e,o.start,o.end)}return r(e,-1,-1)},t}(o.TextModelWithTokens);t.AbstractMirrorModel=l;var p=function(e){function t(r,n,i,o){e.call(this,["changed"],r.getVersionId(),t._getMirrorValueWithinRanges(r,n),i,o),this._actualModel=r}return __extends(t,e),t._getMirrorValueWithinRanges=function(e,t){var r,n="",i=1,o=1;for(r=0;r<t.length;r++){var s=t[r];n+=e.getEmptiedValueInRange({startLineNumber:i,startColumn:o,endLineNumber:s.startLineNumber,endColumn:s.startColumn}," "),n+=e.getValueInRange(s),i=s.endLineNumber,o=s.endColumn}var a=e.getLineCount(),c=e.getLineMaxColumn(a);return n+=e.getEmptiedValueInRange({startLineNumber:i,startColumn:o,endLineNumber:a,endColumn:c}," "),u.TextModel.toRawText(n)},t.prototype.setIncludedRanges=function(e){var r=this.getVersionId();this._lineStarts=null,this._constructLines(t._getMirrorValueWithinRanges(this._actualModel,e)),this._resetTokenizationState(),this._setVersionId(r+1),this.emit("changed",{})},t}(l);t.MirrorModelEmbedded=p;var d=function(){function e(e){this.mode=e,this.ranges=[]}return e}();t.createMirrorModelFromString=c;var h=function(e){function t(t,r,n,i,o,s){e.call(this,["changed"],r,n,i,o,s),this._resourceService=t,this._embeddedModels={},this._updateEmbeddedModels()}return __extends(t,e),t.prototype.getEmbeddedAtPosition=function(e){if(this._isDisposed)throw new Error("MirrorModel.getEmbeddedAtPosition: Model is disposed");var t=this.getModeAtPosition(e.lineNumber,e.column);return this._embeddedModels.hasOwnProperty(t.getId())?this._embeddedModels[t.getId()]:null},t.prototype.getAllEmbedded=function(){var e=this;if(this._isDisposed)throw new Error("MirrorModel.getAllEmbedded: Model is disposed");return Object.keys(this._embeddedModels).map(function(t){return e._embeddedModels[t]})},t.prototype.dispose=function(){var t=this;e.prototype.dispose.call(this);var r=Object.keys(this._embeddedModels).map(function(e){return t._embeddedModels[e]});r.forEach(function(e){return t._resourceService.remove(e.getAssociatedResource())}),a.disposeAll(r),this._embeddedModels={}},t._getModesRanges=function(e){for(var t={},r=function(e,r){return t.hasOwnProperty(e)||(t[e]=new d(r)),t[e]},n=e.getLineCount(),i=e.getMode().getId(),o=e.getMode(),s=1,a=1,u=1;n>=u;u++)for(var c=e._getLineModeTransitions(u),l=0;l<c.length;l++){var p=c[l];if(p.mode.getId()!==i){var h=r(i,o);h.ranges.push({startLineNumber:s,startColumn:a,endLineNumber:u,endColumn:p.startIndex+1}),i=p.mode.getId(),o=p.mode,s=u,a=p.startIndex+1}}var f=n,g=e.getLineMaxColumn(f);if(s!==f||a!==g){var h=r(i,o);h.ranges.push({startLineNumber:s,startColumn:a,endLineNumber:f,endColumn:g})}return t},t.prototype._updateEmbeddedModels=function(){if(!this._resourceService||!this.getMode().tokenizationSupport||!this.getMode().tokenizationSupport.shouldGenerateEmbeddedModels)return!1;for(var e=t._getModesRanges(this),n=Object.keys(this._embeddedModels),i=0;i<n.length;i++){var o=n[i];e.hasOwnProperty(o)||this._embeddedModels[o].setIncludedRanges([{startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1}])}for(var s=Object.keys(e),i=0;i<s.length;i++){var a=s[i];if(this._embeddedModels.hasOwnProperty(a))this._embeddedModels[a].setIncludedRanges(e[a].ranges);else{var u=new r.URL(this.getAssociatedResource().toString()+"URL_MARSHAL_REMOVE="+a);this._embeddedModels[a]=new p(this,e[a].ranges,e[a].mode,u),this._resourceService.insert(this._embeddedModels[a].getAssociatedResource(),this._embeddedModels[a])}}return!1},t.prototype.onEvents=function(e){if(this._isDisposed)throw new Error("MirrorModel.onEvents: Model is disposed");for(var t=!1,r=0,i=e.length;i>r;r++){var o=e[r];switch(o.type){case n.EventType.ModelContentChanged:var s=o;switch(this._lineStarts=null,this._setVersionId(s.versionId),s.changeType){case n.EventType.ModelContentChangedFlush:this._onLinesFlushed(s),t=!0;break;case n.EventType.ModelContentChangedLinesDeleted:this._onLinesDeleted(s),t=!0;break;case n.EventType.ModelContentChangedLinesInserted:this._onLinesInserted(s),t=!0;break;case n.EventType.ModelContentChangedLineChanged:this._onLineChanged(s),t=!0}break;case n.EventType.ModelPropertiesChanged:this._extraProperties=o.properties;break;default:console.warn("Unknown model event: "+o.type)}}var a=!1;return t&&(this.emit("changed",{}),a=this._updateEmbeddedModels()),a},t.prototype._onLinesFlushed=function(e){this._lineStarts=null,this._constructLines(e.detail),this._resetTokenizationState()},t.prototype._onLineChanged=function(e){if(this._lineStarts){var t=this.getEOL().length,r=e.detail.length+t;this._lineStarts.changeValue(e.lineNumber-1,r)}this._lines[e.lineNumber-1].removeText({},1,this._lines[e.lineNumber-1].text.length+1,!1,!1),this._lines[e.lineNumber-1].insertText({},1,{text:e.detail,markers:null},!1),this._invalidateLine(e.lineNumber-1)},t.prototype._onLinesDeleted=function(e){var t=e.fromLineNumber-1,r=e.toLineNumber-1;this._lineStarts&&this._lineStarts.removeValues(t,r-t+1);var n=this._lines[t].getState();this._lines.splice(t,r-t+1),t<this._lines.length&&(this._lines[t].setState(n),this._invalidateLine(t))},t.prototype._onLinesInserted=function(e){var t,r,n=this.getEOL().length,i=e.detail.split("\n");for(t=e.fromLineNumber-1,r=0;t<e.toLineNumber;t++,r++)this._lineStarts&&this._lineStarts.insertValue(t,i[r].length+n),this._lines.splice(t,0,new s.ModelLine(0,i[r]));e.fromLineNumber>=2&&this._invalidateLine(e.fromLineNumber-2)},t}(l);t.MirrorModel=h}),define("vs/editor/modes/boundModels",["require","exports","vs/editor/core/model/mirrorModel","vs/editor/editor","vs/base/collections","vs/base/severity","vs/editor/core/range","vs/platform/thread/attribute","vs/editor/core/constants","vs/base/eventSource"],function(e,t,r,n,i,o,s,a,u,c){var l=function(){function e(e){this.model=e,this.toUnbind=null}return e.prototype.dispose=function(){this._decorationIds=this.model.deltaDecorations(this._decorationIds,[]),this.model=null,this.toUnbind&&(this.toUnbind(),this.toUnbind=null)},e.prototype.deltaMarkers=function(e){var t=this;e=e.slice(0,500);var r=e.map(function(e){return{range:t._createDecorationRange(e),options:t._createDecorationOption(e)}});this._decorationIds=this.model.deltaDecorations(this._decorationIds,r)},e.prototype._createDecorationRange=function(e){var t=this.model.validateRange(new s.Range(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn)),r=new s.Range(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn);if(r.isEmpty()){var n=this.model.getWordAtPosition(r.getStartPosition(),!1);if(n)r.startColumn=n.startColumn,r.endColumn=n.endColumn;else{var i=this.model.getLineLastNonWhitespaceColumn(t.startLineNumber)||this.model.getLineMaxColumn(t.startLineNumber);1===i||(r.endColumn>=i?(r.endColumn=i,r.startColumn=i-1):r.endColumn+=1)}}else if(e.endColumn===Number.MAX_VALUE&&1===e.startColumn&&r.startLineNumber===r.endLineNumber){var o=this.model.getLineFirstNonWhitespaceColumn(e.startLineNumber);o<r.endColumn&&(r.startColumn=o,e.startColumn=o)}return r},e.prototype._createDecorationOption=function(e){var t=e.severity===o.Error,r=null;return"string"==typeof e.message?r=[{isText:!0,text:e.message}]:Array.isArray(e.message)?r=e.message:e.message&&(r=[e.message]),{stickiness:n.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges,isOverlay:!0,className:t?u.ClassName.EditorErrorDecoration:u.ClassName.EditorWarningDecoration,htmlMessage:r,overviewRuler:{color:t?"rgba(255,18,18,0.7)":"rgba(18,136,18,0.7)",position:n.OverviewRulerLane.Right}}},e}(),p=function(){function e(e,t,r,n){this._resourceService=r,this._markerService=t,this._models={},this._modeInstantiator=n,this._onModelAdded=new c,this._onModelRemoved=new c,this._markerService&&e.isInMainThread&&this._markerService.onMarkerChanged.add(this._handleMarkerChange,this),e.registerInstance(this)}return e.prototype.dispose=function(){this._markerService&&this._markerService.onMarkerChanged.remove(this._handleMarkerChange,this)},e.prototype._handleMarkerChange=function(e){var t=this;e.forEach(function(e){var r=t._models[e.toString()];r&&r.deltaMarkers(t._markerService.read({resource:e,take:500}))})},e.prototype._anonymousModelId=function(e){for(var t="",r=0;r<e.length;r++){var n=e[r];t+=n>="0"&&"9">=n?"0":n>="a"&&"z">=n?"a":n>="A"&&"Z">=n?"A":n}return t},e.prototype.addModel=function(e){var t=this,r=e.getAssociatedResource().toString();if(this._models[r])throw new Error("BoundModels: Cannot add model "+this._anonymousModelId(r)+" because it already exists!");var n=new l(e);n.toUnbind=e.addBulkListener(function(e){return t._onModelEvents(r,e)}),this._markerService&&n.deltaMarkers(this._markerService.read({resource:e.getAssociatedResource()})),this._models[r]=n,this._modelInitialize(this._getBoundModelData(e)),this._onModelAdded.fire(e)},e.prototype.removeModel=function(e){var t=this,r=e.getAssociatedResource().toString();if(!this._models[r])throw new Error("BoundModels: Cannot remove model "+this._anonymousModelId(r)+" because it doesn't exist!");if(this._modelDispose(e.getAssociatedResource()),this._models[r].dispose(),delete this._models[r],this._markerService){var n=this._markerService.read({resource:e.getAssociatedResource()}),i=Object.create(null);n.forEach(function(e){return i[e.owner]=t}),Object.keys(i).forEach(function(r){return t._markerService.changeOne(r,e.getAssociatedResource(),[])})}this._onModelRemoved.fire(e)},e.prototype.getModels=function(){var e=[];return i.forEach(this._models,function(t){return e.push(t.value.model)}),e},e.prototype.getModel=function(e){var t=this._models[e.toString()];return t?t.model:this._resourceService?this._resourceService.get(e):null},Object.defineProperty(e.prototype,"onModelAdded",{get:function(){return this._onModelAdded?this._onModelAdded.value:null},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onModelRemoved",{get:function(){return this._onModelRemoved?this._onModelRemoved.value:null},enumerable:!0,configurable:!0}),e.prototype.getId=function(){return e._ID},e.prototype.getSerializableState=function(){var e=this,t={};return Object.keys(this._models).forEach(function(r){t[r]=e._getBoundModelData(e._models[r].model)}),t},e.prototype.setData=function(e){var t=this;Object.keys(e).forEach(function(r){t._addMirrorModel(e[r])})},e.prototype._getBoundModelData=function(e){return{url:e.getAssociatedResource(),versionId:e.getVersionId(),properties:e.getProperties(),value:e.toRawText(),modeId:e.getMode().getId()}},e.prototype._onModelEvents=function(e,t){var r,n,i=[],o=!1;for(r=0,n=t.length;n>r;r++){var s=t[r],a=s.getData();switch(s.getType()){case u.EventType.ModelContentChanged:switch(a.changeType){case u.EventType.ModelContentChangedFlush:i.push(this._mixinProperties({type:s.getType()},a,["changeType","detail","versionId"]));break;case u.EventType.ModelContentChangedLinesDeleted:i.push(this._mixinProperties({type:s.getType()},a,["changeType","fromLineNumber","toLineNumber","versionId"]));break;case u.EventType.ModelContentChangedLinesInserted:i.push(this._mixinProperties({type:s.getType()},a,["changeType","fromLineNumber","toLineNumber","detail","versionId"]));break;case u.EventType.ModelContentChangedLineChanged:i.push(this._mixinProperties({type:s.getType()},a,["changeType","lineNumber","detail","versionId"]))}o=!0;break;case u.EventType.ModelPropertiesChanged:i.push(this._mixinProperties({type:s.getType()},a,["properties"]))}}i.length>0&&this._modelEvents(this._models[e].model.getAssociatedResource(),i)},e.prototype._mixinProperties=function(e,t,r){for(var n=0;n<r.length;n++)e[r[n]]=t[r[n]];return e},e.prototype._addMirrorModel=function(e){var t=this;return this._modeInstantiator(e.modeId).then(function(n){t._resourceService.insert(e.url,new r.MirrorModel(t._resourceService,e.versionId,e.value,n,e.url,e.properties))})},e.prototype._modelInitialize=function(e){return this._addMirrorModel(e)},e.prototype._modelEvents=function(e,t){var r=this._resourceService.get(e);if(!r)throw new Error("Received model events for missing model "+this._anonymousModelId(e.toString()));r.onEvents(t)},e.prototype._modelDispose=function(e){var t=this._resourceService.get(e);this._resourceService.remove(e),t&&t.dispose()},e._ID="boundModels",e.$_modelInitialize=a.AllWorkers(e,e.prototype._modelInitialize),e.$_modelEvents=a.AllWorkers(e,e.prototype._modelEvents),e.$_modelDispose=a.AllWorkers(e,e.prototype._modelDispose),e}();t.BoundModels=p}),define("vs/editor/modes/monarch/monarchCommon",["require","exports"],function(e,t){function r(){return"0.96  (2013.01.22)"}function n(e){return e?!1:!0}function i(e,t){return e.ignoreCase&&t?t.toLowerCase():t}function o(e){return e.replace(h,function(e){var t=d[e];return t?t:""})}function s(e){return e.replace(/[&<>'"_]/g,"-")}function a(e,t){console.log(t)}function u(e,t){throw new Error(t)}function c(e,t,r,o,s){var a=/\$((\$)|(#)|(\d\d?)|[sS](\d\d?)|@(\w+))/g,u=null;return t.replace(a,function(t,a,c,l,p,d,h){return n(c)?n(l)?!n(p)&&p<o.length?i(e,o[p]):!n(h)&&e&&"string"==typeof e[h]?e[h]:(null===u&&(u=s.split("."),u.unshift(s)),!n(d)&&d<u.length?i(e,u[d]):""):i(e,r):"$"})}function l(e,t){for(;t&&t.length>0;){var r=e.tokenizer[t];if(r)return r;var n=t.lastIndexOf(".");t=0>n?null:t.substr(0,n)}return null}function p(e,t){for(;t&&t.length>0;){var r=e.stateNames[t];if(r)return!0;var n=t.lastIndexOf(".");t=0>n?null:t.substr(0,n)}return!1}t.monarchPath="vs/editor/modes/monarch/monarch",t.version=r,t.empty=n,t.fixCase=i;var d={"&":"&amp;","<":"&lt;",">":"&gt;","'":"&apos;",'"':"&quot;"},h=new RegExp("["+Object.keys(d).join("")+"]","g");t.htmlEscape=o,t.sanitize=s,t.log=a,t.throwError=u,t.substituteMatches=c,t.findRules=l,t.stateExists=p}),define("vs/editor/modes/monarch/monarchCompile",["require","exports","vs/base/objects","vs/editor/modes/modes","vs/editor/modes/monarch/monarchCommon"],function(e,t,r,n,i){function o(e,t){if(!t)return!1;if(!Array.isArray(t))return!1;var r;for(r in t)if(t.hasOwnProperty(r)&&!e(t[r]))return!1;return!0}function s(e,t,r){return"boolean"==typeof e?e:(r&&(e||void 0===t)&&r(),void 0===t?null:t)}function a(e,t,r){return"string"==typeof e?e:(r&&(e||void 0===t)&&r(),void 0===t?null:t)}function u(e,t,r){return o(function(e){return"string"==typeof e},e)?e.slice(0):"string"==typeof e?[e]:(r&&(e||void 0===t)&&r(),void 0===t?null:t)}function c(e,t){if("string"!=typeof t)return null;for(var r=0;t.indexOf("@")>=0&&5>r;)r++,t=t.replace(/@(\w+)/g,function(r,n){var o="";return"string"==typeof e[n]?o=e[n]:e[n]&&e[n]instanceof RegExp?o=e[n].source:void 0===e[n]?i.throwError(e,"language definition does not contain attribute '"+n+"', used at: "+t):i.throwError(e,"attribute reference '"+n+"' must be a string, used at: "+t),i.empty(o)?"":"(?:"+o+")"});return new RegExp(t,e.ignoreCase?"i":"")}function l(e,t,r,n){if(0>n)return e;if(n<t.length)return t[n];if(n>=100){n-=100;var i=r.split(".");if(i.unshift(r),n<i.length)return i[n]}return null}function p(e,t,n,s){var a=-1,u=n,p=n.match(/^\$(([sS]?)(\d\d?)|#)(.*)$/);p&&(p[3]&&(a=parseInt(p[3]),p[2]&&(a+=100)),u=p[4]);var d="~",h=u;u&&0!==u.length?/^\w*$/.test(h)?d="==":(p=u.match(/^(@|!@|~|!~|==|!=)(.*)$/),p&&(d=p[1],h=p[2])):(d="!=",h="");var f;if("~"!==d&&"!~"!==d||!/^(\w|\|)*$/.test(h))if("@"===d||"!@"===d){var g=e[h];g||i.throwError(e,"the @ match target '"+h+"' is not defined, in rule: "+t),o(function(e){return"string"==typeof e},g)||i.throwError(e,"the @ match target '"+h+"' must be an array of strings, in rule: "+t);var m=r.createKeywordMatcher(g,e.ignoreCase);f=function(e){return"@"===d?m(e):!m(e)}}else if("~"===d||"!~"===d)if(h.indexOf("$")<0){var v=c(e,"^"+h+"$");f=function(e){return"~"===d?v.test(e):!v.test(e)}}else f=function(t,r,n,o){var s=c(e,"^"+i.substituteMatches(e,h,r,n,o)+"$");return s.test(t)};else if(h.indexOf("$")<0){var _=i.fixCase(e,h);f=function(e){return"=="===d?e===_:e!==_}}else{var _=i.fixCase(e,h);f=function(t,r,n,o){var s=i.substituteMatches(e,_,r,n,o);return"=="===d?t===s:t!==s}}else{var m=r.createKeywordMatcher(h.split("|"),e.ignoreCase);f=function(e){return"~"===d?m(e):!m(e)}}return-1===a?{name:n,value:s,test:function(e,t,r,n){return f(e,e,t,r,n)}}:{name:n,value:s,test:function(e,t,r,n){var i=l(e,t,r,a);return f(i?i:"",e,t,r,n)}}}function d(e,t,r){if(r){if("string"==typeof r)return r;if(r.token||""===r.token){if("string"!=typeof r.token)return i.throwError(e,"a 'token' attribute must be of type string, in rule: "+t),{token:""};var o={token:r.token};if(r.token.indexOf("$")>=0&&(o.tokenSubst=!0),"string"==typeof r.bracket&&("@open"===r.bracket?o.bracket=n.Bracket.Open:"@close"===r.bracket?o.bracket=n.Bracket.Close:i.throwError(e,"a 'bracket' attribute must be either '@open' or '@close', in rule: "+t)),r.next)if("string"!=typeof r.next)i.throwError(e,"the next state must be a string value in rule: "+t);else{var s=r.next;/^(@pop|@push|@popall)$/.test(s)||("@"===s[0]&&(s=s.substr(1)),s.indexOf("$")<0&&(i.stateExists(e,i.substituteMatches(e,s,"",[],""))||i.throwError(e,"the next state '"+r.next+"' is not defined in rule: "+t))),o.next=s}return"number"==typeof r.goBack&&(o.goBack=r.goBack),"string"==typeof r.switchTo&&(o.switchTo=r.switchTo),"string"==typeof r.log&&(o.log=r.log),"string"==typeof r.nextEmbedded&&(o.nextEmbedded=r.nextEmbedded,e.usesEmbedded=!0),o}if(Array.isArray(r)){var a,u=[];for(a in r)r.hasOwnProperty(a)&&(u[a]=d(e,t,r[a]));return{group:u}}if(r.cases){var c,l=[];for(c in r.cases)if(r.cases.hasOwnProperty(c)){var h=d(e,t,r.cases[c]);"@default"===c||"@"===c||""===c?l.push({test:null,value:h,name:c}):"@eos"===c?l.push({test:function(e,t,r,n){return n},value:h,name:c}):l.push(p(e,t,c,h))}var f=e.defaultToken;return{test:function(e,t,r,n){var i;for(i in l)if(l.hasOwnProperty(i)){var o=!l[i].test||l[i].test(e,t,r,n);if(o)return l[i].value}return f}}}return i.throwError(e,"an action must be a string, an object with a 'token' or 'cases' attribute, or an array of actions; in rule: "+t),""}return{token:""}}function h(e){function t(n,o,u){var c;for(c in u)if(u.hasOwnProperty(c)){var l=u[c],d=l.include;if(d)"string"!=typeof d&&i.throwError(r,"an 'include' attribute must be a string at: "+n),"@"===d[0]&&(d=d.substr(1)),e.tokenizer[d]||i.throwError(r,"include target '"+d+"' is not defined at: "+n),t(n+"."+d,o,e.tokenizer[d]);else{var h=new f(n);if(Array.isArray(l)&&l.length>=1&&l.length<=3)if(h.setRegex(p,l[0]),l.length>=3)if("string"==typeof l[1])h.setAction(p,{token:l[1],next:l[2]});else if("object"==typeof l[1]){var g=l[1];g.next=l[2],h.setAction(p,g)}else i.throwError(r,"a next state as the last element of a rule can only be given if the action is either an object or a string, at: "+n);else h.setAction(p,l[1]);else l.regex||i.throwError(r,"a rule must either be an array, or an object with a 'regex' or 'include' field at: "+n),l.name&&(h.name=a(l.name)),l.matchOnlyAtStart&&(h.matchOnlyAtLineStart=s(l.matchOnlyAtLineStart)),h.setRegex(p,l.regex),h.setAction(p,l.action);o.push(h)}}}if(!e||"object"!=typeof e)throw new Error("Monarch: expecting a language definition object");if("string"!=typeof e.name)throw new Error("Monarch: a language definition must include a string 'name' attribute");var r={};if(r.name=e.name,r.displayName=a(e.displayName,r.name),r.logConsole=a(e.logConsole),r.noThrow=!1,r.maxStack=100,r.mimeTypes=u(e.mimeTypes,void 0,function(){i.throwError(r,"the attribute 'mimeTypes' must be defined as an array of strings")}),r.start=a(e.start),r.fileExtensions=u(e.fileExtensions),r.ignoreCase=s(e.ignoreCase,!1),r.lineComment=a(e.lineComment,"//"),r.blockCommentStart=a(e.blockCommentStart,"/*"),r.blockCommentEnd=a(e.blockCommentEnd,"*/"),r.tokenPostfix=a(e.tokenPostfix,"."+r.name),r.defaultToken=a(e.defaultToken,"source",function(){i.throwError(r,"the 'defaultToken' must be a string")}),r.editorOptions=e.editorOptions?e.editorOptions:null,r.workerDescriptor=e.workerDescriptor,r.usesEmbedded=!1,r.wordDefinition=e.wordDefinition||void 0,!r.lineComment&&e.lineComments&&("string"==typeof e.lineComments?r.lineComment=e.lineComments:"string"==typeof e.lineComments[0]&&(r.lineComment=e.lineComments[0])),r.suggestSupport={textualCompletions:!0,triggerCharacters:[],snippets:[]},"undefined"!=typeof e.suggestSupport){var n=e.suggestSupport;if(Array.isArray(n.snippets))for(var o=n.snippets,c=0,l=o.length;l>c;c++)"string"==typeof o[c]?r.suggestSupport.snippets.push({type:"snippet",label:o[c],codeSnippet:o[c]}):r.suggestSupport.snippets.push(o[c]);Array.isArray(n.triggerCharacters)&&(r.suggestSupport.triggerCharacters=n.triggerCharacters),"undefined"!=typeof n.textualCompletions&&(r.suggestSupport.textualCompletions=n.textualCompletions)}var p=e;p.name=r.name,p.displayName=r.displayName,p.ignoreCase=r.ignoreCase,p.noThrow=r.noThrow,p.usesEmbedded=r.usesEmbedded,p.stateNames=e.tokenizer,p.logConsole=r.logConsole,p.defaultToken=r.defaultToken,e.tokenizer&&"object"==typeof e.tokenizer||i.throwError(r,"a language definition must define the 'tokenizer' attribute as an object"),r.tokenizer=[];var d;for(d in e.tokenizer)if(e.tokenizer.hasOwnProperty(d)){r.start||(r.start=d);var h=e.tokenizer[d];r.tokenizer[d]=new Array,t("tokenizer."+d,r.tokenizer[d],h)}r.usesEmbedded=p.usesEmbedded,r.nonWordTokens=u(e.nonWordTokens,["delimiter","delimiter.parenthesis","delimiter.curly","delimiter.square","delimiter.angle"],function(){i.throwError(r,"the 'nonWordTokens' attribute must be an array of strings")});var g;for(g in r.nonWordTokens)r.nonWordTokens.hasOwnProperty(g)&&(r.nonWordTokens[g]+=r.tokenPostfix);e.brackets?Array.isArray(e.brackets)||i.throwError(r,"the 'brackets' attribute must be defined as an array"):e.brackets=[{open:"{",close:"}",token:"delimiter.curly"},{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"},{open:"<",close:">",token:"delimiter.angle"}];var m=[];for(var v in e.brackets)if(e.brackets.hasOwnProperty(v)){var _=e.brackets[v];_&&Array.isArray(_)&&3===_.length&&(_={token:_[2],open:_[0],close:_[1]}),_.open===_.close&&i.throwError(r,"open and close brackets in a 'brackets' attribute must be different: "+_.open+"\n hint: use the 'bracket' attribute if matching on equal brackets is required."),"string"==typeof _.open&&"string"==typeof _.token?m.push({token:a(_.token)+r.tokenPostfix,open:i.fixCase(r,a(_.open)),close:i.fixCase(r,a(_.close))}):i.throwError(r,"every element in the 'brackets' array must be a '{open,close,token}' object or array")}r.brackets=m;var y;if(e.autoClosingPairs?(Array.isArray(e.autoClosingPairs)||i.throwError(r,"the 'autoClosingPairs' attribute must be an array of string pairs (as arrays)"),y=e.autoClosingPairs.slice(0)):y=[['"','"'],["'","'"],["@brackets"]],r.autoClosingPairs=[],y)for(var b in y)if(y.hasOwnProperty(b)){var S,k=y[b];if("@brackets"===k||"@brackets"===k[0]){var C;for(C in m)m.hasOwnProperty(C)&&m[C].open&&1===m[C].open.length&&m[C].close&&1===m[C].close.length&&(S={open:m[C].open,close:m[C].close,notIn:["string","comment"]},r.autoClosingPairs.push(S))}else Array.isArray(k)&&2===k.length&&"string"==typeof k[0]&&1===k[0].length&&"string"==typeof k[1]&&1===k[1].length?(S={open:i.fixCase(r,k[0]),close:i.fixCase(r,k[1]),notIn:["string","comment"]},r.autoClosingPairs.push(S)):"string"==typeof k.open&&1===k.open.length&&"string"==typeof k.close&&1===k.close.length?(S={open:i.fixCase(r,k.open[0]),close:i.fixCase(r,k.close[0]),notIn:["string","comment"]},r.autoClosingPairs.push(S)):i.throwError(r,"every element in an 'autoClosingPairs' array must be a pair of 1 character strings, or a '@brackets' directive")}var T=[];if(e.enhancedBrackets){Array.isArray(e.enhancedBrackets)||i.throwError(r,"the 'enhancedBrackets' attribute must be defined as an array");for(var v in e.enhancedBrackets)if(e.enhancedBrackets.hasOwnProperty(v)){var _=e.enhancedBrackets[v];_.hasOwnProperty("openTrigger")&&"string"!=typeof _.openTrigger&&i.throwError(r,"openTrigger in the 'enhancedBrackets' array must be a string"),!_.hasOwnProperty("open")||_.open instanceof RegExp||i.throwError(r,"open in the 'enhancedBrackets' array must be a regex"),_.hasOwnProperty("closeComplete")&&"string"!=typeof _.closeComplete&&i.throwError(r,"closeComplete in the 'enhancedBrackets' array must be a string"),_.hasOwnProperty("matchCase")&&"boolean"!=typeof _.matchCase&&i.throwError(r,"matchCase in the 'enhancedBrackets' array must be a boolean"),_.hasOwnProperty("closeTrigger")&&"string"!=typeof _.closeTrigger&&i.throwError(r,"closeTrigger in the 'enhancedBrackets' array must be a string"),!_.hasOwnProperty("close")||_.close instanceof RegExp||i.throwError(r,"close in the 'enhancedBrackets' array must be a regex"),_.hasOwnProperty("tokenType")&&("string"!=typeof _.tokenType?i.throwError(r,"tokenType in the 'enhancedBrackets' array must be a string"):_.tokenType+=r.tokenPostfix),T.push(_)
}}r.enhancedBrackets=T;var E=null;e.docComment&&(E=e.docComment,E.hasOwnProperty("scope")&&"string"==typeof E.scope||i.throwError(r,"'docComment' must have a property 'scope' of type string"),E.hasOwnProperty("open")&&"string"==typeof E.open||i.throwError(r,"'docComment' must have a property 'open' of type string"),E.hasOwnProperty("lineStart")&&"string"==typeof E.lineStart||i.throwError(r,"'docComment' must have a property 'lineStart' of type string"),E.hasOwnProperty("close")&&"string"!=typeof E.close&&i.throwError(r,"'close' in 'docComment' must be a string")),r.docComment=E;for(var w=[],c=0;c<m.length;++c)w.push({tokenType:m[c].token,open:m[c].open,close:m[c].close,isElectric:!0});return r.standardBrackets=w,r.outdentTriggers=a(e.outdentTriggers,""),r.logConsole||(r.logConsole="monarchConsole"),r.noThrow=!0,r}var f=function(){function e(e){this.regex=new RegExp(""),this.action={token:""},this.matchOnlyAtLineStart=!1,this.name="",this.name=e}return e.prototype.setRegex=function(e,t){var r;"string"==typeof t?r=t:t instanceof RegExp?r=t.source:i.throwError(e,"rules must start with a match string or regular expression: "+this.name),this.matchOnlyAtLineStart=r.length>0&&"^"===r[0],this.name=this.name+": "+r,this.regex=c(e,"^(?:"+(this.matchOnlyAtLineStart?r.substr(1):r)+")")},e.prototype.setAction=function(e,t){this.action=d(e,this.name,t)},e}();t.compile=h});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/modes/monarch/monarch",["require","exports","vs/platform/platform","vs/platform/services","vs/editor/modes/stream","vs/editor/modes/modes","vs/editor/modes/modesExtensions","vs/editor/modes/supports","vs/editor/modes/monarch/monarchCommon","vs/editor/modes/monarch/monarchCompile","vs/base/lib/winjs.base","vs/platform/thread/attribute","vs/base/objects"],function(e,t,r,n,i,o,s,a,u,c,l,p,d){function h(e,t){if(!t)return null;t=u.fixCase(e,t);for(var r=e.brackets,n=0;n<r.length;n++){var i=r[n];if(i.open===t)return{token:i.token,bracketType:o.Bracket.Open};if(i.close===t)return{token:i.token,bracketType:o.Bracket.Close}}return null}function f(e,t,r){T.registerMonarchDefinition(e,t,r)}function g(e,t){var n=r.Registry?r.Registry.as(s.Extensions.EditorModes):null;return new a.TokenizationSupport(e,{getInitialState:function(){return new C(e,t)},enterNestedMode:function(e){return e instanceof C?e.embeddedEntered:!1},getNestedMode:function(e){var t=null;if(e instanceof C){var r=e.embeddedMode;if(n.isRegisteredMode(r)){var i=k(n,r);if(i)return{mode:i,missingModePromise:t};t=n.getOrCreateMode(r)}}return{mode:k(n,"text/plain"),missingModePromise:t}},getLeavingNestedModeData:function(e,t){for(var r=t.clone(),n=new i.LineStream(e);!n.eos()&&r.embeddedMode;)r.tokenize(n,!0);if(r.embeddedMode)return null;var o=n.pos();return{nestedModeBuffer:e.substring(0,o),bufferAfterNestedMode:e.substring(o),stateAfterNestedMode:r}}},t.usesEmbedded)}function m(e){return{commentsConfiguration:{lineCommentTokens:[e.lineComment],blockCommentStartToken:e.blockCommentStart,blockCommentEndToken:e.blockCommentEnd}}}function v(e){return{brackets:e.standardBrackets,regexBrackets:e.enhancedBrackets,docComment:e.docComment,caseInsensitive:e.ignoreCase,embeddedElectricCharacters:e.outdentTriggers.split("")}}function _(e){return{nonWordTokenTypes:e.nonWordTokens,wordDefinition:e.wordDefinition}}function y(e){return{autoClosingPairs:e.autoClosingPairs}}function b(e,t,r){return r.suggestSupport.textualCompletions&&t instanceof s.AbstractMode?{triggerCharacters:r.suggestSupport.triggerCharacters,excludeTokens:[],suggest:function(e,r){return t.suggest(e,r)},composeSuggest:function(t,n,i){return l.TPromise.as(S(e.getModel(t),n,r,i))}}:{triggerCharacters:r.suggestSupport.triggerCharacters,excludeTokens:[],suggest:function(t,n){return l.TPromise.as(S(e.getModel(t),n,r,null))},composeSuggest:function(e,t,r){return l.TPromise.as(r)}}}function S(e,t,r,n){var i=r.suggestSupport.snippets;return i&&0!==i.length?(n||(n=[]),n.push({currentWord:e.getWordUntilPosition(t,!0,!0).word,suggestions:i.slice(0)}),n):n}function k(e,t){if(!e||void 0===e.getMode)return null;var r=e.getMode(t);if(r)return r;if(e.getOrCreateMode){var n=e.getOrCreateMode(t);return n&&n.value?n.value:null}}var C=function(e){function t(r,n,i,o){e.call(this,r),this.id=t.ID++,this.lexer=n,this.stack=i?i:[n.start],this.embeddedMode=o?o:null,this.embeddedEntered=!1,this.groupActions=null,this.groupMatches=null,this.groupMatched=null,this.groupRule=null}return __extends(t,e),t.prototype.makeClone=function(){return new t(this.getMode(),this.lexer,this.stack.slice(0),this.embeddedMode)},t.prototype.equals=function(r){if(!e.prototype.equals.call(this,r))return!1;if(!(r instanceof t))return!1;var n=r;if(this.stack.length!==n.stack.length||this.lexer.name!==n.lexer.name||this.embeddedMode!==n.embeddedMode)return!1;var i;for(i in this.stack)if(this.stack.hasOwnProperty(i)&&this.stack[i]!==n.stack[i])return!1;return!0},t.prototype.tokenize=function(e,t){var r=this.stack.length,n=0,i=this.stack[0];this.embeddedEntered=!1;var a=null,c=null,l=null,p=null,d=null;if(this.groupActions)n=this.groupActions.length,a=this.groupMatches,c=this.groupMatched.shift(),l=this.groupActions.shift(),d=this.groupRule,0===this.groupActions.length&&(this.groupActions=null,this.groupMatches=null,this.groupMatched=null,this.groupRule=null);else{if(e.eos())return{type:""};var f=e.advanceToEOS();e.goBack(f.length);var g=this.lexer.tokenizer[i];if(g||(g=u.findRules(this.lexer,i)),g){d=null;var m,v=e.pos();for(m in g)if(g.hasOwnProperty(m)&&(d=g[m],(0===v||!d.matchOnlyAtLineStart)&&(a=f.match(d.regex)))){c=a[0],l=d.action;break}}else u.throwError(this.lexer,"tokenizer state is not defined: "+i)}for(a||(a=[""],c=""),l||(e.eos()||(a=[e.peek()],c=a[0]),l=this.lexer.defaultToken),e.advance(c.length);l.test;){var _=l.test(c,a,i,e.eos());l=_}var y=null;if("string"==typeof l||Array.isArray(l))y=l;else if(l.group)y=l.group;else if(null!==l.token&&void 0!==l.token){if(y=l.token,l.tokenSubst&&(y=u.substituteMatches(this.lexer,y,c,a,i)),l.nextEmbedded)if("@pop"===l.nextEmbedded)this.embeddedMode||u.throwError(this.lexer,"cannot pop embedded mode if not inside one"),this.embeddedMode=null;else if(this.embeddedMode)u.throwError(this.lexer,"cannot enter embedded mode from within an embedded mode");else{this.embeddedMode=u.substituteMatches(this.lexer,l.nextEmbedded,c,a,i);var b=s.languageAliasToMime(this.embeddedMode);this.embeddedMode&&b&&(this.embeddedMode=b),this.embeddedEntered=!0}if(l.goBack&&e.goBack(l.goBack),l.switchTo&&"string"==typeof l.switchTo){var S=u.substituteMatches(this.lexer,l.switchTo,c,a,i);"@"===S[0]&&(S=S.substr(1)),u.findRules(this.lexer,S)?this.stack[0]=S:u.throwError(this.lexer,"trying to switch to a state '"+S+"' that is undefined in rule: "+d.name),p=null}else if(l.transform&&"function"==typeof l.transform)this.stack=l.transform(this.stack),p=null;else if(l.next)if("@push"===l.next)this.stack.length>=this.lexer.maxStack?u.throwError(this.lexer,"maximum tokenizer stack size reached: ["+this.stack[0]+","+this.stack[1]+",...,"+this.stack[this.stack.length-2]+","+this.stack[this.stack.length-1]+"]"):this.stack.unshift(i);else if("@pop"===l.next)this.stack.length<=1?u.throwError(this.lexer,"trying to pop an empty stack in rule: "+d.name):this.stack.shift();else if("@popall"===l.next)this.stack.length>1&&(this.stack=[this.stack[this.stack.length-1]]);else{var S=u.substituteMatches(this.lexer,l.next,c,a,i);"@"===S[0]&&(S=S.substr(1)),u.findRules(this.lexer,S)?this.stack.unshift(S):u.throwError(this.lexer,"trying to set a next state '"+S+"' that is undefined in rule: "+d.name)}l.log&&"string"==typeof l.log&&u.log(this.lexer,this.lexer.displayName+": "+u.substituteMatches(this.lexer,l.log,c,a,i))}if(null===y&&(u.throwError(this.lexer,"lexer rule has no well-defined action in rule: "+d.name),y=this.lexer.defaultToken),Array.isArray(y)){this.groupActions&&this.groupActions.length>0&&u.throwError(this.lexer,"groups cannot be nested: "+d.name),a.length!==y.length+1&&u.throwError(this.lexer,"matched number of groups does not match the number of actions in rule: "+d.name);for(var k=0,C=1;C<a.length;C++)k+=a[C].length;return k!==c.length&&u.throwError(this.lexer,"with groups, all characters should be matched in consecutive groups in rule: "+d.name),this.groupMatches=a,this.groupMatched=a.slice(1),this.groupActions=y.slice(0),this.groupRule=d,e.goBack(c.length),this.tokenize(e)}if("@rematch"===y&&(e.goBack(c.length),c="",a=null,y=""),0===c.length)if(r!==this.stack.length||i!==this.stack[0]||(this.groupActions?this.groupActions.length:0)!==n){if(!t)return this.tokenize(e)}else u.throwError(this.lexer,"no progress in tokenizer in rule: "+d.name),e.advanceToEOS();if(0===y.indexOf("@brackets")){var T=y.substr("@brackets".length),E=h(this.lexer,c);return E||(u.throwError(this.lexer,"@brackets token returned but no bracket defined as: "+c),E={token:"",bracketType:o.Bracket.None}),{type:u.sanitize(E.token+T),bracket:E.bracketType}}var w=""===y?"":y+this.lexer.tokenPostfix;return{type:u.sanitize(w),bracket:l.bracket}},t.ID=0,t}(s.AbstractState);t.MonarchLexer=C,t.registerMonarchDefinition=f;var T=function(){function e(){}return e.register=function(t){e.INSTANCE_REGISTERED||(e.INSTANCE_REGISTERED=!0,t.registerInstance(e.INSTANCE))},e.registerMonarchDefinition=function(t,n,i){var o=c.compile(d.clone(i));e.INSTANCE._actualRegister(n,o);var u=r.Registry.as(s.Extensions.EditorModes);u.registerModeSupport(n,"suggestSupport",function(e){return new a.ComposableSuggestSupport(e,b(t,e,o))}),e.INSTANCE._registerMonarchDefinition(n,i)},e.prototype.getId=function(){return"vs.editor.modes.monarchDefinitionForwarder"},e.prototype._registerMonarchDefinition=function(e,t){var r=c.compile(d.clone(t));this._actualRegister(e,r)},e.prototype._actualRegister=function(e,t){s.registerTokenizationSupport(e,function(e){return g(e,t)}),s.registerDeclarativeCommentsSupport(e,m(t)),s.registerDeclarativeElectricCharacterSupport(e,v(t)),s.registerDeclarativeTokenTypeClassificationSupport(e,_(t)),s.registerDeclarativeCharacterPairSupport(e,y(t))},e.INSTANCE=new e,e.INSTANCE_REGISTERED=!1,e.$_registerMonarchDefinition=p.AllWorkers(e,e.prototype._registerMonarchDefinition),e}();s.registerThreadServiceListener(T.register),t.createTokenizationSupport=g,t.createTokenTypeClassificationSupportContribution=_,t.createSuggestSupport=b;var E=function(e){function t(r,i,o){!o.name&&o.lexer&&(o=o.lexer),i||(i={id:o.name,workerParticipants:[]}),e.call(this,r,i,o.workerDescriptor?n.AsyncDescriptor.create(o.workerDescriptor.moduleName,o.workerDescriptor.ctorName):t.WorkerDescriptor),this.tokenizationSupport=g(this,o),this.electricCharacterSupport=new a.BracketElectricCharacterSupport(this,v(o)),this.commentsSupport=new a.CommentsSupport(m(o)),this.tokenTypeClassificationSupport=new a.TokenTypeClassificationSupport(_(o)),this.characterPairSupport=new a.CharacterPairSupport(this,y(o)),this.suggestSupport=new a.ComposableSuggestSupport(this,b(this._modelService,this,o))}return __extends(t,e),t.WorkerDescriptor=n.AsyncDescriptor.create(u.monarchPath+"Worker","MonarchNullWorker"),t}(s.AbstractMode);t.MonarchMode=E}),define("vs/editor/api/base.api",["require","exports","vs/base/env","vs/base/lib/winjs.base","vs/base/network","vs/base/uri","vs/base/strings","vs/base/paths","vs/base/severity","vs/platform/plugins","vs/editor/core/range","vs/editor/modes/monarch/monarch","vs/editor/modes/modes","vs/editor/modes/supports","vs/editor/editor"],function(e,t,r,n,i,o,s,a,u,c,l,p,d,h,f){function g(e){var t;t=new v(e),define("monaco",[],t)}var m=function(){function e(e){this._modelService=e.modelService,this.Promise=n.TPromise,this.URL=i.URL,this.URI=o,this.Models_EndOfLinePreference=f.EndOfLinePreference,this.Modes_Bracket=d.Bracket,this._pathTranslator=new C(e),this.Services_Severity=u}return e.prototype.Range_containsPosition=function(e,t){return l.containsPosition(e,t)},e.prototype.Modes_InplaceReplaceSupport_valueSetReplace=function(e,t,r){return h.ReplaceSupport.valueSetReplace(e,t,r)},e.prototype.Modes_InplaceReplaceSupport_valueSetsReplace=function(e,t,r){return h.ReplaceSupport.valueSetsReplace(e,t,r)},e.prototype.Modes_registerMonarchDefinition=function(e,t){p.registerMonarchDefinition(this._modelService,e,t)},e.prototype.Paths_toAbsoluteFilePath=function(e){return this._pathTranslator.asAbsolutePath(e)},e.prototype.Paths_getAppRoot=function(){return r.appRoot},e}();t.BaseMonacoAPI=m,t.createAPI=g;var v=function(){function e(e){this.Promise=e.Promise,this.URL=e.URL,this.URI=e.URI,this.Range={containsPosition:e.Range_containsPosition.bind(e)},this.Models={EndOfLinePreference:e.Models_EndOfLinePreference},this.Modes=new _(e),this.Paths=new b(e),this.Plugins=new k(e),this.Services=new S(e)}return e}(),_=function(){function e(e){this.Bracket=e.Modes_Bracket,this.InplaceReplaceSupport=new y(e),this.registerMonarchDefinition=e.Modes_registerMonarchDefinition.bind(e),this.loadInBackgroundWorker=e.Modes_loadInBackgroundWorker.bind(e),this.DeclarationSupport={register:e.Modes_DeclarationSupport_register.bind(e)},this.CodeLensSupport={register:e.Modes_CodeLensSupport_register.bind(e)},this.OccurrencesSupport={register:e.Modes_OccurrencesSupport_register.bind(e)},this.OutlineSupport={register:e.Modes_OutlineSupport_register.bind(e)},this.QuickFixSupport={register:e.Modes_QuickFixSupport_register.bind(e)},this.ReferenceSupport={register:e.Modes_ReferenceSupport_register.bind(e)},this.ExtraInfoSupport={register:e.Modes_ExtraInfoSupport_register.bind(e)},this.RenameSupport={register:e.Modes_RenameSupport_register.bind(e)},this.FormattingSupport={register:e.Modes_FormattingSupport_register.bind(e)},this.SuggestSupport={register:e.Modes_SuggestSupport_register.bind(e)},this.NavigateTypesSupport={register:e.Modes_NavigateTypesSupport_register.bind(e)},this.CommentsSupport={register:e.Modes_CommentsSupport_register.bind(e)},this.ParameterHintsSupport={register:e.Modes_ParameterHintsSupport_register.bind(e)},this.TokenTypeClassificationSupport={register:e.Modes_TokenTypeClassificationSupport_register.bind(e)},this.ElectricCharacterSupport={register:e.Modes_ElectricCharacterSupport_register.bind(e)},this.CharacterPairSupport={register:e.Modes_CharacterPairSupport_register.bind(e)}}return e}(),y=function(){function e(e){this.register=e.Modes_InplaceReplaceSupport_register.bind(e),this.create=e.Modes_InplaceReplaceSupport_create.bind(e),this.valueSetReplace=e.Modes_InplaceReplaceSupport_valueSetReplace.bind(e),this.valueSetsReplace=e.Modes_InplaceReplaceSupport_valueSetsReplace.bind(e)}return e}(),b=function(){function e(e){this.toAbsoluteFilePath=e.Paths_toAbsoluteFilePath.bind(e),this.getAppRoot=e.Paths_getAppRoot.bind(e)}return e}(),S=function(){function e(e){this.Severity=e.Services_Severity}return e}(),k=function(){function e(){this.get=c.get.bind(c)}return e}(),C=function(){function e(e){this._baseFileUrl=e.requestService.getRequestUrl("root",s.empty,!0),this._workspacePath=e.contextService.getWorkspace()?e.contextService.getWorkspace().resource.fsPath:void 0}return e.prototype.asRelativePath=function(e){return this._workspacePath&&s.startsWith(e,this._workspacePath)?e.substr(this._workspacePath.length):null},e.prototype.asUrl=function(e){var t=this.asRelativePath(e);return t?i.URL.fromValue(a.join(this._baseFileUrl,a.normalize(t))):null},e.prototype.asRelativeUrl=function(e){var t=e.toString();return s.startsWith(t,this._baseFileUrl)?t.substr(this._baseFileUrl.length):null},e.prototype.asAbsolutePath=function(e){var t=this.asRelativeUrl(e);return t&&this._workspacePath?a.normalize(a.join(this._workspacePath,t),!0):null},e.prototype.toAbsolutePath=function(e){return e&&this._workspacePath?a.normalize(a.join(this._workspacePath,e),!0):null},e}()});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/api/baseRemote.api",["require","exports","vs/editor/modes/monarch/monarch","vs/editor/modes/modesExtensions","vs/editor/api/base.api"],function(e,t,r,n,i){var o=function(e){function t(t,r){e.call(this,t),this._threadService=t.threadService,this._proxy=r}return __extends(t,e),t.prototype.Modes_InplaceReplaceSupport_register=function(e,t){this._proxy.Modes_InplaceReplaceSupport_register(e,this._threadService.proxifyMembers(e+"/inplaceReplaceSupport",t,["navigateValueSet"]))},t.prototype.Modes_registerMonarchDefinition=function(t,r){e.prototype.Modes_registerMonarchDefinition.call(this,t,r),this._proxy.Modes_registerMonarchDefinition(t,r)},t.prototype.Modes_DeclarationSupport_register=function(e,t){this._proxy.Modes_DeclarationSupport_register(e,this._threadService.proxifyMembers(e+"/declarationSupport",t,["tokens","findDeclaration"]))},t.prototype.Modes_CodeLensSupport_register=function(e,t){this._proxy.Modes_CodeLensSupport_register(e,this._threadService.proxifyMembers(e+"/codeLensSupport",t,["findCodeLensSymbols","findCodeLensReferences"]))},t.prototype.Modes_OccurrencesSupport_register=function(e,t){this._proxy.Modes_OccurrencesSupport_register(e,this._threadService.proxifyMembers(e+"/occurrencesSupport",t,["findOccurrences"]))},t.prototype.Modes_OutlineSupport_register=function(e,t){this._proxy.Modes_OutlineSupport_register(e,this._threadService.proxifyMembers(e+"/outlineSupport",t,["getOutline","outlineGroupLabel"]))},t.prototype.Modes_QuickFixSupport_register=function(e,t){this._proxy.Modes_QuickFixSupport_register(e,this._threadService.proxifyMembers(e+"/quickFixSupport",t,["getQuickFixes","runQuickFixAction"]))},t.prototype.Modes_ReferenceSupport_register=function(e,t){this._proxy.Modes_ReferenceSupport_register(e,this._threadService.proxifyMembers(e+"/referenceSupport",t,["tokens","findReferences"]))},t.prototype.Modes_ExtraInfoSupport_register=function(e,t){this._proxy.Modes_ExtraInfoSupport_register(e,this._threadService.proxifyMembers(e+"/extraInfoSupport",t,["computeInfo"]))},t.prototype.Modes_RenameSupport_register=function(e,t){this._proxy.Modes_RenameSupport_register(e,this._threadService.proxifyMembers(e+"/renameSupport",t,["filter","rename"]))},t.prototype.Modes_FormattingSupport_register=function(e,t){this._proxy.Modes_FormattingSupport_register(e,this._threadService.proxifyMembers(e+"/formattingSupport",t,["formatDocument","formatRange","autoFormatTriggerCharacters","formatAfterKeystroke"]))},t.prototype.Modes_SuggestSupport_register=function(e,t){this._proxy.Modes_SuggestSupport_register(e,this._threadService.proxifyMembers(e+"/suggestSupport",t,["triggerCharacters","excludeTokens","sortBy","suggest","getSuggestionDetails"]))},t.prototype.Modes_NavigateTypesSupport_register=function(e,t){this._proxy.Modes_NavigateTypesSupport_register(e,this._threadService.proxifyMembers(e+"/navigateTypesSupport",t,["getNavigateToItems"]))},t.prototype.Modes_CommentsSupport_register=function(e,t){this._proxy.Modes_CommentsSupport_register(e,this._threadService.proxifyMembers(e+"/commentsSupport",t,["commentsConfiguration"]))},t.prototype.Modes_ParameterHintsSupport_register=function(e,t){this._proxy.Modes_ParameterHintsSupport_register(e,this._threadService.proxifyMembers(e+"/parameterHintsSupport",t,["triggerCharacters","excludeTokens","getParameterHints"]))},t.prototype.Modes_TokenTypeClassificationSupport_register=function(e,t){this._proxy.Modes_TokenTypeClassificationSupport_register(e,this._threadService.proxifyMembers(e+"/tokenTypeClassificationSupport",t,["nonWordTokenTypes","wordDefinition"]))},t.prototype.Modes_ElectricCharacterSupport_register=function(e,t){this._proxy.Modes_ElectricCharacterSupport_register(e,this._threadService.proxifyMembers(e+"/electricCharacterSupport",t,["brackets","regexBrackets","docComment","caseInsensitive","embeddedElectricCharacters"]))},t.prototype.Modes_CharacterPairSupport_register=function(e,t){this._proxy.Modes_CharacterPairSupport_register(e,this._threadService.proxifyMembers(e+"/characterPairSupport",t,["autoClosingPairs","surroundingPairs"]))},t}(i.BaseMonacoAPI);t.RemoteMonacoAPI=o;var s=function(){function e(e){this._threadService=e.threadService,this._modelService=e.modelService}return e.prototype.Modes_InplaceReplaceSupport_register=function(e,t){n.registerInplaceReplaceSupport(e,t)},e.prototype.Modes_registerMonarchDefinition=function(e,t){r.registerMonarchDefinition(this._modelService,e,t)},e.prototype.Modes_DeclarationSupport_register=function(e,t){n.registerDeclarativeDeclarationSupport(e,t)},e.prototype.Modes_CodeLensSupport_register=function(e,t){n.registerCodeLensSupport(e,{enableCodeLens:function(){return!0},findCodeLensReferences:t.findCodeLensReferences.bind(t),findCodeLensSymbols:t.findCodeLensSymbols.bind(t)})},e.prototype.Modes_OccurrencesSupport_register=function(e,t){n.registerOccurrencesSupport(e,t)},e.prototype.Modes_OutlineSupport_register=function(e,t){n.registerOutlineSupport(e,t)},e.prototype.Modes_QuickFixSupport_register=function(e,t){n.registerQuickFixSupport(e,t)},e.prototype.Modes_ReferenceSupport_register=function(e,t){n.registerDeclarativeReferenceSupport(e,t)},e.prototype.Modes_ParameterHintsSupport_register=function(e,t){n.registerDeclarativeParameterHintsSupport(e,t)},e.prototype.Modes_ExtraInfoSupport_register=function(e,t){n.registerExtraInfoSupport(e,t)},e.prototype.Modes_RenameSupport_register=function(e,t){n.registerRenameSupport(e,t)},e.prototype.Modes_FormattingSupport_register=function(e,t){var r={formatDocument:t.formatDocument.bind(t)};if(t.formatRange&&(r.formatRange=t.formatRange.bind(t)),t.formatAfterKeystroke&&(r.formatAfterKeystroke=t.formatAfterKeystroke.bind(t)),t.autoFormatTriggerCharacters){var i=t.autoFormatTriggerCharacters;r.getAutoFormatTriggerCharacters=function(){return i}}n.registerFormattingSupport(e,r)},e.prototype.Modes_SuggestSupport_register=function(e,t){n.registerDeclarativeSuggestSupport(e,t)},e.prototype.Modes_NavigateTypesSupport_register=function(e,t){n.registerNavigateTypesSupport(e,t)},e.prototype.Modes_CommentsSupport_register=function(e,t){n.registerDeclarativeCommentsSupport(e,t)},e.prototype.Modes_TokenTypeClassificationSupport_register=function(e,t){n.registerDeclarativeTokenTypeClassificationSupport(e,t)},e.prototype.Modes_ElectricCharacterSupport_register=function(e,t){n.registerDeclarativeElectricCharacterSupport(e,t)},e.prototype.Modes_CharacterPairSupport_register=function(e,t){n.registerDeclarativeCharacterPairSupport(e,t)},e}();t.RemoteMonacoAPIHost=s});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/api/monaco.worker.api",["require","exports","vs/editor/modes/supports","vs/platform/services","vs/editor/api/base.api","vs/editor/api/baseRemote.api"],function(e,t,r,n,i,o){var s=function(e){function t(t){e.call(this,t,a.getInstance(t.threadService)),this._resourceService=t.resourceService,i.createAPI(this)}return __extends(t,e),t.getInstance=function(e){return e.registerAndInstantiateWorkerActor("WorkerMonacoAPI",new n.SyncDescriptor(t),n.ThreadAffinity.Group3)},t.prototype.Modes_InplaceReplaceSupport_create=function(e){return new r.InplaceReplaceSupport(this._resourceService,e)},t.prototype.Modes_loadInBackgroundWorker=function(){throw new Error("Not supported")},t}(o.RemoteMonacoAPI);t.WorkerMonacoAPI=s;var a=function(e){function t(t){e.call(this,t)}return __extends(t,e),t.getInstance=function(e){return e.registerAndInstantiateMainProcessActor("MainProcessWorkerAPIHelper",new n.SyncDescriptor(t))},t}(o.RemoteMonacoAPIHost);t.MainProcessWorkerAPIHelper=a}),define("vs/editor/worker/workerCodeLoader",["require","exports","vs/base/lib/winjs.base","vs/platform/services","vs/platform/plugins"],function(e,t,r,n,i){var o=function(){function e(e,t){t(e)}return e}(),s=function(){function t(e){this._threadService=e.threadService,this._instantiationService=e.instantiationService}return t.getInstance=function(e){return e.registerAndInstantiateWorkerActor("WorkerSideWorkerCodeLoader",new n.SyncDescriptor(t),n.ThreadAffinity.Group3)},t.prototype.loadAMDCode=function(t){var n,s,a=this,u=new r.TPromise(function(e,t){n=e,s=t});if(!/^file\:\/\//.test(t)){var c=t.match(/.*(\/plugins\/.*)\.js$/i);c&&(t="vs"+c[1])}return e([t],function(e){"function"==typeof e.activate?a._instantiationService.createInstance(o,function(r){i.PluginManager.callActivateWithCtx(e,r).done(function(e){n(a._threadService.proxifyMethods("workerCodeLoader/"+t,e))})}):n(a._threadService.proxifyMethods("workerCodeLoader/"+t,e))},s),u},t}();t.WorkerSideWorkerCodeLoader=s});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/platform/eventService",["require","exports","vs/base/eventEmitter"],function(e,t,r){var n=function(e){function t(){e.call(this)}return __extends(t,e),t}(r.EventEmitter);t.EventService=n}),define("vs/base/diff/diffChange",["require","exports"],function(e,t){t.DifferenceType={Add:0,Remove:1,Change:2};var r=function(){function e(e,t,r,n){this.originalStart=e,this.originalLength=t,this.modifiedStart=r,this.modifiedLength=n}return e.prototype.getChangeType=function(){return 0===this.originalLength?t.DifferenceType.Add:0===this.modifiedLength?t.DifferenceType.Remove:t.DifferenceType.Change},e.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},e.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},e}();t.DiffChange=r}),define("vs/base/diff/diff",["require","exports","vs/base/diff/diffChange"],function(e,t,r){var n=function(){function e(){}return e.Assert=function(e,t){if(!e)throw new Error(t)},e}();t.Debug=n;var i=function(){function e(){}return e.Copy=function(e,t,r,n,i){for(var o=0;i>o;o++)r[n+o]=e[t+o]},e}();t.MyArray=i;// Copyright (C) 2008 Microsoft Corporation
var o=1447,s=function(){function e(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return e.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},e.prototype.AddOriginalElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_originalCount++},e.prototype.AddModifiedElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_modifiedCount++},e.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},e.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},e}(),a=function(){function e(e,t,r){void 0===r&&(r=null),this.OriginalSequence=e,this.ModifiedSequence=t,this.ContinueProcessingPredicate=r,this.m_originalIds=[],this.m_modifiedIds=[],this.m_forwardHistory=[],this.m_reverseHistory=[],this.ComputeUniqueIdentifiers()}return e.prototype.ComputeUniqueIdentifiers=function(){var e=this.OriginalSequence.getLength(),t=this.ModifiedSequence.getLength();this.m_originalIds=new Array(e),this.m_modifiedIds=new Array(t);var r,n={},i=1;for(r=0;e>r;r++){var o=this.OriginalSequence.getElementHash(r);n.hasOwnProperty(o)?this.m_originalIds[r]=n[o]:(this.m_originalIds[r]=i++,n[o]=this.m_originalIds[r])}for(r=0;t>r;r++){var s=this.ModifiedSequence.getElementHash(r);n.hasOwnProperty(s)?this.m_modifiedIds[r]=n[s]:(this.m_modifiedIds[r]=i++,n[s]=this.m_modifiedIds[r])}},e.prototype.ElementsAreEqual=function(e,t){return this.m_originalIds[e]===this.m_modifiedIds[t]},e.prototype.ComputeDiff=function(){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1)},e.prototype._ComputeDiff=function(e,t,r,n){var i=[!1];return this.ComputeDiffRecursive(e,t,r,n,i)},e.prototype.ComputeDiffRecursive=function(e,t,i,o,s){for(s[0]=!1;t>=e&&o>=i&&this.ElementsAreEqual(e,i);)e++,i++;for(;t>=e&&o>=i&&this.ElementsAreEqual(t,o);)t--,o--;if(e>t||i>o){var a;return o>=i?(n.Assert(e===t+1,"originalStart should only be one more than originalEnd"),a=[new r.DiffChange(e,0,i,o-i+1)]):t>=e?(n.Assert(i===o+1,"modifiedStart should only be one more than modifiedEnd"),a=[new r.DiffChange(e,t-e+1,i,0)]):(n.Assert(e===t+1,"originalStart should only be one more than originalEnd"),n.Assert(i===o+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}var u=[0],c=[0],l=this.ComputeRecursionPoint(e,t,i,o,u,c,s),p=u[0],d=c[0];if(null!==l)return l;if(!s[0]){var h=this.ComputeDiffRecursive(e,p,i,d,s),f=[];return f=s[0]?[new r.DiffChange(p+1,t-(p+1)+1,d+1,o-(d+1)+1)]:this.ComputeDiffRecursive(p+1,t,d+1,o,s),this.ConcatenateChanges(h,f)}return[new r.DiffChange(e,t-e+1,i,o-i+1)]},e.prototype.WALKTRACE=function(e,t,n,i,o,a,u,c,l,p,d,h,f,g,m,v,_,y){var b,S=null,k=null,C=new s,T=t,E=n,w=f[0]-v[0]-i,x=Number.MIN_VALUE,M=this.m_forwardHistory.length-1;do b=w+e,b===T||E>b&&l[b-1]<l[b+1]?(d=l[b+1],g=d-w-i,x>d&&C.MarkNextChange(),x=d,C.AddModifiedElement(d+1,g),w=b+1-e):(d=l[b-1]+1,g=d-w-i,x>d&&C.MarkNextChange(),x=d-1,C.AddOriginalElement(d,g+1),w=b-1-e),M>=0&&(l=this.m_forwardHistory[M],e=l[0],T=1,E=l.length-1);while(--M>=-1);if(S=C.getReverseChanges(),y[0]){var L=f[0]+1,I=v[0]+1;if(null!==S&&S.length>0){var A=S[S.length-1];L=Math.max(L,A.getOriginalEnd()),I=Math.max(I,A.getModifiedEnd())}k=[new r.DiffChange(L,h-L+1,I,m-I+1)]}else{C=new s,T=a,E=u,w=f[0]-v[0]-c,x=Number.MAX_VALUE,M=_?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do b=w+o,b===T||E>b&&p[b-1]>=p[b+1]?(d=p[b+1]-1,g=d-w-c,d>x&&C.MarkNextChange(),x=d+1,C.AddOriginalElement(d+1,g+1),w=b+1-o):(d=p[b-1],g=d-w-c,d>x&&C.MarkNextChange(),x=d,C.AddModifiedElement(d+1,g+1),w=b-1-o),M>=0&&(p=this.m_reverseHistory[M],o=p[0],T=1,E=p.length-1);while(--M>=-1);k=C.getChanges()}return this.ConcatenateChanges(S,k)},e.prototype.ComputeRecursionPoint=function(e,t,n,s,a,u,c){var l,p,d,h=0,f=0,g=0,m=0;e--,n--,a[0]=0,u[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var v=t-e+(s-n),_=v+1,y=new Array(_),b=new Array(_),S=s-n,k=t-e,C=e-n,T=t-s,E=k-S,w=E%2===0;y[S]=e,b[k]=t,c[0]=!1;var x,M;for(d=1;v/2+1>=d;d++){var L=0,I=0;for(h=this.ClipDiagonalBound(S-d,d,S,_),f=this.ClipDiagonalBound(S+d,d,S,_),x=h;f>=x;x+=2){for(l=x===h||f>x&&y[x-1]<y[x+1]?y[x+1]:y[x-1]+1,p=l-(x-S)-C,M=l;t>l&&s>p&&this.ElementsAreEqual(l+1,p+1);)l++,p++;if(y[x]=l,l+p>L+I&&(L=l,I=p),!w&&Math.abs(x-k)<=d-1&&l>=b[x])return a[0]=l,u[0]=p,M<=b[x]&&o>0&&o+1>=d?this.WALKTRACE(S,h,f,C,k,g,m,T,y,b,l,t,a,p,s,u,w,c):null}var A=(L-e+(I-n)-d)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(L,this.OriginalSequence,A))return c[0]=!0,a[0]=L,u[0]=I,A>0&&o>0&&o+1>=d?this.WALKTRACE(S,h,f,C,k,g,m,T,y,b,l,t,a,p,s,u,w,c):(e++,n++,[new r.DiffChange(e,t-e+1,n,s-n+1)]);for(g=this.ClipDiagonalBound(k-d,d,k,_),m=this.ClipDiagonalBound(k+d,d,k,_),x=g;m>=x;x+=2){for(l=x===g||m>x&&b[x-1]>=b[x+1]?b[x+1]-1:b[x-1],p=l-(x-k)-T,M=l;l>e&&p>n&&this.ElementsAreEqual(l,p);)l--,p--;if(b[x]=l,w&&Math.abs(x-S)<=d&&l<=y[x])return a[0]=l,u[0]=p,M>=y[x]&&o>0&&o+1>=d?this.WALKTRACE(S,h,f,C,k,g,m,T,y,b,l,t,a,p,s,u,w,c):null}if(o>=d){var N=new Array(f-h+2);N[0]=S-h+1,i.Copy(y,h,N,1,f-h+1),this.m_forwardHistory.push(N),N=new Array(m-g+2),N[0]=k-g+1,i.Copy(b,g,N,1,m-g+1),this.m_reverseHistory.push(N)}}return this.WALKTRACE(S,h,f,C,k,g,m,T,y,b,l,t,a,p,s,u,w,c)},e.prototype.ConcatenateChanges=function(e,t){var r=[],n=null;return 0===e.length||0===t.length?t.length>0?t:e:this.ChangesOverlap(e[e.length-1],t[0],r)?(n=new Array(e.length+t.length-1),i.Copy(e,0,n,0,e.length-1),n[e.length-1]=r[0],i.Copy(t,1,n,e.length,t.length-1),n):(n=new Array(e.length+t.length),i.Copy(e,0,n,0,e.length),i.Copy(t,0,n,e.length,t.length),n)},e.prototype.ChangesOverlap=function(e,t,i){if(n.Assert(e.originalStart<=t.originalStart,"Left change is not less than or equal to right change"),n.Assert(e.modifiedStart<=t.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=t.originalStart||e.modifiedStart+e.modifiedLength>=t.modifiedStart){var o=e.originalStart,s=e.originalLength,a=e.modifiedStart,u=e.modifiedLength;return e.originalStart+e.originalLength>=t.originalStart&&(s=t.originalStart+t.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=t.modifiedStart&&(u=t.modifiedStart+t.modifiedLength-e.modifiedStart),i[0]=new r.DiffChange(o,s,a,u),!0}return i[0]=null,!1},e.prototype.ClipDiagonalBound=function(e,t,r,n){if(e>=0&&n>e)return e;var i=r,o=n-r-1,s=t%2===0;if(0>e){var a=i%2===0;return s===a?0:1}var u=o%2===0;return s===u?n-1:n-2},e}();t.LcsDiff=a});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/editor/diff/diffComputer",["require","exports","vs/base/diff/diff","vs/base/strings"],function(e,t,r,n){function i(e){if(e.length<=1)return e;var t,r,n,i,o,a,u=[e[0]],c=u[0];for(t=1,r=e.length;r>t;t++)a=e[t],n=a.originalStart-(c.originalStart+c.originalLength),i=a.modifiedStart-(c.modifiedStart+c.modifiedLength),o=Math.min(n,i),s>o?(c.originalLength=a.originalStart+a.originalLength-c.originalStart,c.modifiedLength=a.modifiedStart+a.modifiedLength-c.modifiedStart):(u.push(a),c=a);return u}var o=5e3,s=3,a=function(){function e(e,t,r){this.buffer=e,this.startMarkers=t,this.endMarkers=r}return e.prototype.equals=function(t){if(!(t instanceof e))return!1;var r=t;if(this.getLength()!==r.getLength())return!1;for(var n=0,i=this.getLength();i>n;n++){var o=this.getElementHash(n),s=r.getElementHash(n);if(o!==s)return!1}return!0},e.prototype.getLength=function(){return this.startMarkers.length},e.prototype.getElementHash=function(e){return this.buffer.substring(this.startMarkers[e].offset,this.endMarkers[e].offset)},e.prototype.getStartLineNumber=function(e){return e===this.startMarkers.length?this.startMarkers[e-1].lineNumber+1:this.startMarkers[e].lineNumber},e.prototype.getStartColumn=function(e){return this.startMarkers[e].column},e.prototype.getEndLineNumber=function(e){return this.endMarkers[e].lineNumber},e.prototype.getEndColumn=function(e){return this.endMarkers[e].column},e}(),u=function(e){function t(t,r){var n,i,o,s,a,u="",c=[],l=[];for(o=0,n=0,i=t.length;i>n;n++)u+=t[n],s=1,a=t[n].length+1,r&&(s=this._getFirstNonBlankColumn(t[n],1),a=this._getLastNonBlankColumn(t[n],1)),c.push({offset:o+s-1,lineNumber:n+1,column:s}),l.push({offset:o+a-1,lineNumber:n+1,column:a}),o+=t[n].length;e.call(this,u,c,l)}return __extends(t,e),t.prototype._getFirstNonBlankColumn=function(e,t){var r=n.firstNonWhitespaceIndex(e);return-1===r?t:r+1},t.prototype._getLastNonBlankColumn=function(e,t){var r=n.lastNonWhitespaceIndex(e);return-1===r?t:r+2},t.prototype.getCharSequence=function(e,t){var r,n,i,o,s=[],u=[];for(r=e;t>=r;r++)for(i=this.startMarkers[r],o=this.endMarkers[r],n=i.offset;n<o.offset;n++)s.push({offset:n,lineNumber:i.lineNumber,column:i.column+(n-i.offset)}),u.push({offset:n+1,lineNumber:i.lineNumber,column:i.column+(n-i.offset)+1});return new a(this.buffer,s,u)},t}(a),c=function(){function e(e,t,r){0===e.originalLength?(this.originalStartLineNumber=0,this.originalStartColumn=0,this.originalEndLineNumber=0,this.originalEndColumn=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalStartColumn=t.getStartColumn(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1),this.originalEndColumn=t.getEndColumn(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=0,this.modifiedStartColumn=0,this.modifiedEndLineNumber=0,this.modifiedEndColumn=0):(this.modifiedStartLineNumber=r.getStartLineNumber(e.modifiedStart),this.modifiedStartColumn=r.getStartColumn(e.modifiedStart),this.modifiedEndLineNumber=r.getEndLineNumber(e.modifiedStart+e.modifiedLength-1),this.modifiedEndColumn=r.getEndColumn(e.modifiedStart+e.modifiedLength-1))}return e}(),l=function(){function e(e,t,n,o,s){if(0===e.originalLength?(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart)-1,this.originalEndLineNumber=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart)-1,this.modifiedEndLineNumber=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1)),0!==e.originalLength&&0!==e.modifiedLength&&o()){var a=t.getCharSequence(e.originalStart,e.originalStart+e.originalLength-1),u=n.getCharSequence(e.modifiedStart,e.modifiedStart+e.modifiedLength-1),l=new r.LcsDiff(a,u,o),p=l.ComputeDiff();s&&(p=i(p)),this.charChanges=[];for(var d=0,h=p.length;h>d;d++)this.charChanges.push(new c(p[d],a,u))}}return e}(),p=function(){function e(e,t,r){this.shouldPostProcessCharChanges=r.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=r.shouldIgnoreTrimWhitespace,this.maximumRunTimeMs=o,this.original=new u(e,this.shouldIgnoreTrimWhitespace),this.modified=new u(t,this.shouldIgnoreTrimWhitespace),r.shouldConsiderTrimWhitespaceInEmptyCase&&this.shouldIgnoreTrimWhitespace&&this.original.equals(this.modified)&&(this.shouldIgnoreTrimWhitespace=!1,this.original=new u(e,this.shouldIgnoreTrimWhitespace),this.modified=new u(t,this.shouldIgnoreTrimWhitespace))}return e.prototype.computeDiff=function(){this.computationStartTime=(new Date).getTime();for(var e=new r.LcsDiff(this.original,this.modified,this._continueProcessingPredicate.bind(this)),t=e.ComputeDiff(),n=[],i=0,o=t.length;o>i;i++)n.push(new l(t[i],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldPostProcessCharChanges));return n},e.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;var e=(new Date).getTime();return e-this.computationStartTime<this.maximumRunTimeMs},e}();t.DiffComputer=p}),define("vs/editor/contrib/links/linkComputer",["require","exports"],function(e,t){function r(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?c.computeLinks(e):[]}var n=[],i=1,o=9,s=10;n[1]={h:2,H:2},n[2]={t:3,T:3},n[3]={t:4,T:4},n[4]={p:5,P:5},n[5]={s:6,S:6,":":7},n[6]={":":7},n[7]={"/":8},n[8]={"/":9};var a;!function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"}(a||(a={}));var u=function(){var e=" 	<>)]}'\"",t=".,;",r=null,n=function(e){for(var t=0,r=0,n=e.length;n>r;r++)t=Math.max(t,e.charCodeAt(r));return t},i=function(e,t){for(var n=0,i=e.length;i>n;n++)r[e.charCodeAt(n)]=t};return function(){if(null===r){var o=Math.max(n(e),n(t));r=[];for(var s=0;o>s;s++)r[s]=a.None;i(e,a.ForceTermination),i(t,a.CannotEndIn)}return r}}(),c=function(){function e(){}return e._createLink=function(e,t,r,n){return{range:{startLineNumber:t,startColumn:r+1,endLineNumber:t,endColumn:n+1},url:e.substring(r,n)}},e.computeLinks=function(t){var r,c,l,p,d,h,f,g,m,v,_,y,b=[],S=u(),k=S.length;for(r=1,c=t.getLineCount();c>=r;r++){for(l=t.getLineContent(r),p=0,h=l.length,f=0,g=i;h>p;){if(m=l.charAt(p),v=l.charCodeAt(p),y=!1,g===s){if(_=k>v?S[v]:a.None,_===a.ForceTermination){d=p-1;do{if(v=l.charCodeAt(d),_=k>v?S[v]:a.None,_!==a.CannotEndIn)break;d--}while(d>f);b.push(e._createLink(l,r,f,d+1)),y=!0}}else g===o?(_=k>v?S[v]:a.None,_===a.ForceTermination?y=!0:g=s):n[g].hasOwnProperty(m)?g=n[g][m]:y=!0;y&&(g=i,f=p+1),p++}g===s&&b.push(e._createLink(l,r,f,h))}return b},e}();t.computeLinks=r}),define("vs/editor/worker/modesWorker",["require","exports","vs/base/lib/winjs.base","vs/editor/diff/diffComputer","vs/editor/modes/modesFilters","vs/editor/core/model/textModel","vs/platform/services","vs/editor/core/model/mirrorModel","vs/editor/contrib/links/linkComputer","vs/base/lifecycle","vs/base/time/schedulers","vs/editor/modes/supports"],function(e,t,r,n,i,o,s,a,u,c,l,p){function d(e){return"function"==typeof e.validate}function h(e){return"function"==typeof e.suggest||"function"==typeof e.filter}var f=function(){function e(e,t){var r=this;this._toDispose=[],this._changeCallback=t,this._model=e,this._isDirty=!1,this._toDispose.push({dispose:e.addBulkListener(function(e){return r._onModelChanged(e)})})}return e.prototype.dispose=function(){this._toDispose=c.disposeAll(this._toDispose),this._changeCallback=null},e.prototype.markAsClean=function(){this._isDirty=!1},e.prototype.markAsDirty=function(){this._isDirty=!0},e.prototype.isDirty=function(){return this._isDirty},e.prototype.getMirrorModel=function(){return this._model},e.prototype._onModelChanged=function(e){for(var t=!1,r=0;!t&&r<e.length;r++)"changed"===e[r].getType()&&(t=!0);t&&this._changeCallback(this)},e}(),g=function(){function e(e,t,r,n){var i=this;void 0===n&&(n=500),this._toDispose=[],this._resourceService=e,this._callback=t,this._filter=r,this._validationDelay=n,this._models={},this._isDueToConfigurationChange=!1,this._toDispose.push(this._resourceService.addListener2(s.ResourceEvents.ADDED,function(e){i._onResourceAdded(e)})),this._toDispose.push(this._resourceService.addListener2(s.ResourceEvents.REMOVED,function(e){i._onResourceRemoved(e)})),this._validate=new l.RunOnceScheduler(function(){return i._invokeCallback()},this._validationDelay),this._toDispose.push(this._validate),this._resourceService.all().forEach(function(e){return i._addElement(e)})}return e.prototype.dispose=function(){var e=this;this._toDispose=c.disposeAll(this._toDispose),c.disposeAll(Object.keys(this._models).map(function(t){return e._models[t]})),this._models=null},e.prototype.trigger=function(){this._validate.schedule()},e.prototype.triggerDueToConfigurationChange=function(){this._isDueToConfigurationChange=!0,this._validate.schedule()},e.prototype._addElement=function(e){var t=this;if(this._filter(e)){var r=e,n=new f(r,function(e){return t._onChanged(e)});this._models[r.getAssociatedResource().toString()]=n,this._onChanged(n)}},e.prototype._onResourceAdded=function(e){var t=e.url.toString();this._models.hasOwnProperty(t)&&this._models[t].dispose(),this._addElement(e.addedElement)},e.prototype._onResourceRemoved=function(e){var t=e.url.toString();this._models.hasOwnProperty(t)&&(this._models[t].dispose(),delete this._models[t])},e.prototype._onChanged=function(e){e.markAsDirty(),this._validate.schedule()},e.prototype._invokeCallback=function(){var e=this;if(this._isEnabled){var t=[],r=[];Object.keys(this._models).map(function(t){return e._models[t]}).forEach(function(e){e.isDirty()?(t.push(e.getMirrorModel().getAssociatedResource()),e.markAsClean()):r.push(e.getMirrorModel().getAssociatedResource())});var n=this._isDueToConfigurationChange;this._isDueToConfigurationChange=!1,this._callback(t,r,n)}},e.prototype.enable=function(){this._isEnabled=!0,this.trigger()},e}();t.ValidationHelper=g;var m=function(){function e(e,t,r){var n=this;this._validationParticipants=[],this._suggestParticipants=[],this._participants=[],this._mode=t,this._participants=r,this.publisher=e.publisherService,this.resourceService=e.resourceService,this.markerService=e.markerService,this._validationHelper=new g(this.resourceService,function(e,t,r){return n._newValidate(e,t,r)},function(e){return n._shouldIncludeModelInValidation(e)},500),this._validationParticipants=this._getWorkerParticipants(function(e){return d(e)}),this._suggestParticipants=this._getWorkerParticipants(function(e){return h(e)}),this.inplaceReplaceSupport=this._createInPlaceReplaceSupport()}return e.prototype._createInPlaceReplaceSupport=function(){return new p.InplaceReplaceSupport(this.resourceService)},e.prototype._getMode=function(){return this._mode},e.prototype._getWorkerParticipants=function(e){return this._participants.filter(e)},e.prototype._shouldIncludeModelInValidation=function(e){if(!(e instanceof a.MirrorModel||e instanceof a.MirrorModelEmbedded))return!1;var t=e;return t.getMode().getId()===this._mode.getId()},e.prototype.enableValidator=function(){return this._validationHelper.enable(),r.Promise.as(null)},e.prototype._newValidate=function(e,t,r){this.doValidateOnChange(e,t,r);for(var n=0;n<e.length;n++)this.triggerValidateParticipation(e[n],this._getContextForValidationParticipants(e[n]))},e.prototype._getContextForValidationParticipants=function(){return null},e.prototype.doValidateOnChange=function(e,t,r){if(r){for(var n=0;n<e.length;n++)this.doValidate(e[n]);for(var n=0;n<t.length;n++)this.doValidate(t[n])}else for(var n=0;n<e.length;n++)this.doValidate(e[n])},e.prototype.triggerValidateParticipation=function(e,t){var r=this;void 0===t&&(t=null);var n=this.resourceService.get(e);this._validationParticipants.forEach(function(e){try{e.validate(n,r.markerService,t)}catch(i){}})},e.prototype.doValidate=function(){return null},e.prototype.suggest=function(e,t){var n=this;return this._getSuggestContext(e).then(function(i){var o=[n.doSuggest(e,t)];return o.push.apply(o,n._participantSuggests(e,t,i)),r.TPromise.join(o)}).then(function(e){for(var t=n.getSuggestionFilterMain(),r=[],i=0,o=e.length;o>i;i++){var s=e[i];s&&r.push({currentWord:s.currentWord,suggestions:s.suggestions.filter(function(r){return t(e[i].currentWord,r)}),incomplete:s.incomplete,overwriteBefore:s.overwriteBefore,overwriteAfter:s.overwriteAfter})}return r},function(){return[{currentWord:"",suggestions:[]}]})},e.prototype._participantSuggests=function(e,t,r){return this._suggestParticipants.map(function(n){try{return n.suggest(e,t,r)}catch(i){}})},e.prototype._getSuggestContext=function(){return r.TPromise.as(void 0)},e.prototype.doSuggest=function(e,t){var n=this.resourceService.get(e),i=n.getWordUntilPosition(t,!0,!0).word,o={currentWord:i,suggestions:[]};return o.suggestions.push.apply(o.suggestions,this.suggestWords(e,t,!1)),o.suggestions.push.apply(o.suggestions,this.suggestSnippets(e,t)),r.Promise.as(o)},e.prototype.suggestWords=function(e,t,r){var n=this.resourceService.get(e),i=n.getWordUntilPosition(t,!0,!0).word,o=n.getAllUniqueWords(i);return r&&!i?[]:o.filter(function(e){return!/^-?\d*\.?\d/.test(e)}).map(function(e){return{type:"text",label:e,codeSnippet:e}})},e.prototype.suggestSnippets=function(){return[]},e.prototype.getSuggestionFilterMain=function(){var e=this.getSuggestionFilter();return this._suggestParticipants.forEach(function(t){"function"==typeof t.filter&&(e=i.and(e,t.filter))}),e},e.prototype.getSuggestionFilter=function(){return e.filter},e.prototype.findOccurrences=function(e,t){for(var n=this.resourceService.get(e),i=n.getWordAtPosition(t,!0,!0),o=i?i.word:"",s=[],a=n.getAllWordsWithRange(),u=Math.min(1e3,a.length),c=0;u>c;c++)a[c].text===o&&s.push({range:a[c].range});return r.TPromise.as(s)},e.prototype.computeDiff=function(e,t,i){var o=this.resourceService.get(e),s=this.resourceService.get(t);if(null!==o&&null!==s){var a=o.getLinesContent(),u=s.getLinesContent(),c=new n.DiffComputer(a,u,{shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:i,shouldConsiderTrimWhitespaceInEmptyCase:!0});return r.TPromise.as(c.computeDiff())}return r.TPromise.as(null)},e.prototype.computeDirtyDiff=function(e,t){var i=this.resourceService.get(e),s=i.getProperty("original");if(s&&null!==i){var a=o.TextModel.toRawText(s),u=a.lines,c=i.getLinesContent(),l=new n.DiffComputer(u,c,{shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:t,shouldConsiderTrimWhitespaceInEmptyCase:!1});return r.TPromise.as(l.computeDiff())}return r.TPromise.as([])},e.prototype.computeLinks=function(e){var t=this.resourceService.get(e),n=u.computeLinks(t);return r.TPromise.as(n)},e.prototype.configure=function(e){var t=this,r=this._doConfigure(e);return r?r.then(function(e){return e&&t._validationHelper.triggerDueToConfigurationChange(),!0}):void 0},e.prototype._doConfigure=function(){return r.TPromise.as(!0)},e.filter=i.DefaultFilter,e}();t.AbstractWorkerMode=m});var __extends=this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);r.prototype=t.prototype,e.prototype=new r};define("vs/languages/plaintext/plaintext",["require","exports","vs/editor/modes/supports","vs/editor/modes/modesExtensions"],function(e,t,r,n){var i=function(e){function t(t){e.call(this,t)}return __extends(t,e),t.prototype.makeClone=function(){return this},t.prototype.equals=function(r){return r instanceof t?e.prototype.equals.call(this,r):!1},t.prototype.tokenize=function(e){return e.advanceToEOS(),{type:""}},t}(n.AbstractState),o=function(e){function t(t,n){var o=this;e.call(this,t,n),this.tokenizationSupport=new r.TokenizationSupport(this,{getInitialState:function(){return new i(o)}},!1)}return __extends(t,e),t}(n.AbstractMode);t.Mode=o}),define("vs/editor/modes/monarch/monarchTypes",["require","exports"],function(){}),define("vs/base/json",["require","exports","vs/nls!vs/editor/worker/editorWorkerServer"],function(e,t,r){function n(e,t){function r(t,r){for(var n=0,i=0;t>n||!r;){var o=e.charCodeAt(f);if(o>=d._0&&o<=d._9)i=16*i+o-d._0;else if(o>=d.A&&o<=d.F)i=16*i+o-d.A+10;else{if(!(o>=d.a&&o<=d.f))break;i=16*i+o-d.a+10}f++,n++}return t>n&&(i=-1),i}function n(){var t=f;if(e.charCodeAt(f)===d._0)f++;else for(f++;f<e.length&&s(e.charCodeAt(f));)f++;if(f<e.length&&e.charCodeAt(f)===d.dot){if(f++,!(f<e.length&&s(e.charCodeAt(f))))return y=l.UnexpectedEndOfNumber,e.substring(t,r);for(f++;f<e.length&&s(e.charCodeAt(f));)f++}var r=f;if(f<e.length&&(e.charCodeAt(f)===d.E||e.charCodeAt(f)===d.e))if(f++,(f<e.length&&e.charCodeAt(f)===d.plus||e.charCodeAt(f)===d.minus)&&f++,f<e.length&&s(e.charCodeAt(f))){for(f++;f<e.length&&s(e.charCodeAt(f));)f++;r=f}else y=l.UnexpectedEndOfNumber;return e.substring(t,r)}function a(){for(var t="",n=f;;){if(f>=g){t+=e.substring(n,f),y=l.UnexpectedEndOfString;break}var i=e.charCodeAt(f);if(i===d.doubleQuote){t+=e.substring(n,f),f++;break}if(i!==d.backslash){if(o(i)){t+=e.substring(n,f),y=l.UnexpectedEndOfString;break}f++}else{if(t+=e.substring(n,f),f++,f>=g){y=l.UnexpectedEndOfString;break}switch(i=e.charCodeAt(f++)){case d.doubleQuote:t+='"';break;case d.backslash:t+="\\";break;case d.slash:t+="/";break;case d.b:t+="\b";break;case d.f:t+="\f";break;case d.n:t+="\n";break;case d.r:t+="\r";break;case d.t:t+="	";break;case d.u:var i=r(4,!0);i>=0?t+=String.fromCharCode(i):y=l.InvalidUnicode;break;default:y=l.InvalidEscapeCharacter}n=f}}return t}function u(){if(m="",y=l.None,v=f,f>=g)return v=g,_=p.EOF;var t=e.charCodeAt(f);if(i(t)||o(t)){do f++,m+=String.fromCharCode(t),t=e.charCodeAt(f);while(i(t)||o(t));return _=p.Trivia}switch(t){case d.openBrace:return f++,_=p.OpenBraceToken;case d.closeBrace:return f++,_=p.CloseBraceToken;case d.openBracket:return f++,_=p.OpenBracketToken;case d.closeBracket:return f++,_=p.CloseBracketToken;case d.colon:return f++,_=p.ColonToken;case d.comma:return f++,_=p.CommaToken;case d.doubleQuote:return f++,m=a(),_=p.StringLiteral;case d.slash:var r=f-1;if(e.charCodeAt(f+1)===d.slash){for(f+=2;g>f&&!o(e.charCodeAt(f));)f++;return m=e.substring(r,f),_=p.LineCommentTrivia}if(e.charCodeAt(f+1)===d.asterisk){f+=2;for(var u=g-1,h=!1;u>f;){var b=e.charCodeAt(f);if(b===d.asterisk&&e.charCodeAt(f+1)===d.slash){f+=2,h=!0;break}f++}return h||(f++,y=l.UnexpectedEndOfComment),m=e.substring(r,f),_=p.BlockCommentTrivia}return m+=String.fromCharCode(t),f++,_=p.Unknown;case d.minus:if(m+=String.fromCharCode(t),f++,f===g||!s(e.charCodeAt(f)))return _=p.Unknown;case d._0:case d._1:case d._2:case d._3:case d._4:case d._5:case d._6:case d._7:case d._8:case d._9:return m+=n(),_=p.NumericLiteral;default:for(;g>f&&c(t);)f++,t=e.charCodeAt(f);if(v!==f){switch(m=e.substring(v,f)){case"true":return _=p.TrueKeyword;case"false":return _=p.FalseKeyword;case"null":return _=p.NullKeyword}return _=p.Unknown}return m+=String.fromCharCode(t),f++,_=p.Unknown}}function c(e){if(i(e)||o(e))return!1;switch(e){case d.closeBrace:case d.closeBracket:case d.openBrace:case d.openBracket:case d.doubleQuote:case d.colon:case d.comma:return!1}return!0}function h(){var e;do e=u();while(e===p.Trivia||e===p.LineCommentTrivia||e===p.BlockCommentTrivia);return e}void 0===t&&(t=!1);var f=0,g=e.length,m="",v=0,_=p.Unknown,y=l.None;return{getPosition:function(){return f},scan:t?h:u,getToken:function(){return _},getTokenValue:function(){return m},getTokenOffset:function(){return v},getTokenLength:function(){return f-v},getTokenError:function(){return y}}}function i(e){return e===d.space||e===d.tab||e===d.verticalTab||e===d.formFeed||e===d.nonBreakingSpace||e===d.ogham||e>=d.enQuad&&e<=d.zeroWidthSpace||e===d.narrowNoBreakSpace||e===d.mathematicalSpace||e===d.ideographicSpace||e===d.byteOrderMark}function o(e){return e===d.lineFeed||e===d.carriageReturn||e===d.lineSeparator||e===d.paragraphSeparator}function s(e){return e>=d._0&&e<=d._9}function a(e){return e>=d.a&&e<=d.z||e>=d.A&&e<=d.Z}function u(e,t){var r,i,o=n(e),s=[],a=0;do switch(i=o.getPosition(),r=o.scan()){case p.LineCommentTrivia:case p.BlockCommentTrivia:case p.EOF:a!==i&&s.push(e.substring(a,i)),void 0!==t&&s.push(o.getTokenValue().replace(/[^\r\n]/g,t)),a=o.getPosition()}while(r!==p.EOF);return s.join("")}function c(e,t){function i(){for(var e=f.scan();e===p.Unknown;)o(r.localize("vs_base_json",0)),e=f.scan();return e}function o(e,r,n){if(void 0===r&&(r=[]),void 0===n&&(n=[]),t.push(e),r.length+n.length>0)for(var o=f.getToken();o!==p.EOF;){if(-1!==r.indexOf(o)){i();break}if(-1!==n.indexOf(o))break;o=i()}}function s(){if(f.getToken()!==p.StringLiteral)return h;var e=f.getTokenValue();return i(),e}function a(){var e;switch(f.getToken()){case p.NumericLiteral:try{e=JSON.parse(f.getTokenValue()),"number"!=typeof e&&(o(r.localize("vs_base_json",1)),e=0)}catch(t){e=0}break;case p.NullKeyword:e=null;break;case p.TrueKeyword:e=!0;break;case p.FalseKeyword:e=!1;break;default:return h}return i(),e}function u(e){var t=s();if(t===h)return o(r.localize("vs_base_json",2),[],[p.CloseBraceToken,p.CommaToken]),!1;if(f.getToken()===p.ColonToken){i();var n=d();n!==h?e[t]=n:o(r.localize("vs_base_json",3),[],[p.CloseBraceToken,p.CommaToken])}else o(r.localize("vs_base_json",4),[],[p.CloseBraceToken,p.CommaToken]);return!0}function c(){if(f.getToken()!==p.OpenBraceToken)return h;var e={};i();for(var t=!1;f.getToken()!==p.CloseBraceToken&&f.getToken()!==p.EOF;){f.getToken()===p.CommaToken?(t||o(r.localize("vs_base_json",5),[],[]),i()):t&&o(r.localize("vs_base_json",6),[],[]);var n=u(e);n||o(r.localize("vs_base_json",7),[],[p.CloseBraceToken,p.CommaToken]),t=!0}return f.getToken()!==p.CloseBraceToken?o(r.localize("vs_base_json",8),[p.CloseBraceToken],[]):i(),e}function l(){if(f.getToken()!==p.OpenBracketToken)return h;var e=[];i();for(var t=!1;f.getToken()!==p.CloseBracketToken&&f.getToken()!==p.EOF;){f.getToken()===p.CommaToken?(t||o(r.localize("vs_base_json",9),[],[]),i()):t&&o(r.localize("vs_base_json",10),[],[]);var n=d();n===h?o(r.localize("vs_base_json",11),[],[p.CloseBracketToken,p.CommaToken]):e.push(n),t=!0}return f.getToken()!==p.CloseBracketToken?o(r.localize("vs_base_json",12),[p.CloseBracketToken],[]):i(),e}function d(){var e=l();return e!==h?e:(e=c(),e!==h?e:(e=s(),e!==h?e:a()))}void 0===t&&(t=[]);var h=Object(),f=n(e,!0);i();var g=d();return g===h?(o(r.localize("vs_base_json",13),[],[]),void 0):(f.getToken()!==p.EOF&&o(r.localize("vs_base_json",14),[],[]),g)}!function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter"}(t.ScanError||(t.ScanError={}));var l=t.ScanError;!function(e){e[e.Unknown=0]="Unknown",e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.Trivia=14]="Trivia",e[e.EOF=15]="EOF"}(t.SyntaxKind||(t.SyntaxKind={}));var p=t.SyntaxKind;t.createScanner=n,t.isLetter=a;var d;!function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"
}(d||(d={})),t.stripComments=u,t.parse=c}),require.config({ignoreDuplicateModules:["vs/languages/typescript/features/tokenization","vs/languages/typescript/features/quickFixMainActions","vs/languages/typescript/typescript","vs/languages/typescript/typescriptMode","vs/languages/typescript/typescript.configuration","vs/languages/javascript/javascript.configuration","vs/languages/javascript/javascript.extensions","vs/base/severity","vs/base/paths","vs/base/uuid","vs/base/trie","vs/base/callbackList","vs/base/eventSource","vs/languages/csharp/features/tokenization","vs/base/glob","vs/base/time/schedulers","vs/platform/configuration/configurationRegistry","vs/languages/csharp/csharp.extensions","vs/base/lifecycle"]}),define("vs/editor/languages.common",["./modes/modesExtensions","vs/languages/plaintext/plaintext","./modes/autoIndentation/autoIndentation","vs/editor/core/constants","./modes/monarch/monarchTypes","./modes/monarch/monarchCommon","./modes/monarch/monarchCompile","./modes/monarch/monarch","vs/base/json"],function(){}),define("vs/editor/worker/editorWorkerServer",["require","exports","vs/base/lib/winjs.base","vs/base/async","vs/platform/services","vs/platform/telemetry/workerTelemetryService","./resourceService","./dispatcherService","vs/platform/markers/markerService2","vs/platform/thread/workerThreadService","vs/editor/modes/modesExtensions","vs/platform/platform","vs/editor/modes/boundModels","vs/platform/instantiation/instantiationService","vs/platform/plugins","vs/editor/api/monaco.worker.api","vs/editor/worker/workerCodeLoader","vs/platform/eventService","vs/editor/worker/modesWorker","vs/editor/languages.common"],function(e,t,r,n,i,o,s,a,u,c,l,p,d,h,f,g,m,v){var _=function(){function e(){var e=this;this.dispatcherService=new a.DispatcherService,this.modePromise=new r.Promise(function(t){e.modeCompleteCallback=t})}return e.prototype.initialize=function(e,t,a,_,y){f.registerPlugins(y.plugins);var b=new i.BaseWorkspaceContextService(y.contextService.workspace,y.contextService.configuration,y.contextService.options),S=new o.WorkerTelemetryService(b,{enableTelemetry:y.telemetryService.enableTelemetry,publicOnly:!y.telemetryService.enablePrivateTelemetry,sessionID:y.telemetryService.telemetrySessionID,enableHardIdle:!1,enableSoftIdle:!1}),k={sendMessage:function(t,r){return e.request(t,r)}},C=new o.WorkerTelemetryAppender(k);S.addTelemetryAppender(C);var T=new c.WorkerThreadService(y.threadService,e.getRemoteCom(),this.dispatcherService,k),E=new s.ResourceService,w=new u.MarkerService(T),x=p.Registry.as(l.Extensions.EditorModes),M=new n.PromiseSource,L=new d.BoundModels(T,w,E,function(e){return M.value.then(function(){return x.getOrCreateMode(e)})}),I=new i.BaseRequestService({contextService:b,telemetryService:S}),A={threadService:T,contextService:b,eventService:new v.EventService,resourceService:E,dispatcherService:this.dispatcherService,publisherService:k,markerService:w,telemetryService:S,modelService:L,requestService:I},N=r.Promise.as(null),P=b.getConfiguration().additionalWorkerServices;P&&P.forEach(function(e){N=N.then(function(){var t=i.AsyncDescriptor.create(e.moduleName,e.ctorName);return h.create(A).createInstance(t).then(function(t){A[e.serviceId]=t})})}),N.then(function(){var e=h.create(A);T.setInstantiationService(e),g.WorkerMonacoAPI.getInstance(T),m.WorkerSideWorkerCodeLoader.getInstance(T),x.setThreadService(T),M.complete(),t(void 0)})},e.prototype.request=function(e,t,r,n,i){this.dispatcherService.dispatch(i).then(t,r,n)},e}();t.EditorWorkerServer=_,t.value=new _});