/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/typescript/features/tokenization",["require","exports","vs/base/strings","vs/base/arrays","vs/base/collections","vs/editor/modes/modes","vs/editor/modes/supports","vs/languages/vsxml/vsxml","vs/editor/modes/stream","vs/languages/typescript/lib/typescriptServices","vs/editor/modes/modesExtensions"],function(e,t,n,r,i,o,s,a,c,l,u){function d(e,t){var n=l.createClassifier(),r=t===m.TypeScript?y:_,i=t===m.TypeScript?w:k;return{shouldGenerateEmbeddedModels:!1,getInitialState:function(){return new b(e,null,t,g.Unknown)},tokenize:function(e,t,o,s){return h(r,i,n,t,e,o,s)}}}function h(e,t,i,a,c,u){function d(e,t,n){(0===h.tokens.length||void 0!==n||r.tail(h.tokens).type!==t)&&h.tokens.push(new s.Token(e,t,n||o.Bracket.None))}void 0===u&&(u=0);var h={tokens:[],actualStopOffset:u+c.length,endState:new b(a.getMode(),a.getStateData(),a.language,g.Unknown),modeTransitions:[{startIndex:u,mode:a.getMode()}]};if(f(a,u,c,d))return h;var y=a.language===m.TypeScript;if(!y&&p(a,u,c,d))return h;var w=i.getClassificationsForLine(c,g.toEndOfLineState(a.errorState),!0),_=0;return h.endState.errorState=g.toErrorState(w.finalLexState,c,a.errorState),w.entries.forEach(function(r){var i,s=o.Bracket.None;if(r.classification===l.TokenClass.Punctuation){var h=c.charCodeAt(_);s=v[h]||o.Bracket.None,i=e[h]||t[r.classification],d(_+u,i,s)}else r.classification===l.TokenClass.Comment?a.errorState===g.InDocMultiLineCommentTrivia||c.match(/\/\*\*.*$/)&&!c.match(/^\s*\/\//)?d(_+u,y?"comment.doc.ts":"comment.doc.js",o.Bracket.None):a.errorState===g.InMultiLineCommentTrivia||c.match(/\/\*.*$/)&&!c.match(/^\s*\/\//)?d(_+u,y?"comment.block.ts":"comment.block.js",o.Bracket.None):d(_+u,y?"comment.line.ts":"comment.line.js",o.Bracket.None):d(_+u,t[r.classification]||n.empty,void 0);_+=r.length}),h}function p(e,t,n,r){return 0===n.indexOf("#!")?(r(t,"comment.shebang",o.Bracket.None),!0):void 0}function f(e,t,n,r){if(!n.match(S))return!1;var i,s,l=new c.LineStream(n),u=new a.VSXMLExpression(e.getMode(),e);for(l.advanceIfRegExp(S).length>0&&r(t,"comment.vs",o.Bracket.None);!l.eos();){s=l.pos();do{if(i=u.tokenize(l),null===i||void 0===i||(void 0===i.type||null===i.type)&&(void 0===i.nextState||null===i.nextState))throw new Error("Tokenizer must return a valid state");if(i.nextState&&(i.nextState.setStateData(u.getStateData()),u=i.nextState),l.pos()<=s)throw new Error}while(!i.type&&""!==i.type);r(s+t,i.type,i.bracket)}return!0}!function(e){e[e.TypeScript=0]="TypeScript",e[e.EcmaScript5=1]="EcmaScript5"}(t.Language||(t.Language={}));var m=t.Language;t.createTokenizationSupport=d;var g;!function(e){e[e.Unknown=0]="Unknown",e[e.InMultiLineCommentTrivia=1]="InMultiLineCommentTrivia",e[e.InDocMultiLineCommentTrivia=2]="InDocMultiLineCommentTrivia",e[e.InSingleQuoteStringLiteral=3]="InSingleQuoteStringLiteral",e[e.InDoubleQuoteStringLiteral=4]="InDoubleQuoteStringLiteral"}(g||(g={}));var g;!function(e){function t(t){switch(t){case e.InSingleQuoteStringLiteral:return l.EndOfLineState.InSingleQuoteStringLiteral;case e.InDoubleQuoteStringLiteral:return l.EndOfLineState.InDoubleQuoteStringLiteral;case e.InMultiLineCommentTrivia:case e.InDocMultiLineCommentTrivia:return l.EndOfLineState.InMultiLineCommentTrivia}return l.EndOfLineState.None}function n(t,n,r){switch(t){case l.EndOfLineState.None:return e.Unknown;case l.EndOfLineState.InSingleQuoteStringLiteral:return e.InSingleQuoteStringLiteral;case l.EndOfLineState.InDoubleQuoteStringLiteral:return e.InDoubleQuoteStringLiteral;case l.EndOfLineState.InMultiLineCommentTrivia:return r===e.InDocMultiLineCommentTrivia||n.match(/\/\*\*.*$/)?e.InDocMultiLineCommentTrivia:e.InMultiLineCommentTrivia}}e.toEndOfLineState=t,e.toErrorState=n}(g||(g={}));var b=function(){function e(e,t,n,r){this._mode=e,this._state=t,this.language=n,this.errorState=r}return e.prototype.clone=function(){return new e(this._mode,u.safeStateClone(this._state),this.language,this.errorState)},e.prototype.equals=function(t){return t===this?!0:t&&t instanceof e?this.errorState!==t.errorState?!1:u.safeStateEquals(this._state,t._state):!1},e.prototype.getMode=function(){return this._mode},e.prototype.tokenize=function(){throw new Error},e.prototype.getStateData=function(){return this._state},e.prototype.setStateData=function(e){this._state=e},e}(),v=i.createNumberDictionary();v["(".charCodeAt(0)]=o.Bracket.Open,v[")".charCodeAt(0)]=o.Bracket.Close,v["{".charCodeAt(0)]=o.Bracket.Open,v["}".charCodeAt(0)]=o.Bracket.Close,v["[".charCodeAt(0)]=o.Bracket.Open,v["]".charCodeAt(0)]=o.Bracket.Close;var y=i.createNumberDictionary();y["(".charCodeAt(0)]="delimiter.parenthesis.ts",y[")".charCodeAt(0)]="delimiter.parenthesis.ts",y["{".charCodeAt(0)]="delimiter.bracket.ts",y["}".charCodeAt(0)]="delimiter.bracket.ts",y["[".charCodeAt(0)]="delimiter.array.ts",y["]".charCodeAt(0)]="delimiter.array.ts";var w=i.createNumberDictionary();w[l.TokenClass.Identifier]="identifier.ts",w[l.TokenClass.Keyword]="keyword.ts",w[l.TokenClass.Operator]="delimiter.ts",w[l.TokenClass.Punctuation]="delimiter.ts",w[l.TokenClass.NumberLiteral]="number.ts",w[l.TokenClass.RegExpLiteral]="regexp.ts",w[l.TokenClass.StringLiteral]="string.ts";var _=i.createNumberDictionary();_["(".charCodeAt(0)]="delimiter.parenthesis.js",_[")".charCodeAt(0)]="delimiter.parenthesis.js",_["{".charCodeAt(0)]="delimiter.bracket.js",_["}".charCodeAt(0)]="delimiter.bracket.js",_["[".charCodeAt(0)]="delimiter.array.js",_["]".charCodeAt(0)]="delimiter.array.js";var k=i.createNumberDictionary();k[l.TokenClass.Identifier]="identifier.js",k[l.TokenClass.Keyword]="keyword.js",k[l.TokenClass.Operator]="delimiter.js",k[l.TokenClass.Punctuation]="delimiter.js",k[l.TokenClass.NumberLiteral]="number.js",k[l.TokenClass.RegExpLiteral]="regexp.js",k[l.TokenClass.StringLiteral]="string.js";var S=/^\s*\/\/\//}),define("vs/base/lifecycle",["require","exports"],function(e,t){function n(e){for(var t=0,n=e.length;n>t;t++)e[t]&&e[t].dispose();return[]}function r(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return{dispose:function(){return n(e)}}}function i(e){return{dispose:function(){return n(e)}}}function o(e){return{dispose:function(){return e()}}}function s(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return i(e.map(o))}function a(e){if(e){if("function"==typeof e)return e(),null;if(Array.isArray(e)){for(;e.length>0;)e.pop()();return e}return null}return null}t.disposeAll=n,t.combinedDispose=r,t.combinedDispose2=i,t.fnToDisposable=o,t.toDisposable=s,t.cAll=a;var c=function(){function e(e){this._prefix=e,this._lastId=0}return e.prototype.generate=function(){return this._prefix+ ++this._lastId},e}();t.IdGenerator=c}),define("vs/base/time/schedulers",["require","exports"],function(e,t){var n=function(){function e(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}return e.prototype.dispose=function(){this.cancel(),this.runner=null},e.prototype.cancel=function(){-1!==this.timeoutToken&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)},e.prototype.setRunner=function(e){this.runner=e},e.prototype.setTimeout=function(e){this.timeout=e},e.prototype.schedule=function(){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,this.timeout)},e.prototype.onTimeout=function(){this.timeoutToken=-1,this.runner&&this.runner()},e}();t.RunOnceScheduler=n}),define("vs/languages/typescript/features/quickFixMainActions",["require","exports","vs/base/strings","vs/base/errors","vs/base/lib/winjs.base","vs/base/paths"],function(e,t,n,r,i,o){var s=function(){function e(e){this._requestService=e.requestService,this._fileService=e.fileService,this._contextService=e.contextService}return e.prototype.evaluate=function(e,t,n){var r=JSON.parse(n);switch(r.type){case"addtripleslash":return this.evaluateTripleSlashQuickFix(r.name,e)}return i.Promise.as(null)},e.prototype.evaluateTripleSlashQuickFix=function(e,t){var i=this,s="/typings/"+e,a=this._contextService.toWorkspaceRelativePath(t);a||(a=t.toString());var c=n.rtrim(o.dirname(a),"/"),l=o.relative(c,s),u=n.format('/// <reference path="{0}"/>\n',l),d={editOperations:[{range:{startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1},text:u}]};return this._fileService.resolveFileStat(s).then(function(){return d},function(){var t="https://raw.githubusercontent.com/borisyankov/DefinitelyTyped/master/"+e;return i._requestService.makeRequest({url:t,followRedirects:5}).then(function(e){return i._fileService.createFile(s,e.responseText).then(function(){return d},function(){return d})},function(e){return r.onUnexpectedError(n.format("Unable to fetch d.ts file at {0}: {1}",t,e.toString())),d})})},e}();t.QuickFixMainActions=s}),define("vs/languages/typescript/typescript",["require","exports","vs/platform/platform","vs/base/uri"],function(e,t,n,r){function i(){return{resolveProjects:function(){return void 0},resolveFiles:function(){return void 0}}}function o(e){return"string"==typeof e?0===e.indexOf("ts://defaultlib"):"ts"===e.scheme&&"defaultlib"===e.authority}!function(e){e[e.Changed=0]="Changed",e[e.Added=1]="Added",e[e.Removed=2]="Removed"}(t.ChangeKind||(t.ChangeKind={}));t.ChangeKind;t.createDefaultProjectResolver=i,t.defaultLib=r.create("ts","defaultlib","/vs/text!vs/languages/typescript/lib/lib.d.ts"),t.defaultLibES6=r.create("ts","defaultlib","/vs/text!vs/languages/typescript/lib/lib.es6.d.ts"),t.isDefaultLib=o;var s;!function(e){function t(e){i=e}function r(){return i}e.Identifier="typescript",n.Registry.add(e.Identifier,e);var i;e.setProjectResolver=t,e.getProjectResolver=r}(s=t.Extensions||(t.Extensions={}))});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/typescript/typescriptMode",["require","exports","vs/base/lib/winjs.base","vs/base/uri","vs/base/lifecycle","vs/base/async","vs/base/time/schedulers","vs/editor/modes/modesExtensions","vs/editor/modes/supports","vs/platform/services","vs/editor/core/constants","vs/languages/typescript/features/tokenization","vs/languages/typescript/features/quickFixMainActions","vs/platform/thread/attribute","vs/languages/typescript/typescript"],function(e,t,n,r,i,o,s,a,c,l,u,d,h,p,f){var m=function(){function e(e,t){this._listener=Object.create(null),this._lastValidationReq=0,this._modelService=e.modelService,this._mode=t,this._validation=new s.RunOnceScheduler(this._doValidate.bind(this),750),this._modelService?(this._modelService.onModelAdded.add(this._onModelAdded,this),this._modelService.onModelRemoved.add(this._onModelRemoved,this),this._modelService.getModels().forEach(this._onModelAdded,this)):console.warn("NO model service for validation")}return e.prototype.dispose=function(){this._validation.dispose()},e.prototype.validateOpen=function(){this._scheduleValidation()},e.prototype._scheduleValidation=function(e){this._lastValidationReq+=1,this._lastChangedResource=e,this._validation.schedule()},e.prototype._doValidate=function(){var e=this,t=[];this._lastChangedResource&&t.push(this._lastChangedResource);for(var i in this._listener)this._lastChangedResource&&i===this._lastChangedResource.toString()||t.push(r.parse(i));var s=this._lastValidationReq,a=o.sequence(t.map(function(t){return function(){return e._modelService.getModel(t)?s===e._lastValidationReq?e._mode.performSemanticValidation(t):void 0:n.Promise.as(void 0)}}));a.done(void 0,function(e){return console.warn(e)})},e.prototype._onModelAdded=function(e){var t=this;if(this._mode._shouldBeValidated(e)){var n,r;n=function(){t._scheduleValidation(e.getAssociatedResource())},r=e.addListener(u.EventType.ModelContentChanged2,function(){return n()}),this._listener[e.getAssociatedResource().toString()]=r,n()}},e.prototype._onModelRemoved=function(e){var t=this._listener[e.getAssociatedResource().toString()];t&&(t(),delete this._listener[e.getAssociatedResource().toString()])},e}(),g=function(t){function r(e,r){var i=this;if(t.call(this,e,r,l.AsyncDescriptor.create("vs/languages/typescript/typescriptWorker2","TypeScriptWorker2")),this._disposables=[],this._telemetryService=e.telemetryService,this._threadService&&this._threadService.isInMainThread){this._semanticValidator=e.instantiationService.createInstance(m,this),this._disposables.push(this._semanticValidator);var o=this._getProjectResolver();this._projectResolver=o?e.instantiationService.createInstance(o,this).then(void 0,function(e){return console.error(e),f.createDefaultProjectResolver()}):n.TPromise.as(f.createDefaultProjectResolver())}this.navigateTypesSupport=this,this.extraInfoSupport=this,this.formattingSupport=this,this.quickFixSupport=this,this.logicalSelectionSupport=this,this.outlineSupport=this,this.emitOutputSupport=this,this.codeLensSupport=this,this.renameSupport=this,this.tokenizationSupport=d.createTokenizationSupport(this,d.Language.TypeScript),this.electricCharacterSupport=new c.BracketElectricCharacterSupport(this,{brackets:[{tokenType:"delimiter.bracket.ts",open:"{",close:"}",isElectric:!0},{tokenType:"delimiter.array.ts",open:"[",close:"]",isElectric:!0},{tokenType:"delimiter.parenthesis.ts",open:"(",close:")",isElectric:!0}],docComment:{scope:"comment.doc",open:"/**",lineStart:" * ",close:" */"}}),this.referenceSupport=new c.ReferenceSupport(this,{tokens:["identifier.ts"],findReferences:function(e,t,n){return i.findReferences(e,t,n)}}),this.declarationSupport=new c.DeclarationSupport(this,{tokens:["identifier.ts","string.ts","attribute.value.vs"],findDeclaration:function(e,t){return i.findDeclaration(e,t)}}),this.parameterHintsSupport=new c.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["string.ts"],getParameterHints:function(e,t){return i.getParameterHints(e,t)}}),this.characterPairSupport=new c.CharacterPairSupport(this,{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string","comment"]},{open:"`",close:"`"}]}),this.suggestSupport=new c.SuggestSupport(this,{triggerCharacters:["."],excludeTokens:["string","comment","number"],sortBy:[{type:"reference",partSeparator:"/"}],suggest:function(e,t){return i.suggest(e,t)},getSuggestionDetails:function(e,t,n){return i.getSuggestionDetails(e,t,n)}})}return __extends(r,t),r.prototype.dispose=function(){this._disposables=i.disposeAll(this._disposables)},r.prototype._shouldBeValidated=function(e){return e.getMode()===this||/\.ts$/.test(e.getAssociatedResource().fsPath)},r.prototype._getProjectResolver=function(){return f.Extensions.getProjectResolver()},r.prototype.acceptProjectChanges=function(e){return this._semanticValidator.validateOpen(),this._doAcceptProjectChanges(e)},r.prototype._doAcceptProjectChanges=function(e){return this._worker(function(t){return t.acceptProjectChanges(e)})},r.prototype.acceptFileChanges=function(e){return this._semanticValidator.validateOpen(),this._doAcceptFileChanges(e)},r.prototype._doAcceptFileChanges=function(e){return this._worker(function(t){return t.acceptFileChanges(e)})},r.prototype._defaultLib=function(){var t=this;if(!this._defaultLibPromise){var r=[],i=new n.TPromise(function(t,n){return e([f.defaultLib.path.substr(1)],t,n)}).then(function(e){r.push({kind:f.ChangeKind.Added,resource:f.defaultLib,content:e})}),s=new n.TPromise(function(t,n){return e([f.defaultLibES6.path.substr(1)],t,n)}).then(function(e){r.push({kind:f.ChangeKind.Added,resource:f.defaultLibES6,content:e})});this._defaultLibPromise=n.TPromise.join([i,s]).then(function(){return t.acceptFileChanges(r)})}return new o.ShallowCancelThenPromise(this._defaultLibPromise)},r.prototype._syncProjects=function(){var e=this;return this._projectResolver?this._defaultLib().then(function(){return e._projectResolver}).then(function(e){return e.resolveProjects()}):void 0},r.prototype.configure=function(e){var n=this,r=t.prototype.configure.call(this,e);return this._semanticValidator&&r.then(function(e){return e&&n._semanticValidator.validateOpen()}),r},r.prototype._worker=function(e){return t.prototype._worker.call(this,e)},r.prototype.getNonWordTokenTypes=function(){return["delimiter.ts","delimiter.parenthesis.ts","delimiter.bracket.ts","delimiter.array.ts"]},r.prototype.getCommentsConfiguration=function(){return{lineCommentTokens:["//"],blockCommentStartToken:"/*",blockCommentEndToken:"*/"}},r.prototype._pickAWorkerToValidate=function(){return this._worker(function(e){return e.enableValidator()})},r.prototype.performSemanticValidation=function(e){var t=this;return this.doValidateSemantics(e).then(function(e){return e?t.getMissingFiles().then(function(e){return e?t._projectResolver.then(function(t){return t.resolveFiles(e)}):void 0}):void 0})},r.prototype.doValidateSemantics=function(e){return this._worker(function(t){return t.doValidateSemantics(e)})},r.prototype.getMissingFiles=function(){return this._worker(function(e){return e.getMissingFiles()})},r.prototype.getOutline=function(e){return this._worker(function(t){return t.getOutline(e)})},r.prototype.findOccurrences=function(e,t,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(e,t,n)})},r.prototype.suggest=function(e,t){return this._worker(function(n){return n.suggest(e,t)})},r.prototype.getSuggestionDetails=function(e,t,n){return this._worker(function(r){return r.getSuggestionDetails(e,t,n)})},r.prototype.getParameterHints=function(e,t){return this._worker(function(n){return n.getParameterHints(e,t)})},r.prototype.getEmitOutput=function(e,t){return void 0===t&&(t=void 0),this._worker(function(n){return n.getEmitOutput(e,t)})},r.prototype.getWordDefinition=function(){return r.WORD_DEFINITION},r.prototype.findReferences=function(e,t,n){return this._worker(function(r){return r.findReferences(e,t,n)})},Object.defineProperty(r.prototype,"filter",{get:function(){return["identifier.ts","string.ts"]},enumerable:!0,configurable:!0}),r.prototype.rename=function(e,t,n){return this._worker(function(r){return r.rename(e,t,n)})},r.prototype.getNavigateToItems=function(e){return this._worker(function(t){return t.getNavigateToItems(e)})},r.prototype.runQuickFixAction=function(e,t,n){var r=this,i=this._instantiationService.createInstance(h.QuickFixMainActions);return i.evaluate(e,t,n).then(function(i){return i?i:r.runQuickFixActionInWorker(e,t,n)})},r.prototype.runQuickFixActionInWorker=function(e,t,n){return this._worker(function(r){return r.runQuickFixAction(e,t,n)})},r.prototype.getQuickFixes=function(e,t){return this._worker(function(n){return n.getQuickFixes(e,t)})},r.prototype.getRangesToPosition=function(e,t){return this._worker(function(n){return n.getRangesToPosition(e,t)})},r.prototype.findDeclaration=function(e,t){return this._worker(function(n){return n.findDeclaration(e,t)})},r.prototype.computeInfo=function(e,t){return this._worker(function(n){return n.computeInfo(e,t)})},r.prototype.getAutoFormatTriggerCharacters=function(){return[";","}","\n"]},r.prototype.formatDocument=function(e,t){return this._worker(function(n){return n.formatDocument(e,t)})},r.prototype.formatRange=function(e,t,n){return this._worker(function(r){return r.formatRange(e,t,n)})},r.prototype.formatAfterKeystroke=function(e,t,n,r){return this._worker(function(i){return i.formatAfterKeystroke(e,t,n,r)})},r.prototype.enableCodeLens=function(){return this._options&&this._options.referenceInfos===!0},r.prototype.findCodeLensSymbols=function(e){return this._worker(function(t){return t.findCodeLensSymbols(e)})},r.prototype.findCodeLensReferences=function(e,t){return this._worker(function(n){return n.findCodeLensReferences(e,t)})},r.$_doAcceptProjectChanges=p.AllWorkers(r,r.prototype._doAcceptProjectChanges),r.$_doAcceptFileChanges=p.AllWorkers(r,r.prototype._doAcceptFileChanges),r.$_pickAWorkerToValidate=p.OneWorker(r,r.prototype._pickAWorkerToValidate,r.prototype._syncProjects,l.ThreadAffinity.Group3),r.$doValidateSemantics=p.OneWorker(r,r.prototype.doValidateSemantics,r.prototype._syncProjects,l.ThreadAffinity.Group3),r.$getMissingFiles=p.OneWorker(r,r.prototype.getMissingFiles,r.prototype._syncProjects,l.ThreadAffinity.Group3),r.$getOutline=p.OneWorker(r,r.prototype.getOutline,r.prototype._syncProjects,l.ThreadAffinity.Group1),r.$findOccurrences=p.OneWorker(r,r.prototype.findOccurrences,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$suggest=p.OneWorker(r,r.prototype.suggest,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$getSuggestionDetails=p.OneWorker(r,r.prototype.getSuggestionDetails,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$getParameterHints=p.OneWorker(r,r.prototype.getParameterHints,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$getEmitOutput=p.OneWorker(r,r.prototype.getEmitOutput,r.prototype._syncProjects,l.ThreadAffinity.Group3),r.WORD_DEFINITION=a.createWordRegExp("$"),r.$findReferences=p.OneWorker(r,r.prototype.findReferences,r.prototype._syncProjects,l.ThreadAffinity.Group3),r.$rename=p.OneWorker(r,r.prototype.rename,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$getNavigateToItems=p.OneWorker(r,r.prototype.getNavigateToItems,r.prototype._syncProjects,l.ThreadAffinity.Group3),r.$runQuickFixActionInWorker=p.OneWorker(r,r.prototype.runQuickFixActionInWorker,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$getQuickFixes=p.OneWorker(r,r.prototype.getQuickFixes,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$getRangesToPosition=p.OneWorker(r,r.prototype.getRangesToPosition,r.prototype._syncProjects,l.ThreadAffinity.Group1),r.$findDeclaration=p.OneWorker(r,r.prototype.findDeclaration,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$computeInfo=p.OneWorker(r,r.prototype.computeInfo,r.prototype._syncProjects,l.ThreadAffinity.Group2),r.$formatDocument=p.OneWorker(r,r.prototype.formatDocument,r.prototype._syncProjects,l.ThreadAffinity.Group1),r.$formatRange=p.OneWorker(r,r.prototype.formatRange,r.prototype._syncProjects,l.ThreadAffinity.Group1),r.$formatAfterKeystroke=p.OneWorker(r,r.prototype.formatAfterKeystroke,r.prototype._syncProjects,l.ThreadAffinity.Group1),r.findCodeLensSymbols=p.OneWorker(r,r.prototype.findCodeLensSymbols,r.prototype._syncProjects,l.ThreadAffinity.Group1),r.findCodeLensReferences=p.OneWorker(r,r.prototype.findCodeLensReferences,r.prototype._syncProjects,l.ThreadAffinity.Group3),r}(a.AbstractMode);t.TypeScriptMode=g}),define("vs/languages/javascript/javascript.extensions",["require","exports","vs/platform/platform"],function(e,t,n){var r;!function(e){function t(e){i=e}function r(){return i}e.Identifier="javascript",n.Registry.add(e.Identifier,e);var i;e.setProjectResolver=t,e.getProjectResolver=r}(r=t.Extensions||(t.Extensions={}))});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/javascript/javascript",["require","exports","vs/base/lib/winjs.base","vs/editor/modes/modesExtensions","vs/platform/services","vs/languages/typescript/features/tokenization","vs/languages/typescript/typescriptMode","vs/editor/modes/supports","vs/languages/javascript/javascript.extensions"],function(e,t,n,r,i,o,s,a,c){var l=function(t){function s(e,n){var r=this;t.call(this,e,n),this._workerDescriptor=i.AsyncDescriptor.create("vs/languages/javascript/javascriptWorker","JavaScriptWorker"),this.tokenizationSupport=o.createTokenizationSupport(this,o.Language.EcmaScript5),this.referenceSupport=new a.ReferenceSupport(this,{tokens:["identifier.js"],findReferences:function(e,t,n){return r.findReferences(e,t,n)}}),this.declarationSupport=new a.DeclarationSupport(this,{tokens:["identifier.js","string.js","attribute.value.vs"],findDeclaration:function(e,t){return r.findDeclaration(e,t)}}),this.parameterHintsSupport=new a.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["string.js","string.escape.js"],getParameterHints:function(e,t){return r.getParameterHints(e,t)}}),this.electricCharacterSupport=new a.BracketElectricCharacterSupport(this,{brackets:[{tokenType:"delimiter.bracket.js",open:"{",close:"}",isElectric:!0},{tokenType:"delimiter.array.js",open:"[",close:"]",isElectric:!0},{tokenType:"delimiter.parenthesis.js",open:"(",close:")",isElectric:!0}],docComment:{scope:"comment.doc",open:"/**",lineStart:" * ",close:" */"}}),this.characterPairSupport=new a.CharacterPairSupport(this,{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string","comment"]}]}),this.suggestSupport=new a.SuggestSupport(this,{triggerCharacters:["."],excludeTokens:["string","comment","number"],sortBy:[{type:"reference",partSeparator:"/"}],suggest:function(e,t){return r.suggest(e,t)},getSuggestionDetails:function(e,t,n){return r.getSuggestionDetails(e,t,n)}})}return __extends(s,t),s.prototype.asyncCtor=function(){var t=this;return this._threadService.isInMainThread?n.Promise.as(this):new n.Promise(function(n){e(["vs/languages/typescript/typescriptWorker2"],function(){n(t)})})},s.prototype._getProjectResolver=function(){return c.Extensions.getProjectResolver()},s.prototype._shouldBeValidated=function(e){return e.getMode()===this||/\.(d\.ts|js)$/.test(e.getAssociatedResource().fsPath)},s.prototype._worker=function(e){return t.prototype._worker.call(this,e)},s.prototype.getNonWordTokenTypes=function(){return["delimiter.js","delimiter.parenthesis.js","delimiter.bracket.js","delimiter.array.js","regexp.js"]},s.prototype.getCommentsConfiguration=function(){return{lineCommentTokens:["//"],blockCommentStartToken:"/*",blockCommentEndToken:"*/"}},s.prototype.getWordDefinition=function(){return s.JS_WORD_DEFINITION},Object.defineProperty(s.prototype,"filter",{get:function(){return["identifier.js","string.js"]},enumerable:!0,configurable:!0}),s.JS_WORD_DEFINITION=r.createWordRegExp("$"),s}(s.TypeScriptMode);t.JSMode=l});