/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/typescript/js/shebangRewriter",["require","exports"],function(){var e=function(){function e(){}return Object.defineProperty(e.prototype,"name",{get:function(){return"rewriter.shebang"},enumerable:!0,configurable:!0}),e.prototype.computeEdits=function(t){var n=t.sourceFile.getFullText();if(n.charCodeAt(0)===e._hash&&n.charCodeAt(1)===e._bang){var r=~n.indexOf("\n")||~n.indexOf("\r");r=r?~r:n.length,t.newDelete(0,r)}},e._hash="#".charCodeAt(0),e._bang="!".charCodeAt(0),e}();return e});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/javascript/javascriptWorker",["require","exports","vs/base/uri","vs/base/objects","vs/base/arrays","vs/base/lib/winjs.base","vs/languages/typescript/typescriptWorker2","vs/languages/typescript/options","vs/languages/typescript/js/rewriting","vs/languages/typescript/features/suggestions","vs/languages/typescript/features/parameterHints","vs/languages/typescript/features/occurrences","vs/languages/typescript/features/extraInfo","vs/languages/typescript/features/references","vs/languages/typescript/features/definitions","vs/languages/typescript/features/quickFix","vs/languages/typescript/features/diagnostics","vs/languages/typescript/features/rename","vs/languages/typescript/js/shebangRewriter"],function(e,t,n,r,i,o,s,a,c,l,u,d,h,p,f,m,g,b,v){var y=function(e){function t(t,n,r){var i=this;e.call(this,t,n,r),this._projectService.defaultRewriter=[new v],this._fancyRewriters=[new v],r.forEach(function(e){"function"==typeof e.computeEdits&&i._fancyRewriters.push(e)})}return __extends(t,e),t.prototype._doConfigure=function(t){return e.prototype._doConfigure.call(this,t,a.javaScriptOptions)},t.prototype.doValidateSemantics=function(e){e=this._filePaths.toFileUri(e);var t=[],n=this._projectService.getProject(e,this._fancyRewriters),i=g.getSemanticDiagnostics(n.languageService,e,this._options);if(i){var o=n.translations.getTranslator(e);return i.markers.forEach(function(e){var n=o.info(e);n.origin?(r.mixin(e,n.origin,!0),t.push(e)):n.isInserted||(r.mixin(e,o.from(e),!0),t.push(e))}),this.markerService.changeOne("/"+this._getMode().getId()+"/semantic",e,t),i.hasMissingFiles}},t.prototype.doSuggest=function(e,t){e=this._filePaths.toFileUri(e);var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var r=l.computeSuggestions(n.languageService,e,t,this._options);return i.forEach(r.suggestions,function(e,t){c.containsEncodedVariableName(e.label)&&t()}),o.TPromise.as(r)},t.prototype.getSuggestionDetails=function(e,t,n){e=this._filePaths.toFileUri(e);var r=this._projectService.getProject(e,this._fancyRewriters);t=r.translations.getTranslator(e).to(t);var i=l.getSuggestionDetails(r.languageService,e,t,n,this._options);return i.typeLabel=c.decodeVariableNames(i.typeLabel,r.translations.getOriginal(e)),o.TPromise.as(i)},t.prototype.getParameterHints=function(e,t){e=this._filePaths.toFileUri(e);var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var r=u.compute(n.languageService,e,t);return o.TPromise.as(r)},t.prototype.findOccurrences=function(e,t,n){e=this._filePaths.toFileUri(e);var r=this._projectService.getProject(e,this._fancyRewriters),s=r.translations.getTranslator(e);t=s.to(t);var a=d.compute(r.languageService,e,t,n);return i.forEach(a,function(t,n){s.info(t.range).isInserted?n():t.range=r.translations.getTranslator(e).from(t.range)}),o.TPromise.as(a)},t.prototype._findTypeScriptDeclaration=function(e,t){e=this._filePaths.toFileUri(e);var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var r=f.findDeclaration(n,e,t);if(r){var i=n.translations.getTranslator(r.resourceUrl);if(!i.info(r.range).isInserted)return this._fixReference(r),r.range=i.from(r.range),o.TPromise.as(r)}},t.prototype.findReferences=function(e,t,n){var r=this;e=this._filePaths.toFileUri(e);var s=this._projectService.getProject(e,this._fancyRewriters);t=s.translations.getTranslator(e).to(t);var a=p.find(s,e,t,n);return i.forEach(a,function(e,t){var n=s.translations.getTranslator(e.resourceUrl);n.info(e.range).isInserted?t():(r._fixReference(e),e.range=n.from(e.range))}),o.TPromise.as(a)},t.prototype.computeInfo=function(e,t){e=this._filePaths.toFileUri(e);var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var r=h.compute(n.languageService,e,t);return r&&(r.range=n.translations.getTranslator(e).from(r.range),c.decodeVariableNames(r.htmlContent,n.translations.getOriginal(e))),o.TPromise.as(r)},t.prototype.runQuickFixAction=function(e,t,n){e=this._filePaths.toFileUri(e);var r=this._projectService.getProject(e,this._fancyRewriters),i=r.translations.getTranslator(e);t=i.to(t);var s=m.evaluate(r.languageService,e,t,n);return s&&s.editOperations.forEach(function(e){return e.range=i.from(e.range)}),o.TPromise.as(s)},t.prototype.getQuickFixes=function(e,t){e=this._filePaths.toFileUri(e);var n=this._projectService.getProject(e,this._fancyRewriters),i=n.translations.getTranslator(e).to(t);r.mixin(i,t,!1);var s=m.compute(n.languageService,e,i);return o.TPromise.as(s)},t.prototype.rename=function(e,t,r){e=this._filePaths.toFileUri(e);for(var i=this._projectService.getProject(e,this._fancyRewriters),s=b(i,e,i.translations.getTranslator(e).to(t),r),a=0;a<s.edits.length;a++){var c=s.edits[a],l=i.translations.getTranslator(n.parse(c.resource)),u=l.info(c.range);if(u.isInserted)s.edits.splice(a,1),a-=1;else if(u.isOverlapping){s.edits=[];break}c.range=l.from(c.range)}return o.TPromise.as(s)},t}(s.TypeScriptWorker2);t.JavaScriptWorker=y});