/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/json/features/tokenization",["require","exports","vs/editor/modes/modes","vs/base/json"],function(e,t,n,r){function o(e,t){return{shouldGenerateEmbeddedModels:!1,getInitialState:function(){return new s(e,null,null,!1)},tokenize:function(n,r,o,s){return i(e,t,n,r,o,s)}}}function i(e,t,o,i,a){void 0===a&&(a=0);var c=0,l=!1;switch(i.scanError){case r.ScanError.UnexpectedEndOfString:o='"'+o,c=1;break;case r.ScanError.UnexpectedEndOfComment:o="/*"+o,c=2}var u,d,h=r.createScanner(o),p=i.lastWasColon;for(d={tokens:[],actualStopOffset:o.length,endState:i.clone(),modeTransitions:[{startIndex:0,mode:e}]};;){var f=a+h.getPosition(),m=n.Bracket.None,g="";if(u=h.scan(),u===r.SyntaxKind.EOF)break;if(f===a+h.getPosition())throw new Error("Scanner did not advance, next 3 characters are: "+o.substr(h.getPosition(),3));switch(l&&(f-=c),l=c>0,u){case r.SyntaxKind.OpenBraceToken:m=n.Bracket.Open,g="delimiter.bracket.json";break;case r.SyntaxKind.CloseBraceToken:m=n.Bracket.Close,g="delimiter.bracket.json";break;case r.SyntaxKind.OpenBracketToken:m=n.Bracket.Open,g="delimiter.array.json";break;case r.SyntaxKind.CloseBracketToken:m=n.Bracket.Close,g="delimiter.array.json";break;case r.SyntaxKind.ColonToken:g="delimiter.colon.json";break;case r.SyntaxKind.CommaToken:g="delimiter.comma.json";break;case r.SyntaxKind.TrueKeyword:case r.SyntaxKind.FalseKeyword:case r.SyntaxKind.NullKeyword:g="keyword.json";break;case r.SyntaxKind.StringLiteral:g=p?"string.value.json":"string.key.json";break;case r.SyntaxKind.NumericLiteral:g="number.json"}if(t)switch(u){case r.SyntaxKind.LineCommentTrivia:g="comment.line.json";break;case r.SyntaxKind.BlockCommentTrivia:g="comment.block.json"}""!==g&&(p=u===r.SyntaxKind.ColonToken),d.endState=new s(i.getMode(),i.getStateData(),h.getTokenError(),p),d.tokens.push({startIndex:f,type:g,bracket:m})}return d}t.createTokenizationSupport=o;var s=function(){function e(e,t,n,r){this._mode=e,this._state=t,this.scanError=n,this.lastWasColon=r}return e.prototype.clone=function(){return new e(this._mode,this._state,this.scanError,this.lastWasColon)},e.prototype.equals=function(t){return t===this?!0:t&&t instanceof e?this.scanError===t.scanError&&this.lastWasColon===t.lastWasColon:!1},e.prototype.getMode=function(){return this._mode},e.prototype.tokenize=function(){throw new Error},e.prototype.getStateData=function(){return this._state},e.prototype.setStateData=function(e){this._state=e},e}()});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/json/json",["require","exports","vs/platform/configuration/configurationRegistry","vs/editor/modes/supports","vs/editor/modes/modesExtensions","vs/platform/platform","vs/nls!vs/languages/json/json","vs/platform/services","vs/platform/thread/attribute","vs/languages/json/features/tokenization"],function(e,t,n,r,o,i,s,a,c,l){var u=function(e){function t(t,n){var o=this;e.call(this,t,n,a.AsyncDescriptor.create("vs/languages/json/jsonWorker","JSONWorker")),this.tokenizationSupport=l.createTokenizationSupport(this,!0),this.electricCharacterSupport=new r.BracketElectricCharacterSupport(this,{brackets:[{tokenType:"delimiter.bracket.json",open:"{",close:"}",isElectric:!0},{tokenType:"delimiter.array.json",open:"[",close:"]",isElectric:!0}]}),this.extraInfoSupport=this,this.outlineSupport=this,this.outlineGroupLabel=Object.create(null),this.outlineGroupLabel.object=s.localize("vs_languages_json_json",0),this.outlineGroupLabel.array=s.localize("vs_languages_json_json",1),this.outlineGroupLabel.string=s.localize("vs_languages_json_json",2),this.outlineGroupLabel.number=s.localize("vs_languages_json_json",3),this.outlineGroupLabel["boolean"]=s.localize("vs_languages_json_json",4),this.outlineGroupLabel["null"]=s.localize("vs_languages_json_json",5),this.formattingSupport=this,this.characterPairSupport=new r.CharacterPairSupport(this,{autoClosingPairs:[{open:"{",close:"}",notIn:["string"]},{open:"[",close:"]",notIn:["string"]},{open:'"',close:'"',notIn:["string"]}]}),this.suggestSupport=new r.SuggestSupport(this,{triggerCharacters:[],excludeTokens:["comment.line.json","comment.block.json"],suggest:function(e,t){return o.suggest(e,t)}})}return __extends(t,e),t.prototype.creationDone=function(){if(e.prototype.creationDone.call(this),this._threadService.isInMainThread){var t=i.Registry.as(n.Extensions.Configuration);this._configureWorkerSchemas(t.getConfigurationSchemas())}},t.prototype.getSerializableState=function(){var e=i.Registry.as(n.Extensions.Configuration);return{schemas:e.getConfigurationSchemas()}},t.prototype.setData=function(e){this._worker(function(t){return t.setConfigurationSchemas(e.schemas)})},t.prototype._worker=function(t){return e.prototype._worker.call(this,t)},t.prototype._configureWorkerSchemas=function(e){return this._worker(function(t){return t.setConfigurationSchemas(e)})},t.prototype.computeInfo=function(e,t){return this._worker(function(n){return n.computeInfo(e,t)})},t.prototype.getOutline=function(e){return this._worker(function(t){return t.getOutline(e)})},t.prototype.formatDocument=function(e,t){return this._worker(function(n){return n.format(e,null,t)})},t.prototype.formatRange=function(e,t,n){return this._worker(function(r){return r.format(e,t,n)})},t.prototype.getCommentsConfiguration=function(){return{lineCommentTokens:["//"],blockCommentStartToken:"/*",blockCommentEndToken:"*/"}},t.prototype.getNonWordTokenTypes=function(){return["delimiter.json","delimiter.bracket.json","delimiter.array.json"]},t.prototype.getWordDefinition=function(){return t.WORD_DEFINITION},t.$_configureWorkerSchemas=c.AllWorkers(t,t.prototype._configureWorkerSchemas),t.$computeInfo=c.OneWorker(t,t.prototype.computeInfo),t.$getOutline=c.OneWorker(t,t.prototype.getOutline),t.$formatDocument=c.OneWorker(t,t.prototype.formatDocument),t.$formatRange=c.OneWorker(t,t.prototype.formatRange),t.WORD_DEFINITION=o.createWordRegExp(".-"),t}(o.AbstractMode);t.JSONMode=u});