/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/languages/json/jsonWorker.nls.keys",[],{vs_languages_json_parser_jsonParser:{path:"client/vs/languages/json/parser/jsonParser.js",keys:["typeArrayMismatchWarning","typeMismatchWarning","notSchemaWarning","oneOfWarning","enumWarning","additionalItemsWarning","minItemsWarning","maxItemsWarning","uniqueItemsWarning","multipleOfWarning","exclusiveMinimumWarning","minimumWarning","exclusiveMaximumWarning","maximumWarning","minLengthWarning","maxLengthWarning","patternWarning","MissingRequiredPropWarning","DisallowedExtraPropWarning","MaxPropWarning","MinPropWarning","RequiredDependentPropWarning","InvalidUnicode","InvalidEscapeCharacter","UnexpectedEndOfNumber","UnexpectedEndOfComment","UnexpectedEndOfString","ValueExpected","ExpectedCloseBracket","DoubleQuotesExpected","DuplicateKeyWarning","ColonExpected","ValueExpected","PropertyExpected","ExpectedCloseBrace","InvalidNumberFormat","InvalidNumberFormat","Invalid symbol","End of file expected"]},vs_languages_json_jsonSchemaService:{path:"client/vs/languages/json/jsonSchemaService.js",keys:["snippetSchema.json","snippetSchema.json.prefix","snippetSchema.json.body","snippetSchema.json.description","json.schema.unabletoload","schema.json","schema.json.id","schema.json.$schema","schema.json.title","schema.json.description","schema.json.default","schema.json.multipleOf","schema.json.maximum","schema.json.exclusiveMaximum","schema.json.minimum","schema.json.exclusiveMininum","schema.json.maxLength","schema.json.minLength","schema.json.pattern","schema.json.additionalItems","schema.json.items","schema.json.maxItems","schema.json.minItems","schema.json.uniqueItems","schema.json.maxProperties","schema.json.minProperties","schema.json.required","schema.json.additionalProperties","schema.json.definitions","schema.json.properties","schema.json.patternProperties","schema.json.dependencies","schema.json.enum","schema.json.type","schema.json.allOf","schema.json.anyOf","schema.json.oneOf","schema.json.not","project.json.title","project.json.compilationOptions","project.json.dependency.name","project.json.dependency.type","project.json.dependencies","project.json.script","project.json.authors","project.json.bundleExclude","project.json.code","project.json.commands","project.json.configurations","project.json.description","project.json.exclude","project.json.frameworks","project.json.preprocess","project.json.resources","project.json.scripts","project.json.shared","project.json.version","project.json.webroot","bower.json.title","bower.json.invalidPatternName","bower.json.packagename","bower.json.description","bower.json.version","bower.json.main","bower.json.license","bower.json.ignore","bower.json.keywords","bower.json.authors","bower.json.homepage","bower.json.repository","bower.json.dependencies","bower.json.devDependencies","bower.json.resolutions","bower.json.private","bower.json.exportsOverride","bower.json.moduleType","package.json.description","package.json.person","package.json.dependency","package.json.underscore","package.json.name","package.json.version","package.json.descr","package.json.keywords","package.json.homepage","package.json.bugs","package.json.bugs.url","package.json.bugs.email","package.json.license","package.json.licenses","package.json.contributors","package.json.maintainers","package.json.files","package.json.main","package.json.man","package.json.directories.bin","package.json.directories.doc","package.json.directories.example","package.json.directories.lib","package.json.directories.man","package.json.repository","package.json.scripts","package.json.config","package.json.bundleDependencies","package.json.bundledDependencies","package.json.preferGlobal","package.json.private","global.json.title","global.json.projects","global.json.sources","tsconfig.json.title","tsconfig.json.compilerOptions","tsconfig.json.compilerOptions.charset","tsconfig.json.compilerOptions.declaration","tsconfig.json.compilerOptions.diagnostics","tsconfig.json.compilerOptions.emitBOM","tsconfig.json.compilerOptions.inlineSourceMap","tsconfig.json.compilerOptions.inlineSources","tsconfig.json.compilerOptions.listFiles","tsconfig.json.compilerOptions.locale","tsconfig.json.compilerOptions.mapRoot","tsconfig.json.compilerOptions.module","tsconfig.json.compilerOptions.newLine","tsconfig.json.compilerOptions.noEmit","tsconfig.json.compilerOptions.noEmitOnError","tsconfig.json.compilerOptions.noEmitHelpers","tsconfig.json.compilerOptions.noImplicitAny","tsconfig.json.compilerOptions.noLib","tsconfig.json.compilerOptions.out","tsconfig.json.compilerOptions.outDir","tsconfig.json.compilerOptions.preserveConstEnums","tsconfig.json.compilerOptions.removeComments","tsconfig.json.compilerOptions.rootDir","tsconfig.json.compilerOptions.sourceMap","tsconfig.json.compilerOptions.sourceRoot","tsconfig.json.compilerOptions.suppressImplicitAnyIndexErrors","tsconfig.json.compilerOptions.target","tsconfig.json.files","jsconfig.json.title","jsconfig.json.compilerOptions","jsconfig.json.compilerOptions.charset","jsconfig.json.compilerOptions.diagnostics","jsconfig.json.compilerOptions.locale","jsconfig.json.compilerOptions.mapRoot","jsconfig.json.compilerOptions.module","jsconfig.json.compilerOptions.noLib","jsconfig.json.compilerOptions.target","jsconfig.json.files","app.plugin.json.pluginId","app.plugin.json.activationEvents","app.plugin.json.dependencies","app.plugin.json.mainModule","app.plugin.json.contributes","app.plugin.json.contributes.language","app.plugin.json.contributes.language.id","app.plugin.json.contributes.language.extensions","app.plugin.json.contributes.language.filenames","app.plugin.json.contributes.language.aliases","app.plugin.json.scripts","app.plugin.json.scripts.compile"]},vs_languages_json_jsonIntellisense:{path:"client/vs/languages/json/jsonIntellisense.js",keys:["json.suggest.default"]},vs_languages_json_contributions_projectJSONContribution:{path:"client/vs/languages/json/contributions/projectJSONContribution.js",keys:["json.project.default","json.nugget.error.repoaccess","json.nugget.error.repoaccess","json.nugget.versiondescription.suggest","json.nugget.package.hover","json.nugget.version.hover"]},vs_languages_json_contributions_packageJSONContribution:{path:"client/vs/languages/json/contributions/packageJSONContribution.js",keys:["json.package.default","json.npm.error.repoaccess","json.npm.error.repoaccess","json.npm.latestversion","json.npm.majorversion","json.npm.minorversion","json.npm.package.hover","json.npm.version.hover"]},vs_languages_json_contributions_bowerJSONContribution:{path:"client/vs/languages/json/contributions/bowerJSONContribution.js",keys:["json.bower.default","json.bower.error.repoaccess","json.bower.error.repoaccess","json.bower.package.hover"]},vs_languages_json_contributions_globPatternContribution:{path:"client/vs/languages/json/contributions/globPatternContribution.js",keys:["fileLabel","fileDescription","filesLabel","filesDescription","derivedLabel","derivedDescription","topFolderLabel","topFolderDescription","topFoldersLabel","topFoldersDescription","folderLabel","folderDescription","trueLabel","trueDescription","falseLabel","falseDescription","derivedLabel","siblingsDescription"]}});