/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/less/less",["require","exports","vs/base/lib/winjs.base","vs/editor/modes/modesExtensions","vs/editor/modes/monarch/monarch","vs/editor/modes/monarch/monarchCompile","vs/platform/thread/attribute","vs/editor/modes/supports"],function(e,t,n,r,o,i,s,a){t.language={displayName:"LESS",name:"less",mimeTypes:["text/x-less"],fileExtensions:[".less"],workerDescriptor:{moduleName:"vs/languages/less/lessWorker",ctorName:"LessWorker"},nonWordTokens:["delimiter.curly.less","delimiter.bracket.less","delimiter.parenthesis.less","delimiter.angle.less"],wordDefinition:/(#?-?\d*\.\d\w*%?)|([@#!.:]?[\w-?]+%?)|[@#!.]/g,defaultToken:"",lineComment:"//",blockCommentStart:"/*",blockCommentEnd:"*/",brackets:[{open:"{",close:"}",token:"delimiter.curly"},{open:"[",close:"]",token:"delimiter.bracket"},{open:"(",close:")",token:"delimiter.parenthesis"},{open:"<",close:">",token:"delimiter.angle"}],tokenizer:{root:[{include:"@nestedJSBegin"},["[ \\t\\r\\n]+",""],{include:"@comments"},{include:"@keyword"},{include:"@strings"},{include:"@numbers"},["[*_]?[a-zA-Z\\-\\s]+(?=:.*(;|(\\\\$)))","attribute.name","@attribute"],{include:"@operators"},["url(\\-prefix)?\\(",{token:"tag",bracket:"@open",next:"@urldeclaration"}],["[{}()\\[\\]]","@brackets"],["[,:;]","delimiter"],["#[\\w\\-.:]+","tag.id"],["&","identifier"],["\\.[\\w\\-.:]+(?=\\()","tag.class","@attribute"],["\\.[\\w\\-.:]+","tag.class"],["[\\w\\-.:]+","tag"],["@[\\w\\-]+(?=[:,\\)])","variable","@attribute"],["@[\\w\\-]+","variable"],["@","key","@atRules"]],nestedJSBegin:[["``","delimiter.backtick"],["`",{token:"delimiter.backtick",bracket:"@open",next:"@nestedJSEnd",nextEmbedded:"text/javascript"}]],nestedJSEnd:[["`",{token:"delimiter.backtick",bracket:"@close",next:"@pop"}],[".",{token:"@rematch",next:"@javascript_block"}]],javascript_block:[["`",{token:"@rematch",next:"@pop",nextEmbedded:"@pop"}]],operators:[["[<>=\\+\\-\\*\\/\\^\\|\\~]","operator"]],keyword:[["(@[\\s]*import|![\\s]*important|true|false|when|iscolor|isnumber|isstring|iskeyword|isurl|ispixel|ispercentage|isem|hue|saturation|lightness|alpha|lighten|darken|saturate|desaturate|fadein|fadeout|fade|spin|mix|round|ceil|floor|percentage)\\b","keyword"]],urldeclaration:[{include:"@strings"},["[^)\r\n]+","string"],["\\)",{token:"tag",bracket:"@close",next:"@pop"}]],attribute:[{include:"@nestedJSBegin"},{include:"@comments"},{include:"@strings"},{include:"@numbers"},{include:"@keyword"},["[a-zA-Z\\-]+(?=\\()","attribute.value","@attribute"],[">","operator","@pop"],["\\w+\\-\\w+","attribute.value"],{include:"@operators"},["@[\\w\\-]+","variable"],["[)\\}]","@brackets","@pop"],["[{}()\\[\\]>]","@brackets"],["[;]","delimiter","@pop"],["[,=:]","delimiter"],["\\s",""],["\\w+","attribute.value"],[".","attribute.value"]],comments:[["\\/\\*","comment","@comment"],["\\/\\/+.*","comment"]],comment:[["\\*\\/","comment","@pop"],[".","comment"]],numbers:[["(\\d*\\.)?\\d+([eE][\\-+]?\\d+)?",{token:"attribute.value.number",next:"@units"}],["#[0-9a-fA-F_]+(?!\\w)","attribute.value.hex"]],units:[["((em|ex|ch|rem|vw|vh|vm|cm|mm|in|px|pt|pc|deg|grad|rad|turn|s|ms|Hz|kHz|%)\\b)?","attribute.value.unit","@pop"]],strings:[['~?"',{token:"string.delimiter",bracket:"@open",next:"@stringsEndDoubleQuote"}],["~?'",{token:"string.delimiter",bracket:"@open",next:"@stringsEndQuote"}]],stringsEndDoubleQuote:[['\\\\"',"string"],['"',{token:"string.delimiter",next:"@popall",bracket:"@close"}],[".","string"]],stringsEndQuote:[["\\\\'","string"],["'",{token:"string.delimiter",next:"@popall",bracket:"@close"}],[".","string"]],atRules:[{include:"@comments"},{include:"@strings"},["[()]","delimiter"],["[\\{;]","delimiter","@pop"],[".","key"]]}};var c=function(e){function o(n,r){var o=this;e.call(this,n,r,i.compile(t.language)),this.extraInfoSupport=this,this.referenceSupport=new a.ReferenceSupport(this,{tokens:["attribute.name.less","attribute.value.less","variable.less","tag.class.less","tag.id.less","tag.less"],findReferences:function(e,t){return o.findReferences(e,t)}}),this.logicalSelectionSupport=this,this.declarationSupport=new a.DeclarationSupport(this,{tokens:["variable.less","tag.class.less","tag.id.less","tag.less"],findDeclaration:function(e,t){return o.findDeclaration(e,t)}}),this.outlineSupport=this,this.suggestSupport=new a.SuggestSupport(this,{triggerCharacters:[],excludeTokens:["comment.less","string.less"],suggest:function(e,t){return o.suggest(e,t)}})}return __extends(o,e),o.prototype._worker=function(t){var o=this;return r.getOrCreateMode("css").then(function(e){return e._worker(function(){return n.TPromise.as(!0)})}).then(function(){return e.prototype._worker.call(o,t)})},o.prototype.findReferences=function(e,t){return this._worker(function(n){return n.findReferences(e,t)})},o.prototype.getRangesToPosition=function(e,t){return this._worker(function(n){return n.getRangesToPosition(e,t)})},o.prototype.computeInfo=function(e,t){return this._worker(function(n){return n.computeInfo(e,t)})},o.prototype.getOutline=function(e){return this._worker(function(t){return t.getOutline(e)})},o.prototype.findDeclaration=function(e,t){return this._worker(function(n){return n.findDeclaration(e,t)})},o.prototype.findColorDeclarations=function(e){return this._worker(function(t){return t.findColorDeclarations(e)})},o.$findReferences=s.OneWorker(o,o.prototype.findReferences),o.$getRangesToPosition=s.OneWorker(o,o.prototype.getRangesToPosition),o.$computeInfo=s.OneWorker(o,o.prototype.computeInfo),o.$getOutline=s.OneWorker(o,o.prototype.getOutline),o.$findDeclaration=s.OneWorker(o,o.prototype.findDeclaration),o.$findColorDeclarations=s.OneWorker(o,o.prototype.findColorDeclarations),o}(o.MonarchMode);t.LESSMode=c});