/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/sass/parser/sassScanner",["require","exports","vs/languages/css/parser/cssScanner"],function(e,t,n){var r="/".charCodeAt(0),i="\n".charCodeAt(0),s="\r".charCodeAt(0),o="\f".charCodeAt(0),a="$".charCodeAt(0),c="#".charCodeAt(0),l="{".charCodeAt(0),u="=".charCodeAt(0),p="!".charCodeAt(0),h="<".charCodeAt(0),d=">".charCodeAt(0),m=".".charCodeAt(0),f=n.TokenType.CustomToken;t.VariableName=f++,t.InterpolationFunction=f++,t.Default=f++,t.EqualsOperator=f++,t.NotEqualsOperator=f++,t.GreaterEqualsOperator=f++,t.SmallerEqualsOperator=f++,t.Ellipsis=f++;var g=function(e){function f(){e.apply(this,arguments)}return __extends(f,e),f.prototype.scan=function(r){void 0===r&&(r=!0);var i={type:void 0,text:void 0,offset:this.stream.pos(),len:0};return this.sassComment()?this.ignoreComment?this.scan(r):this.finishToken(i,n.TokenType.SingleLineComment):this.stream.peekChar()===a&&this.nmchar(this.stream.peekChar(1))?(this.stream.advance(1),this.stream.advanceWhileChar(this.nmchar.bind(this)),this.finishToken(i,t.VariableName)):this.stream.advanceIfChars([c,l])?this.finishToken(i,t.InterpolationFunction):this.stream.advanceIfChars([u,u])?this.finishToken(i,t.EqualsOperator):this.stream.advanceIfChars([p,u])?this.finishToken(i,t.NotEqualsOperator):this.stream.advanceIfChar(h)?this.stream.advanceIfChar(u)?this.finishToken(i,t.SmallerEqualsOperator):this.finishToken(i,n.TokenType.Delim):this.stream.advanceIfChar(d)?this.stream.advanceIfChar(u)?this.finishToken(i,t.GreaterEqualsOperator):this.finishToken(i,n.TokenType.Delim):this.stream.advanceIfChars([m,m,m])?this.finishToken(i,t.Ellipsis):e.prototype.scan.call(this,r)},f.prototype.sassComment=function(){return this.stream.advanceIfChars([r,r])?(this.stream.advanceWhileChar(function(e){switch(e){case i:case s:case o:return!1;default:return!0}}),!0):!1},f}(n.Scanner);t.SassScanner=g}),define("vs/languages/sass/parser/sassErrors",["require","exports","vs/nls!vs/languages/sass/sassWorker"],function(e,t,n){var r=function(){function e(e,t){this.id=e,this.message=t}return e}();t.SassIssueType=r,t.ParseError={FromExpected:new r("sass-fromexpected",n.localize("vs_languages_sass_parser_sassErrors",0)),ThroughOrToExpected:new r("sass-throughexpected",n.localize("vs_languages_sass_parser_sassErrors",1)),InExpected:new r("sass-fromexpected",n.localize("vs_languages_sass_parser_sassErrors",2))}});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/sass/parser/sassParser",["require","exports","./sassScanner","./sassErrors","vs/languages/css/parser/cssScanner","vs/languages/css/parser/cssParser","vs/languages/css/parser/cssNodes","vs/languages/css/parser/cssErrors"],function(e,t,n,r,i,s,o,a){var c=function(e){function t(){e.call(this,new n.SassScanner)}return __extends(t,e),t.prototype._parseStylesheetStatement=function(){return e.prototype._parseStylesheetStatement.call(this)||this._parseVariableDeclaration()||this._parseWarnAndDebug()||this._parseControlStatement()||this._parseMixinDeclaration()||this._parseMixinContent()||this._parseMixinReference()||this._parseFunctionDeclaration()},t.prototype._parseImport=function(){var e=this.create(o.Import);if(!this.accept(i.TokenType.AtKeyword,"@import"))return null;if(!this.accept(i.TokenType.URI)&&!this.accept(i.TokenType.String))return this.finish(e,a.ParseError.URIOrStringExpected);for(;this.accept(i.TokenType.Comma);)if(!this.accept(i.TokenType.URI)&&!this.accept(i.TokenType.String))return this.finish(e,a.ParseError.URIOrStringExpected);return e.setMedialist(this._parseMediaList()),this.finish(e)},t.prototype._parseVariableDeclaration=function(e){void 0===e&&(e=[]);var t=this.create(o.VariableDeclaration);return t.setVariable(this._parseVariable())?this.accept(i.TokenType.Colon,":")?(t.colonPosition=this.prevToken.offset,t.setValue(this._parseExpr())?this.accept(i.TokenType.Exclamation)&&!this.accept(i.TokenType.Ident,"default",!0)?this.finish(t,a.ParseError.UnknownKeyword):this.finish(t):this.finish(t,a.ParseError.VariableValueExpected,[],e)):this.finish(t,a.ParseError.ColonExpected):null},t.prototype._parseMediaFeatureName=function(){return this._parseFunction()||this._parseIdent()||this._parseVariable()},t.prototype._parseKeyframeSelector=function(){return e.prototype._parseKeyframeSelector.call(this)||this._parseMixinContent()},t.prototype._parseVariable=function(){var e=this.create(o.Variable);return this.accept(n.VariableName)?e:null},t.prototype._parseIdent=function(e){var t=this.create(o.Identifier);t.referenceTypes=e;for(var n=!1;(this.accept(i.TokenType.Ident)||t.addChild(this._parseInterpolation()))&&(n=!0,!this.hasWhitespace()&&this.accept(i.TokenType.Delim,"-"),!this.hasWhitespace()););return n?this.finish(t):null},t.prototype._parseTerm=function(){var t=e.prototype._parseTerm.call(this);return t?t:(t=this.create(o.Term),t.setExpression(this._parseVariable())||t.setExpression(this._parseOperation())?this.finish(t):null)},t.prototype._parseInterpolation=function(){var e=this.create(o.Interpolation);return this.accept(n.InterpolationFunction)?e.addChild(this._parseBinaryExpr())?this.accept(i.TokenType.CurlyR)?this.finish(e):this.finish(e,a.ParseError.RightCurlyExpected):this.finish(e,a.ParseError.ExpressionExpected):null},t.prototype._parseOperation=function(){var e=this.create(o.Node);return this.accept(i.TokenType.ParenthesisL)?(e.addChild(this._parseExpr()),this.accept(i.TokenType.ParenthesisR)?this.finish(e):this.finish(e,a.ParseError.RightParenthesisExpected)):null},t.prototype._parseOperator=function(){var t=this.createNode(o.NodeType.Operator);if(this.peek(n.EqualsOperator)||this.peek(n.NotEqualsOperator)||this.peek(n.GreaterEqualsOperator)||this.peek(n.SmallerEqualsOperator)||this.peek(i.TokenType.Delim,">")||this.peek(i.TokenType.Delim,"<")||this.peek(i.TokenType.Ident,"and")||this.peek(i.TokenType.Ident,"or")||this.peek(i.TokenType.Delim,"%")){var t=this.createNode(o.NodeType.Operator);return this.consumeToken(),this.finish(t)}return e.prototype._parseOperator.call(this)},t.prototype._parseUnaryOperator=function(){if(this.peek(i.TokenType.Ident,"not")){var t=this.create(o.Node);return this.consumeToken(),this.finish(t)}return e.prototype._parseUnaryOperator.call(this)},t.prototype._parseRuleSetDeclaration=function(){return this.peek(i.TokenType.AtKeyword)?this._parseKeyframe()||this._parseImport()||this._parseMedia()||this._parseFontFace()||this._parseWarnAndDebug()||this._parseControlStatement()||this._parseFunctionDeclaration()||this._parseExtends()||this._parseMixinReference()||this._parseMixinContent()||this._parseMixinDeclaration():this._parseVariableDeclaration()||this._tryParseRuleset(!0)||this._parseDeclaration()},t.prototype._parseDeclaration=function(e){var t=this.create(o.Declaration);if(!t.setProperty(this._parseProperty()))return null;if(!this.accept(i.TokenType.Colon,":"))return this.finish(t,a.ParseError.ColonExpected,[i.TokenType.Colon],e);t.colonPosition=this.prevToken.offset;var n=!1;if(t.setValue(this._parseExpr())&&(n=!0,t.addChild(this._parsePrio())),this.peek(i.TokenType.CurlyL))t.setNestedProperties(this._parseNestedProperties());else if(!n)return this.finish(t,a.ParseError.PropertyValueExpected);return this.peek(i.TokenType.SemiColon)&&(t.semicolonPosition=this.token.offset),this.finish(t)},t.prototype._parseNestedProperties=function(){var e=this.create(o.NestedProperties);return this._parseBody(e,this._parseDeclaration.bind(this))},t.prototype._parseExtends=function(){var e=this.create(o.ExtendsReference);return this.accept(i.TokenType.AtKeyword,"@extend")?e.setSelector(this._parseSimpleSelector())?this.accept(i.TokenType.Exclamation)&&!this.accept(i.TokenType.Ident,"optional",!0)?this.finish(e,a.ParseError.UnknownKeyword):this.finish(e):this.finish(e,a.ParseError.SelectorExpected):null},t.prototype._parseSimpleSelectorBody=function(){return this._parseSelectorCombinator()||this._parseSelectorPlaceholder()||e.prototype._parseSimpleSelectorBody.call(this)},t.prototype._parseSelectorCombinator=function(){var e=this.createNode(o.NodeType.SelectorCombinator);if(this.accept(i.TokenType.Delim,"&")){for(;!this.hasWhitespace()&&(this.accept(i.TokenType.Delim,"-")||e.addChild(this._parseIdent())||this.accept(i.TokenType.Delim,"&")););return this.finish(e)}return null},t.prototype._parseSelectorPlaceholder=function(){var e=this.createNode(o.NodeType.SelectorPlaceholder);return this.accept(i.TokenType.Delim,"%")?(this._parseIdent(),this.finish(e)):null},t.prototype._parseWarnAndDebug=function(){if(!this.peek(i.TokenType.AtKeyword,"@debug")&&!this.peek(i.TokenType.AtKeyword,"@warn"))return null;var e=this.createNode(o.NodeType.Debug);return this.consumeToken(),e.addChild(this._parseExpr()),this.finish(e)},t.prototype._parseControlStatement=function(e){return void 0===e&&(e=this._parseRuleSetDeclaration.bind(this)),this.peek(i.TokenType.AtKeyword)?this._parseIfStatement(e)||this._parseForStatement(e)||this._parseEachStatement(e)||this._parseWhileStatement(e):null},t.prototype._parseIfStatement=function(e){return this.peek(i.TokenType.AtKeyword,"@if")?this._internalParseIfStatement(e):null},t.prototype._internalParseIfStatement=function(e){var t=this.create(o.IfStatement);if(this.consumeToken(),!t.setExpression(this._parseBinaryExpr()))return this.finish(t,a.ParseError.ExpressionExpected);if(this._parseBody(t,e),this.accept(i.TokenType.AtKeyword,"@else"))if(this.peek(i.TokenType.Ident,"if"))t.setElseClause(this._internalParseIfStatement(e));else if(this.peek(i.TokenType.CurlyL)){var n=this.create(o.ElseStatement);this._parseBody(n,e),t.setElseClause(n)}return this.finish(t)},t.prototype._parseForStatement=function(e){if(!this.peek(i.TokenType.AtKeyword,"@for"))return null;var t=this.create(o.ForStatement);return this.consumeToken(),t.setVariable(this._parseVariable())?this.accept(i.TokenType.Ident,"from")?t.addChild(this._parseBinaryExpr())?this.accept(i.TokenType.Ident,"to")||this.accept(i.TokenType.Ident,"through")?t.addChild(this._parseBinaryExpr())?this._parseBody(t,e):this.finish(t,a.ParseError.ExpressionExpected,[i.TokenType.CurlyR]):this.finish(t,r.ParseError.ThroughOrToExpected,[i.TokenType.CurlyR]):this.finish(t,a.ParseError.ExpressionExpected,[i.TokenType.CurlyR]):this.finish(t,r.ParseError.FromExpected,[i.TokenType.CurlyR]):this.finish(t,a.ParseError.VariableNameExpected,[i.TokenType.CurlyR])},t.prototype._parseEachStatement=function(e){if(!this.peek(i.TokenType.AtKeyword,"@each"))return null;var t=this.create(o.EachStatement);return this.consumeToken(),t.setVariable(this._parseVariable())?this.accept(i.TokenType.Ident,"in")?t.addChild(this._parseExpr())?this._parseBody(t,e):this.finish(t,a.ParseError.ExpressionExpected,[i.TokenType.CurlyR]):this.finish(t,r.ParseError.InExpected,[i.TokenType.CurlyR]):this.finish(t,a.ParseError.VariableNameExpected,[i.TokenType.CurlyR])},t.prototype._parseWhileStatement=function(e){if(!this.peek(i.TokenType.AtKeyword,"@while"))return null;var t=this.create(o.WhileStatement);return this.consumeToken(),t.addChild(this._parseBinaryExpr())?this._parseBody(t,e):this.finish(t,a.ParseError.ExpressionExpected,[i.TokenType.CurlyR])},t.prototype._parseFunctionBodyDeclaration=function(){return this._parseVariableDeclaration()||this._parseReturnStatement()||this._parseControlStatement(this._parseFunctionBodyDeclaration.bind(this))},t.prototype._parseFunctionDeclaration=function(){if(!this.peek(i.TokenType.AtKeyword,"@function"))return null;var e=this.create(o.FunctionDeclaration);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([o.ReferenceType.Function])))return this.finish(e,a.ParseError.IdentifierExpected,[i.TokenType.CurlyR]);if(!this.accept(i.TokenType.ParenthesisL))return this.finish(e,a.ParseError.LeftParenthesisExpected,[i.TokenType.CurlyR]);if(e.getParameters().addChild(this._parseParameterDeclaration()))for(;this.accept(i.TokenType.Comma);)if(!e.getParameters().addChild(this._parseParameterDeclaration()))return this.finish(e,a.ParseError.VariableNameExpected);return this.accept(i.TokenType.ParenthesisR)?this._parseBody(e,this._parseFunctionBodyDeclaration.bind(this)):this.finish(e,a.ParseError.RightParenthesisExpected,[i.TokenType.CurlyR])},t.prototype._parseReturnStatement=function(){if(!this.peek(i.TokenType.AtKeyword,"@return"))return null;var e=this.createNode(o.NodeType.ReturnStatement);return this.consumeToken(),e.addChild(this._parseExpr())?this.finish(e):this.finish(e,a.ParseError.ExpressionExpected)},t.prototype._parseMixinDeclaration=function(){if(!this.peek(i.TokenType.AtKeyword,"@mixin"))return null;var e=this.create(o.MixinDeclaration);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([o.ReferenceType.Mixin])))return this.finish(e,a.ParseError.IdentifierExpected,[i.TokenType.CurlyR]);if(this.accept(i.TokenType.ParenthesisL)){if(e.getParameters().addChild(this._parseParameterDeclaration()))for(;this.accept(i.TokenType.Comma);)if(!e.getParameters().addChild(this._parseParameterDeclaration()))return this.finish(e,a.ParseError.VariableNameExpected);if(!this.accept(i.TokenType.ParenthesisR))return this.finish(e,a.ParseError.RightParenthesisExpected,[i.TokenType.CurlyR])}return this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},t.prototype._parseParameterDeclaration=function(){var e=this.create(o.FunctionParameter);return e.setIdentifier(this._parseVariable())?(this.accept(n.Ellipsis),this.accept(i.TokenType.Colon)&&!e.setDefaultValue(this._parseExpr(!0))?this.finish(e,a.ParseError.VariableValueExpected,[],[i.TokenType.Comma,i.TokenType.ParenthesisR]):this.finish(e)):null},t.prototype._parseMixinContent=function(){if(!this.peek(i.TokenType.AtKeyword,"@content"))return null;var e=this.createNode(o.NodeType.MixinContent);return this.consumeToken(),this.finish(e)},t.prototype._parseMixinReference=function(){if(!this.peek(i.TokenType.AtKeyword,"@include"))return null;var e=this.create(o.MixinReference);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([o.ReferenceType.Mixin])))return this.finish(e,a.ParseError.IdentifierExpected,[i.TokenType.CurlyR]);if(this.accept(i.TokenType.ParenthesisL)){if(e.getArguments().addChild(this._parseFunctionArgument()))for(;this.accept(i.TokenType.Comma);)if(!e.getArguments().addChild(this._parseFunctionArgument()))return this.finish(e,a.ParseError.ExpressionExpected);if(!this.accept(i.TokenType.ParenthesisR))return this.finish(e,a.ParseError.RightParenthesisExpected)}if(this.peek(i.TokenType.CurlyL)){var t=this.create(o.BodyDeclaration);this._parseBody(t,this._parseMixinReferenceBodyStatement.bind(this)),e.setContent(t)}return this.finish(e)},t.prototype._parseMixinReferenceBodyStatement=function(){return this._parseRuleSetDeclaration()||this._parseKeyframeSelector()},t.prototype._parseFunctionArgument=function(){var e=this.create(o.FunctionArgument),t=this.mark(),r=this._parseVariable();if(r)if(this.accept(i.TokenType.Colon))e.setIdentifier(r);else{if(this.accept(n.Ellipsis))return e.setValue(r),this.finish(e);this.restoreAtMark(t)}return e.setValue(this._parseExpr(!0))?this.finish(e):null},t}(s.Parser);t.SassParser=c});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/sass/services/intelliSense",["require","exports","vs/languages/css/services/intelliSense","vs/nls!vs/languages/sass/sassWorker"],function(e,t,n,r){var i=function(e){function t(){e.call(this,"$")}return __extends(t,e),t.prototype.createFunctionProposals=function(e,n){var r=function(e,n){return n+": {{"+(t.variableDefaults[n]||"")+"}}"};return e.forEach(function(e){n.push({label:e.func.substr(0,e.func.indexOf("(")),typeLabel:e.func,documentationLabel:e.desc,codeSnippet:e.func.replace(/\[?(\$\w+)\]?/g,r),type:"function"})}),n},t.prototype.getCompletionsForSelector=function(n,r){return this.createFunctionProposals(t.selectorFuncs,r),e.prototype.getCompletionsForSelector.call(this,n,r)},t.prototype.getTermProposals=function(n){return this.createFunctionProposals(t.builtInFuncs,n),e.prototype.getTermProposals.call(this,n)},t.prototype.getColorProposals=function(n,r){return this.createFunctionProposals(t.colorProposals,r),e.prototype.getColorProposals.call(this,n,r)},t.variableDefaults={$red:"1",$green:"2",$blue:"3",$alpha:"1.0",$color:"$color",$weight:"0.5",$hue:"0",$saturation:"0%",$lightness:"0%",$degrees:"0",$amount:"0",$string:'""',$substring:'"s"',$number:"0",$limit:"1"},t.colorProposals=[{func:"red($color)",desc:r.localize("vs_languages_sass_services_intelliSense",0)},{func:"green($color)",desc:r.localize("vs_languages_sass_services_intelliSense",1)},{func:"blue($color)",desc:r.localize("vs_languages_sass_services_intelliSense",2)},{func:"mix($color, $color, [$weight])",desc:r.localize("vs_languages_sass_services_intelliSense",3)},{func:"hue($color)",desc:r.localize("vs_languages_sass_services_intelliSense",4)},{func:"saturation($color)",desc:r.localize("vs_languages_sass_services_intelliSense",5)},{func:"lightness($color)",desc:r.localize("vs_languages_sass_services_intelliSense",6)},{func:"adjust-hue($color, $degrees)",desc:r.localize("vs_languages_sass_services_intelliSense",7)},{func:"lighten($color, $amount)",desc:r.localize("vs_languages_sass_services_intelliSense",8)},{func:"darken($color, $amount)",desc:r.localize("vs_languages_sass_services_intelliSense",9)},{func:"saturate($color, $amount)",desc:r.localize("vs_languages_sass_services_intelliSense",10)},{func:"desaturate($color, $amount)",desc:r.localize("vs_languages_sass_services_intelliSense",11)},{func:"grayscale($color)",desc:r.localize("vs_languages_sass_services_intelliSense",12)},{func:"complement($color)",desc:r.localize("vs_languages_sass_services_intelliSense",13)},{func:"invert($color)",desc:r.localize("vs_languages_sass_services_intelliSense",14)},{func:"alpha($color)",desc:r.localize("vs_languages_sass_services_intelliSense",15)},{func:"opacity($color)",desc:"Gets the alpha component (opacity) of a color."},{func:"rgba($color, $alpha)",desc:r.localize("vs_languages_sass_services_intelliSense",16)},{func:"opacify($color, $amount)",desc:r.localize("vs_languages_sass_services_intelliSense",17)},{func:"fade-in($color, $amount)",desc:r.localize("vs_languages_sass_services_intelliSense",18)},{func:"transparentize($color, $amount) / fade-out($color, $amount)",desc:r.localize("vs_languages_sass_services_intelliSense",19)},{func:"adjust-color($color, [$red], [$green], [$blue], [$hue], [$saturation], [$lightness], [$alpha])",desc:r.localize("vs_languages_sass_services_intelliSense",20)},{func:"scale-color($color, [$red], [$green], [$blue], [$saturation], [$lightness], [$alpha])",desc:r.localize("vs_languages_sass_services_intelliSense",21)},{func:"change-color($color, [$red], [$green], [$blue], [$hue], [$saturation], [$lightness], [$alpha])",desc:r.localize("vs_languages_sass_services_intelliSense",22)},{func:"ie-hex-str($color)",desc:r.localize("vs_languages_sass_services_intelliSense",23)}],t.selectorFuncs=[{func:"selector-nest($selectors…)",desc:r.localize("vs_languages_sass_services_intelliSense",24)},{func:"selector-append($selectors…)",desc:r.localize("vs_languages_sass_services_intelliSense",25)},{func:"selector-extend($selector, $extendee, $extender)",desc:r.localize("vs_languages_sass_services_intelliSense",26)},{func:"selector-replace($selector, $original, $replacement)",desc:r.localize("vs_languages_sass_services_intelliSense",27)},{func:"selector-unify($selector1, $selector2)",desc:r.localize("vs_languages_sass_services_intelliSense",28)},{func:"is-superselector($super, $sub)",desc:r.localize("vs_languages_sass_services_intelliSense",29)},{func:"simple-selectors($selector)",desc:r.localize("vs_languages_sass_services_intelliSense",30)},{func:"selector-parse($selector)",desc:r.localize("vs_languages_sass_services_intelliSense",31)}],t.builtInFuncs=[{func:"unquote($string)",desc:r.localize("vs_languages_sass_services_intelliSense",32)},{func:"quote($string)",desc:r.localize("vs_languages_sass_services_intelliSense",33)},{func:"str-length($string)",desc:r.localize("vs_languages_sass_services_intelliSense",34)},{func:"str-insert($string, $insert, $index)",desc:r.localize("vs_languages_sass_services_intelliSense",35)},{func:"str-index($string, $substring)",desc:r.localize("vs_languages_sass_services_intelliSense",36)},{func:"str-slice($string, $start-at, [$end-at])",desc:r.localize("vs_languages_sass_services_intelliSense",37)},{func:"to-upper-case($string)",desc:r.localize("vs_languages_sass_services_intelliSense",38)},{func:"to-lower-case($string)",desc:r.localize("vs_languages_sass_services_intelliSense",39)},{func:"percentage($number)",desc:r.localize("vs_languages_sass_services_intelliSense",40)},{func:"round($number)",desc:r.localize("vs_languages_sass_services_intelliSense",41)},{func:"ceil($number)",desc:r.localize("vs_languages_sass_services_intelliSense",42)},{func:"floor($number)",desc:r.localize("vs_languages_sass_services_intelliSense",43)},{func:"abs($number)",desc:r.localize("vs_languages_sass_services_intelliSense",44)},{func:"min($numbers)",desc:r.localize("vs_languages_sass_services_intelliSense",45)},{func:"max($numbers)",desc:r.localize("vs_languages_sass_services_intelliSense",46)},{func:"random([$limit])",desc:r.localize("vs_languages_sass_services_intelliSense",47)},{func:"length($list)",desc:r.localize("vs_languages_sass_services_intelliSense",48)},{func:"nth($list, $n)",desc:r.localize("vs_languages_sass_services_intelliSense",49)},{func:"set-nth($list, $n, $value)",desc:r.localize("vs_languages_sass_services_intelliSense",50)},{func:"join($list1, $list2, [$separator])",desc:r.localize("vs_languages_sass_services_intelliSense",51)},{func:"append($list1, $val, [$separator])",desc:r.localize("vs_languages_sass_services_intelliSense",52)},{func:"zip($lists)",desc:r.localize("vs_languages_sass_services_intelliSense",53)},{func:"index($list, $value)",desc:r.localize("vs_languages_sass_services_intelliSense",54)},{func:"list-separator(#list)",desc:r.localize("vs_languages_sass_services_intelliSense",55)},{func:"map-get($map, $key)",desc:r.localize("vs_languages_sass_services_intelliSense",56)},{func:"map-merge($map1, $map2)",desc:r.localize("vs_languages_sass_services_intelliSense",57)},{func:"map-remove($map, $keys)",desc:r.localize("vs_languages_sass_services_intelliSense",58)},{func:"map-keys($map)",desc:r.localize("vs_languages_sass_services_intelliSense",59)},{func:"map-values($map)",desc:r.localize("vs_languages_sass_services_intelliSense",60)},{func:"map-has-key($map, $key)",desc:r.localize("vs_languages_sass_services_intelliSense",61)},{func:"keywords($args)",desc:r.localize("vs_languages_sass_services_intelliSense",62)},{func:"feature-exists($feature)",desc:r.localize("vs_languages_sass_services_intelliSense",63)},{func:"variable-exists($name)",desc:r.localize("vs_languages_sass_services_intelliSense",64)},{func:"global-variable-exists($name)",desc:r.localize("vs_languages_sass_services_intelliSense",65)},{func:"function-exists($name)",desc:r.localize("vs_languages_sass_services_intelliSense",66)},{func:"mixin-exists($name)",desc:r.localize("vs_languages_sass_services_intelliSense",67)},{func:"inspect($value)",desc:r.localize("vs_languages_sass_services_intelliSense",68)},{func:"type-of($value)",desc:r.localize("vs_languages_sass_services_intelliSense",69)},{func:"unit($number)",desc:r.localize("vs_languages_sass_services_intelliSense",70)},{func:"unitless($number)",desc:r.localize("vs_languages_sass_services_intelliSense",71)},{func:"comparable($number1, $number2)",desc:r.localize("vs_languages_sass_services_intelliSense",72)},{func:"call($name, $args…)",desc:r.localize("vs_languages_sass_services_intelliSense",73)}],t}(n.CSSIntellisense);t.SASSIntellisense=i});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/sass/sassWorker",["require","exports","vs/languages/css/cssWorker","./parser/sassParser","./services/intelliSense"],function(e,t,n,r,i){var s=function(e){function t(t,n,r){e.call(this,t,n,r)}return __extends(t,e),t.prototype.createIntellisense=function(){return new i.SASSIntellisense},t.prototype.createParser=function(){return new r.SassParser},t}(n.CSSWorker);t.SassWorker=s});