/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/typescript/js/importAndExportRewriter",["require","exports","vs/base/strings","vs/base/paths","vs/languages/typescript/lib/typescriptServices","vs/base/collections"],function(e,t,n,r,i,s){var o=function(){function e(e,t){this.offset=e,this.length=t}return e}();t.Node=o;var a=function(e){function t(){e.apply(this,arguments),this.items=[]}return __extends(t,e),t}(o);t.List=a;var c=function(e){function t(t,n,r){e.call(this,t,n),this.scope=r,this.requireStatements=[],this.exportsDotExpressions=[]}return __extends(t,e),t}(o);t.DefineNode=c;var l=function(e){function t(t,n,r){e.call(this,t,n),this.name=r}return __extends(t,e),t}(o);t.CallbackParameter=l;var u=function(e){function t(t,n,i){e.call(this,t,n),this._path=i;var s,o=/('|")(.+)\1/.exec(this._path);o&&(s=r.extname(o[2]))&&(this._path=""+o[1]+o[2].substring(0,o[2].length-s.length)+o[1])}return __extends(t,e),Object.defineProperty(t.prototype,"path",{get:function(){return this._path},enumerable:!0,configurable:!0}),t}(o);t.DependencyNode=u;var p=function(e){function t(t,n,r,i){e.call(this,t,n,i),this.name=r}return __extends(t,e),t}(u);t.RequireStatement=p;var h=function(e){function t(t,n,r){e.call(this,t,n),this.name=r}return __extends(t,e),t}(o);t.ExportsExpression=h;var d=function(e){function t(t,n){e.call(this,t,n)}return __extends(t,e),t}(o);t.GlobalExportsExpression=d;var m=function(e){function t(t){e.call(this,0,0),this.name=t}return __extends(t,e),t}(o);t.NamedExportExpresson=m;var f=function(){function e(){}return Object.defineProperty(e.prototype,"name",{get:function(){return"rewriter.importsAndExports"},enumerable:!0,configurable:!0}),e.prototype.computeEdits=function(e){e.newInsert("declare var exports:any; declare var module:any; declare var require:any;\n"),this._context=e,this._currentScopeId=0,this._currentNode=null,this._bucket=[],this._variableNames=new y,this._visitNode(this._context.sourceFile);for(var t=!1,n=0,r=this._bucket.length;r>n;n++){var i=this._bucket[n];i instanceof c&&!t&&0===i.scope?(this._translateDefineNode(i),t=!0):i instanceof d?this._translateGlobalExportsExpression(i):i instanceof h?this._translateExportsExpression(i):i instanceof m?this._translateNamedExportExpresson(i):i instanceof p&&this._translateRequireStatement(i)}},Object.defineProperty(e.prototype,"nodes",{get:function(){return this._bucket},enumerable:!0,configurable:!0}),e.prototype._untilParent=function(e,t){for(var n=e.parent;n&&n.kind!==t;)n=n.parent;return n},e.prototype._store=function(e){this._currentNode?e instanceof p?this._currentNode.requireStatements.push(e):e instanceof h&&this._currentNode.exportsDotExpressions.push(e):this._bucket.push(e)},e.prototype.visitBinaryExpression=function(e){var t;if(e.operatorToken.kind===i.SyntaxKind.EqualsToken&&e.parent.kind===i.SyntaxKind.ExpressionStatement){var n,r;if(g.isIdentifier(e.left,"exports"))n=e.left.getStart(),r=e.left.getEnd(),t=new d(n,r-n);else if(e.left.kind===i.SyntaxKind.PropertyAccessExpression){var s=e.left,o=s.name.text;if(s.expression.kind===i.SyntaxKind.Identifier){var a=i.getTextOfNode(s.expression);"exports"===a?t=new h(s.getStart(),s.getWidth(),o):"module"===a&&"exports"===o&&(t=new d(s.getStart(),s.getWidth()))}else if(s.expression.kind===i.SyntaxKind.PropertyAccessExpression){var c=s.expression;g.isIdentifier(c.expression,"module")&&g.isIdentifier(c.name,"exports")&&(t=new h(s.getStart(),s.getWidth(),o))}}t&&i.getContainingFunction(e)&&!g.getContainingAmdDefineCall(e)&&(t instanceof h?t=new m(t.name):t instanceof d&&(t=void 0))}t?this._store(t):this._visitNode(e)},e.prototype.visitCallExpression=function(t){var n;return g.isIdentifier(t.expression,e._Define)&&(this._currentNode=new c(i.getTokenPosOfNode(t),t.getWidth(),this._currentScopeId),n=t.arguments,g.isPath(n,i.SyntaxKind.ObjectLiteralExpression)?this._currentNode.objectLiteral=new o(i.getTokenPosOfNode(n[0]),n[0].getWidth()):g.isPath(n,i.SyntaxKind.FunctionExpression)?this._fillInParametersAndBody(n[0],this._currentNode):g.isPath(n,i.SyntaxKind.ArrayLiteralExpression,i.SyntaxKind.FunctionExpression)?(this._fillInDependencies(n[0],this._currentNode),this._fillInParametersAndBody(n[1],this._currentNode)):g.isPath(n,i.SyntaxKind.StringLiteral,i.SyntaxKind.ArrayLiteralExpression,i.SyntaxKind.FunctionExpression)?(this._currentNode.identifier=n[0].text,this._fillInDependencies(n[1],this._currentNode),this._fillInParametersAndBody(n[2],this._currentNode)):this._currentNode=null,this._currentNode)?(this._bucket.push(this._currentNode),this._visitNode(t),this._currentNode=null,void 0):(this._visitNode(t),void 0)},e.prototype._fillInDependencies=function(e,t){t.dependencyArray=new a(i.getTokenPosOfNode(e),e.getWidth());for(var n=0,r=e.elements.length;r>n;n++){var s=e.elements[n];t.dependencyArray.items.push(new u(i.getTokenPosOfNode(s),s.getWidth(),i.getTextOfNode(s)))}},e.prototype._fillInParametersAndBody=function(e,t){var n,r;n=e.parameters.pos,r=e.parameters.end,t.callbackParameters=new a(n,r-n);for(var s=e.parameters,c=0,u=s.length;u>c;c++){var p=s[c];t.callbackParameters.items.push(new l(i.getTokenPosOfNode(p),p.getWidth(),i.getTextOfNode(p)))}n=e.body.getStart()+1,r=e.body.getEnd()-1,t.callbackBody=new o(n,r-n)},e.prototype._visitNode=function(e){var t=this;i.forEachChild(e,function(e){switch(e.kind){case i.SyntaxKind.BinaryExpression:t.visitBinaryExpression(e);break;case i.SyntaxKind.CallExpression:t.visitCallExpression(e);break;case i.SyntaxKind.FunctionDeclaration:case i.SyntaxKind.FunctionExpression:case i.SyntaxKind.ArrowFunction:t._currentScopeId+=1,t._visitNode(e),t._currentScopeId-=1;break;default:t._visitNode(e)}})},e.prototype._translateRequireStatement=function(e){var t=this._variableNames.next(e.name||e.path);this._context.newInsert(n.format("import {0} = require({1});\n",t,e.path)),this._context.newReplace(e.offset,e.length,t)},e.prototype._translateGlobalExportsExpression=function(e){var t=this._variableNames.next();this._context.newReplace(e.offset,e.length,n.format("var {0}",t)),this._context.newAppend(n.format("\nexport = {0};",t))},e.prototype._translateExportsExpression=function(e){this._context.newReplace(e.offset,e.length-e.name.length,"export var ")},e.prototype._translateNamedExportExpresson=function(e){this._context.newAppend("export var "+e.name+":any;\n")},e.prototype._translateDefineNode=function(t){if(t.objectLiteral)this._context.newInsert(e._DeclareWithLiteral);else{for(var r,i,s=[],r=0,i=t.requireStatements.length;i>r;r++){var o=t.requireStatements[r],a=this._variableNames.next(),c=this._variableNames.next();this._context.newInsert(n.format("import {0} = require({1});\n",a,o.path)),this._context.newReplace(o.offset,o.length,c),s.push(n.format("{0}:typeof {1}",c,a))}s.length>0&&this._context.newInsert(t.callbackParameters.offset+t.callbackParameters.length,n.format("{0}{1}",t.callbackParameters.items.length>0?",":"",s.join(",")));for(var l=[],r=0,i=t.exportsDotExpressions.length;i>r;r++){var u=t.exportsDotExpressions[r],p=this._variableNames.next();this._context.newReplace(u.offset,u.length,n.format("var {0}",p)),l.push(u.name),l.push(":"),l.push(p),l.push(",")}l.length>0&&(l.pop(),this._context.newInsert(t.callbackBody.offset+t.callbackBody.length,n.format("return {{0}};",l.join(n.empty))));var h=t.identifier?"id,":n.empty,d=t.dependencyArray?"dep,":n.empty,m=t.callbackParameters.items.map(function(e){return e.name}).concat(t.requireStatements.map(function(e,t){return n.format("_p{0}",t)})).join(",");this._context.newInsert(n.format(e._DeclareTemplate,h,d,m))}var f=this._variableNames.next();this._context.newInsert(t.offset,n.format("var {0} = ",f)),this._context.newAppend(n.format("\nexport = {0};",f))},e._SpecialCallbackParams={exports:!0,module:!0,require:!0},e._DeclareWithLiteral="declare function define<T>(literal:T):T;\n",e._DeclareTemplate="declare function define<T>({0}{1}callback:({2})=>T):T;\n",e._Define="define",e._Require="require",e}();t.ImportsAndExportsCollector=f;var g,y=function(){function e(){this._counter=0,this._proposalToName={},this._allNames={}}return e.prototype.next=function(t){if(!t)return n.format("_var_{0}",this._counter++);var i=s.lookup(this._proposalToName,t);if(i)return i;if(i=t.replace(/["']/g,n.empty),i=r.basename(i),i=i.replace(e._RegExp,n.empty),0===i.length)return this.next();i=i.split(n.empty).join(e._SpecialChar),i+=e._SpecialChar;for(var o=i,a=1;s.contains(this._allNames,i);a++)i=o+a;return this._allNames[i]=!0,this._proposalToName[t]=i,i},e.prototype.allocateIfFree=function(e){return s.contains(this._allNames,e)?!1:(this._allNames[e]=!0,!0)},e.prototype.reset=function(){this._counter=0,this._proposalToName={},this._allNames={}},e._RegExp=/[^A-Za-z_$]/g,e._SpecialChar="̲",e}();!function(e){function t(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];if(t.length!==e.length)return!1;for(var r=0,i=t.length;i>r;r++)if(e[r].kind!==t[r])return!1;return!0}function n(e,t){return e.kind===i.SyntaxKind.Identifier&&i.getTextOfNode(e)===t}function r(e){for(;;)if(e=e.parent,!e||s(e))return e}function s(t){if(t.kind!==i.SyntaxKind.CallExpression)return!1;var r=t;return n(r.expression,"define")?e.isPath(r.arguments,i.SyntaxKind.ObjectLiteralExpression)?!0:e.isPath(r.arguments,i.SyntaxKind.FunctionExpression)?!0:e.isPath(r.arguments,i.SyntaxKind.ArrayLiteralExpression,i.SyntaxKind.FunctionExpression)?!0:e.isPath(r.arguments,i.SyntaxKind.StringLiteral,i.SyntaxKind.ArrayLiteralExpression,i.SyntaxKind.FunctionExpression)?!0:!1:!1}e.isPath=t,e.isIdentifier=n,e.getContainingAmdDefineCall=r,e.isAmdDefineCall=s}(g||(g={}))});