/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/search/searchModel",["require","exports","vs/base/network","vs/base/time/schedulers","vs/base/strings","vs/base/paths","vs/base/lifecycle","vs/base/collections","vs/base/eventEmitter","vs/editor/editor","vs/editor/core/range","vs/editor/core/constants"],function(e,t,n,r,i,o,s,a,c,u,l,d){var p=function(){function e(e,t,n,r,i){this._parent=e,this._lineText=t,this._id=e.id()+">"+n+">"+r,this._range=new l.Range(1+n,1+r,1+n,1+r+i)}return e.prototype.id=function(){return this._id},e.prototype.parent=function(){return this._parent},e.prototype.text=function(){return this._lineText},e.prototype.range=function(){return this._range},e.prototype.preview=function(){var e=this._lineText.substring(0,this._range.startColumn-1),t=this._lineText.substring(this._range.startColumn-1,this._range.endColumn-1),n=this._lineText.substring(this._range.endColumn-1,Math.min(this._range.endColumn+150,this._lineText.length));return e=i.lcut(e,26),{before:e,inside:t,after:n}},e}();t.Match=p;var h=function(e){function t(t){e.call(this,t,null,Date.now(),Date.now(),Date.now())}return __extends(t,e),t}(p);t.EmptyMatch=h;var f=function(){function e(e,t){this._resource=t,this._parent=e,this._matches=Object.create(null)}return e.prototype.dispose=function(){},e.prototype.id=function(){return this.resource().toString()},e.prototype.parent=function(){return this._parent},e.prototype.add=function(e){this._matches[e.id()]=e},e.prototype.remove=function(e){delete this._matches[e.id()]},e.prototype.matches=function(){return a.values(this._matches)},e.prototype.count=function(){var e=0;for(var t in this._matches)this._matches[t]instanceof h||(e+=1);return e},e.prototype.resource=function(){return this._resource},e.prototype.name=function(){return o.basename(this.resource().fsPath)},e}();t.FileMatch=f;var m=function(e){function t(t,n,i,o,s){var a=this;e.call(this,t,n),this._modelDecorations=[],this._unbind=[],this._query=i,this._model=o,this._serverFileMatch=s,this._updateScheduler=new r.RunOnceScheduler(this._updateMatches.bind(this),250),this._unbind.push(this._model.addListener(d.EventType.ModelContentChanged,function(){return a._updateScheduler.schedule()})),this._updateMatches()}return __extends(t,e),t.prototype.dispose=function(){this._unbind=s.cAll(this._unbind),this._isTextModelDisposed()||this._model.deltaDecorations(this._modelDecorations,[])},t.prototype._updateMatches=function(){var e=this;if(!this._isTextModelDisposed()){this._matches=Object.create(null);var t=this._model.findMatches(this._query.pattern,this._model.getFullModelRange(),this._query.isRegExp,this._query.isCaseSensitive,this._query.isWordMatch);0===t.length?this.add(new h(this)):t.forEach(function(t){return e.add(new p(e,e._model.getLineContent(t.startLineNumber),t.startLineNumber-1,t.startColumn-1,t.endColumn-t.startColumn))}),this.parent().emit("changed",this),this.updateHighlights()}},t.prototype.updateHighlights=function(){this._model.isDisposed()||(this._modelDecorations=this.parent()._showHighlights?this._model.deltaDecorations(this._modelDecorations,this.matches().map(function(e){return{range:e.range(),options:t.DecorationOption}})):this._model.deltaDecorations(this._modelDecorations,[]))},t.prototype._isTextModelDisposed=function(){return!this._model||this._model.isDisposed()},t.DecorationOption={stickiness:u.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges,isOverlay:!1,className:"findMatch",overviewRuler:{color:"rgba(246, 185, 77, 0.7)",position:u.OverviewRulerLane.Center}},t}(f);t.LiveFileMatch=m;var g=function(e){function t(t,n){void 0===n&&(n=null),e.call(this),this._disposables=[],this._matches=Object.create(null),this._instantiationService=t.instantiationService,this._contextService=t.contextService,this._requestService=t.requestService,this._modelService=t.modelService,this._query=n,this._query&&(this._modelService.onModelAdded.add(this._onModelAdded,this,this._disposables),this._modelService.onModelRemoved.add(this._onModelRemoved,this,this._disposables))}return __extends(t,e),t.prototype._onModelAdded=function(e){var t=this._requestService.getPath("root",e.getAssociatedResource()),n=this._contextService.toResource(t);if(n){var r=this._matches[n.toString()];if(r){var i=new m(this,n,this._query,e,r);i.updateHighlights(),this._matches[n.toString()]=i,this.emit("changed",this)}}},t.prototype._onModelRemoved=function(e){var t=this,n=this._requestService.getPath("root",e.getAssociatedResource()),r=this._contextService.toResource(n);if(r){var i=this._matches[r.toString()];i instanceof m&&this.deferredEmit(function(){t.remove(i),t._matches[r.toString()]=i._serverFileMatch})}},t.prototype.append=function(e){var t=this;e.forEach(function(e){var n=t._getOrAdd(e);n instanceof m&&(n=n._serverFileMatch),e.lineMatches.forEach(function(e){e.offsetAndLengths.forEach(function(t){var r=new p(n,e.preview,e.lineNumber,t[0],t[1]);n.add(r)})})})},t.prototype._getOrAdd=function(e){var t=this;return a.lookupOrInsert(this._matches,e.resource.toString(),function(){var r,i,o=t._contextService.toWorkspaceRelativePath(e.resource);r=o?n.URL.fromValue(t._requestService.getRequestUrl("root",o,!0)):n.URL.fromValue(e.resource.toString()),i=t._modelService.getModel(r);var s=new f(t,e.resource);return i&&t._query&&(s=new m(t,e.resource,t._query,i,s)),s})},t.prototype.remove=function(e){delete this._matches[e.resource().toString()],e.dispose(),this.emit("changed",this)},t.prototype.matches=function(){return a.values(this._matches)},t.prototype.isEmpty=function(){return 0===this.fileCount()},t.prototype.fileCount=function(){return Object.keys(this._matches).length},t.prototype.count=function(){return this.matches().reduce(function(e,t){return e+t.count()},0)},t.prototype.toggleHighlights=function(e){if(this._showHighlights!==e){this._showHighlights=e;for(var t in this._matches){var n=this._matches[t];n instanceof m&&n.updateHighlights()}}},t.prototype.dispose=function(){this._disposables=s.disposeAll(this._disposables),s.disposeAll(this.matches()),e.prototype.dispose.call(this)},t}(c.EventEmitter);t.SearchResult=g}),define("vs/workbench/contrib/search/patternInput",["require","exports","vs/nls!vs/workbench/contrib/search/searchViewlet","vs/base/dom/builder","vs/base/dom/mouseEvent","vs/base/dom/keyboardEvent","vs/base/ui/widgets/inputBox","vs/base/glob","vs/base/strings"],function(e,t,n,r,i,o,s,a,c){var u=r.$,l=function(){function e(e,t,n,r){var s=this;this.actionClassName=e,this.title=t,this.isChecked=n,this.onChange=r,this.listenersToRemove=[],this.domNode=document.createElement("div"),this.domNode.title=this.title,this.render(),u(this.domNode).attr({"aria-checked":"false","aria-label":this.title,tabindex:0,role:"checkbox"}),u(this.domNode).on("click",function(e){var t=new i.StandardMouseEvent(e);s.isChecked=!s.isChecked,s.render(),s.onChange(),t.preventDefault()},this.listenersToRemove),u(this.domNode).on("keydown",function(e){var t=new o.KeyboardEvent(e);("Space"===t.key||"Enter"===t.key)&&(s.isChecked=!s.isChecked,s.render(),s.onChange(),t.preventDefault())},this.listenersToRemove)}return e.prototype.focus=function(){this.domNode.focus()},e.prototype.render=function(){this.domNode.className=this.className()},e.prototype.setChecked=function(e){this.isChecked=e,u(this.domNode).attr("aria-checked",this.isChecked),this.render()},e.prototype.className=function(){return"custom-checkbox "+this.actionClassName+" "+(this.isChecked?"checked":"unchecked")},e.prototype.width=function(){return 22},e.prototype.enable=function(){this.domNode.tabIndex=0},e.prototype.disable=function(){this.domNode.tabIndex=-1},e.prototype.destroy=function(){this.listenersToRemove.forEach(function(e){e()}),this.listenersToRemove=[]},e}();t.CustomCheckbox=l;var d=function(){function e(e,t,r){void 0===r&&(r=Object.create(null)),this.contextViewProvider=t,this.onOptionChange=null,this.width=r.width||100,this.placeholder=r.placeholder||"",this.validation=r.validation,this.label=r.label||n.localize("vs_workbench_contrib_search_patternInput",0),this.listenersToRemove=[],this.pattern=null,this.domNode=null,this.inputNode=null,this.inputBox=null,this.validationNode=null,this.buildDomNode(),Boolean(e)&&e.appendChild(this.domNode)}return e.prototype.destroy=function(){this.pattern.destroy(),this.listenersToRemove.forEach(function(e){e()}),this.listenersToRemove=[]},e.prototype.on=function(t,n){switch(t){case"keydown":case"keyup":u(this.inputBox.inputElement).on(t,n);break;case e.OPTION_CHANGE:this.onOptionChange=n}return this},e.prototype.setWidth=function(e){this.width=e,this.domNode.style.width=this.width+"px",this.contextViewProvider.layout(),this.setInputWidth()},e.prototype.getValue=function(){return this.inputBox.value},e.prototype.setValue=function(e){this.inputBox.value!==e&&(this.inputBox.value=e)},e.prototype.getGlob=function(){var e=this.getValue(),t=this.isGlobPattern();if(!e)return void 0;var n,r=Object.create(null);return n=t?a.splitGlobAware(e,",").map(function(e){return e.trim()}).filter(function(e){return!!e.length}):e.split(",").map(function(e){return e.trim()}).filter(function(e){return!!e.length}).map(function(e){return"."===e[0]&&(e="*"+e),c.format("{{0}/**,**/{1}}",e,e)}),n.reduce(function(e,t){return r[t]=!0,r},r)},e.prototype.select=function(){this.inputBox.select()},e.prototype.focus=function(){this.inputBox.focus()},e.prototype.isGlobPattern=function(){return this.pattern.isChecked},e.prototype.setIsGlobPattern=function(e){this.pattern.setChecked(e),this.setInputWidth()},e.prototype.setInputWidth=function(){var e=this.width-this.pattern.width();this.inputBox.width=e},e.prototype.buildDomNode=function(){var e=this;this.domNode=document.createElement("div"),this.domNode.style.width=this.width+"px",u(this.domNode).addClass("monaco-findInput"),this.inputBox=new s.InputBox(this.domNode,this.contextViewProvider,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation||null,showMessage:!0}}),this.pattern=new l("pattern",n.localize("vs_workbench_contrib_search_patternInput",1),!1,function(){e.onOptionChange(null),e.inputBox.focus(),e.setInputWidth(),e.validate(),e.isGlobPattern()?e.showGlobHelp():e.inputBox.hideMessage()}),u(this.pattern.domNode).on("mouseover",function(){e.isGlobPattern()&&e.showGlobHelp()}),u(this.pattern.domNode).on(["mouseleave","mouseout"],function(){e.inputBox.hideMessage()}),this.setInputWidth();var t=document.createElement("div");t.className="controls",t.appendChild(this.pattern.domNode),this.domNode.appendChild(t)},e.prototype.showGlobHelp=function(){this.inputBox.showMessage({type:s.MessageType.INFO,formatContent:!0,content:n.localize("vs_workbench_contrib_search_patternInput",2)},!0)},e.prototype.validate=function(){this.inputBox.validate()},e.prototype.showMessage=function(e){this.inputBox.showMessage(e)},e.prototype.clearMessage=function(){this.inputBox.hideMessage()},e.prototype.clearValidation=function(){this.inputBox.hideMessage()},e.OPTION_CHANGE="optionChange",e}();t.PatternInput=d}),define("vs/workbench/contrib/search/searchQuery",["require","exports","vs/base/assert","vs/base/types","vs/base/objects","vs/base/lib/winjs.base","vs/base/lifecycle","vs/platform/services"],function(e,t,n,r,i,o,s,a){function c(e){var t=e&&e.files&&e.files.exclude,n=e&&e.search&&e.search.exclude;if(!t&&!n)return null;if(!t||!n)return t||n;var r=Object.create(null);return r=i.mixin(r,t),r=i.mixin(r,n,!0)}t.getExcludes=c;var u=function(){function e(e){var t=this;this.configurationService=e.configurationService,this.callOnDispose=[],this.callOnDispose.push(this.configurationService.addListener(a.ConfigurationServiceEventTypes.UPDATED,function(e){t.configurationPromise=o.Promise.as(e.config)}))}return e.prototype.dispose=function(){s.cAll(this.callOnDispose)},e.prototype.text=function(e,t){return this._query(a.Search.QueryType.Text,e,t)},e.prototype.file=function(e){return this._query(a.Search.QueryType.File,null,e)},e.prototype._query=function(e,t,n){return void 0===n&&(n={}),this.loadConfiguration().then(function(r){var o=r&&r.files&&r.files.encoding;n.fileEncoding=o;var s=c(r);return n.excludePattern?i.mixin(n.excludePattern,s,!1):n.excludePattern=s,new l(e,t,n)})},e.prototype.loadConfiguration=function(){return this.configurationPromise?this.configurationPromise:(this.configurationPromise=this.configurationService.loadConfiguration(),this.configurationPromise)},e}();t.QueryBuilder=u;var l=function(){function e(e,t,i){void 0===i&&(i={}),n.ok(!r.isUndefinedOrNull(e)),n.ok(e!==a.Search.QueryType.Text||t&&t.pattern&&0!==t.pattern.length),this._type=e,this._contentPattern=t,this._filePatterns=i.filePatterns||[],this._excludePattern=i.excludePattern,this._includePattern=i.includePattern,this._maxResults=i.maxResults,this._rootResources=i.rootResources,this._fileEncoding=i.fileEncoding}return Object.defineProperty(e.prototype,"type",{get:function(){return this._type},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"contentPattern",{get:function(){return this._contentPattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filePatterns",{get:function(){return this._filePatterns},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"excludePattern",{get:function(){return this._excludePattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"includePattern",{get:function(){return this._includePattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"maxResults",{get:function(){return this._maxResults},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"rootResources",{get:function(){return this._rootResources},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fileEncoding",{get:function(){return this._fileEncoding},enumerable:!0,configurable:!0}),e.prototype.toJSON=function(){return{type:this.type,contentPattern:this.contentPattern,filePatterns:this.filePatterns,excludePattern:this._excludePattern,includePattern:this._includePattern,maxResults:this._maxResults,rootResources:this._rootResources,fileEncoding:this._fileEncoding}},e}()}),define("vs/css!vs/workbench/contrib/search/media/searchviewlet",["vs/css!vs/workbench/contrib/search/searchViewlet"],{});var __extends=this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/contrib/search/searchViewlet",["require","exports","vs/base/lib/winjs.base","vs/nls!vs/workbench/contrib/search/searchViewlet","vs/base/env","vs/editor/core/range","vs/base/lifecycle","vs/platform/services","vs/base/errors","vs/base/assert","vs/base/types","vs/base/strings","vs/base/dom/dom","vs/base/ui/actions","vs/base/dom/keyboardEvent","vs/base/performance/timer","vs/base/dom/builder","vs/base/ui/widgets/fileLabel","vs/base/ui/widgets/findInput","vs/base/ui/widgets/leftRightWidget/leftRightWidget","vs/base/ui/widgets/countBadge/countBadge","vs/base/ui/widgets/tree/treeImpl","vs/base/ui/widgets/tree/treeDefaults","vs/base/ui/widgets/tree/actionsRenderer","vs/workbench/ui/actionBarRegistry","vs/editor/core/constants","vs/workbench/core/memento","vs/workbench/ui/actions/openSettings","vs/workbench/events","vs/workbench/ui/parts/viewlet","vs/workbench/contrib/search/searchModel","vs/workbench/contrib/search/patternInput","./searchQuery","vs/workbench/contrib/search/search.contribution","vs/base/ui/widgets/inputBox","vs/css!./media/searchviewlet"],function(e,t,n,r,i,o,s,a,c,u,l,d,p,h,f,m,g,v,y,_,b,E,S,T,k,w,C,x,A,L,I,N,P,O,M){var D=g.$,R=O.VIEWLET_ID,F=function(e){function t(t,n){e.call(this,"workbench.search.action.findInFolder",r.localize("vs_workbench_contrib_search_searchViewlet",0)),this.viewletService=t.viewletService,this.resource=n}return __extends(t,e),t.prototype.run=function(){var e=this;return this.viewletService.openViewlet(R,!0).then(function(t){t.searchInFolder(e.resource)})},t}(h.Action);t.FindInFolderAction=F;var V=function(){function e(){}return e.prototype.getId=function(e,t){return t instanceof I.FileMatch?t.id():t instanceof I.Match?t.id():t instanceof I.SearchResult?"root":(u.ok(!1),void 0)},e.prototype.getChildren=function(e,t){var r=[];return t instanceof I.FileMatch?r=t.matches():t instanceof I.SearchResult&&(r=t.matches()),n.Promise.as(r)},e.prototype.hasChildren=function(e,t){return t instanceof I.FileMatch||t instanceof I.SearchResult},e.prototype.getParent=function(e,t){var r=null;return t instanceof I.Match?r=t.parent():t instanceof I.FileMatch&&(r=t.parent()),n.Promise.as(r)},e}();t.SearchDataSource=V;var B=function(){function e(){}return e.prototype.compare=function(e,t,n){return t instanceof I.FileMatch&&n instanceof I.FileMatch?d.localeCompare(t.resource().fsPath,n.resource().fsPath)||d.localeCompare(t.name(),n.name()):t instanceof I.Match&&n instanceof I.Match?o.compareRangesUsingStarts(t.range(),n.range()):void 0},e}();t.SearchSorter=B;var H=function(e){function t(){var t=this;e.call(this,{clickBehavior:S.ClickBehavior.ON_MOUSE_DOWN}),this.downKeyBindings.Delete=function(e,n){t.onDelete(e,n)}}return __extends(t,e),t.prototype.onDelete=function(e){for(var t=!1,n=e.getSelection(),r=0;r<n.length;r++){var i=n[r];i instanceof I.FileMatch&&(new j(e,i).run().done(null,c.onUnexpectedError),t=!0)}return t},t}(S.DefaultController),W=function(){function e(){}return e.prototype.isVisible=function(e,t){return!(t instanceof I.FileMatch)||t.matches().length>0},e}(),U=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.hasActions=function(t,n){return n instanceof I.FileMatch||e.prototype.hasActions.call(this,t,n)},t.prototype.getActions=function(t,n){return e.prototype.getActions.call(this,t,n).then(function(e){return n instanceof I.FileMatch&&e.unshift(new j(t,n)),e})},t}(k.ContributableActionProvider),j=function(e){function t(t,n){e.call(this,"remove",r.localize("vs_workbench_contrib_search_searchViewlet",1),"action-remove"),this._viewer=t,this._fileMatch=n}return __extends(t,e),t.prototype.run=function(){var e=this._fileMatch.parent();return e.remove(this._fileMatch),this._viewer.refresh(e)},t}(h.Action),G=function(e){function t(t,n){e.call(this,{actionProvider:new U,actionRunner:n}),this._contextService=t.contextService}return __extends(t,e),t.prototype.getContentHeight=function(){return 24},t.prototype.renderContents=function(e,t,n){var i=this;if(t instanceof I.FileMatch){var o,s,a,c=t,u=D(".filematch");return o=function(e){return new v.FileLabel(e,c.resource(),i._contextService),null},s=function(e){var t=c.count();return new b.CountBadge(e,t,t>1?r.localize("vs_workbench_contrib_search_searchViewlet",2,t):r.localize("vs_workbench_contrib_search_searchViewlet",3,t))},a=new _.LeftRightWidget(u,o,s),u.appendTo(n),a.dispose.bind(a)}if(t instanceof I.EmptyMatch)p.addClass(n,"linematch"),D("a.plain.label").innerHtml(r.localize("vs_workbench_contrib_search_searchViewlet",4)).appendTo(n);else if(t instanceof I.Match){p.addClass(n,"linematch");var l=[],h=t.preview();l.push("<span>"),l.push(d.escape(h.before)),l.push('</span><span class="findInFileMatch">'),l.push(d.escape(h.inside)),l.push("</span><span>"),l.push(d.escape(h.after)),l.push("</span>"),D("a.plain").innerHtml(l.join(d.empty)).appendTo(n)}return null},t}(T.ActionsRenderer),z=function(e){function t(t){e.call(this,"refresh"),this.label=r.localize("vs_workbench_contrib_search_searchViewlet",5),this.enabled=!1,this.class="search-action refresh",this.viewlet=t}return __extends(t,e),t.prototype.run=function(){return this.viewlet.onQueryChanged(!0),n.Promise.as(null)},t}(h.Action);t.RefreshAction=z;var $=function(e){function t(t){e.call(this,"selectOrRemove"),this.label=r.localize("vs_workbench_contrib_search_searchViewlet",6),this.enabled=!1,this.selectMode=!0,this.viewlet=t}return __extends(t,e),t.prototype.run=function(){var e;return e=this.selectMode?this.runAsSelect():this.runAsRemove(),this.selectMode=!this.selectMode,this.label=this.selectMode?r.localize("vs_workbench_contrib_search_searchViewlet",7):r.localize("vs_workbench_contrib_search_searchViewlet",8),e},t.prototype.runAsSelect=function(){return this.viewlet.getResults().addClass("select"),n.Promise.as(null)},t.prototype.runAsRemove=function(){var e=[],t=this.viewlet.getControl();return t.getInput().matches().forEach(function(t){t.matches().filter(function(e){return e.$checked}).forEach(function(t){t.parent().remove(t),e.push(t.parent())})}),this.viewlet.getResults().removeClass("select"),e.length>0?t.refreshAll(e).then(function(){return t.refresh()}):n.Promise.as(null)},t}(h.Action);t.SelectOrRemoveAction=$;var q=function(e){function t(t){e.call(this,"collapseAll"),this.label=r.localize("vs_workbench_contrib_search_searchViewlet",9),this.enabled=!1,this.class="search-action collapse",this.viewlet=t}return __extends(t,e),t.prototype.run=function(){return this.viewlet.getControl()?this.viewlet.getControl().collapseAll():n.Promise.as(null)},t}(h.Action);t.CollapseAllAction=q;var K=function(e){function t(t){e.call(this,"clearSearchResults"),this.label=r.localize("vs_workbench_contrib_search_searchViewlet",10),this.enabled=!1,this.class="search-action clear-search-results",this.viewlet=t}return __extends(t,e),t.prototype.run=function(){return this.viewlet.clearSearchResults(),n.Promise.as(null)},t}(h.Action);t.ClearSearchResultsAction=K;var X=function(e){function t(t){e.call(this,"configureGlobalExclusionsAction"),this.label=r.localize("vs_workbench_contrib_search_searchViewlet",11),this.enabled=!0,this.class="search-configure-exclusions",this.instantiationService=t.instantiationService}return __extends(t,e),t.prototype.run=function(){var e=this.instantiationService.createInstance(x.OpenGlobalSettingsAction);return e.run().done(function(){return e.dispose()},c.onUnexpectedError),n.Promise.as(null)},t}(h.Action),Y=function(e){function t(t){var n=this;e.call(this,t,R),this.eventService=t.eventService,this.editorService=t.editorService,this.progressService=t.progressService,this.messageService=t.messageService,this.storageService=t.storageService,this.contextViewService=t.contextViewService,this.instantiationService=t.instantiationService,this.configurationService=t.configurationService,this.searchServices=t.textFileSearchService,this.textFileService=t.textFileService,this.contextService=t.contextService,this._viewletVisible=t.keybindingService.createKey("searchViewletVisible",!0),this.callOnModelChange=[],this.queryBuilder=this.instantiationService.createInstance(P.QueryBuilder),this.loadSettings(this.storageService),this.toUnbind.push(this.eventService.addListener(a.Files.EventType.FILE_CHANGES,function(e){return n.onFilesChanged(e)})),this.toUnbind.push(this.eventService.addListener(A.EventType.UNTITLED_FILE_DELETED,function(e){return n.onUntitledFileDeleted(e)})),this.toUnbind.push(this.configurationService.addListener(a.ConfigurationServiceEventTypes.UPDATED,function(e){return n.onConfigurationUpdated(e.config)}))}return __extends(t,e),t.prototype.onConfigurationUpdated=function(e){this.updateGlobalPatternExclusions(e)},t.prototype.loadSettings=function(e){var t=this;this.viewletSettings||this.loadMemento(e,C.Scope.WORKSPACE).done(function(e){t.viewletSettings=e},c.onUnexpectedError)},t.prototype.getResults=function(){return this.results},t.prototype.create=function(t){var i=this;e.prototype.create.call(this,t);var o,s=this.viewletSettings["query.filePatterns"]||"",a=this.viewletSettings["query.folderExclusions"]||"",u=this.viewletSettings["query.exclusionsUsePattern"],l=this.viewletSettings["query.includesUsePattern"],h=this.viewletSettings["query.folderIncludes"]||"",m=this.viewletSettings["query.contentPattern"]||"",g=this.viewletSettings["query.regex"]===!0,v=this.viewletSettings["query.wholeWords"]===!0,_=this.viewletSettings["query.caseSensitive"]===!0;this.domNode=t.div({class:"search-viewlet"},function(e){o=e});var b=function(e){var t=new f.KeyboardEvent(e);"Enter"===t.key&&i.onQueryChanged(!0)};this.queryBox=o.div({class:"query-box"},function(e){var t={label:r.localize("vs_workbench_contrib_search_searchViewlet",12),validation:function(e){if(0===e.length)return null;if(!i.findInput.getRegex())return null;var t;try{t=new RegExp(e)}catch(n){return{content:n.message}}return d.regExpLeadsToEndlessLoop(t)?{content:r.localize("vs_workbench_contrib_search_searchViewlet",13)}:void 0}};i.findInput=new y.FindInput(e.getHTMLElement(),i.contextViewService,t).on(p.EventType.KEY_UP,b).on(p.EventType.KEY_DOWN,function(e){var t=new f.KeyboardEvent(e);"DownArrow"===t.key&&(p.EventHelper.stop(e),i.showsFileTypes()?i.toggleFileTypes(!0):i.selectTreeIfNotSelected(t))}).on(y.FindInput.OPTION_CHANGE,function(){i.onQueryChanged(!0)}),i.findInput.setValue(m),i.findInput.setRegex(g),i.findInput.setCaseSensitive(_),i.findInput.setWholeWords(v)}).style({position:"relative"}).getHTMLElement(),this.queryDetails=o.div({class:["query-details","separator"]},function(e){e.div({class:"more",text:"…"}).on(p.EventType.CLICK,function(e){p.EventHelper.stop(e),i.toggleFileTypes()}),e.div({class:"file-types"},function(e){var t=r.localize("vs_workbench_contrib_search_searchViewlet",14);e.element("h4",{text:t}),i.inputPatternIncludes=new N.PatternInput(e.getContainer(),i.contextViewService,{label:r.localize("vs_workbench_contrib_search_searchViewlet",15)}),i.inputPatternIncludes.setIsGlobPattern(l),i.inputPatternIncludes.setValue(h),i.inputPatternIncludes.on(p.EventType.KEY_UP,b).on(p.EventType.KEY_DOWN,function(e){var t=new f.KeyboardEvent(e);switch(t.asString()){case"UpArrow":p.EventHelper.stop(e),i.findInput.focus(),i.findInput.select();break;case"DownArrow":p.EventHelper.stop(e),i.inputPatternExclusions.focus(),i.inputPatternExclusions.select()}}).on(y.FindInput.OPTION_CHANGE,function(){i.onQueryChanged(!1)})}),e.div({class:"file-types"},function(e){var t=r.localize("vs_workbench_contrib_search_searchViewlet",16);e.element("h4",{text:t}),i.inputPatternExclusions=new N.PatternInput(e.getContainer(),i.contextViewService,{label:r.localize("vs_workbench_contrib_search_searchViewlet",17)}),i.inputPatternExclusions.setIsGlobPattern(u),i.inputPatternExclusions.setValue(a),i.inputPatternExclusions.on(p.EventType.KEY_UP,b).on(p.EventType.KEY_DOWN,function(e){var t=new f.KeyboardEvent(e);switch(t.asString()){case"UpArrow":p.EventHelper.stop(e),i.inputPatternIncludes.focus(),i.inputPatternIncludes.select();break;case"DownArrow":p.EventHelper.stop(e),i.selectTreeIfNotSelected(t)}}).on(y.FindInput.OPTION_CHANGE,function(){i.onQueryChanged(!1)})}),i.inputPatternGlobalExclusionsContainer=e.div({class:"file-types global-exclude disabled"},function(e){var t=r.localize("vs_workbench_contrib_search_searchViewlet",18);e.element("h4",{text:t}),i.inputPatternGlobalExclusions=new M.InputBox(e.getContainer(),i.contextViewService,{actions:[i.instantiationService.createInstance(X)]}),i.inputPatternGlobalExclusions.inputElement.readOnly=!0,D(i.inputPatternGlobalExclusions.inputElement).addClass("disabled")}).hide()}).getHTMLElement(),this.messages=o.div({class:"messages"}).hide().clone(),o.div({class:"results"},function(e){i.results=e;var t=new V,n=i.instantiationService.createInstance(G,i.getActionRunner());i.tree=new E.Tree(e.getHTMLElement(),{dataSource:t,renderer:n,sorter:new B,filter:new W,controller:new H},{paddingLeft:12,allowHorizontalScroll:!1}),i.toUnbind.push(function(){return n.dispose()}),i.toUnbind.push(i.tree.addListener("selection",function(e){var t,n=e.payload&&"keyboard"===e.payload.origin;t=n?i.tree.getFocus():e.selection[0];var r=e&&e.payload&&e.payload.originalEvent&&(e.payload.originalEvent.ctrlKey||e.payload.originalEvent.metaKey);i.onFocus(t,!n,r)}))}),this.actionRegistry={};var S=[new q(this),new z(this),new K(this),new $(this)];return S.forEach(function(e){i.actionRegistry[e.id]=e}),(""!==s||""!==a||""!==h)&&this.toggleFileTypes(!0,!0),this.configurationService.loadConfiguration().then(function(e){i.updateGlobalPatternExclusions(e)}).done(null,c.onUnexpectedError),n.Promise.as(null)},t.prototype.updateGlobalPatternExclusions=function(e){if(this.inputPatternGlobalExclusionsContainer){var t=P.getExcludes(e);if(t){var n=Object.getOwnPropertyNames(t).filter(function(e){return t[e]===!0||"string"==typeof t[e].when}).map(function(e){return t[e]===!0?e:r.localize("vs_workbench_contrib_search_searchViewlet",19,e,t[e].when)});n.length?(this.inputPatternGlobalExclusions.value=n.join(", "),this.inputPatternGlobalExclusionsContainer.show()):this.inputPatternGlobalExclusionsContainer.hide()}}},t.prototype.setVisible=function(t){var n;if(this._viewletVisible.set(t),t?(n=e.prototype.setVisible.call(this,t),this.tree.onVisible()):(this.tree.onHidden(),n=e.prototype.setVisible.call(this,t)),this.viewModel&&this.viewModel.toggleHighlights(t),t&&!this.editorService.getActiveEditorInput()){var r=this.tree.getFocus();r&&this.onFocus(r,!1,!1)}return n},t.prototype.focus=function(){e.prototype.focus.call(this);var t=this.getSelectionFromEditor();t&&this.findInput.setValue(t),this.findInput.focus(),this.findInput.select()},t.prototype.reLayout=function(){if(!this.isDisposed){this.findInput.setWidth(this.size.width-34),this.inputPatternExclusions.setWidth(this.size.width-42),this.inputPatternIncludes.setWidth(this.size.width-42),this.inputPatternGlobalExclusions.width=this.size.width-42-24;var e=p.getTotalHeight(this.queryBox),t=p.getTotalHeight(this.queryDetails),n=this.size.height-e-t;this.results.style({height:n+"px"}),this.tree.layout(n)}},t.prototype.layout=function(t){var r=this;this.size=t,e.prototype.layout.call(this,t),n.Promise.timeout(10).done(function(){r.reLayout()},c.onUnexpectedError)},t.prototype.getControl=function(){return this.tree},t.prototype.clearSearchResults=function(){this.disposeModel(),this.showEmptyStage(),this.findInput.clear(),this.currentRequest&&(this.currentRequest.cancel(),this.currentRequest=null)},t.prototype.selectTreeIfNotSelected=function(){if(this.tree.getInput()){this.tree.DOMFocus();var e=this.tree.getSelection();0===e.length&&this.tree.focusNext()}},t.prototype.getSelectionFromEditor=function(){if(!this.editorService.getActiveEditor())return null;var e=this.editorService.getActiveEditor().getControl();if(!e||!l.isFunction(e.getEditorType)||e.getEditorType()!==w.EditorType.ICodeEditor)return null;var t=e.getSelection();if(t&&!t.isEmpty()&&t.startLineNumber===t.endLineNumber){var n=e.getModel().getLineContent(t.startLineNumber);return n=n.substring(t.startColumn-1,t.endColumn-1)}return null},t.prototype.showsFileTypes=function(){return p.hasClass(this.queryDetails,"more")},t.prototype.toggleFileTypes=function(e,t){var n="more";e="undefined"==typeof e?!p.hasClass(this.queryDetails,n):Boolean(e),t=Boolean(t),e?(p.addClass(this.queryDetails,n),this.inputPatternIncludes.focus(),this.inputPatternIncludes.select()):p.removeClass(this.queryDetails,n),!t&&this.size&&this.layout(this.size)},t.prototype.searchInFolder=function(e){this.showsFileTypes()||this.toggleFileTypes(!0,!1);var t=this.contextService.toWorkspaceRelativePath(e);t&&(this.inputPatternIncludes.setIsGlobPattern(!1),this.inputPatternIncludes.setValue(d.trim(t,"/")),this.findInput.focus())},t.prototype.onQueryChanged=function(e){var n=this,r=this.findInput.getRegex(),i=this.findInput.getWholeWords(),o=this.findInput.getCaseSensitive(),s=this.findInput.getValue(),a=this.inputPatternExclusions.getValue().trim(),u=this.inputPatternExclusions.isGlobPattern(),l=this.inputPatternIncludes.getValue().trim(),p=this.inputPatternIncludes.isGlobPattern();if(this.viewletSettings["query.contentPattern"]=s,this.viewletSettings["query.regex"]=r,this.viewletSettings["query.wholeWords"]=i,this.viewletSettings["query.caseSensitive"]=o,this.viewletSettings["query.folderExclusions"]=a,this.viewletSettings["query.exclusionsUsePattern"]=u,this.viewletSettings["query.folderIncludes"]=l,this.viewletSettings["query.includesUsePattern"]=p,e&&(/^\s+|\s$/.test(s)&&(s=d.escapeRegExpCharacters(s),r=!0),0!==s.length)){if(r){var h;
try{h=new RegExp(s)}catch(f){return}if(d.regExpLeadsToEndlessLoop(h))return}var m={pattern:s,isRegExp:r,isCaseSensitive:o,isWordMatch:i},g=this.inputPatternExclusions.getGlob(),v=this.inputPatternIncludes.getGlob(),y=this.textFileService.getWorkingFilesModel().getOutOfWorkspaceContextEntries().map(function(e){return e.resource});this.contextService.getWorkspace()&&y.push(this.contextService.getWorkspace().resource);var _={rootResources:y,excludePattern:g,includePattern:v,maxResults:t.MAX_TEXT_RESULTS};this.queryBuilder.text(m,_).then(function(e){return n.onQueryTriggered(e,a,l)},c.onUnexpectedError)}},t.prototype.onQueryTriggered=function(e,t,n){var i=this;this.currentRequest&&(this.currentRequest.cancel(),this.currentRequest=null);var o=this.telemetryService.start("searchResultsFirstRender"),s=this.telemetryService.start("searchResultsFinished"),a=100,u=this.progressService.show(a),l=0;this.loading=!0,this.findInput.clearMessage(),this.disposeModel(),this.showEmptyStage();var d=function(e){if(i.viewModel){var t=i.viewModel.matches();t.forEach(function(n){var r=n.matches().length;10>r||e&&1===t.length&&50>r?i.tree.expand(n).done(null,c.onUnexpectedError):i.tree.collapse(n).done(null,c.onUnexpectedError)})}},h=m.start(m.Topic.WORKBENCH,"Search"),f=!1,g=function(o){h.stop(),f=!0,u.worked(a-l),setTimeout(function(){return u.done()},200),i.viewModel=i.viewModel||i.instantiationService.createInstance(I.SearchResult,e.contentPattern),i.viewModel.append(o.results),i.tree.refresh().then(function(){d(!0)}).done(void 0,c.onUnexpectedError);var m=!i.viewModel.isEmpty();if(i.loading=!1,i.telemetryService.publicLog("searchResultsShown",{count:i.viewModel.count(),fileCount:i.viewModel.fileCount()}),i.actionRegistry.refresh.enabled=!0,i.actionRegistry.selectOrRemove.enabled=m,i.actionRegistry.collapseAll.enabled=m,i.actionRegistry.clearSearchResults.enabled=m,o.limitHit&&i.findInput.showMessage({content:r.localize("vs_workbench_contrib_search_searchViewlet",20),type:M.MessageType.WARNING}),m)i.viewModel.toggleHighlights(!0);else{var g,v=!!t,y=!!n;g=y&&v?r.localize("vs_workbench_contrib_search_searchViewlet",21,n,t):y?r.localize("vs_workbench_contrib_search_searchViewlet",22,n):v?r.localize("vs_workbench_contrib_search_searchViewlet",23,t):r.localize("vs_workbench_contrib_search_searchViewlet",24),i.tree.onHidden(),i.results.hide();var _=i.messages.empty().show().asContainer().div({class:"message",text:g});(y||v)&&D(_).a({class:["pointer","prominent"],text:r.localize("vs_workbench_contrib_search_searchViewlet",25)}).on(p.EventType.CLICK,function(e){p.EventHelper.stop(e,!1),i.inputPatternExclusions.setValue(""),i.inputPatternIncludes.setValue(""),i.onQueryChanged(!0)})}s.stop()},v=function(e){i.loading=!1,f=!0,u.done(),o.stop(),s.stop(),e&&"Canceled"===e.message||i.messageService.show(2,e)},y=0,_=0,b=0,E=[],S=function(t){t.total&&(y=t.total),t.worked&&(_=t.worked),t.resource&&(E.push(t),i.viewModel||(i.viewModel=i.instantiationService.createInstance(I.SearchResult,e.contentPattern),i.tree.setInput(i.viewModel).then(function(){d(!1),i.callOnModelChange.push(i.viewModel.addListener("changed",function(e){return i.tree.refresh(e,!0)}))}).done(null,c.onUnexpectedError)),i.viewModel.append(E),o.stop())},T=setInterval(function(){if(f)return window.clearInterval(T),void 0;var e=!0;if(y>0&&_>0){var t=Math.round(_/y*100);t>l&&(u.worked(t-l),l=t,e=!1)}e&&90>l&&(l++,u.worked(1)),b!==E.length&&(b=E.length,i.tree.refresh().then(function(){d(!1)}).done(null,c.onUnexpectedError))},200);this.currentRequest=this.searchServices.search(e),this.currentRequest.then(g,v,S)},t.prototype.showEmptyStage=function(){this.actionRegistry.refresh.enabled=!1,this.actionRegistry.selectOrRemove.enabled=!1,this.actionRegistry.collapseAll.enabled=!1,this.actionRegistry.clearSearchResults.enabled=!1,this.messages.hide(),this.tree.setInput(this.instantiationService.createInstance(I.SearchResult)).done(null,c.onUnexpectedError),this.results.show(),this.tree.onVisible()},t.prototype.onFocus=function(e,t,r){if(!(e instanceof I.Match))return n.Promise.as(!0);var i=e.parent().resource(),o=e.range();return this.telemetryService.publicLog("searchResultChosen"),this.editorService.openEditor({resource:i,options:{preserveFocus:t,selection:o}},r)},t.prototype.onUntitledFileDeleted=function(e){if(this.viewModel)for(var t=this.viewModel.matches(),n=0,r=t.length;r>n;n++)e.resource.toString()===t[n].resource().toString()&&this.viewModel.remove(t[n])},t.prototype.onFilesChanged=function(e){if(this.viewModel)for(var t=this.viewModel.matches(),n=0,r=t.length;r>n;n++)e.contains(t[n].resource(),a.Files.FileChangeType.DELETED)&&this.viewModel.remove(t[n])},t.prototype.getSelection=function(){return new a.StructuredSelection(this.tree.getSelection())},t.prototype.getActions=function(){return[this.actionRegistry.refresh,this.actionRegistry.collapseAll,this.actionRegistry.clearSearchResults]},t.prototype.dispose=function(){this.isDisposed=!0,this.tree&&this.tree.dispose(),this.disposeModel(),e.prototype.dispose.call(this)},t.prototype.disposeModel=function(){this.viewModel&&(this.viewModel.dispose(),this.viewModel=null),s.cAll(this.callOnModelChange)},t.MAX_TEXT_RESULTS=i.isWeb?1024:2048,t}(L.Viewlet);t.SearchViewlet=Y});